Package: IntEREst
Title: Intron-Exon Retention Estimator
Version: 1.37.0
Date: 2024-03-19
Author: Ali Oghabian <Ali.Oghabian@Helsinki.Fi>, Dario Greco
        <dario.greco@helsinki.fi>, Mikko Frilander
        <Mikko.Frilander@helsinki.fi>
Maintainer: Ali Oghabian <Ali.Oghabian@Helsinki.Fi>
Description: This package performs Intron-Exon Retention analysis on
        RNA-seq data (.bam files).
Depends: R (>= 3.5.0), GenomicRanges, Rsamtools, SummarizedExperiment,
        edgeR, S4Vectors, GenomicFiles
Imports: seqLogo, Biostrings, GenomicFeatures (>= 1.39.4), txdbmaker,
        IRanges, seqinr, graphics, grDevices, stats, utils, grid,
        methods, DBI, RMariaDB, GenomicAlignments, BiocParallel,
        BiocGenerics, DEXSeq, DESeq2
Suggests: clinfun, knitr, rmarkdown, BSgenome.Hsapiens.UCSC.hg19
VignetteBuilder: knitr
LazyData: true
biocViews: Software, AlternativeSplicing, Coverage,
        DifferentialSplicing, Sequencing, RNASeq, Alignment,
        Normalization, DifferentialExpression, ImmunoOncology
License: GPL-2
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/IntEREst
git_branch: devel
git_last_commit: 9e02eb2
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
Packaged: 2026-04-28 23:20:04 UTC; biocbuild

This README.TXT file is located in the scripts/ folder of the
MDS.Chr22 package. This folder contains the scripts that
were used to produce the data located in the extdata/ folder.

This file describes how to regenrate the data in extdata/
folder.

-----
Requirements:

- The samples were sequenced very deep (~ 60-80 million pair of 
sequenced reads) hence the mapping could be extremely time-consuming (from 
24 hours up to 5 days). In this respect, we recommend running the mapping 
(Tophat2 runs) of the sequencing reads by using at least 4 threads and in 
an environment with at least 4 computing cores. We ran the analysis
on Introni i.e. a local server with 64 cores (AMD Opteron(TM) Processor 6274)
528 Gb of RAM, and a Linux x86_64 (CentOS release 5.11) Operating System.

- 1.3 TB of available disk space.

- Fast internet connection. About 150 GB needs to be downloaded. 

- Software: bowtie2-2.0.0-beta7, tophat-2.0.5, and SAMtools (0.1.18).

-----
Installing required software:

- For Bowtie2 instllation see 
   http://bowtie-bio.sourceforge.net/tutorial.shtml

- For Tophat2 installation see 
   https://ccb.jhu.edu/software/tophat/tutorial.shtml

- For samtools installation see
   http://www.htslib.org/download/

-----
Regenrating data:
To regenerate the data carry out the following: 

1. Set the proper environmental variables: SCRIPTSPATH should be set to the 
   absolute path of scripts/ folder of IntEREst package. Set RAWDATAPATH to 
   where you like to download the raw files. If IntEREst is installed, in R you 
   can retreive the path to the scripts with the following command:
   system.file("scripts", package="IntEREst"). Set MAPPINGPATH to where the 
   mapping results and the contents in extdata/ should be stored (Could be the 
   same as RAWDATAPATH). indexPATH should be set as the path of the bowtie 2 
   indexes.
    

2. Run the commands in following order:

   sh $SCRIPTSPATH/download-sra.sh
   sh $SCRIPTSPATH/sraTofastqConvert.sh
   sh $SCRIPTSPATH/allTophat2Runs.sh
   sh $SCRIPTSPATH/selectCh22fromBam.sh
   Rscript --vanilla $SCRIPTSPATH/build_mdsChr22Obj.R $MAPPINGPATH ./

updateRowDataCol<- function(x,  updateCol, value){
	tmp<- x
	if(is.numeric(updateCol) | 
		length(which(!is.na(match(updateCol, colnames(
			SummarizedExperiment::rowData(tmp))))))>0){
		SummarizedExperiment::rowData(tmp)[,updateCol]<-value
	} else {		
		tmpDat<- cbind( as.data.frame(SummarizedExperiment::rowData(x)), value)
		colnames(tmpDat)[ncol(tmpDat)]<- updateCol
		SummarizedExperiment::rowData(tmp)<- S4Vectors::DataFrame(tmpDat)
	}

	return(tmp)
}

interestAnalyse <-
function(
	reference,
	bamFile,
	isPaired,
	yieldSize,
	maxNoMappedReads,
	logFile,
	method,
	strandSpecific,
	appendLogFile=TRUE,
	repeatsTableToFilter,
	referenceIntronExon,
	clusterNo,
	junctionReadsOnly,
	isPairedDuplicate,
	isSingleReadDuplicate,
	bpparam,
	limitRanges,
	excludeFusionReads,
	loadLimitRangesReads,
	...)
{
	resTmpPair<-c()
	resTmpSingle<- c()
#Paralle running impelementation
	if(logFile!=""){
		cat( "InERESt:interestAnalyse: Begins ...\n", file=logFile, 
			append=appendLogFile)
	}
	cat( "InERESt:interestAnalyse: Begins ...\n")

	if(is(reference,"GRanges")){
		if(length(names(reference))>0){
			tmpReference=data.frame(
				chr=as.character(GenomicRanges::seqnames(reference)), 
				begin=as.numeric(GenomicRanges::start(reference)),
				end=as.numeric(GenomicRanges::end(reference)), 
				strand=as.character(GenomicRanges::strand(reference)), 
				names=as.character(names(reference)))
		} else{
			tmpReference=data.frame(
				chr=as.character(GenomicRanges::seqnames(reference)), 
				begin=as.numeric(GenomicRanges::start(reference)),
				end=GenomicRanges::end(reference), 
				strand=as.character(GenomicRanges::strand(reference)))
		}
		reference=tmpReference
	}

	time1=Sys.time()



	# Set parallel environment	
	if((!missing(bpparam)))
		BiocParallel::register(bpparam)
	
	if((missing(bpparam))){
	  parallel=FALSE
	} else if(bpparam@class[[1]]=="SerialParam"){
	  parallel=FALSE
	} else {
	  parallel=TRUE
	}
	
	if(isPaired){
		# Defining connection to bam file
		bf<- Rsamtools::BamFile(bamFile, yieldSize=yieldSize, 
				asMates=TRUE, ... )
		# Analyzing mapped paired reads together
		if(length(limitRanges)==0 | (!loadLimitRangesReads)){
		  scParam=Rsamtools::ScanBamParam(
		  	what=Rsamtools::scanBamWhat()[c(1,
			  	3,5,8,13,9, 10, 6, 4, 14, 15)], 
			  flag=Rsamtools::scanBamFlag(isPaired=TRUE,
				  isDuplicate=isPairedDuplicate)) } else {
				    scParam=Rsamtools::ScanBamParam(
				      which=limitRanges,
				      what=Rsamtools::scanBamWhat()[c(1,
				                                      3,5,8,13,9, 10, 6, 4, 14, 15)], 
				      flag=Rsamtools::scanBamFlag(isPaired=TRUE,
				                                  isDuplicate=isPairedDuplicate))				    
				  
				}

		# Initialize the iterator and combine with REDUCE:
		# ITER <- bamIterPair(bf, scParam=scParam)
	#	resTmpPair<- BiocParallel::bpiterate(ITER, interestIntExAnalysePair, 
		YIELD <- function(X, ...) {
		  
		  yld=GenomicAlignments::readGAlignmentPairs(X, 
		                                             param=scParam)
		  return(yld)
		  
		}
		
		if(strandSpecific=="unstranded"){
  		resPair<- GenomicFiles::reduceByYield(bf, YIELD= YIELD, 
  		  MAP=interestIntExAnalysePairUnstranded,
  			reference=reference,
  			maxNoMappedReads=maxNoMappedReads,
  			logFile=logFile,
  			method=method,
  			appendLogFile=appendLogFile,
  			repeatsTableToFilter=repeatsTableToFilter,
  			referenceIntronExon=referenceIntronExon,
  			junctionReadsOnly=junctionReadsOnly,
  			limitRanges=limitRanges,
  			excludeFusionReads=excludeFusionReads,
  			#BPPARAM=bpparam, 
  			REDUCE = `+`, parallel=parallel, iterate = TRUE, 
  			init=rep(0, nrow(reference)))
  		} else{
  		resPair<- GenomicFiles::reduceByYield(bf, YIELD= YIELD, 
  			MAP=interestIntExAnalysePairStranded,
  			reference=reference,
  			maxNoMappedReads=maxNoMappedReads,
  			logFile=logFile,
  			method=method,
  			appendLogFile=appendLogFile,
  			repeatsTableToFilter=repeatsTableToFilter,
  			referenceIntronExon=referenceIntronExon,
  			junctionReadsOnly=junctionReadsOnly,
  			limitRanges=limitRanges,
  			strandSpecific=strandSpecific,
  			excludeFusionReads=excludeFusionReads,
  			#BPPARAM=bpparam, 
  			REDUCE = `+`, parallel=parallel, iterate = TRUE, 
  			init=rep(0, nrow(reference)))  			  
  			}

		
		if(logFile!="")
		  cat( "BETWEEN SINGLE AND PAIRED N1 \n", 
		       file=logFile, append=appendLogFile)
		cat( "BETWEEN SINGLE AND PAIRED N1\n")
		
		# Analyzing single mapped reads
		if(length(limitRanges)==0 | (!loadLimitRangesReads)){
		  scParam2=Rsamtools::ScanBamParam(
			  what=Rsamtools::scanBamWhat()[c(1,
				  3,5,8,13,9, 10, 6, 4, 14, 15,2)], 
			  flag=Rsamtools::scanBamFlag(hasUnmappedMate=TRUE,
				  isPaired=TRUE, 
				  isDuplicate=isSingleReadDuplicate))
		} else{
		  scParam2=Rsamtools::ScanBamParam(
		    which=limitRanges,
		    what=Rsamtools::scanBamWhat()[c(1,
		                                    3,5,8,13,9, 10, 6, 4, 14, 15,2)],
		    flag=Rsamtools::scanBamFlag(hasUnmappedMate=TRUE,
		                                isPaired=TRUE,
		                                isDuplicate=isSingleReadDuplicate))		  
		}
		
		if(logFile!="")
		  cat( "BETWEEN SINGLE AND PAIRED N2 \n", 
		       file=logFile, append=appendLogFile)
		cat( "BETWEEN SINGLE AND PAIRED N2 \n")	
		
		#ITER <- bamIterSingle(bf, scParam=scParam)
		
		if(logFile!="")
		  cat( "BETWEEN SINGLE AND PAIRED N3 \n", 
		       file=logFile, append=appendLogFile)
		cat( "BETWEEN SINGLE AND PAIRED N3\n")
		
		#resTmpSingle<- BiocParallel::bpiterate(ITER,
		YIELD2 <- function(X, ...) {
		  
		  yld=GenomicAlignments::readGAlignmentsList(X, 
		                                             param=scParam2)
		  return(yld)
		  
		}
		if(strandSpecific=="unstranded"){
  		resSingle<- GenomicFiles::reduceByYield(bf, YIELD= YIELD2,
  		  MAP=interestIntExAnalyseSingleUnstranded, 
  			reference=reference,
  			maxNoMappedReads=maxNoMappedReads,
  			logFile=logFile,
  			method=method,
  			appendLogFile=appendLogFile,
  			repeatsTableToFilter=repeatsTableToFilter,
  			referenceIntronExon=referenceIntronExon,
  			junctionReadsOnly=junctionReadsOnly,
  			limitRanges=limitRanges,
  			excludeFusionReads=excludeFusionReads,
  			# BPPARAM=bpparam,
  			REDUCE = `+`, parallel=parallel, iterate = TRUE, 
  			init=rep(0, nrow(reference)))
		} else{
		  resSingle<- GenomicFiles::reduceByYield(bf, YIELD= YIELD2,
		    MAP=interestIntExAnalyseSingleStranded, 
		    reference=reference,
		    maxNoMappedReads=maxNoMappedReads,
		    logFile=logFile,
		    method=method,
		    appendLogFile=appendLogFile,
		    repeatsTableToFilter=repeatsTableToFilter,
		    referenceIntronExon=referenceIntronExon,
		    junctionReadsOnly=junctionReadsOnly,
		    limitRanges=limitRanges,
		    strandSpecific=strandSpecific,
		    excludeFusionReads=excludeFusionReads,
		    # BPPARAM=bpparam,
		    REDUCE = `+`, parallel=parallel, iterate = TRUE, 
		    init=rep(0, nrow(reference)))		  
		}
		
		if(logFile!="")
		  cat( "BETWEEN SINGLE AND PAIRED N4 \n", 
		       file=logFile, append=appendLogFile)
		cat( "BETWEEN SINGLE AND PAIRED N4\n")
	} else {
		# Defining connection to bam file
		bf<- Rsamtools::BamFile(bamFile, yieldSize=yieldSize, ...)
		#Analyzing unpaired sequencing data
#
		if(length(limitRanges)==0 | (!loadLimitRangesReads)){
		scParam3=Rsamtools::ScanBamParam(
			what=Rsamtools::scanBamWhat()[c(1,
				3,5,8,13,9, 10, 6, 4, 14, 15,2)], 
			flag=Rsamtools::scanBamFlag(
				isPaired=NA, 
				isDuplicate=isSingleReadDuplicate))
		} else{
		  scParam3=Rsamtools::ScanBamParam(
		    which=limitRanges,
		    what=Rsamtools::scanBamWhat()[c(1,
		                                    3,5,8,13,9, 10, 6, 4, 14, 15,2)],
		    flag=Rsamtools::scanBamFlag(
		      isPaired=NA, 
		      isDuplicate=isSingleReadDuplicate))		  
		  
		}

		#ITER <- bamIterSingle(bf, scParam=scParam)
		#resTmpSingle<- BiocParallel::bpiterate(ITER, 
		YIELD3 <- function(X, ...) {
		  
		  yld=GenomicAlignments::readGAlignmentsList(X, 
		                                             param=scParam3)
		  return(yld)
		  
		}
		if(strandSpecific=="unstranded"){
  		resSingle<-GenomicFiles::reduceByYield(bf, 
        YIELD= YIELD3,
  		  MAP=interestIntExAnalyseSingleUnstranded, 
  			reference=reference,
  			maxNoMappedReads=maxNoMappedReads,
  			logFile=logFile,
  			method=method,
  			appendLogFile=appendLogFile,
  			repeatsTableToFilter=repeatsTableToFilter,
  			referenceIntronExon=referenceIntronExon,
  			junctionReadsOnly=junctionReadsOnly,
  			limitRanges=limitRanges,
  			excludeFusionReads=excludeFusionReads,
  #			BPPARAM=bpparam, 
  			REDUCE = `+`, parallel=parallel, iterate = TRUE, 
        init=rep(0, nrow(reference)))
		} else{
		  resSingle<-GenomicFiles::reduceByYield(bf, 
		    YIELD= YIELD3,
		    MAP=interestIntExAnalyseSingleStranded, 
		    reference=reference,
		    maxNoMappedReads=maxNoMappedReads,
		    logFile=logFile,
		    method=method,
		    appendLogFile=appendLogFile,
		    repeatsTableToFilter=repeatsTableToFilter,
		    referenceIntronExon=referenceIntronExon,
		    junctionReadsOnly=junctionReadsOnly,
		    limitRanges=limitRanges,
		    strandSpecific=strandSpecific,
		    excludeFusionReads=excludeFusionReads,
		    #			BPPARAM=bpparam, 
		    REDUCE = `+`, parallel=parallel, iterate = TRUE, 
		    init=rep(0, nrow(reference)))		  
		}
  	resPair<-rep(0, nrow(reference)*length(method))
	}
	# resPair<-rep(0, nrow(reference)*length(method))
	# resSingle<-rep(0, nrow(reference)*length(method))

	
	# if(isPaired & (length(resTmpPair)>0)){
	# 	resTmpPair[sapply(resTmpPair, is.null)] <- NULL
	# 	resPair<-Reduce("+", resTmpPair)
	# }
	# if(length(resTmpSingle)>0){
	# 	resTmpSingle[sapply(resTmpSingle, is.null)] <- NULL
	# 	resSingle<-Reduce("+", resTmpSingle)
	# }
	if(is.null(resPair) | (length(resPair)==0)){
	  resPair<- rep(0, 
	    length(which(method%in%c("ExEx", "IntRet", "IntSpan", "ExSkip"))))
	  if(logFile!="")
	    cat( "There are no paired reads !\n", 
	         file=logFile, append=appendLogFile)
	  cat( "There are no paired reads !\n")
	}
	if(is.null(resSingle) | (length(resSingle)==0)){
	  resSingle<- rep(0, 
	    length(which(method%in%c("ExEx", "IntRet", "IntSpan", "ExSkip"))))
	  if(logFile!="")
	    cat( "There are no singletons !\n", 
	         file=logFile, append=appendLogFile)
	  cat( "There are no singletons !\n")
	}
	res<- resPair+resSingle
  #NEW!
	rm("resPair", "resSingle")
	time2=Sys.time()
	runTime=difftime(time2,time1, units="secs")
	if(logFile!="")
		cat( "InERESt:interestAnalyse: Read counting ends. Running time: ",
			runTime," secs\n", file=logFile, append=TRUE)
	cat( "InERESt:interestAnalyse: Read counting ends. Running time: ",
		runTime," secs\n")

	return(res)	
}

mergeInterestResult<-function(x, y){
	msg<-
"The retention levels should be similarly scaled. The scaleLength and 
scaleFragment of the two input objects should be equal."
	if(S4Vectors::metadata(x)$scaleLength!= 
			S4Vectors::metadata(y)$scaleLength | 
		S4Vectors::metadata(x)$scaleFragment!=
			S4Vectors::metadata(y)$scaleFragment)
		stop(msg)
	tmpAnno<- rbind(as.data.frame(getAnnotation(x)),
			as.data.frame(getAnnotation(y)))
	nreadTmp<- cbind(counts(x), counts(y))
	scaledRetTmp<- cbind(scaledRetention(x), scaledRetention(y))
	colnames(nreadTmp)<- rownames(tmpAnno)
	colnames(scaledRetTmp)<- rownames(tmpAnno)
	res<- InterestResult (
		counts=nreadTmp, 
		scaledRetention=scaledRetTmp, 
		scaleLength= S4Vectors::metadata(x)$scaleLength, 
		scaleFragment= S4Vectors::metadata(x)$scaleLength, 
		sampleAnnotation= tmpAnno, 
		rowData=SummarizedExperiment::rowData(x))	

	return(res)
}

# Function to correct length  based on possible removal of repeat elements
correctLengthRepeat<-function(ref, repeatsTableToFilter){	

	lenRef=ref[,"end"]-ref[,"begin"]+1
	if(length(repeatsTableToFilter)!=0){
		repeatGRanges= GenomicRanges::GRanges( seqnames=
			repeatsTableToFilter[,"chr"],
			IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
			end=repeatsTableToFilter[,"end"], 
			width=repeatsTableToFilter[,"end"]-
				repeatsTableToFilter[,"begin"]+1))
		reduceRepeatGr=GenomicRanges::reduce(repeatGRanges)
		reduceRepeatBegin=as.numeric(GenomicRanges::start(reduceRepeatGr))
		reduceRepeatBeginGr= GenomicRanges::GRanges(
			seqnames=as.character(GenomicRanges::seqnames(reduceRepeatGr)),
				IRanges::IRanges(start=reduceRepeatBegin,
					end=reduceRepeatBegin))

		reduceRepeatEnd=as.numeric(GenomicRanges::end(reduceRepeatGr))
		reduceRepeatEndGr= GenomicRanges::GRanges(
			seqnames=as.character(GenomicRanges::seqnames(reduceRepeatGr)), 
			 	IRanges::IRanges(start=reduceRepeatEnd, end=reduceRepeatEnd))

		refGr=GenomicRanges::GRanges( seqnames=ref[,"chr"],
			IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"],
				width=ref[,"end"]-ref[,"begin"]+1))
		#Repeat elements that are fully located in the reference (Intron/Exon)
		hitsRepeat= GenomicRanges::findOverlaps(reduceRepeatGr, refGr, 
			type= "within")
		#Repeat elements which their 'end' coordinates are only located in the
		#reference
		hitsEndRepeat= GenomicRanges::findOverlaps(reduceRepeatEndGr, refGr, 
			type= "within")
		hitsEndRepeatFilQuery= S4Vectors::queryHits(hitsEndRepeat)[
			is.na(match(S4Vectors::queryHits(hitsEndRepeat), 
				S4Vectors::queryHits(hitsRepeat) ))]
		hitsEndRepeatFilSubject=S4Vectors::subjectHits(hitsEndRepeat)[
			is.na(match(S4Vectors::queryHits(hitsEndRepeat), 
				S4Vectors::queryHits(hitsRepeat) ))]
		#Repeat elements which their 'begin' coordinate are only located in the
		#reference
		hitsBeginRepeat= GenomicRanges::findOverlaps(reduceRepeatBeginGr, 
			refGr, type= "within")
		hitsBeginRepeatFilQuery= S4Vectors::queryHits(hitsBeginRepeat)[
			is.na(match(S4Vectors::queryHits(hitsBeginRepeat), 
				S4Vectors::queryHits(hitsRepeat) ))]
		hitsBeginRepeatFilSubject= S4Vectors::subjectHits(hitsBeginRepeat)[
			is.na(match(S4Vectors::queryHits(hitsBeginRepeat), 
				S4Vectors::queryHits(hitsRepeat) ))]

		lenRef[S4Vectors::subjectHits(hitsRepeat)]= 
			lenRef[S4Vectors::subjectHits(hitsRepeat)]- 
				as.numeric(GenomicRanges::width(reduceRepeatGr)
					[S4Vectors::queryHits(hitsRepeat)])
		if(length(hitsEndRepeatFilQuery)>0){
			lenRef[hitsEndRepeatFilSubject]=
				lenRef[hitsEndRepeatFilSubject]-
					(reduceRepeatEnd[hitsEndRepeatFilQuery]-
						ref[hitsEndRepeatFilSubject,"begin"]+1)
		}
		if(length(hitsBeginRepeatFilQuery)>0){
			lenRef[hitsBeginRepeatFilSubject]=lenRef[hitsBeginRepeatFilSubject]-
				(ref[hitsBeginRepeatFilSubject,"end"]-
					reduceRepeatBegin[hitsBeginRepeatFilQuery]+1)
		}

	}
	return(lenRef)
}

# Function for summarizing the results
interestSummarise <-function(
	reference,
	referenceIntronExon,
	inAnRes,
	method=c("ExEx", "IntRet", "IntSpan", "ExSkip"),
	referenceGeneNames,
	outFile,
	logFile="",
	appendLogFile=TRUE,
	repeatsTableToFilter=c(),
	scaleLength= c(TRUE,TRUE), 
	scaleFragment= c(TRUE,TRUE))
{
	if(logFile!="")
		cat( "IntERESt:interestSummarise: Begins ...\n", file=logFile, 
			append=appendLogFile)
	cat( "IntERESt:interestSummarise: Begins ...\n")

	if(is(reference,"GRanges")){
		if(length(names(reference))>0){
			tmpReference=data.frame(
				chr=as.character(GenomicRanges::seqnames(reference)), 
				begin=as.numeric(GenomicRanges::start(reference)),
				end=as.numeric(GenomicRanges::end(reference)), 
				strand=as.character(GenomicRanges::strand(reference)), 
				names=as.character(names(reference)))
		} else{
			tmpReference=data.frame(
				chr=as.character(GenomicRanges::seqnames(reference)), 
				begin=as.numeric(GenomicRanges::start(reference)),
				end=as.numeric(GenomicRanges::end(reference)), 
				strand=as.character(GenomicRanges::strand(reference)))
		}
		reference=tmpReference
	}

	res=reference
	writeResults=FALSE
	exExInd=which(method=="ExEx")
	intExInd=which(method=="IntRet")
	intSpanInd=which(method=="IntSpan")
	exSkipInd=which(method=="ExSkip")

	inAnMat<- matrix(inAnRes, 
		ncol=length(which(c(length(exExInd)>0, length(intExInd)>0,
			length(intSpanInd)>0, length(exSkipInd)>0))), 
			byrow=FALSE)

	if(length(exExInd)>0) {
		ref=reference[referenceIntronExon=="exon",]
		# Calculate the corrected length
		lenRef=correctLengthRepeat(ref, repeatsTableToFilter)
		indFrq<- 1
		writeResults=TRUE
		res<- cbind(res, inAnMat[ , indFrq])
		colnames(res)[ncol(res)]="ExEx_frequency"
		msg<-
"IntERESt:interestSummarise: Normalizing exon-exon junction read levels.\n"
		if(logFile!="")
			cat( msg, file=logFile, append=TRUE)
		cat( msg)

		frq<- inAnMat[ which(referenceIntronExon=="exon"), indFrq]
		referenceGeneNamesTmp=as.character(referenceGeneNames[
			which(referenceIntronExon=="exon")])
		geneCnt=tapply(frq,referenceGeneNamesTmp,sum)
		FPKM=frq
		if(scaleFragment[exExInd])
			FPKM=((10^6)*FPKM)/(as.numeric(geneCnt[referenceGeneNamesTmp])+1)
		if(scaleLength[exExInd])
			FPKM=((10^3)*FPKM)/lenRef

		resTmp=rep(0,nrow(reference))
		resTmp[referenceIntronExon=="exon"]=as.numeric(FPKM)
		res=cbind(res, resTmp)
		colnames(res)[ncol(res)]="ExEx_genewide_scaled"
	}
	
	if(length(intExInd)>0){
	  ref=reference[which(referenceIntronExon=="intron"),]
	    indFrq<- 2
	    if(length(exExInd)==0)
	      indFrq<- 1
	  # Calculate the corrected length
	  
	  lenRef=correctLengthRepeat(ref, repeatsTableToFilter)
	  writeResults=TRUE
	  res<- cbind(res, inAnMat[ , indFrq])
	  colnames(res)[ncol(res)]="IntRet_frequency"
	  msg<-
	    "IntERESt:interestSummarise: Normalizing intron retention read levels.\n"
	  if(logFile!="")
	    cat( msg, file=logFile, append=TRUE)
	  cat(msg)
	  frq<- inAnMat[ which(referenceIntronExon=="intron"), indFrq]
	  referenceGeneNamesTmp<- as.character(referenceGeneNames[
	    referenceIntronExon=="intron"])
	  geneCnt<- tapply(frq,referenceGeneNamesTmp,sum)
	  FPKM=frq
	  if(scaleFragment[intExInd])
	    FPKM=((10^6)*frq)/(as.numeric(geneCnt[referenceGeneNamesTmp])+1)
	  if(scaleLength[intExInd])
	    FPKM=((10^3)*FPKM)/lenRef
	  
	  resTmp=rep(0,nrow(reference))
	  resTmp[referenceIntronExon=="intron"]=as.numeric(FPKM)
	  res=cbind(res, resTmp)
	  colnames(res)[ncol(res)]="IntRet_genewide_scaled"
	} 
	
	if(length(intSpanInd)>0){
		ref=reference[which(referenceIntronExon=="intron"),]
		cntMet<-length(which(c("ExEx", "IntRet")%in%method))
		#indFrq<- 2*cntMet+1
		indFrq<- cntMet+1
		# Calculate the corrected length
		
		lenRef=correctLengthRepeat(ref, repeatsTableToFilter)
		writeResults=TRUE
		res<- cbind(res, inAnMat[ , indFrq])
		colnames(res)[ncol(res)]="IntSpan_frequency"
		msg<-
"IntERESt:interestSummarise: Normalizing intron retention read levels.\n"
		if(logFile!="")
			cat( msg, file=logFile, append=TRUE)
		cat(msg)
		frq<- inAnMat[ which(referenceIntronExon=="intron"), indFrq]
		referenceGeneNamesTmp<- as.character(referenceGeneNames[
			referenceIntronExon=="intron"])
		geneCnt<- tapply(frq,referenceGeneNamesTmp,sum)
		FPKM=frq
		if(scaleFragment[intSpanInd])
			FPKM=((10^6)*frq)/(as.numeric(geneCnt[referenceGeneNamesTmp])+1)
		if(scaleLength[intSpanInd])
			FPKM=((10^3)*FPKM)/lenRef

		resTmp=rep(0,nrow(reference))
		resTmp[referenceIntronExon=="intron"]=as.numeric(FPKM)
		res=cbind(res, resTmp)
		colnames(res)[ncol(res)]="IntSpan_genewide_scaled"
	} 

	if(length(exSkipInd)>0) {
	  ref=reference[referenceIntronExon=="exon",]
	  cntMet<-length(which(c("ExEx", "IntRet", "IntSpan")%in%method))
	  indFrq<- cntMet+1
	  # Calculate the corrected length
	  lenRef=correctLengthRepeat(ref, repeatsTableToFilter)
	  # indFrq<- 1
	  writeResults=TRUE
	  res<- cbind(res, inAnMat[ , indFrq])
	  colnames(res)[ncol(res)]="ExSkip_frequency"
	  msg<-
	    "IntERESt:interestSummarise: Normalizing exon-exon junction read levels.\n"
	  if(logFile!="")
	    cat( msg, file=logFile, append=TRUE)
	  cat( msg)
	  
	  frq<- inAnMat[ which(referenceIntronExon=="exon"), indFrq]
	  referenceGeneNamesTmp=as.character(referenceGeneNames[
	    which(referenceIntronExon=="exon")])
	  geneCnt=tapply(frq,referenceGeneNamesTmp,sum)
	  FPKM=frq
	  if(scaleFragment[exSkipInd])
	    FPKM=((10^6)*FPKM)/(as.numeric(geneCnt[referenceGeneNamesTmp])+1)
	  if(scaleLength[exSkipInd])
	    FPKM=((10^3)*FPKM)/lenRef
	  
	  resTmp=rep(0,nrow(reference))
	  resTmp[referenceIntronExon=="exon"]=as.numeric(FPKM)
	  res=cbind(res, resTmp)
	  colnames(res)[ncol(res)]="ExSkip_genewide_scaled"
	}


	if(writeResults){
		write.table(res, outFile, col.names=TRUE, row.names=FALSE, sep='\t', 
			quote=FALSE)
	} else {
		stop(
'wrong method setting. The correct values are "IntRet", "ExEx", and "IntSpan".'
			)
	}
}

interestResultIntEx<- function(intObj, exObj, intExCol=c(), 
	mean.na.rm=TRUE, postExName="ex_junc" ){
	if(length(intExCol)==1){
		intObj<- intObj[which(rowData(intObj)[,intExCol]=="intron"), ]
		exObj<- exObj[which(rowData(exObj)[,intExCol]=="exon"), ]
	}
	if(length(intExCol)==2){
		intObj<- intObj[which(rowData(intObj)[,intExCol[1]]=="intron"), ]
		exObj<- exObj[which(rowData(exObj)[,intExCol[2]]=="exon"), ]
	}
	exEndGr<- GenomicRanges::GRanges(rowData(exObj)$chr,
		IRanges::IRanges(rowData(exObj)$end+1, 
			rowData(exObj)$end+1))
	exBegGr<- GenomicRanges::GRanges(rowData(exObj)$chr,
		IRanges::IRanges(rowData(exObj)$begin-1, 
			rowData(exObj)$begin-1))
	intGr<- GenomicRanges::GRanges(rowData(intObj)$chr,
		IRanges::IRanges(rowData(intObj)$begin, 
			rowData(intObj)$end))

	intExEnd<-GenomicRanges::findOverlaps(intGr, exEndGr, type="start")
	intExBeg<-GenomicRanges::findOverlaps(intGr, exBegGr, type="end")
	exCnt<- counts(exObj)
	meanExVals<- lapply(1:ncol(exCnt), function(j){
		endVals<- tapply(subjectHits(intExEnd), queryHits(intExEnd), 
			function(tmp) mean(exCnt[unique(tmp),j], na.rm=mean.na.rm))
		begVals<- tapply(subjectHits(intExBeg), queryHits(intExBeg), 
			function(tmp) mean(exCnt[unique(tmp),j], na.rm=mean.na.rm))
		return(trunc(apply(cbind(endVals, begVals), 1, mean, 
			na.rm=mean.na.rm)))
	})
	exCnt<- as.data.frame(meanExVals)
	if(all(colnames(counts(intObj)) %in% colnames(counts(exObj))))
		colnames(exCnt)<- paste(colnames(counts(intObj)),postExName,sep="_")

	exSr<- scaledRetention(exObj)
	meanExSrVals<- lapply(1:ncol(exSr), function(j){
		endVals<- tapply(subjectHits(intExEnd), queryHits(intExEnd), 
			function(tmp) mean(exSr[unique(tmp),j], na.rm=mean.na.rm))
		begVals<- tapply(subjectHits(intExBeg), queryHits(intExBeg), 
			function(tmp) mean(exSr[unique(tmp),j], na.rm=mean.na.rm))
		return(apply(cbind(endVals, begVals), 1, mean, na.rm=mean.na.rm))
	})
	exSr<- as.data.frame(meanExSrVals)
	if(all(colnames(counts(intObj)) %in% colnames(counts(exObj))))
		colnames(exSr)<- paste(colnames(counts(intObj)),postExName,sep="_")
	
	annoMat<- rbind(colData(intObj), colData(intObj))
	annoMat<- cbind(as.data.frame(annoMat), 
		c(rep("intron", nrow(colData(intObj))), 
			rep("exon", nrow(colData(intObj)))))
	rownames(annoMat)<- c(colnames(scaledRetention(intObj)), colnames(exCnt))
	colnames(annoMat)[ncol(annoMat)]<- "intronExon"
	resObj<- InterestResult(
		resultFiles=annoMat[,1], 
		counts=cbind(counts(intObj), exCnt), 
		scaledRetention=cbind(scaledRetention(intObj), exSr), 
		scaleLength=intObj@metadata$scaleFragmentscaleLength, 
		scaleFragment=intObj@metadata$scaleFragmentscaleFragment, 
		sampleAnnotation=annoMat[,-1], 
		rowData=rowData(intObj))
	return(resObj)
}

u12DensityPlot<-function(x, type=c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), 
	fcType="edgeR", sampleAnnotation=c(),  sampleAnnoCol=c(), group=c(), 
	intExCol="int_ex", intTypeCol="int_type", intronExon, strandCol="strand", 
	geneIdCol="collapsed_transcripts", naUnstrand=FALSE, col=1, lty=1, lwd=1, 
	plotLegend=TRUE, cexLegend=1, xLegend="topright", yLegend=NULL, legend=c(),
	randomSeed=NULL, xlab="", ...){
	#Check parameters
	object=x
	if(length(col)==1 ){
		col=rep(col, length(type))
	} else if (length(col)!=length(type)){
		msg<-
"The length of the col parameter should be either 1 or the same size as type."
		stop(msg)
	}
	if(length(lty)==1 ){
		lty=rep(lty, length(type))
	} else if (length(lty)!=length(type)){
		msg<-
"The length of the lty parameter should be either 1 or the same size as type."
		stop(msg)
	}
	if(length(lwd)==1 ){
		lwd=rep(lwd, length(type))
	} else if (length(lwd)!=length(type)){
		msg<-
"The length of the lwd parameter should be either 1 or the same size as type."
		stop(msg)
	}

	#Check type availability for data
	if(length(which(c("U2Up", "U2Dn", "U2UpDn") %in% type))>0 & 
		length(which("intron" %in% 
			SummarizedExperiment::rowData(object)[,intExCol]))==0){
		msg<-
"Plotting types 'U12', 'U2Rand' are available for references with exons only."
		stop(msg)

	}
	

	fcRes=lfc(object, fcType=fcType, sampleAnnoCol=sampleAnnoCol, 
		sampleAnnotation=sampleAnnotation, group=group)
	u12Ind= u12Index(object,intExCol=intExCol, intTypeCol=intTypeCol, 
	intronExon=intronExon)
	u12NbInd= u12NbIndex(object,intExCol=intExCol, intTypeCol=intTypeCol, 
		strandCol=strandCol, geneIdCol=geneIdCol, naUnstrand=naUnstrand)
	uniStrand=unique(SummarizedExperiment::rowData(object)[,strandCol])
	definedStrand=uniStrand[uniStrand!="*"]
	listPlot=c()
	if(intronExon=="intron"){
		if("U12" %in% type)
			listPlot=c(listPlot, list(U12_introns=fcRes[u12Ind]))
		if("U2Up" %in% type)
			listPlot=c(listPlot, 
				list(Upstream_U2_introns=fcRes[u12NbInd$upIntron]))
		if("U2Dn" %in% type)
			listPlot=c(listPlot, 
				list(Downstream_U2_introns=fcRes[u12NbInd$downIntron]))
		if("U2UpDn" %in% type)
			listPlot=c(listPlot, list(UpDown_stream_U2_introns=
				fcRes[c(u12NbInd$downIntron,u12NbInd$upIntron)]))
		if("U2Rand"%in% type){
			set.seed(randomSeed)
			allIntronsInd=which(SummarizedExperiment::rowData(object)[,
				intExCol]=="intron")
			randInd=sample(
				allIntronsInd[which(is.na(match(allIntronsInd,u12Ind)))], 
				length(u12Ind))
			listPlot=c(listPlot, list(random_U2_introns=fcRes[randInd]))
		}
	} else if(intronExon=="exon"){
		if(length(which(c("U2Up", "U2Dn", "U2UpDn") %in% type))>0){
			upIndU2Tmp1=u12NbInd$upExon-1
			upIndU2Tmp2=u12NbInd$upExon-2
			upIndU2Tmp1[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$upExon[u12NbInd$upExon>u12NbInd$downExon]+1
			upIndU2Tmp2[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$upExon[u12NbInd$upExon>u12NbInd$downExon]+2
			dnIndU2Tmp1=u12NbInd$downExon+1
			dnIndU2Tmp2=u12NbInd$downExon+2
			dnIndU2Tmp1[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$downExon[u12NbInd$upExon>u12NbInd$downExon]-1
			dnIndU2Tmp2[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$downExon[u12NbInd$upExon>u12NbInd$downExon]-2
	
			upIndsU2=unique(c(upIndU2Tmp1, upIndU2Tmp2))
			dnIndsU2=unique(c(dnIndU2Tmp1, dnIndU2Tmp1))
			upIndsU12=u12NbInd$upExon
			dnIndsU12=u12NbInd$downExon
			upIndsU2=unique(upIndsU2[which(!is.na(upIndsU2))])
			dnIndsU2=unique(dnIndsU2[which(!is.na(dnIndsU2))])
			upIndsU12=unique(upIndsU12[which(!is.na(upIndsU12))])
			dnIndsU12=unique(dnIndsU12[which(!is.na(dnIndsU12))])
			upDnIndsU2=unique(c(upIndsU2,dnIndsU2))[
				which(is.na(match(unique(c(upIndsU2,dnIndsU2)), 
					c(upIndsU12,dnIndsU12))))]
		}
		if("U12" %in% type){
			if(length(which("intron" %in% 
				SummarizedExperiment::rowData(object)[,intExCol]))>0){
				listPlot=c(listPlot, list(U12_introns=
					fcRes[unique(c(upIndsU12, dnIndsU12))]))
			} else {
				listPlot=c(listPlot, list(U12_introns=
					fcRes[unique(u12Ind)]))
			}
		}
		if("U2Up" %in% type)
			listPlot=c(listPlot, list(Upstream_U2_introns=
				fcRes[ upIndsU2[which(is.na(match(upIndsU2, 
					c(upIndsU12,dnIndsU12))))] ]))
		if("U2Dn" %in% type)
			listPlot=c(listPlot, list(Downstream_U2_introns=
				fcRes[ dnIndsU2[which(is.na(match(dnIndsU2, 
					c(upIndsU12,dnIndsU12))))] ]))
		if("U2UpDn" %in% type)
			listPlot=c(listPlot, list(UpDown_stream_U2_introns=
				fcRes[ upDnIndsU2 ]))
		if("U2Rand"%in% type){
			set.seed(randomSeed)
			allExonsInd=which(SummarizedExperiment::rowData(object)[,
				intExCol]=="exon")
			randInd=sample(allExonsInd[ which(is.na(match(allExonsInd, 
				unique(c(u12Ind)) )))], length(u12Ind))
			listPlot=c(listPlot, list(random_U2_introns=fcRes[randInd]))
		}
	}
	# Temporary index variables for correctly assigning lty col, and lwd
	indOrdFull=match(c("U12","U2Up","U2Dn","U2UpDn","U2Rand"), type)
	indOrd=indOrdFull[which(!is.na(indOrdFull))]

	#Index to use for correct order of listPlot 
	#(based on order of type definition)
	indOrd2=1:length(indOrd)
	indOrd2[indOrd]=1:length(indOrd)

	for(i in 1:length(listPlot)){
		if(i==1){
			graphics::plot(stats::density(unlist(listPlot[[i]]), na.rm=TRUE), 
				type='l', lty=lty[indOrd[i]], lwd=lwd[indOrd[i]], 
				col=col[indOrd[i]], main="", xlab=xlab, ...)
		}else{
			graphics::points(stats::density(unlist(listPlot[[i]]), na.rm=TRUE),
				type='l', lty=lty[indOrd[i]], lwd=lwd[indOrd[i]], 
				col=col[indOrd[i]])
		}
	}

	if(plotLegend | length(legend)!=0){
		if(length(legend)==0){
			legendTmp=c("U12 introns", "U2 upstream introns", 
				"U2 downstream introns", "Up/Down stream U2 introns", 
				"Random U2 introns" )
			if(intronExon=="exon")
				legendTmp=c("Exons flanking U12 introns", 
					"Exons flanking upstream U2 introns", 
					"Exons flanking downstream U2 introns", 
					"Exons flanking up/down stream U2 introns", 
					"Exons flanking random U2 introns" )
			names(legendTmp)=c("U12","U2Up","U2Dn","U2UpDn","U2Rand")
			#Index to order the correct legend names
			indOrdLegend=match(type,c("U12","U2Up","U2Dn","U2UpDn","U2Rand"))
			legend=paste(paste(legendTmp[indOrdLegend], unlist(lapply(indOrd2,
				function(tmp)  
					return(length(unlist(listPlot[[tmp]])[
						which(!is.na(unlist(listPlot[[tmp]])))])) )), 
				sep=" (n="), ")", sep="")
		}
		graphics::legend(x=xLegend,y=yLegend, legend=legend, col=col, lty=lty,
			lwd=lwd, cex=cexLegend)
	}


}

u12NbIndex<- function(
	x, intExCol="int_ex", intTypeCol="int_type", strandCol="strand", 
	geneIdCol="collapsed_transcripts", naUnstrand=FALSE) {
	object=x
	dat=SummarizedExperiment::rowData(object)
	minInd=tapply(1:nrow(dat), dat[,geneIdCol], min)
	maxInd=tapply(1:nrow(dat), dat[,geneIdCol], max)
	u12Ind=u12Index(object, intExCol=intExCol, intTypeCol=intTypeCol)
	u12Gen=dat[u12Ind,geneIdCol]
	u12Str=dat[u12Ind,strandCol]
	# Analyzing positive strand first
	upEx=u12Ind-1
	upInt=u12Ind-2
	upInt[upInt<minInd[u12Gen]]=NA
	upEx[upEx<minInd[u12Gen]]=NA
	dnEx=u12Ind+1
	dnInt=u12Ind+2
	dnInt[dnInt>maxInd[u12Gen]]=NA
	dnEx[dnEx>maxInd[u12Gen]]=NA
	#Correcting for minus strand
	upInt[u12Str=="-"]=dnInt[u12Str=="-"]
	upEx[u12Str=="-"]=dnEx[u12Str=="-"]
	# if naUnstrand is FALSE, NA is returned for Unstranded (strand=='*'); 
	#it would be analyzed like '+' strand otherwise
	if(naUnstrand){
			upInt[u12Str=="*"]=NA
			upEx[u12Str=="*"]=NA
			dnInt[u12Str=="*"]=NA
			dnEx[u12Str=="*"]=NA
	}

	# Correct in case intron and exon don't match!
	
	upInt[dat[upInt,intExCol]=="exon" & !is.na(upInt) ]=NA
	upEx[dat[upEx,intExCol]=="intron" & !is.na(upInt)]=NA
	dnInt[dat[dnInt,intExCol]=="exon" & !is.na(dnInt)]=NA
	dnEx[dat[dnEx,intExCol]=="intron" & !is.na(dnInt)]=NA
	
	res=c()
	res$upIntron=upInt
	res$downIntron=dnInt
	res$upExon=upEx
	res$downExon=dnEx
	return(res)
}

u12BoxplotNb<-function(
	x, sampleAnnoCol=2, intExCol="int_ex", intTypeCol="int_type", 
	intronExon, strandCol="strand", geneIdCol, col=c(), names=c(), lasNames=1, 
	outline=FALSE, plotLegend=TRUE, cexLegend=1, xLegend="topright", 
	yLegend=NULL, bgLegend="transparent", legend=c(), addGrid=FALSE, ...)
{
	object=x
	group=as.vector(SummarizedExperiment::colData(object)[,sampleAnnoCol])
	uniGroup=unique(as.vector(group))
	if(length(col)!=1 & length(col)!=length(uniGroup) ){
		stop(paste("Length of col should be either 1 or ",length(uniGroup),
			", i.e. the same length as c('", 
			paste(uniGroup, collapse="','", sep=""), "')", collapse='', 
				sep=""))
	}
	u12NbInd= u12NbIndex(object, intExCol=intExCol, intTypeCol=intTypeCol, 
		strandCol=strandCol, geneIdCol=geneIdCol, naUnstrand=FALSE)
	u12Ind=u12Index(object, intExCol=intExCol, intTypeCol=intTypeCol)
	datFpkm=scaledRetention(object)
	if(length(col)==1){
		col=rep(col,length(uniGroup))
	}
	if(length(col)>1)
		names(col)=uniGroup	
	upPlot=c()
	u12Plot=c()
	dnPlot=c()
	updnPlot=c()
	upIntType=SummarizedExperiment::rowData(object)[u12NbInd$upIntron, 
		intTypeCol]
	dnIntType=SummarizedExperiment::rowData(object)[u12NbInd$downIntron, 
		intTypeCol]
	for(cnt in 1:ncol(datFpkm)){
		if(intronExon=="intron"){
			upTmp=datFpkm[u12NbInd$upIntron,cnt]
			dnTmp=datFpkm[u12NbInd$downIntron,cnt]
			upTmp[upIntType=="U12"]=NA
			dnTmp[dnIntType=="U12"]=NA
			upPlot=c(upPlot, list(upTmp))
			u12Plot=c(u12Plot, list(datFpkm[u12Ind,cnt]))
			dnPlot=c(dnPlot, list(dnTmp))
			updnPlot=c(updnPlot, list(c(upTmp,dnTmp)))
		} else if(intronExon=="exon"){
			#Fix for strand
			upIndU2Tmp1=u12NbInd$upExon-1
			upIndU2Tmp2=u12NbInd$upExon-2
			upIndU2Tmp1[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$upExon[u12NbInd$upExon>u12NbInd$downExon]+1
			upIndU2Tmp2[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$upExon[u12NbInd$upExon>u12NbInd$downExon]+2
			dnIndU2Tmp1=u12NbInd$downExon+1
			dnIndU2Tmp2=u12NbInd$downExon+2
			dnIndU2Tmp1[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$downExon[u12NbInd$upExon>u12NbInd$downExon]-1
			dnIndU2Tmp2[u12NbInd$upExon>u12NbInd$downExon]=
				u12NbInd$downExon[u12NbInd$upExon>u12NbInd$downExon]-2

			upIndsU2=unique(c(upIndU2Tmp1, upIndU2Tmp2))
			dnIndsU2=unique(c(dnIndU2Tmp1, dnIndU2Tmp1))
			upIndsU12=u12NbInd$upExon
			dnIndsU12=u12NbInd$downExon
			upIndsU2=unique(upIndsU2[which(!is.na(upIndsU2))])
			dnIndsU2=unique(dnIndsU2[which(!is.na(dnIndsU2))])
			upIndsU12=unique(upIndsU12[which(!is.na(upIndsU12))])
			dnIndsU12=unique(dnIndsU12[which(!is.na(dnIndsU12))])
			upTmp= datFpkm[upIndsU2[which(is.na(match(upIndsU2, 
				c(upIndsU12,dnIndsU12))))], cnt]
			dnTmp= datFpkm[dnIndsU2[which(is.na(match(dnIndsU2, 
				c(upIndsU12,dnIndsU12))))], cnt]
			upPlot= c(upPlot, list(upTmp))
			u12Plot= c(u12Plot, 
				list(datFpkm[unique(c(upIndsU12, dnIndsU12)),cnt]))
			dnPlot=c(dnPlot, list(dnTmp))
			updnPlot=c(updnPlot, list(c(upTmp,dnTmp)))			
		}else {
			msg<- 
'The intronExon parameter should be defined and set to either "intron" for 
plotting intron retention levels or "exon" for plotting exon-exon junction 
levels.'
			stop(msg)
		}
	}
	
	color=c(as.vector(col[group]), NA)
	
	strand=SummarizedExperiment::rowData(object)[u12Ind, strandCol]
# If all strands are * plot introns up- and down-stream U12 introns together
	if(length(which(unique(strand)=="*"))==1 & length(unique(strand))==1){
		typePlot=2
		plotList=c(updnPlot,list(NA),u12Plot)
	} else {
		typePlot=1
		plotList=c(upPlot,list(NA),u12Plot,list(NA),dnPlot)
	}
	if(typePlot==1){
		graphics::boxplot(plotList, names=c(), xaxt = "n", outline=outline, 
			col=color, ...)
		axisAt=seq(from= trunc((length(plotList)-2)/6), 
			by=trunc((length(plotList)-2)/3)+1, length.out=3)
		graphics::axis(1 ,at=axisAt, labels=c("Upstream U2 intron", 
			"U12 intron", "Downstream U2 intron"), las=lasNames, ...)
		if(addGrid){
			graphics::grid(nx=NA, ny=NULL)
			graphics::boxplot(plotList, names=c(), xaxt = "n", yaxt="n",
				outline=outline, col=color, add=TRUE)	
		}
		if(plotLegend)
			graphics::legend(x=xLegend,y=yLegend, legend=uniGroup, fill=col, 
				cex=cexLegend, bg=bgLegend)
	} else if(typePlot==2){
		graphics::boxplot(plotList, names=c(), xaxt = "n", outline=outline, 
			col=color, ...)
		axisAt=seq(from= trunc((length(plotList)-1)/4), 
			by=trunc((length(plotList)-1)/2)+1, length.out=2)
		graphics::axis(1 ,at=axisAt, 
			labels=c("(Up/Down)stream U2 intron", "U12 intron"), las=lasNames, 
			...)

		if(addGrid){
			graphics::grid(nx=NA, ny=NULL)
			graphics::boxplot(plotList, names=c(), xaxt = "n", yaxt="n", 
				outline=outline, col=color, add=TRUE)	
		}
		if(length(legend)==0 & plotLegend)
			legend=uniGroup
		if(plotLegend)
			graphics::legend(x=xLegend,y=yLegend, legend=legend, 
				fill=unique(color), cex=cexLegend, bg=bgLegend)
	}

}

qlfInterest<-function(x, design=c(), silent=TRUE, disp="common", coef=c(),
	contrast=NULL, poisson.bound=TRUE, ...){
	y=counts(x)
	if(length(design)==0){
		stop('Please provide a suitable design.')
	}
	
	if(disp=="tagwiseInitCommon" & length(disp)==1){
		yDisp <- edgeR::estimateGLMTagwiseDisp(y,design, 
			dispersion=edgeR::estimateGLMTrendedDisp(y,design))
		dispersionType=disp
	} else if(disp=="tagwiseInitTrended" & length(disp)==1){
		yDisp <- edgeR::estimateGLMTagwiseDisp(y,design, 
			dispersion=edgeR::estimateGLMCommonDisp(y,design))
		dispersionType=disp
	} else if(disp=="trended"& length(disp)==1){
		yDisp <- edgeR::estimateGLMTrendedDisp(y,design)
		dispersionType=disp
	} else if(disp=="common"& length(disp)==1){
		yDisp <- edgeR::estimateGLMCommonDisp(y,design)
		dispersionType=disp
	} else if(is.numeric(disp)){
		dispersionType="manualSet"
	}  else{
		msg<-
'Argument disp should be either "common", "trended", "tagwiseInitCommon", 
"tagwiseInitTrended" or a number.'
		stop(msg)
	}

	fit <- edgeR::glmQLFit(y, design, dispersion=yDisp, ...)
	if(length(coef)==0)
		coef=ncol(fit$design)
	res <- edgeR::glmQLFTest(fit, coef=coef, contrast, 
		poisson.bound=poisson.bound)
	if(!silent)
		print(edgeR::topTags(res))
	res$dispersionType=dispersionType
	res$dispersion=yDisp
	return(res)
}

readInterestResults<-function(resultFiles, sampleNames, sampleAnnotation, 
	commonColumns, freqCol, scaledRetentionCol, scaleLength, scaleFragment, 
	reScale=FALSE, geneIdCol, repeatsTableToFilter=c()){	
	readFreqColIndex=c()
	scaledRetentionColIndex=c()

	for(i in 1:length(resultFiles)){
		cat("\nReading file", i, "/", length(resultFiles), ":",  
			resultFiles[i], "\n", sep=" ")
		tmpDat=read.table(resultFiles[i], header=TRUE, stringsAsFactors=FALSE,
			sep='\t')
		if(i==1){
			ref=tmpDat[,commonColumns]
			res=ref
		}
		if(freqCol<=ncol(tmpDat))
			res=cbind(res, as.numeric(tmpDat[,freqCol]))
		if(scaledRetentionCol<=ncol(tmpDat))
			res=cbind(res, as.numeric(tmpDat[,scaledRetentionCol]))
		readFreqColIndex=c(readFreqColIndex, (ncol(res)-1))
		scaledRetentionColIndex=c(scaledRetentionColIndex, ncol(res))
		colnames(res)[(ncol(res)-1):ncol(res)]=paste(sampleNames[i], 
			c("frequency", "scaledRetention"), sep="_")
		if(reScale){
			FPKM=res[,ncol(res)-1]

			if(scaleFragment){
				referenceGeneNamesTmp=as.character(ref[ , geneIdCol])
				geneCnt=tapply(FPKM, referenceGeneNamesTmp, sum)
				FPKM=((10^6)*FPKM)/
					(as.numeric(geneCnt[referenceGeneNamesTmp])+1)
			}
			if(scaleLength){
				if(i==1)
					lenRef=correctLengthRepeat(ref, repeatsTableToFilter)
				FPKM=((10^3)*FPKM)/lenRef

			}
			res[,ncol(res)]=FPKM
		}
	}
	if(!missing(sampleAnnotation)){
		if(is.vector(sampleAnnotation))
			sampleAnnotation=data.frame(sampleGroup=sampleAnnotation)
		rownames(sampleAnnotation)=sampleNames

		readFrq<-as.matrix(res[,readFreqColIndex])
		scaledRet<-as.matrix(res[,scaledRetentionColIndex])
		colnames(readFrq)<-sampleNames
		colnames(scaledRet)<-sampleNames
		resObj=InterestResult(
			resultFiles=resultFiles,
			counts=readFrq,
			scaledRetention=scaledRet,
			sampleAnnotation=sampleAnnotation,
			rowData=ref,
			scaleLength=scaleLength, 
			scaleFragment=scaleFragment)
	} else {

		readFrq<-as.matrix(res[,readFreqColIndex])
		scaledRet<-as.matrix(res[,scaledRetentionColIndex])
		colnames(readFrq)<-c()
		colnames(scaledRet)<-c()
		resObj=InterestResult(
			resultFiles=resultFiles,
			counts=readFrq,
			scaledRetention=scaledRet,
			rowData=ref,
			scaleLength=scaleLength, 
			scaleFragment=scaleFragment)

	}

	return(resObj)
}

referencePrepare <-
function( outFileTranscriptsAnnotation="",
	annotateGeneIds=TRUE, 
	u12IntronsChr=c(), u12IntronsBeg=c(), u12IntronsEnd=c(),
	u12IntronsRef,
	collapseExons=TRUE, sourceBuild="UCSC", ucscGenome="hg19",
	ucscTableName="knownGene",
	ucscUrl="http://genome-euro.ucsc.edu/cgi-bin/",
	biomart="ENSEMBL_MART_ENSEMBL",
	biomartDataset="hsapiens_gene_ensembl",
	biomartTranscriptIds=NULL, biomartExtraFilters=NULL,
	biomartIdPrefix="ensembl_", biomartHost="www.ensembl.org",
	biomartPort=80, circSeqs="", taxonomyId=NA,
	filePath="", fileFormat=c("auto", "gff3", "gtf"), fileDatSrc=NA,
	fileOrganism=NA, fileChrInf=NULL, 
	fileDbXrefTag=c(), addCollapsedTranscripts=TRUE, 
	ignore.strand=FALSE)
{

	if(circSeqs[1]=="")
		circSeqs<- NULL
#		circSeqs=GenomicFeatures::DEFAULT_CIRC_SEQS

	if(sourceBuild=="UCSC"){
		human.txdb <- txdbmaker::makeTxDbFromUCSC(genome=ucscGenome,
			tablename=ucscTableName, circ_seqs=circSeqs, url=ucscUrl,
			taxonomyId=taxonomyId)
	} else if (sourceBuild=="biomaRt"){
		human.txdb <- txdbmaker::makeTxDbFromBiomart(biomart=biomart,
			dataset=biomartDataset,
			transcript_ids=biomartTranscriptIds,
			circ_seqs=circSeqs,
			filter=biomartExtraFilters,
			id_prefix=biomartIdPrefix,
			host=biomartHost,
			port=biomartPort,
			taxonomyId=taxonomyId)
	}else if (sourceBuild=="file"){
		if(length(fileDbXrefTag)==0){
			human.txdb <- txdbmaker::makeTxDbFromGFF(file=filePath,
				format=fileFormat,
				dataSource=fileDatSrc, organism=fileOrganism,
				taxonomyId=taxonomyId,
				circ_seqs=circSeqs, chrominfo=fileChrInf)
		} else {
			human.txdb <- txdbmaker::makeTxDbFromGFF(file=filePath,
				format=fileFormat, 
				dataSource=fileDatSrc, organism=fileOrganism, 
				taxonomyId=taxonomyId, 
				circ_seqs=circSeqs, chrominfo=fileChrInf, 
				dbxrefTag=fileDbXrefTag)
		}
	}

	exons<- GenomicFeatures::exonsBy(human.txdb, by="tx", use.names=TRUE)
	namesExons=names(exons)


	time1=Sys.time()

	if(!ignore.strand){
	  strandsEx=as.character(GenomicRanges::strand(unlist(exons)))
	  exonsGR=GenomicRanges::GRanges( 
	    seqnames=as.character(GenomicRanges::seqnames(unlist(exons))), 
	    IRanges::IRanges(
	      start=as.numeric(GenomicRanges::start(unlist(exons))) , 
	      end=as.numeric(GenomicRanges::end(unlist(exons))) ),
	    strand=strandsEx)
	} else {
	  exonsGR=GenomicRanges::GRanges( 
	    seqnames=as.character(GenomicRanges::seqnames(unlist(exons))), 
	    IRanges::IRanges(
	      start=as.numeric(GenomicRanges::start(unlist(exons))) , 
	      end=as.numeric(GenomicRanges::end(unlist(exons))) ))
	}
	
	if (collapseExons){
		genMat=matrix(as.vector(unlist(sapply(exons,function(tmp)
			return(  c((as.character(GenomicRanges::seqnames(tmp)))[1], 
				as.numeric(GenomicRanges::start(tmp))[1], 
				as.numeric(GenomicRanges::width(tmp))[1], 
				utils::tail(as.numeric(GenomicRanges::start(tmp)),n=1), 
				utils::tail(as.numeric(GenomicRanges::width(tmp)),n=1), 
				as.character(GenomicRanges::strand(tmp))[1]  ))))), 
			byrow=TRUE, ncol=6)
	
		genBegs= as.numeric(as.numeric(genMat[,2]))
		genBegs[genMat[,6]=="-"]= 
			as.numeric(as.numeric(genMat[genMat[,6]=="-",4]))
		genEnds= (as.numeric(genMat[,4])+as.numeric(genMat[,5])-1)
		genEnds[genMat[,6]=="-"]= as.numeric(genMat[genMat[,6]=="-",2])+
			as.numeric(genMat[genMat[,6]=="-",3])-1
	
		genGr=GenomicRanges::GRanges( seqnames=genMat[,1], 
			IRanges::IRanges(start=genBegs , end=genEnds ), strand=genMat[,6])
	
		reduceExGr=GenomicRanges::reduce(exonsGR, ignore.strand=ignore.strand)
		intronsGr=GenomicRanges::gaps(reduceExGr)

		reduceGenGr=GenomicRanges::reduce(genGr, ignore.strand=ignore.strand)
	
		hitsEx= GenomicRanges::findOverlaps(reduceExGr, reduceGenGr, 
			type="any", ignore.strand=ignore.strand)
		hitsInt= GenomicRanges::findOverlaps(intronsGr, reduceGenGr, 
			type="any", ignore.strand=ignore.strand)

		genesExMap=tapply(S4Vectors::queryHits(hitsEx), 
			S4Vectors::subjectHits(hitsEx), unique)
		genesIntMap=tapply(S4Vectors::queryHits(hitsInt), 
			S4Vectors::subjectHits(hitsInt), unique)

		lenGenesExMap=sapply(genesExMap,length)
		multiEx=names(genesExMap[lenGenesExMap>1])
		singleEx=names(genesExMap[lenGenesExMap==1])

		allEx=names(genesExMap)
		matOutVecTmp=lapply(allEx, function(tmp){ 
			genExUnl=unlist(genesExMap[tmp])
			genIntUnl=unlist(genesIntMap[tmp])

			if(length(genIntUnl)>0){
				res=as.vector(c( 
					as.character(GenomicRanges::seqnames(reduceExGr)[
						genExUnl]),
					as.character(GenomicRanges::seqnames(intronsGr)[
						genIntUnl]),
					as.numeric(GenomicRanges::start(reduceExGr))[genExUnl],
					as.numeric(GenomicRanges::start(intronsGr))[genIntUnl],
					as.numeric(GenomicRanges::end(reduceExGr))[genExUnl],
					as.numeric(GenomicRanges::end(intronsGr))[genIntUnl],
					as.character(GenomicRanges::strand(reduceExGr))[genExUnl],
					as.character(GenomicRanges::strand(intronsGr))[genIntUnl],
					rep("exon",length(genExUnl)),
					rep("intron",length(genIntUnl)),
					seq(from=1, by=2, length.out=length(genExUnl)),
					seq(from=2, by=2, length.out=length(genIntUnl)),
					rep(tmp,length(genIntUnl)+ length(genExUnl))))
			} else {
				res= as.vector(c( 
					as.character(GenomicRanges::seqnames(reduceExGr)[
						genExUnl]),
					as.numeric(GenomicRanges::start(reduceExGr))[genExUnl],
					as.numeric(GenomicRanges::end(reduceExGr))[genExUnl],
					as.character(GenomicRanges::strand(reduceExGr))[genExUnl],
					rep("exon",length(genExUnl)),
					seq(from=1, by=2, length.out=length(genExUnl)), 
					rep(tmp,length(genExUnl))))
			}
			return( res )
		} )
	
		matOut=  data.frame(
			chr=as.character(unlist(sapply(matOutVecTmp, function(tmp) 
				return( (tmp[1:(length(tmp)/7)]) ) ) )) ,
			begin=as.numeric(unlist(sapply(matOutVecTmp, function(tmp) 
				return( (tmp[1*(length(tmp)/7)+(1:(length(tmp)/7))])[
					order(as.numeric(tmp[5*(length(tmp)/7)+
						(1:(length(tmp)/7))]),decreasing=FALSE)] ) ) )),
			end=as.numeric(unlist(sapply(matOutVecTmp, function(tmp) 
				return( (tmp[2*(length(tmp)/7)+(1:(length(tmp)/7))])[
					order(as.numeric(tmp[5*(length(tmp)/7)+
						(1:(length(tmp)/7))]),decreasing=FALSE)] ) ) )),
			strand=as.character(unlist(sapply(matOutVecTmp, function(tmp) 
				return( (tmp[3*(length(tmp)/7)+(1:(length(tmp)/7))]) ) ) )),
			int_ex=as.character(unlist(sapply(matOutVecTmp, function(tmp) 
				return( (tmp[4*(length(tmp)/7)+(1:(length(tmp)/7))])[
					order(as.numeric(tmp[5*(length(tmp)/7)+
						(1:(length(tmp)/7))]),decreasing=FALSE)] ) ))),
			int_ex_num=as.numeric(unlist(sapply(matOutVecTmp, function(tmp) 
				return( (tmp[5*(length(tmp)/7)+(1:(length(tmp)/7))])[
					order(as.numeric(tmp[5*(length(tmp)/7)+
						(1:(length(tmp)/7))]),decreasing=FALSE)] ) ))),
			collapsed_transcripts_id=as.numeric(unlist(sapply(matOutVecTmp, 
				function(tmp) 
					return( (tmp[6*(length(tmp)/7)+(1:(length(tmp)/7))]) ) ) 
						)),
			stringsAsFactors=FALSE)

		hitsGenToColl= GenomicRanges::findOverlaps(genGr,reduceGenGr, 
			type="any", ignore.strand=FALSE)
#Annotate collapsed transcripts
		trAnnoCollList=lapply(
			as.numeric(unique(matOut[,"collapsed_transcripts_id"])), 
			function(tmp) 
				namesExons[S4Vectors::queryHits(hitsGenToColl)[
					S4Vectors::subjectHits(hitsGenToColl)==tmp]])
		trAnnoColl=sapply(trAnnoCollList, function(tmp) paste(tmp, 
			collapse=','))
		names(trAnnoColl)= 
			as.character(unique(matOut[,"collapsed_transcripts_id"]))
	
		if(addCollapsedTranscripts)
			matOut$collapsed_transcripts=
				trAnnoColl[as.character(matOut[,"collapsed_transcripts_id"])]

		if(annotateGeneIds){
			trGenesTx<- GenomicFeatures::transcriptsBy(human.txdb, by="gene")
			if(length(trGenesTx)>0){
				trGenesVec=unlist(lapply(1:length(trGenesTx), function(tmp)
					paste(names(trGenesTx)[tmp], 
						trGenesTx[[tmp]]$tx_name,sep=",")))
				trGenes=unlist(strsplit(trGenesVec,split=","))[
					seq(from=1,by=2,length.out=length(trGenesVec))]
				names(trGenes)=unlist(strsplit(trGenesVec,split=","))[
					seq(from=2,by=2,length.out=length(trGenesVec))]
	
				gene_ids= unlist(sapply(trAnnoCollList, function(tmp)
					paste(unique(trGenes[tmp]), collapse=',')))
				names(gene_ids)= 
					as.character(unique(matOut[,"collapsed_transcripts_id"]))
				matOut$collapsed_gene_id=
					gene_ids[as.character(matOut[,"collapsed_transcripts_id"])]
			} else{
				warning("Gene annotations were NOT available !")
				annotateGeneIds=FALSE
			}
		}

		if(outFileTranscriptsAnnotation!=""){
			if(!annotateGeneIds){
				write.table(cbind(names(trAnnoColl),as.vector(trAnnoColl)), 
					outFileTranscriptsAnnotation, sep='\t', quote=FALSE, 
					col.names=c("id", "collapsed_transcripts"), 
					row.names=FALSE)
			} else {
				write.table(cbind(names(trAnnoColl),as.vector(trAnnoColl), 
					trGenes[as.vector(trAnnoColl)]),
					outFileTranscriptsAnnotation, sep='\t', quote=FALSE, 
					col.names=c("id", "collapsed_transcripts", "gene_id"), 
					row.names=FALSE)
			}
		}


	} else {
		introns <- GenomicFeatures::intronsByTranscript(human.txdb, 
			use.names=TRUE)
		
		if(ignore.strand){
			strMat=rep("*", 
				length(as.character(GenomicRanges::seqnames(unlist(exons))))+ 
				length(as.character(GenomicRanges::seqnames(unlist(introns)))))
		} else {
			strMat<- c(as.character(GenomicRanges::strand(unlist(exons))), 
				as.character(GenomicRanges::strand(unlist(introns))))
		}

		chrEx<- as.character(GenomicRanges::seqnames(unlist(exons)))
		chrInt<- as.character(GenomicRanges::seqnames(unlist(introns)))		
		stEx<- as.numeric(GenomicRanges::start(unlist(exons)))
		stInt<- as.numeric(GenomicRanges::start(unlist(introns)))
		endEx<- as.numeric(GenomicRanges::end(unlist(exons)))
		endInt<- as.numeric(GenomicRanges::end(unlist(introns)))
		noEx<- as.vector(unlist(lapply(1:length(exons), function(tmp) 
				return(seq(from=1, by=2, 
					length.out=length(exons[[tmp]]))))))
		noInt<- as.vector(unlist(lapply(1:length(introns), function(tmp) 
				return(seq(from=2, by=2, 
					length.out=length(introns[[tmp]]))))))

		exInt<- c(rep("exon",length(unlist(exons))), 
			rep("intron",length(unlist(introns))))
		genNames<- c(names(unlist(exons)), names(unlist(introns)))
		matTmp<- data.frame(chr=c(chrEx,chrInt), 
			begin=c(stEx,stInt),
			end=c(endEx,endInt),
			strand=strMat,
			int_ex_num=c(noEx,noInt),
			int_ex= exInt,
			transcript_id=genNames
			)
	
		matInd= unlist(tapply(1:nrow(matTmp), as.character(matTmp[,7]), 
			function(tmp)return( tmp[order(as.numeric(matTmp[tmp,5]), 
				decreasing=FALSE)] )))
		matOutTmp= data.frame(
			chr=as.character(matTmp[,1]),
			begin=as.numeric(matTmp[,2]), 
			end=as.numeric(matTmp[,3]), 
			strand=as.character(matTmp[,4]),
			int_ex_num=as.numeric(matTmp[,5]), 
			int_ex=as.character(matTmp[,6]), 
			transcript_id=as.character(matTmp[,7]), 
			stringsAsFactors=FALSE)[matInd,]

		matOut=matOutTmp
		
		if(annotateGeneIds){
			trGenesTx<- GenomicFeatures::transcriptsBy(human.txdb, by="gene")
			if(length(trGenesTx)>0){
				trGenesVec= unlist(lapply(1:length(trGenesTx), function(tmp)
					paste(names(trGenesTx)[tmp], trGenesTx[[tmp]]$tx_name,
						sep=",")))

				trGenes= unlist(strsplit(trGenesVec,split=","))[
					seq(from=1,by=2,length.out=length(trGenesVec))]
				names(trGenes)= unlist(strsplit(trGenesVec,split=","))[
					seq(from=2,by=2,length.out=length(trGenesVec))]
	
				matOut$gene_id= trGenes[as.character(matOut[,"transcript_id"])]
	
				if(outFileTranscriptsAnnotation!="")
					write.table(cbind(names(trGenes),as.vector(trGenes)), 
						outFileTranscriptsAnnotation, sep='\t', quote=FALSE, 
						col.names=c("transcript_id", "collapsed_transcripts"), 
						row.names=FALSE)
			} else {
				warning("Gene annotations were NOT available !")
				annotateGeneIds<-FALSE
			}

		}
#end else
	}

	#if(sourceBuild=="biomaRt")
	#	matOut[,"chr"]=paste("chr",matOut[,"chr"],sep="")

	if( ( (length(u12IntronsChr)>0 & length(u12IntronsBeg)>0 & 
		length(u12IntronsEnd)>0)|(!missing(u12IntronsRef)) ) ){
		matOutGr= GenomicRanges::GRanges( seqnames=matOut[,"chr"], 
			IRanges::IRanges(start=matOut[,"begin"] , end=matOut[,"end"] ))
		if(missing(u12IntronsRef)){
			u12IntGr= GenomicRanges::GRanges( seqnames=u12IntronsChr, 
				IRanges::IRanges(start=u12IntronsBeg , end=u12IntronsEnd ))
		} else {
			u12IntGr=u12IntronsRef
		}
		hitsU12Intron= GenomicRanges::findOverlaps(u12IntGr, matOutGr, 
			type="equal")
		matOut$int_type= rep(NA, nrow(matOut))
		matOut$int_type[matOut[,"int_ex"]=="intron"]= "U2"
		matOut$int_type[unique(S4Vectors::subjectHits(hitsU12Intron))]= "U12"
	}

	if(!ignore.strand & collapseExons){
			matOutTrGr=GenomicRanges::GRanges( seqnames=tapply(as.character(
					matOut[,"chr"]),
				matOut[,"collapsed_transcripts_id"],head, n=1), 
				IRanges::IRanges(start=tapply(as.numeric(matOut[,"begin"]),
					matOut[,"collapsed_transcripts_id"],min) ,
					end=tapply(as.numeric(matOut[,"end"]),
						matOut[,"collapsed_transcripts_id"],max) ), 
				strand= tapply(as.character(
				  matOut[,"strand"]),
				  matOut[,"collapsed_transcripts_id"],head, n=1))
			namesMatOutTrGr=unique(matOut[,"collapsed_transcripts_id"])
		hitsExMat= GenomicRanges::findOverlaps(exonsGR, matOutTrGr, 
			type="any", ignore.strand=ignore.strand)
		strTmp=tapply(strandsEx[S4Vectors::queryHits(hitsExMat)], 
			namesMatOutTrGr[S4Vectors::subjectHits(hitsExMat)], unique)
		strTmpVec=sapply(strTmp, function(tmp){
			if(length(tmp)==1){
				return(as.character(tmp))	
			} else {
				return("*")
			}	
		})
		names(strTmpVec)= names(strTmp)
		matStr=strTmpVec[as.character(matOut[,"collapsed_transcripts_id"])]
		matOut$strand=matStr
	}
	return(matOut)
}

subInterestResult<-function(x, selectRow, selectCol, 
	sampleAnnoCol, sampleAnnotation=c()){
	if(!missing(selectRow))
		tmpObj<-x[selectRow,]
	sampleTF=rep(TRUE, ncol(x))
	if(!missing(selectCol)){
		sampleTF<-rep(FALSE, ncol(x))
		sampleTF[selectCol]<- TRUE
	}
	if(!missing(sampleAnnoCol)){
		sampleTF<-sampleTF & !is.na(match(
			SummarizedExperiment::colData(x)[,sampleAnnoCol], 
				sampleAnnotation))
	}
	res<-tmpObj[,sampleTF]
	return(res)
}

interestIntExAnalysePairStranded <- function(
	readTmp,
	reference,
	maxNoMappedReads,
	logFile,
	method,
	appendLogFile,
	repeatsTableToFilter,
	referenceIntronExon,
	junctionReadsOnly,
	limitRanges,
	strandSpecific,
	excludeFusionReads){
  
  revStr<- c("-", "+", "*")
  names(revStr)<- c("+", "-", "*") 
  qNam<- as.data.frame(GenomicAlignments::first(readTmp))[1,"qname"]
  if(logFile!="")
  	cat( "start ", 
  	   qNam, "\n",
  		file=logFile, append=appendLogFile)
  cat( "start ", 
       qNam, "\n")
  
  if(length(limitRanges)>0){
    
    readTmpFirst<- GenomicAlignments::first(readTmp)
    readTmpSecond<- GenomicAlignments::second(readTmp)

    
    r1Map<- GenomicRanges::findOverlaps(
      readTmpFirst, 
      limitRanges,
      type= "within",
      ignore.strand= FALSE)
    r2Map<- GenomicRanges::findOverlaps(
      readTmpSecond, 
      limitRanges,
      type= "within",
      ignore.strand= FALSE)
    
    filLimInd<- sort(unique(intersect(S4Vectors::queryHits(r1Map),
                                      S4Vectors::queryHits(r2Map))), 
                     decreasing=FALSE)
    filExtra<- c()
    if(excludeFusionReads){
      r1LimReads<- tapply(queryHits(r1Map),subjectHits(r1Map),  unique)
      r2LimReads<- tapply(queryHits(r2Map),subjectHits(r2Map),  unique)
      commonSubjects<- intersect(names(r1LimReads), names(r2LimReads))
      filExtraTmp<- lapply(commonSubjects, 
                           function(x) return (
                             intersect(r1LimReads[[x]], r2LimReads[[x]])
                             ))
      filExtra<-  unique(unlist(filExtraTmp))
      if(length(filExtra[which(!is.na(filExtra))])>0)
        filLimInd<- intersect(filLimInd, filExtra)
    }
    readTmp<- readTmp[filLimInd,]
  }
  
  filStrandInd<-which ( xor(
    (as.data.frame(GenomicAlignments::first(readTmp))[,"strand"]=="+") , 
    (as.data.frame(GenomicAlignments::second(readTmp))[,"strand"]=="+") ))
  readTmp<- readTmp[filStrandInd,]
  
	sam1<- as.data.frame(GenomicAlignments::first(readTmp))[,
		c("qname", "rname", "strand", "pos", "qual", "cigar")]
	sam2<- as.data.frame(GenomicAlignments::second(readTmp))[,
		c("qname", "rname", "strand", "pos", "qual", "cigar")]
	colnames(sam1)<- c("qName","rName","strand","pos","qual",
		"cigar")
	colnames(sam2)<- c("qName","rName","strand","pos","qual",
		"cigar")
	# if(logFile!="")
	# 	cat( "Analyzing paired reads, ID: ", sam1[1,"qName"], "\n", 
	# 		file=logFile, append=appendLogFile)
	# cat( "Analyzing paired reads, ID: ", sam1[1,"qName"], "\n")
######
######!!!
	exExRes<- c()
	intRetRes<- c()
	intSpanRes<- c()
	exSkipRes<- c()
  if(length(readTmp)>0)	{
  	if( length(which(method %in% c("IntRet","ExEx")))>0 ){ 
  ######!!!
  ######
  		lenRead1= unlist(lapply(sam1$cigar, function(tmp) {
  			frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  			names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  				unlist(strsplit(tmp,split="")))]
  			return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  		}))
  		lenRead2= unlist(lapply(sam2$cigar, function(tmp) {
  			frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  			names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  				unlist(strsplit(tmp,split="")))]
  			return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))
  		}))
  		locRead1=sam1[,"pos"]
  		chrRead1=sam1[,"rName"]
  		strRead1=sam1[,"strand"]
  		chrRead2=sam2[,"rName"]
  		locRead2=sam2[,"pos"]
  		strRead2=sam2[,"strand"]
  		if(strandSpecific=="stranded"){
  		  strAdj1<- as.character(strRead1)
  		  strAdj2<- as.character(revStr[strRead2])
  		} else if (strandSpecific=="reverse"){
  		  strAdj2<- as.character(strRead2)
  		  strAdj1<- as.character(revStr[strRead1])
  		}
  		
  		frqEventRead1<- lapply(1:length(sam1$cigar), function (tmp) {
  			frqEventTmp= as.numeric(unlist(strsplit(sam1$cigar[tmp],
  				split="[A-Z]")))
  			names(frqEventTmp)= unlist(strsplit(sam1$cigar[tmp], 
  				split=""))[grep('[A-Z]', unlist(strsplit(sam1$cigar[tmp]
  					,split="")))]
  			frqEventTmp=frqEventTmp[!is.na(match(names(frqEventTmp),
  				c("N","D","M")))]
  
  	# Finding start and end of the mapped pieces of the reads using cigar 
  			eventTmp<- c(locRead1[tmp], locRead1[tmp]+
  				cumsum(as.numeric(frqEventTmp)))
  			begEventTmp<-eventTmp[-length(eventTmp)]
  			endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  
  			frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			return( list(readNo=rep(tmp,length(frqEventTmpM)), 
  				chr=rep(chrRead1[tmp],length(frqEventTmpM)), 
  				frqEventTmpM, begEventTmpM, endEventTmpM, 
  				str=rep(strRead1[tmp],length(frqEventTmpM))) )
  	
  		})
  	
  		frqEventRead2<- lapply(1:length(sam2$cigar), function (tmp) {
  			frqEventTmp= as.numeric(unlist(strsplit(sam2$cigar[tmp],
  				split="[A-Z]")))
  			names(frqEventTmp)= unlist(strsplit(sam2$cigar[tmp], 
  				split=""))[grep('[A-Z]', unlist(strsplit(sam2$cigar[tmp]
  				, split="")))]
  			frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  				c("N","D","M")))]
  	# Finding start and end of the mapped pieces of the reads using cigar 
  			eventTmp<- c(locRead2[tmp], locRead2[tmp]+
  				cumsum(as.numeric(frqEventTmp)))
  			begEventTmp<-eventTmp[-length(eventTmp)]
  			endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  
  			frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			return(list(readNo=rep(tmp,length(frqEventTmpM)), 
  				chr=rep(chrRead2[tmp],length(frqEventTmpM)), 
  				frqEventTmpM, begEventTmpM, endEventTmpM, 
  				str=rep(strRead2[tmp],length(frqEventTmpM))))
  		})
  
  		noRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[1]]))))
  		chrRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			as.character(unlist(tmp[[2]])))))
  		begRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[4]]))))
  		endRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[5]]))))
  		strRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  		  as.character(unlist(tmp[[6]])))))
  		noRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  			unlist(tmp[[1]]))))
  		chrRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  			as.character(unlist(tmp[[2]])))))
  		begRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  			unlist(tmp[[4]]))))
  		endRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  			unlist(tmp[[5]]))))
  		strRead2=as.vector(unlist(sapply(frqEventRead2, function(tmp)
  		  as.character(unlist(tmp[[6]])))))
  		
  		if(strandSpecific=="stranded"){
  		  strAdj1<- as.character(strRead1)
  		  strAdj2<- as.character(revStr[strRead2])
  		} else if (strandSpecific=="reverse"){
  		  strAdj2<- as.character(strRead2)
  		  strAdj1<- as.character(revStr[strRead1])
  		}
  		
  		noVec=c(noRead1,noRead2)
  		chrVec=c(as.character(chrRead1),
  			as.character(chrRead2))
  		begVec=c(begRead1,begRead2)
  		endVec=c(endRead1,endRead2)
  		strVec=c(as.character(strAdj1),
  		         as.character(strAdj2))
  
  		methodNo=which(method=="ExEx")
  		if(length(methodNo)>0){
  			ref=reference[which(referenceIntronExon=="exon"),]
  			
  			#if(strandSpecific%in%c("stranded","reverse")){
  			# FOR READ1
  			read1GRanges=GenomicRanges::GRanges( seqnames=chrRead1, 
  				IRanges::IRanges(start=begRead1, end=endRead1), strand=strAdj1)
  			refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  				IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"], 
  					width=ref[,"end"]-ref[,"begin"]+1), strand=ref[,"strand"])
  			
  			if(logFile!="")
  			  cat( "Part1 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			
  			
  			hits1_1 <- GenomicRanges::findOverlaps(read1GRanges, refGRanges, 
  				type= "start", ignore.strand=FALSE)
  			
  			if(logFile!="")
  			  cat( "Part2 ",qNam, "\n",
  			       file=logFile, append=appendLogFile)
  			
  			hits1_2 <- GenomicRanges::findOverlaps(read1GRanges, refGRanges, 
  				type= "end", ignore.strand=FALSE)
  			
  			if(logFile!="")
  			  cat( "Part3 ",qNam, "\n",
  			       file=logFile, append=appendLogFile)
  			
  			hits1_3 <- GenomicRanges::findOverlaps(read1GRanges, refGRanges, 
  				type= "equal", ignore.strand=FALSE)
  			
  			if(logFile!="")
  			  cat( "Part4 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			# FOR READ2
  			
  			read2GRanges=GenomicRanges::GRanges( seqnames=chrRead2, 
  			  IRanges::IRanges(start=begRead2, 
  			    end=endRead2), 
  			  strand=strAdj2)
  			refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  			  IRanges::IRanges(start=ref[,"begin"], 
  			    end=ref[,"end"], 
  			      width=ref[,"end"]-ref[,"begin"]+1), 
  			  strand=ref[,"strand"])
  			
  			if(logFile!="")
  			  cat( "Part1 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			
  			
  			hits2_1 <- GenomicRanges::findOverlaps(read2GRanges, refGRanges, 
  			  type= "start", ignore.strand=FALSE)
  			
  			if(logFile!="")
  			  cat( "Part2 ",qNam, "\n",
  			       file=logFile, append=appendLogFile)
  			
  			hits2_2 <- GenomicRanges::findOverlaps(read2GRanges, refGRanges, 
  			                                       type= "end", 
  			                                       ignore.strand=FALSE)
  			
  			if(logFile!="")
  			  cat( "Part3 ",qNam, "\n",
  			       file=logFile, append=appendLogFile)
  			
  			hits2_3 <- GenomicRanges::findOverlaps(read2GRanges, refGRanges, 
  			                                       type= "equal", 
  			                                       ignore.strand=FALSE)
  			
  			if(logFile!="")
  			  cat( "Part4 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile) 			
  			hitsSubject<- c()
  			hitsQuery<- c()
  			hits1Subject=c()
  			hits1Query=c()
  			hits2Subject=c()
  			hits2Query=c()
  			# Filter reads mapped to repeats regions if requested
  			if(length(repeatsTableToFilter)!=0){
  				repeatGRanges= GenomicRanges::GRanges( 
  					seqnames=repeatsTableToFilter[,"chr"], 
  					IRanges::IRanges(start=repeatsTableToFilter[,"begin"], 
  						end=repeatsTableToFilter[,"end"], 
  						width=repeatsTableToFilter[,"end"]-
  							repeatsTableToFilter[,"begin"]+1))
  				hitsFilter= GenomicRanges::findOverlaps(read1GRanges, 
  					repeatGRanges, type= "any", ignore.strand=TRUE)
  	
  				filtInd1_1= which(is.na(match(S4Vectors::queryHits(hits1_1), 
  					S4Vectors::queryHits(hitsFilter))))
  				filtInd1_2= which(is.na(match(S4Vectors::queryHits(hits1_2),  
  					S4Vectors::queryHits(hitsFilter))))
  				filtInd1_3= which(is.na(match(S4Vectors::queryHits(hits1_3),  
  					S4Vectors::queryHits(hitsFilter))))
  				
  				hitsFilter= GenomicRanges::findOverlaps(read2GRanges, 
  				                                        repeatGRanges, type= "any", 
  				                                        ignore.strand=TRUE)
  				
  				filtInd2_1= which(is.na(match(S4Vectors::queryHits(hits2_1), 
  				                              S4Vectors::queryHits(hitsFilter))))
  				filtInd2_2= which(is.na(match(S4Vectors::queryHits(hits2_2),  
  				                              S4Vectors::queryHits(hitsFilter))))
  				filtInd2_3= which(is.na(match(S4Vectors::queryHits(hits2_3),  
  				                              S4Vectors::queryHits(hitsFilter))))
  				
  				hits1_1= hits1_1[filtInd1_1,]
  				hits1_2= hits1_2[filtInd1_2,]
  				hits1_3= hits1_3[filtInd1_3,]
  				hits2_1= hits2_1[filtInd2_1,]
  				hits2_2= hits2_2[filtInd2_2,]
  				hits2_3= hits2_3[filtInd2_3,]
  			}
  			# Include the reads that completely map to exons if user asked
  			if(!junctionReadsOnly){
  				hits1Extra= GenomicRanges::findOverlaps(read1GRanges, 
  					refGRanges, type= "within", ignore.strand=FALSE)
  				hits2Extra= GenomicRanges::findOverlaps(read2GRanges, 
  				  refGRanges, type= "within", ignore.strand=FALSE)

  				hits1Subject=S4Vectors::subjectHits(hits1Extra)
  				hits1Query=S4Vectors::queryHits(hits1Extra)
  				hits2Subject=S4Vectors::subjectHits(hits2Extra)
  				hits2Query=S4Vectors::queryHits(hits2Extra)
  			}
  		
  			hits1Subject=c(hits1Subject, S4Vectors::subjectHits(hits1_1),
  				S4Vectors::subjectHits(hits1_2),S4Vectors::subjectHits(hits1_3))
  			hits2Subject=c(hits2Subject, S4Vectors::subjectHits(hits2_1),
  			   S4Vectors::subjectHits(hits2_2),S4Vectors::subjectHits(hits2_3))
  			
  			if(logFile!="")
  			  cat( "Part5 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			
  			hits1Query=c(hits1Query, S4Vectors::queryHits(hits1_1), 
  			  S4Vectors::queryHits(hits1_2), S4Vectors::queryHits(hits1_3))
  			hits2Query=c(hits2Query, S4Vectors::queryHits(hits2_1), 
  			  S4Vectors::queryHits(hits2_2), S4Vectors::queryHits(hits2_3))
  			
  			if(logFile!="")
  			  cat( "Part6 ",qNam, "\n",
  			       file=logFile, append=appendLogFile)
  			
  			refRes= rep(0,nrow(ref))
  			if(length(hits1Query)>0){
  				hitsApply= tapply(c(noRead1[hits1Query], noRead2[hits2Query]), 
  				  c(hits1Subject, hits2Subject), 
  				  function(tmp) return(length(unique(tmp))) )
  				refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			}
  			if(logFile!="")
  			  cat( "Part7 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			exExRes<-rep(0, nrow(reference))
  			exExRes[which(referenceIntronExon=="exon")]<- refRes
  			rm("refRes")
  	
  		}	
  		methodNo=which(method=="IntRet")
  		if((length(methodNo)>0) & (! junctionReadsOnly)){
  
  			ref=reference[which(referenceIntronExon=="intron"),]
  			read1GRanges=GenomicRanges::GRanges( seqnames=chrRead1, 
  			  IRanges::IRanges(start=begRead1, end=endRead1), strand=strAdj1)
  			read2GRanges=GenomicRanges::GRanges( seqnames=chrRead2, 
  			  IRanges::IRanges(start=begRead2, end=endRead2), strand=strAdj2)
  			refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  			  IRanges::IRanges(start=ref[,"begin"], 
  			    end=ref[,"end"], 
  			    width=ref[,"end"]-ref[,"begin"]+1), 
  			  strand=ref[,"strand"])
  			
  			hits1 <- GenomicRanges::findOverlaps(read1GRanges, refGRanges, 
  				type= "any", ignore.strand=FALSE)
  			hits2 <- GenomicRanges::findOverlaps(read2GRanges, refGRanges, 
  			  type= "any", ignore.strand=FALSE)

  			# Filter reads mapped to repeats regions if requested
  			if(length(repeatsTableToFilter)!=0){
  				repeatGRanges= GenomicRanges::GRanges( 
  					seqnames=repeatsTableToFilter[,"chr"], 
  					IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  						end=repeatsTableToFilter[,"end"], 
  						width=repeatsTableToFilter[,"end"]-
  							repeatsTableToFilter[,"begin"]+1))
  				hitsFilter1= GenomicRanges::findOverlaps(read1GRanges, 
  					repeatGRanges, type= "any",ignore.strand=TRUE)
  				hitsFilter2= GenomicRanges::findOverlaps(read2GRanges, 
  				  repeatGRanges, type= "any", ignore.strand=TRUE)
# Explanation: If both reads have regions overlapping repeat regions ignore them!
  				filNoHits<- 
  				  unique(intersect(noRead1[queryHits(hitsFilter1)], 
  				            noRead2[queryHits(hitsFilter2)]))
  				  				
  				filtInd1= 
  				  which( !(noRead1[S4Vectors::queryHits(hits1)] %in% filNoHits))
  				filtInd2= 
  				  which( !(noRead2[S4Vectors::queryHits(hits2)] %in% filNoHits))
  				hits1=hits1[filtInd1,]
  				hits2=hits2[filtInd2,]
  			}
  			refRes= rep(0,nrow(ref))
  			if(length(S4Vectors::queryHits(hits1))>0 | length(S4Vectors::queryHits(hits2))>0){
  				hitsApply=tapply(
  				  c(noRead1[S4Vectors::queryHits(hits1)],
  				    noRead2[S4Vectors::queryHits(hits2)]),
  					c(S4Vectors::subjectHits(hits1), S4Vectors::subjectHits(hits2)),
  					function(tmp) return(length(unique(tmp))) )
  				
  				refRes[as.numeric(unique(names(hitsApply)))]= 
  				  as.vector(hitsApply)
  			}
  			intRetRes<- rep(0,nrow(reference))
  			intRetRes[which(referenceIntronExon=="intron")]<- refRes
  			rm("refRes")

  		} else if ((length(methodNo)>0) & (junctionReadsOnly)) {
  		  
  		  
  			ref=reference[which(referenceIntronExon=="intron"),]
  			refEndGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  			  IRanges::IRanges(start=ref[,"end"], end=ref[,"end"]), 
  			  strand=ref[,"strand"])
  			refBegGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  			  IRanges::IRanges(start=ref[,"begin"], end=ref[,"begin"]),
  			  strand=ref[,"strand"])
  			
  			read1GRanges=GenomicRanges::GRanges( seqnames=chrRead1, 
  			  IRanges::IRanges(start=begRead1, end=endRead1), strand=strAdj1)
  			hitsEnd1 <- GenomicRanges::findOverlaps(refEndGRanges, read1GRanges,
  			  type= "within", ignore.strand=FALSE)
  			hitsBeg1 <- GenomicRanges::findOverlaps(refBegGRanges, read1GRanges,
  			  type= "within", ignore.strand=FALSE)

  			read2GRanges=GenomicRanges::GRanges( seqnames=chrRead2, 
  			  IRanges::IRanges(start=begRead2, end=endRead2), strand=strAdj2)
  			hitsEnd2 <- GenomicRanges::findOverlaps(refEndGRanges, read2GRanges,
  			  type= "within", ignore.strand=FALSE)
  			hitsBeg2 <- GenomicRanges::findOverlaps(refBegGRanges, read2GRanges,
  			  type= "within", ignore.strand=FALSE)

  			# Filter reads mapped to repeats regions if requested
  			if(length(repeatsTableToFilter)!=0){
  				repeatGRanges= GenomicRanges::GRanges( 
  					seqnames=repeatsTableToFilter[,"chr"], 
  					IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  						end=repeatsTableToFilter[,"end"], 
  						width=repeatsTableToFilter[,"end"]-
  							repeatsTableToFilter[,"begin"]+1))
  				hitsFilter1= GenomicRanges::findOverlaps(read1GRanges, 
  					repeatGRanges, type= "any", ignore.strand=TRUE)
  				hitsFilter2= GenomicRanges::findOverlaps(read2GRanges, 
  				  repeatGRanges, type= "any", ignore.strand=TRUE)
  				
  				noFilQuHits<- 
  				  intersect(noRead1[queryHits(hitsFilter1)], 
  				             noRead2[queryHits(hitsFilter2)])
  				
  				filtEndInd1= which(! noRead1[S4Vectors::subjectHits(hitsEnd1)] %in% 
  				                     noFilQuHits)
  				filtBegInd1= which(! noRead1[S4Vectors::subjectHits(hitsBeg1)] %in% 
  				                     noFilQuHits)
  				
  				filtEndInd2= which(! noRead2[S4Vectors::subjectHits(hitsEnd2)] %in% 
  				                     noFilQuHits)
  				filtBegInd2= which(! noRead2[S4Vectors::subjectHits(hitsBeg2)] %in% 
  				                     noFilQuHits)
  				
  				
  				hitsEnd1=hitsEnd1[filtEndInd1,]
  				hitsBeg1=hitsBeg1[filtBegInd1,]
  				hitsEnd2=hitsEnd2[filtEndInd2,]
  				hitsBeg2=hitsBeg2[filtBegInd2,]
  			}
  			
  			  
  			refRes= rep(0,nrow(ref))
  			refResBeg= refRes
  			refResEnd= refRes
  			if( (length(S4Vectors::subjectHits(hitsBeg1))>0) | 
  				(length(S4Vectors::subjectHits(hitsEnd1))>0) | 
  				(length(S4Vectors::subjectHits(hitsBeg2))>0) | 
  				(length(S4Vectors::subjectHits(hitsEnd2))>0) ){
  				hitsEndApply=tapply(
  				  c(noRead1[S4Vectors::subjectHits(hitsEnd1)], 
  				    noRead2[S4Vectors::subjectHits(hitsEnd2)]),
  					c(S4Vectors::queryHits(hitsEnd1), S4Vectors::queryHits(hitsEnd2)),
  					function(tmp) return(length(unique(tmp))) )
  				hitsBegApply=tapply(
  				  c(noRead1[S4Vectors::subjectHits(hitsBeg1)], 
  				    noRead2[S4Vectors::subjectHits(hitsBeg2)]),
  					c(S4Vectors::queryHits(hitsBeg1), S4Vectors::queryHits(hitsBeg2)), 
  					function(tmp) return(length(unique(tmp))) )
  				
  				refResBeg[as.numeric(names(hitsBegApply))]= 
  					as.numeric(hitsBegApply)
  				refResEnd[as.numeric(names(hitsEndApply))]= 
  					as.numeric(hitsEndApply)
  				refRes=refResBeg+refResEnd
  				rm("refResBeg","refResEnd")
  			}
  			intRetRes<- rep(0,nrow(reference))
  			intRetRes[which(referenceIntronExon=="intron")]<- refRes
  			rm("refRes")
  		}
  ########
  ########!!!
  	}
  	methodNo=which(method=="IntSpan")
  	if(length(methodNo)>0){
  
  	  sam1IndSp<- grep("N",sam1$cigar)
  	  sam2IndSp<- grep("N",sam2$cigar)
  	  
  	  lenRead1= unlist(lapply(sam1$cigar[sam1IndSp], function(tmp) {
  	    frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  	    names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  	                                                        unlist(strsplit(tmp,split="")))]
  	    return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  	  }))
  	  
  	  lenRead2= unlist(lapply(sam2$cigar[sam2IndSp], function(tmp) {
  	    frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  	    names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  	                                                        unlist(strsplit(tmp,split="")))]
  	    return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  	  }))
  	  
  	  locRead1=sam1[,"pos"]
  	  chrRead1=sam1[,"rName"]
  	  strRead1=sam1[,"strand"]
  	  chrRead2=sam2[,"rName"]
  	  locRead2=sam2[,"pos"]
  	  strRead2=sam2[,"strand"]
  	  
  	  
  	  frqEventRead1 =lapply(sam1IndSp, function (tmp) {
  	    frqEventTmp= as.numeric(unlist(strsplit(sam1$cigar[tmp],
  	                                            split="[A-Z]")))
  	    names(frqEventTmp)= unlist(strsplit(sam1$cigar[tmp], 
  	                                        split=""))[grep('[A-Z]', unlist(strsplit(sam1$cigar[tmp]
  	                                                                                 , split="")))]
  	    frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          c("N","D","M")))]
  	    
  	    # Finding start and end of the mapped pieces of the reads using cigar 
  	    eventTmp<- c(locRead1[tmp], locRead1[tmp]+
  	                   cumsum(as.numeric(frqEventTmp)))
  	    begEventTmp<-eventTmp[-length(eventTmp)]
  	    endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  	    frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]	    
  	    frqEventTmpN=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    begEventTmpN=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    endEventTmpN=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    return( list(readNo=rep(tmp,length(frqEventTmpN)), 
  	                 chr=rep(chrRead1[tmp],length(frqEventTmpN)), 
  	                 frqEventTmpN, begEventTmpN, endEventTmpN,
  	                 frqEventTmpM, begEventTmpM, endEventTmpM,
  	                 readNoM=rep(tmp,length(frqEventTmpM)),
  	                 strand=rep(strRead1[tmp],length(frqEventTmpN)) ))
  	    
  	  })
  	  
  	  
  	  frqEventRead2= lapply(sam2IndSp, function (tmp) {
  	    frqEventTmp= as.numeric(unlist(strsplit(sam2$cigar[tmp],
  	                                            split="[A-Z]")))
  	    names(frqEventTmp)= unlist(strsplit(sam2$cigar[tmp], 
  	                                        split=""))[grep('[A-Z]', unlist(strsplit(sam2$cigar[tmp]
  	                                                                                 , split="")))]
  	    frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          c("N","D","M")))]
  	    
  	    # Finding start and end of the mapped pieces of the reads using cigar 
  	    eventTmp<- c(locRead2[tmp], locRead2[tmp]+
  	                   cumsum(as.numeric(frqEventTmp)))
  	    begEventTmp<-eventTmp[-length(eventTmp)]
  	    endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  	    frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]	    
  	    frqEventTmpN=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    begEventTmpN=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    endEventTmpN=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    return( list(readNo=rep(tmp,length(frqEventTmpN)), 
  	                 chr=rep(chrRead1[tmp],length(frqEventTmpN)), 
  	                 frqEventTmpN, begEventTmpN, endEventTmpN,
  	                 frqEventTmpM, begEventTmpM, endEventTmpM,
  	                 readNoM=rep(tmp,length(frqEventTmpM)),
  	                 strand=rep(strRead2[tmp],length(frqEventTmpN) )))
  	    
  	  })
  	  
  	  noRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[1]]))))
  	  chrRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[2]]))))
  	  begRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[4]]))))
  	  endRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[5]]))))
  	  strRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    as.character(unlist(tmp[[10]])))))
  	  
  	  noRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[1]]))))
  	  chrRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[2]]))))
  	  begRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[4]]))))
  	  endRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[5]]))))
  	  strRead2=as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    as.character(unlist(tmp[[10]])))))
  	  
  	  if(strandSpecific=="stranded"){
  	    strAdj1<- as.character(strRead1)
  	    strAdj2<- as.character(revStr[strRead2])
  	  } else if (strandSpecific=="reverse"){
  	    strAdj2<- as.character(strRead2)
  	    strAdj1<- as.character(revStr[strRead1])
  	  }
  	  
  	  # analyzing reads
  	  noVec=c(noRead1,noRead2)
  	  chrVec=c(as.character(chrRead1),
  	           as.character(chrRead2))
  	  begVec=c(begRead1,begRead2)
  	  endVec=c(endRead1,endRead2)
  	  strVec<- c(strAdj1,strAdj2)
  	  
  		ref=reference[which(referenceIntronExon=="intron"),]
  		read1GRanges=GenomicRanges::GRanges( seqnames=chrRead1, 
  		  IRanges::IRanges(start=begRead1, end=endRead1), strand=strAdj1)
  		read2GRanges=GenomicRanges::GRanges( seqnames=chrRead2, 
  		  IRanges::IRanges(start=begRead2, end=endRead2), strand=strAdj2)
  
  		# refIntBegGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  		# 	IRanges::IRanges(start=ref[,"begin"]-1, end=ref[,"begin"]-1), 
  		# 	strand=ref[,"strand"])
  		# refIntEndGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  		# 	IRanges::IRanges(start=ref[,"end"]+1, end=ref[,"end"]+1),
  		# 	strand=ref[,"strand"])
  
  		refIntGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  		  IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"]), 
  		  strand=ref[,"strand"])
  		
  		### !!!
  		### THIS IS NOT THE BEST WAY. WHY SEPARATE ON BEGIN AND END ?
  		###WHY NOT 	hitsBegInt <- GenomicRanges::findOverlaps(readGRanges, 
  		###    refIntGRanges, type= "equal")
  		
  		# hitsBegInt1 <- GenomicRanges::findOverlaps(read1GRanges, 
  		# 	refIntBegGRanges, type= "end", ignore.strand=FALSE)
  		# hitsEndInt1 <- GenomicRanges::findOverlaps(read1GRanges, 
  		# 	refIntEndGRanges, type= "start", ignore.strand=FALSE)
  		
  		# hitsBegInt2 <- GenomicRanges::findOverlaps(read2GRanges, 
  		#   refIntBegGRanges, type= "end", ignore.strand=FALSE)
  		# hitsEndInt2 <- GenomicRanges::findOverlaps(read2GRanges, 
  		#   refIntEndGRanges, type= "start", ignore.strand=FALSE)
  		
  		
  		hitsInt1 <- GenomicRanges::findOverlaps(read1GRanges, 
  		  refIntGRanges, type= "equal", ignore.strand=FALSE)
  		
  		hitsInt2 <- GenomicRanges::findOverlaps(read2GRanges,
        refIntGRanges, type= "equal", ignore.strand=FALSE)
  		
  			# Filter reads mapped to repeats regions if requested
  			# if(length(repeatsTableToFilter)!=0){
  			# 	repeatGRanges= GenomicRanges::GRanges( 
  			# 		seqnames=repeatsTableToFilter[,"chr"], 
  			# 		IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  			# 			end=repeatsTableToFilter[,"end"], 
  			# 			width=repeatsTableToFilter[,"end"]-
  			# 				repeatsTableToFilter[,"begin"]+1))
  			# 	hitsFilter1= GenomicRanges::findOverlaps(read1GRanges, 
  			# 		repeatGRanges, type= "any", ignore.strand=TRUE)
  			# 	hitsFilter2= GenomicRanges::findOverlaps(read2GRanges, 
  			# 	  repeatGRanges, type= "any", ignore.strand=TRUE)
  			# 	
  			# 	noFilQuHits<- 
  			# 	  intersect(noRead1[queryHits(hitsFilter1)], 
  			# 	            noRead2[queryHits(hitsFilter2)])
  			# 	
  			# 	filtEndInd1= which(! noRead1[S4Vectors::subjectHits(hitsEndInt1)] %in% 
  			# 	  noFilQuHits)
  			# 	filtBegInd1= which(! noRead1[S4Vectors::subjectHits(hitsBegInt1)] %in% 
  			# 	  noFilQuHits)
  			# 	
  			# 	filtEndInd2= which(! noRead2[S4Vectors::subjectHits(hitsEndInt2)] %in% 
  			# 	  noFilQuHits)
  			# 	filtBegInd2= which(! noRead2[S4Vectors::subjectHits(hitsBegInt2)] %in% 
  			# 	  noFilQuHits)
  			# 	
  			# 	
  			# 	hitsBegInt1=hitsBegInt1[filtBegInd1,]
  			# 	hitsEndInt1=hitsEndInt1[filtEndInd1,]
  			# 	hitsBegInt2=hitsBegInt2[filtBegInd2,]
  			# 	hitsEndInt2=hitsEndInt2[filtEndInd2,]
  			# }

  		
  		# if(length(repeatsTableToFilter)!=0){
  		#   repeatGRanges= GenomicRanges::GRanges( 
  		#     seqnames=repeatsTableToFilter[,"chr"], 
  		#     IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  		#                      end=repeatsTableToFilter[,"end"], 
  		#                      width=repeatsTableToFilter[,"end"]-
  		#                        repeatsTableToFilter[,"begin"]+1))
  		#   hitsFilter1= GenomicRanges::findOverlaps(read1GRanges, 
  		#                                            repeatGRanges, type= "equal", ignore.strand=TRUE)
  		#   hitsFilter2= GenomicRanges::findOverlaps(read2GRanges, 
  		#                                            repeatGRanges, type= "equal", ignore.strand=TRUE)
  		#   
  		#   noFilQuHits<- 
  		#     intersect(noRead1[queryHits(hitsFilter1)], 
  		#               noRead2[queryHits(hitsFilter2)])
  		#   
  		#   filtInd1= which(! noRead1[S4Vectors::subjectHits(hitsInt1)] %in% 
  		#                        noFilQuHits)
  		#   
  		#   filtEndInd2= which(! noRead2[S4Vectors::subjectHits(hitsInt2)] %in% 
  		#                        noFilQuHits)
  		# 
  		#   hitsInt1=hitsInt1[filtInd1,]
  		#   hitsInt2=hitsInt2[filtInd2,]
  		# }
  		  		
  			# Filter reads mapped completely to Either introns or exons
  
  			refRes= rep(0,nrow(ref))
  			# if(length(c(S4Vectors::queryHits(hitsBegInt1), 
  			# 	S4Vectors::queryHits(hitsEndInt1)))>0 |
  			# 	length(c(S4Vectors::queryHits(hitsBegInt2), 
  			# 	S4Vectors::queryHits(hitsEndInt2)))>0){
  			# 	hitsApply=tapply(
  			# 		c(noRead1[c(S4Vectors::queryHits(hitsBegInt1), 
  			# 			  S4Vectors::queryHits(hitsEndInt1))], 
  			# 			noRead2[c(S4Vectors::queryHits(hitsBegInt2), 
  			# 			  S4Vectors::queryHits(hitsEndInt2))]), 
  			# 		c(S4Vectors::subjectHits(hitsBegInt1), 
  			# 			S4Vectors::subjectHits(hitsEndInt1),
  			# 			S4Vectors::subjectHits(hitsBegInt2), 
  			# 			S4Vectors::subjectHits(hitsEndInt2)),
  			# 		function(tmp) return(length(unique(tmp))) )
  			# 	refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			# }
  			
  			if(length(S4Vectors::queryHits(hitsInt1))>0 |
  			   length(S4Vectors::queryHits(hitsInt2))>0){
  			  hitsApply=tapply(
  			    c(noRead1[S4Vectors::queryHits(hitsInt1)], 
  			      noRead2[S4Vectors::queryHits(hitsInt2)]), 
  			    c(S4Vectors::subjectHits(hitsInt1), 
  			      S4Vectors::subjectHits(hitsInt2)),
  			    function(tmp) return(length(unique(tmp))) )
  			  refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			}
  			
  			
  			intSpanRes<- rep(0,nrow(reference))
  			intSpanRes[which(referenceIntronExon=="intron")]<- refRes
  			rm("refRes")
  	}
  
  	####
  	### NEW ExSkip
  	methodNo=which(method=="ExSkip")
  	if(length(methodNo)>0){
  	  
  	  sam1IndSp<- grep("N",sam1$cigar)
  	  sam2IndSp<- grep("N",sam2$cigar)
  	  
  	  lenRead1= unlist(lapply(sam1$cigar[sam1IndSp], function(tmp) {
  	    frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  	    names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  	                                                        unlist(strsplit(tmp,split="")))]
  	    return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  	  }))
  	  
  	  lenRead2= unlist(lapply(sam2$cigar[sam2IndSp], function(tmp) {
  	    frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  	    names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  	                                                        unlist(strsplit(tmp,split="")))]
  	    return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  	  }))
  	  
  	  locRead1=sam1[,"pos"]
  	  chrRead1=sam1[,"rName"]
  	  strRead1=sam1[,"strand"]
  	  chrRead2=sam2[,"rName"]
  	  locRead2=sam2[,"pos"]
  	  strRead2=sam2[,"strand"]
  	  
  	  
  	  frqEventRead1 =lapply(sam1IndSp, function (tmp) {
  	    frqEventTmp= as.numeric(unlist(strsplit(sam1$cigar[tmp],
  	                                            split="[A-Z]")))
  	    names(frqEventTmp)= unlist(strsplit(sam1$cigar[tmp], 
  	                                        split=""))[grep('[A-Z]', unlist(strsplit(sam1$cigar[tmp]
  	                                                                                 , split="")))]
  	    frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          c("N","D","M")))]
  	    
  	    # Finding start and end of the mapped pieces of the reads using cigar 
  	    eventTmp<- c(locRead1[tmp], locRead1[tmp]+
  	                   cumsum(as.numeric(frqEventTmp)))
  	    begEventTmp<-eventTmp[-length(eventTmp)]
  	    endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  	    frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]	    
  	    frqEventTmpN=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    begEventTmpN=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    endEventTmpN=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    return( list(readNo=rep(tmp,length(frqEventTmpN)), 
  	              chr=rep(chrRead1[tmp],length(frqEventTmpN)), 
  	              frqEventTmpN, begEventTmpN, endEventTmpN,
  	              frqEventTmpM, begEventTmpM, endEventTmpM,
  	              readNoM=rep(tmp,length(frqEventTmpM)),
  	              strand=rep(strRead1[tmp],length(frqEventTmpN)) ))
  	    
  	  })
  	  
  	  
  	  frqEventRead2= lapply(sam2IndSp, function (tmp) {
  	    frqEventTmp= as.numeric(unlist(strsplit(sam2$cigar[tmp],
  	                                            split="[A-Z]")))
  	    names(frqEventTmp)= unlist(strsplit(sam2$cigar[tmp], 
  	                                        split=""))[grep('[A-Z]', unlist(strsplit(sam2$cigar[tmp]
  	                                                                                 , split="")))]
  	    frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          c("N","D","M")))]
  	    
  	    # Finding start and end of the mapped pieces of the reads using cigar 
  	    eventTmp<- c(locRead2[tmp], locRead2[tmp]+
  	                   cumsum(as.numeric(frqEventTmp)))
  	    begEventTmp<-eventTmp[-length(eventTmp)]
  	    endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  	    frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]	    
  	    frqEventTmpN=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    begEventTmpN=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    endEventTmpN=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    return( list(readNo=rep(tmp,length(frqEventTmpN)), 
  	              chr=rep(chrRead1[tmp],length(frqEventTmpN)), 
  	              frqEventTmpN, begEventTmpN, endEventTmpN,
  	              frqEventTmpM, begEventTmpM, endEventTmpM,
  	              readNoM=rep(tmp,length(frqEventTmpM)),
  	              strand=rep(strRead2[tmp],length(frqEventTmpN) )))
  	    
  	  })
  	  
  	  noRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[1]]))))
  	  chrRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[2]]))))
  	  begRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[4]]))))
  	  endRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[5]]))))
  	  strRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    as.character(unlist(tmp[[10]])))))
  
  	  noRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[1]]))))
  	  chrRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[2]]))))
  	  begRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[4]]))))
  	  endRead2= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    unlist(tmp[[5]]))))
  	  strRead2=as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	    as.character(unlist(tmp[[10]])))))
  	  
  	  if(strandSpecific=="stranded"){
  	    strAdj1<- as.character(strRead1)
  	    strAdj2<- as.character(revStr[strRead2])
  	  } else if (strandSpecific=="reverse"){
  	    strAdj2<- as.character(strRead2)
  	    strAdj1<- as.character(revStr[strRead1])
  	  }
  	  
  	  # analyzing reads
  	  noVec=c(noRead1,noRead2)
  	  chrVec=c(as.character(chrRead1),
  	           as.character(chrRead2))
  	  begVec=c(begRead1,begRead2)
  	  endVec=c(endRead1,endRead2)
  	  strVec<- c(strAdj1,strAdj2)
  	  
  	  ref=reference[which(referenceIntronExon=="exon"),]
  	  read1GRanges=GenomicRanges::GRanges( seqnames=chrRead1, 
  	    IRanges::IRanges(start=begRead1, end=endRead1), strand=strAdj1)
  	  read2GRanges=GenomicRanges::GRanges( seqnames=chrRead2, 
  	    IRanges::IRanges(start=begRead2, end=endRead2), strand=strAdj2)
  	  
  	  refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  	    IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"]), 
  	    strand=ref[,"strand"])
  	  
  	  hitsAllEx1 <- GenomicRanges::findOverlaps(refGRanges, 
  	                                           read1GRanges, type= "within",
  	                                           ignore.strand= FALSE)
  	  hitsAllEx2 <- GenomicRanges::findOverlaps(refGRanges, 
  	                                            read2GRanges, type= "within",
  	                                            ignore.strand= FALSE)
  	  

  	  
  	  # Filter reads mapped to repeats regions if requested
  	  # if(length(repeatsTableToFilter)!=0){
  	  #   noRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	  #     unlist(tmp[[9]]))))
  	  #   chrRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	  #     unlist(tmp[[2]]))))
  	  #   begRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	  #     unlist(tmp[[7]]))))
  	  #   endRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	  #     unlist(tmp[[8]]))))
  	  # 
  	  #   noRead2M= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	  #     unlist(tmp[[9]]))))
  	  #   chrRead2M= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	  #     unlist(tmp[[2]]))))
  	  #   begRead2M= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	  #     unlist(tmp[[7]]))))
  	  #   endRead2M= as.vector(unlist(sapply(frqEventRead2, function(tmp)
  	  #     unlist(tmp[[8]]))))
  	  #   
  	  #   # analyzing reads
  	  #   noVecM=c(noRead1M,noRead2M)
  	  #   chrVecM=c(as.character(chrRead1M),
  	  #             as.character(chrRead2M))
  	  #   begVecM=c(begRead1M,begRead2M)
  	  #   endVecM=c(endRead1M,endRead2M)
  	  #   
  	  #   readGRangesM1=GenomicRanges::GRanges( seqnames=chrRead1M, 
  	  #     IRanges::IRanges(start=begRead1M, end=endRead1M))
  	  #   repeatGRanges= GenomicRanges::GRanges( 
  	  #     seqnames=repeatsTableToFilter[,"chr"], 
  	  #     IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  	  #                      end=repeatsTableToFilter[,"end"], 
  	  #                      width=repeatsTableToFilter[,"end"]-
  	  #                        repeatsTableToFilter[,"begin"]+1))
  	  #   hitsFilter1= GenomicRanges::findOverlaps(readGRangesM1, 
  	  #     repeatGRanges, type= "any", ignore.strand=TRUE)
  	  #   hitsFilter2= GenomicRanges::findOverlaps(readGRangesM2, 
  	  #     repeatGRanges, type= "any", ignore.strand=TRUE)
  	  # 
  	  #   # noVecFil<- unique(noVecM[queryHits(hitsFilter)])
  	  #   # filthitsAllExInd<- which(!subjectHits(hitsAllEx) %in% 
  	  #   #                            subjectHits(hitsAllEx)[
  	  #   #                              which(noVec[subjectHits(hitsAllEx)]
  	  #   #                                    %in% noVecFil)])
  	  #   # hitsAllEx=hitsAllEx[filthitsAllExInd,]
  	  #   noFilQuHits<- 
  	  #     intersect(noRead1[queryHits(hitsFilter1)], 
  	  #               noRead2[queryHits(hitsFilter2)])
  	  # 
  	  #   filtAllInd1= which(! noRead1[S4Vectors::subjectHits(hitsAllEx1)] %in% 
  	  #                        noFilQuHits)
  	  #   filtAllInd2= which(! noRead1[S4Vectors::subjectHits(hitsAllEx2)] %in% 
  	  #                        noFilQuHits)
  	  #   
  	  # 
  	  #   
  	  #   hitsAllEx1=hitsAllEx1[filtAllInd1,]
  	  #   hitsAllEx2=hitsAllEx2[filtAllInd2,]
  	  #   # hitsBegInt2=hitsBegInt2[filtBegInd2,]
  	  #   # hitsEndInt2=hitsEndInt2[filtEndInd2,]
  	  #   
  	  # }
  	  
  	  # Filter reads mapped completely to Either introns or exons
  	  
  	  refRes= rep(0,nrow(ref))
  	  if(length(c(S4Vectors::subjectHits(hitsAllEx1),
  	              S4Vectors::subjectHits(hitsAllEx2)))>0){
  	    hitsApply=tapply(
  	      c(noRead1[S4Vectors::subjectHits(hitsAllEx1)],
  	        noRead2[S4Vectors::subjectHits(hitsAllEx2)]), 
  	      c(S4Vectors::queryHits(hitsAllEx1),
  	        S4Vectors::queryHits(hitsAllEx2)),
  	      function(tmp) return(length(unique(tmp))) )
  	    refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  	  }
  	  exSkipRes<- rep(0,nrow(reference))
  	  exSkipRes[which(referenceIntronExon=="exon")]<- refRes
  	  rm("refRes")
  	}
  }
########!!!
########	
	
########!!!
########
	finalRes<-c()
	
	if(length(exExRes)==0)
	  exExRes<- rep(0,nrow(reference))	
	
	if(length(intRetRes)==0)
	  intRetRes<- rep(0,nrow(reference))
	  
	if(length(intSpanRes)==0)
	  intSpanRes<- rep(0,nrow(reference))

	if(length(exSkipRes)==0)
	  exSkipRes<- rep(0,nrow(reference))

	
	#	if(length(exExRes)>0){
	if("ExEx" %in% method)
	  finalRes<-c(finalRes, exExRes)
	rm("exExRes")	
	
#	if(length(intRetRes)>0)
	if("IntRet" %in% method)
		finalRes<-c(finalRes, intRetRes)
	rm("intRetRes")

########
########!!!
#	if(length(intSpanRes)>0)
	if("IntSpan" %in% method)
		finalRes<-c(finalRes, intSpanRes)
	rm("intSpanRes")
	
#	if(length(exSkipRes)>0)
	if("ExSkip" %in% method)
	  finalRes<-c(finalRes, exSkipRes)
	rm("exSkipRes")
########!!!
########
	if(logFile!="")
	  cat( "end ", 
	       qNam, " ", length(finalRes), "\n",
	       file=logFile, append=appendLogFile)
	cat( "end ", 
	     qNam, " ", length(finalRes), "\n")	
	# if(is.null(finalRes))
	#   finalRes<- rep(0, 
	#     length(which(method%in%c("ExEx", "IntRet", "IntSpan", "ExSkip"))))
	return(finalRes)
	rm("finalRes")
#End of defining function for paired-mapped reads that runs on parallel cores 
} 
	

# For single reads
interestIntExAnalyseSingleStranded <- function(
	readTmp,
	reference,
	maxNoMappedReads,
	logFile,
	method,
	appendLogFile,
	repeatsTableToFilter,
	referenceIntronExon,
	junctionReadsOnly,
	limitRanges,
	strandSpecific,
	excludeFusionReads){
  revStr<- c("-", "+", "*")
  names(revStr)<- c("+", "-", "*")
  qNam<- as.data.frame(readTmp)[1, "qname"]
  if(logFile!="")
    cat( "Singlestart ", 
         qNam, "\n",
         file=logFile, append=appendLogFile)
  cat( "Singlestart ", 
       qNam, "\n")
  
  
# Filtering readTmp based on number of mapping targets for each read
	lenTmp<- unlist(sapply(readTmp, length))
	readTmpFil<- readTmp[which(lenTmp<= maxNoMappedReads)]
	
	sam2= NA
	sam1Flag<- mcols(unlist(readTmpFil))$flag
	sam1FlagMat<-bamFlagAsBitMatrix(sam1Flag)
	readMate<- rep(1,nrow(sam1FlagMat))
	readMate[which(sam1FlagMat[,"isSecondMateRead"]==1)]<- 2

	
	readTmpFirst<- unlist(readTmpFil) 
	if(strandSpecific=="stranded"){
	  if(length(which(readMate==1))>0)
	    GenomicRanges::strand(readTmpFirst)[which(readMate==1)]<- 
	      as.character(GenomicRanges::strand(readTmpFirst)[which(readMate==1)])
	  if(length(which(readMate==2))>0)
	    GenomicRanges::strand(readTmpFirst)[which(readMate==2)]<- 
	      as.character(revStr[as.character(GenomicRanges::strand(readTmpFirst))][which(readMate==2)])
	} else if (strandSpecific=="reverse"){
	  if(length(which(readMate==2))>0)
	    GenomicRanges::strand(readTmpFirst)[which(readMate==2)]<- 
	      as.character(GenomicRanges::strand(readTmpFirst)[which(readMate==2)])
	  if(length(which(readMate==1))>0)
	    GenomicRanges::strand(readTmpFirst)[which(readMate==1)]<- 
	      as.character(revStr[as.character(GenomicRanges::strand(readTmpFirst))][which(readMate==1)])
	}
	
	if(length(limitRanges)>0 & length(readTmpFirst)>0){

	  r1Map<- GenomicRanges::findOverlaps(
	    readTmpFirst, 
	    limitRanges,
	    type= "within",
	    ignore.strand= FALSE)
	  
	  filLimInd<- sort(unique(S4Vectors::queryHits(r1Map)), decreasing=FALSE)
	  readTmpFirst<- readTmpFirst[filLimInd,]
	}
	
#Extract information of the mapped pieces of the reads
	sam1<- as.data.frame(readTmpFirst)[, c("qname", "rname", "strand", 
		"pos", "qual", "cigar")]
	colnames(sam1)<- c("qName","rName","strand","pos","qual",
		"cigar")

	### Incorporate FLAGS to figure what reads are fisrt or second from mate in singletons
	### then adjust strands accordingly.
	### Use flags<-bamFlagAsBitMatrix(mcols(unlist(readTmpFil))$flag)
	### Column 7 and 8 is first or second mate
	### Update what in scanbamwhat with scParam3=Rsamtools::ScanBamParam(
	###what=Rsamtools::scanBamWhat()[c(1,
	###                                3,5,8,13,9, 10, 6, 4, 14, 15, 2)],

	# if(logFile!="")
	# 	cat( "Analyzing single reads, ID: ", sam1[1,"qName"], "\n", 
	# 		file=logFile, append=appendLogFile)
	# cat( "Analyzing single reads, ID: ", sam1[1,"qName"], "\n")

######
######!!!
	exExRes<- c()
	intRetRes<- c()
	intSpanRes<- c()
	exSkipRes<- c()
  if(length(readTmp)>0){
  	if( length(which(method %in% c("IntRet","ExEx")))>0 ){ 
  ######!!!
  ######
  		lenRead1= unlist(lapply(sam1$cigar, function(tmp) {
  			frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  			names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  				unlist(strsplit(tmp,split="")))]
  			return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  		}))
  
  		lenRead2= 0
  		locRead1= sam1[,"pos"]
  		chrRead1= sam1[,"rName"]
  		chrRead2= 0
  		locRead2= 0
  		strRead1=sam1[,"strand"]
  		strRead2=0

  		if(strandSpecific=="stranded"){
  		  if(length(which(readMate==2))>0)
  		    strRead1[which(readMate==2)]<- 
  		      as.character(revStr[which(readMate==2)]) 
  		} else if (strandSpecific=="reverse"){
  		  strRead1[which(readMate==1)]<- 
  		    as.character(revStr[strRead1[which(readMate==1)]])
  		}  

  
  		frqEventRead1 =lapply(1:length(sam1$cigar), function (tmp) {
  			frqEventTmp= as.numeric(unlist(strsplit(sam1$cigar[tmp],
  				split="[A-Z]")))
  			names(frqEventTmp)= unlist(strsplit(sam1$cigar[tmp], 
  				split=""))[grep('[A-Z]', unlist(strsplit(sam1$cigar[tmp]
  					, split="")))]
  			frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  				c("N","D","M")))]
  
  	# Finding start and end of the mapped pieces of the reads using cigar 
  			eventTmp<- c(locRead1[tmp], locRead1[tmp]+
  				cumsum(as.numeric(frqEventTmp)))
  			begEventTmp<-eventTmp[-length(eventTmp)]
  			endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  
  			frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  				"M"))]
  			return( list(readNo=rep(tmp,length(frqEventTmpM)), 
  				chr=rep(chrRead1[tmp],length(frqEventTmpM)), 
  				frqEventTmpM, begEventTmpM, endEventTmpM,
  				strand=rep(strRead1[tmp],length(frqEventTmpM)),
  				mate=rep(readMate[tmp],length(frqEventTmpM))))
  		})
  
  		frqEventRead2=NA
  		noRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[1]]))))
  		chrRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[2]]))))
  		begRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[4]]))))
  		endRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  			unlist(tmp[[5]]))))
  		strRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  		  as.character(unlist(tmp[[6]])))))
  		mateRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  		  as.character(unlist(tmp[[7]])))))
  		noRead2= c()
  		chrRead2= c()
  		begRead2= c()
  		endRead2= c()
  		strRead2= c()
  		strRead2= c()
  		strAdj1<- strRead1
  		
  		##### HERE 1 !!!!
  		strAdj2<- c()
  # analyzing reads
  		noVec=c(noRead1,noRead2)
  		chrVec=c(as.character(chrRead1),
  			as.character(chrRead2))
  		begVec=c(begRead1,begRead2)
  		endVec=c(endRead1,endRead2)
  		strVec=c(as.character(strAdj1),
  		         as.character(strAdj2))
  		exExRes<- c()
  		intRetRes<- c()
  		methodNo= which(method=="ExEx")
  		if(length(methodNo)>0){
  			ref= reference[which(referenceIntronExon=="exon"),]
  			readGRanges=GenomicRanges::GRanges( seqnames=chrVec, 
  				IRanges::IRanges(start=begVec, end=endVec), strand=strVec)
  			refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  				IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"], 
  					width=ref[,"end"]-ref[,"begin"]+1), strand=ref[,"strand"])
  			hits1 <- GenomicRanges::findOverlaps(readGRanges, refGRanges, 
  				type= "start", ignore.strand=FALSE)
  			if(logFile!="")
  			  cat( "Part8 ",qNam, "\n",
  			       file=logFile, append=appendLogFile)
  			hits2 <- GenomicRanges::findOverlaps(readGRanges, refGRanges, 
  				type= "end", ignore.strand=FALSE)
  			if(logFile!="")
  			  cat( "Part9 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			hits3 <- GenomicRanges::findOverlaps(readGRanges, refGRanges, 
  				type= "equal", ignore.strand=FALSE)
  			if(logFile!="")
  			  cat( "Part10 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			hitsSubject<- c()
  			hitsQuery<- c()
  			# Filter reads mapped to repeats regions if requested
  			if(length(repeatsTableToFilter)!=0){
  				repeatGRanges= GenomicRanges::GRanges( 
  					seqnames=repeatsTableToFilter[,"chr"], 
  					IRanges::IRanges(start=repeatsTableToFilter[,"begin"], 
  						end=repeatsTableToFilter[,"end"], 
  						width=repeatsTableToFilter[,"end"]-
  							repeatsTableToFilter[,"begin"]+1))
  				hitsFilter= GenomicRanges::findOverlaps(readGRanges, 
  					repeatGRanges, type= "any", ignore.strand=TRUE)
  	
  				filtInd1= which(is.na(match(S4Vectors::queryHits(hits1), 
  					S4Vectors::queryHits(hitsFilter))))
  				filtInd2= which(is.na(match(S4Vectors::queryHits(hits2),  
  					S4Vectors::queryHits(hitsFilter))))
  				filtInd3= which(is.na(match(S4Vectors::queryHits(hits3),  
  					S4Vectors::queryHits(hitsFilter))))
  				hits1= hits1[filtInd1,]
  				hits2= hits2[filtInd2,]
  				hits3= hits3[filtInd3,]
  			}
  			# Include the reads that completely map to exons if user asked
  			if(!junctionReadsOnly){
  				hitsExtra= GenomicRanges::findOverlaps(readGRanges, 
  					refGRanges, type= "within", ignore.strand=FALSE)
  				hitsSubject=S4Vectors::subjectHits(hitsExtra)
  				hitsQuery=S4Vectors::queryHits(hitsExtra)
  			}
  		
  			hitsSubject=c(hitsSubject, S4Vectors::subjectHits(hits1),
  				S4Vectors::subjectHits(hits2),S4Vectors::subjectHits(hits3))
  			if(logFile!="")
  			  cat( "Part11 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			hitsQuery=c(hitsQuery, S4Vectors::queryHits(hits1), 
  				S4Vectors::queryHits(hits2), S4Vectors::queryHits(hits3))
  			refRes= rep(0,nrow(ref))
  			if(length(hitsQuery)>0){
  				hitsApply= tapply(noVec[hitsQuery], hitsSubject, function(tmp)
  					return(length(unique(tmp))) )
  				refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			}
  			if(logFile!="")
  			  cat( "Part12 ",qNam, "\n", 
  			       file=logFile, append=appendLogFile)
  			exExRes<-rep(0, nrow(reference))
  			exExRes[which(referenceIntronExon=="exon")]<- refRes

  			rm("refRes")
  	
  		}

  		methodNo=which(method=="IntRet")
  		if((length(methodNo)>0) & (! junctionReadsOnly)){
  	
  			ref=reference[which(referenceIntronExon=="intron"),]
  			readGRanges=GenomicRanges::GRanges( seqnames=chrVec, 
  				IRanges::IRanges(start=begVec, end=endVec), strand=strVec)
  			refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  				IRanges(start=ref[,"begin"], end=ref[,"end"], 
  					width=ref[,"end"]-ref[,"begin"]+1), strand=ref[,"strand"])
  			hits <- GenomicRanges::findOverlaps(readGRanges, refGRanges, 
  				type= "any", ignore.strand=FALSE)
  			# Filter reads mapped to repeats regions if requested
  			if(length(repeatsTableToFilter)!=0){
  				repeatGRanges= GenomicRanges::GRanges( 
  					seqnames=repeatsTableToFilter[,"chr"], 
  					IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  						end=repeatsTableToFilter[,"end"], 
  						width=repeatsTableToFilter[,"end"]-
  							repeatsTableToFilter[,"begin"]+1))
  				hitsFilter= GenomicRanges::findOverlaps(readGRanges, 
  					repeatGRanges, type= "any", ignore.strand=TRUE)
  				filtInd= which(is.na(match(S4Vectors::queryHits(hits), 
  					S4Vectors::queryHits(hitsFilter))))
  				hits=hits[filtInd,]
  			}
  			# Filter reads mapped completely to Either introns or exons
  			refRes= rep(0,nrow(ref))
  			if(length(S4Vectors::queryHits(hits))>0){
  				hitsApply=tapply(noVec[S4Vectors::queryHits(hits)], 
  					S4Vectors::subjectHits(hits), 
  					function(tmp) return(length(unique(tmp))) )
  				refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			}
  			intRetRes<- rep(0,nrow(reference))
  			intRetRes[which(referenceIntronExon=="intron")]<- refRes
  			
  			rm("refRes")
  	
  		} else if ((length(methodNo)>0) & (junctionReadsOnly)) {
  			ref=reference[which(referenceIntronExon=="intron"),]
  			readGRanges=GenomicRanges::GRanges( seqnames=chrVec, 
  				IRanges::IRanges(start=begVec, end=endVec), strand=strVec)
  			refEndGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  				IRanges::IRanges(start=ref[,"end"], end=ref[,"end"]),
  				strand=ref[,"strand"])
  			refBegGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  				IRanges::IRanges(start=ref[,"begin"], end=ref[,"begin"]),
  				strand=ref[,"strand"])
  			hitsEnd <- GenomicRanges::findOverlaps(refEndGRanges, readGRanges,
  				type= "within", ignore.strand=FALSE)
  			hitsBeg <- GenomicRanges::findOverlaps(refBegGRanges, readGRanges,
  				type= "within", ignore.strand=FALSE)
  			# Filter reads mapped to repeats regions if requested
  			if(length(repeatsTableToFilter)!=0){
  				repeatGRanges= GenomicRanges::GRanges( 
  					seqnames=repeatsTableToFilter[,"chr"], 
  					IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  						end=repeatsTableToFilter[,"end"], 
  						width=repeatsTableToFilter[,"end"]-
  							repeatsTableToFilter[,"begin"]+1))
  				hitsFilter= GenomicRanges::findOverlaps(readGRanges, 
  					repeatGRanges, type= "any", ignore.strand=TRUE)
  				filtEndInd= which(is.na(match(S4Vectors::subjectHits(hitsEnd), 
  					S4Vectors::queryHits(hitsFilter))))
  				filtBegInd= which(is.na(match(S4Vectors::subjectHits(hitsBeg), 
  					S4Vectors::queryHits(hitsFilter))))
  				hitsEnd=hitsEnd[filtEndInd,]
  				hitsBeg=hitsBeg[filtBegInd,]
  			}
  
  			refRes= rep(0,nrow(ref))
  			refResBeg= refRes
  			refResEnd= refRes
  			if( (length(S4Vectors::subjectHits(hitsBeg))>0) | 
  				(length(S4Vectors::subjectHits(hitsEnd))>0) ){
  				hitsEndApply=tapply(noVec[S4Vectors::subjectHits(hitsEnd)], 
  					S4Vectors::queryHits(hitsEnd), 
  					function(tmp) return(length(unique(tmp))) )
  				hitsBegApply=tapply(noVec[S4Vectors::subjectHits(hitsBeg)], 
  					S4Vectors::queryHits(hitsBeg), 
  					function(tmp) return(length(unique(tmp))) )
  				refResBeg[as.numeric(names(hitsBegApply))]= 
  					as.numeric(hitsBegApply)
  				refResEnd[as.numeric(names(hitsEndApply))]= 
  					as.numeric(hitsEndApply)
  				refRes=refResBeg+refResEnd
  				rm("refResBeg","refResEnd")
  			}
  			intRetRes<- rep(0,nrow(reference))
  			intRetRes[which(referenceIntronExon=="intron")]<- refRes
  			
  			rm("refRes")
  		}
  	}
    
### HERE !!!
    
  	methodNo=which(method=="IntSpan")
  	if(length(methodNo)>0){
  
  	  sam1IndSp<- grep("N",sam1$cigar)
  	  sam2IndSp<- c()
  	  
  	  lenRead1= unlist(lapply(sam1$cigar[sam1IndSp], function(tmp) {
  	    frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  	    names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  	                                                        unlist(strsplit(tmp,split="")))]
  	    return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  	  }))
  	  
  	  locRead1= sam1[,"pos"]
  	  chrRead1= sam1[,"rName"]
  	  strRead1=sam1[,"strand"]
  	  chrRead2= c()
  	  strRead2=c()
  	  locRead2=c()
  	  
  	  if(strandSpecific=="stranded"){
  	    if(length(which(readMate==2))>0)
  	      strRead1[which(readMate==2)]<- 
  	        as.character(revStr[which(readMate==2)]) 
  	  } else if (strandSpecific=="reverse"){
  	    strRead1[which(readMate==1)]<- 
  	      as.character(revStr[strRead1[which(readMate==1)]])
  	  }  
  	  
  	  frqEventRead1 =lapply(sam1IndSp, function (tmp) {
  	    frqEventTmp= as.numeric(unlist(strsplit(sam1$cigar[tmp],
  	                                            split="[A-Z]")))
  	    names(frqEventTmp)= unlist(strsplit(sam1$cigar[tmp], 
  	                                        split=""))[grep('[A-Z]', unlist(strsplit(sam1$cigar[tmp]
  	                                                                                 , split="")))]
  	    frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          c("N","D","M")))]
  	    
  	    # Finding start and end of the mapped pieces of the reads using cigar 
  	    eventTmp<- c(locRead1[tmp], locRead1[tmp]+
  	                   cumsum(as.numeric(frqEventTmp)))
  	    begEventTmp<-eventTmp[-length(eventTmp)]
  	    endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  	    frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]	    
  	    frqEventTmpN=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    begEventTmpN=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    endEventTmpN=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    return( list(readNo=rep(tmp,length(frqEventTmpN)), 
  	                 chr=rep(chrRead1[tmp],length(frqEventTmpN)), 
  	                 frqEventTmpN, begEventTmpN, endEventTmpN,
  	                 frqEventTmpM, begEventTmpM, endEventTmpM,
  	                 readNoM=rep(tmp,length(frqEventTmpM)),
  	                 strand=rep(strRead1[tmp],length(frqEventTmpN)),
  	                 mate=rep(readMate[tmp],length(frqEventTmpN)),
  	                 chrM=rep(chrRead1[tmp],length(frqEventTmpM))))
  	    
  	  })
  	  
  	  frqEventRead2=NA
  	  
  	  noRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[1]]))))
  	  chrRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[2]]))))
  	  begRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[4]]))))
  	  endRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[5]]))))
  	  strRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    as.character(unlist(tmp[[10]])))))
  	  mateRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    as.character(unlist(tmp[[11]])))))
  	  noRead2= c()
  	  chrRead2= c()
  	  begRead2= c()
  	  endRead2= c()
  	  strRead2=c()
  	  strAdj1<- strRead1
  	  
  	  # analyzing reads
  	  noVec=c(noRead1,noRead2)
  	  chrVec=c(as.character(chrRead1),
  	           as.character(chrRead2))
  	  begVec=c(begRead1,begRead2)
  	  endVec=c(endRead1,endRead2)
  	  strVec=c(as.character(strAdj1),
  	           as.character(strAdj2))
  	  
  		ref=reference[which(referenceIntronExon=="intron"),]
  		readGRanges=GenomicRanges::GRanges( seqnames=chrVec, 
  			IRanges::IRanges(start=begVec, end=endVec), strand=strVec)
  
  		# refIntBegGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  		# 	IRanges::IRanges(start=ref[,"begin"]-1, end=ref[,"begin"]-1), 
  		# 	strand=ref[,"strand"])
  		# refIntEndGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"], 
  		# 	IRanges::IRanges(start=ref[,"end"]+1, end=ref[,"end"]+1), 
  		# 	strand=ref[,"strand"])
  		refIntGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"],
  		  IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"]),
        strand=ref[,"strand"])

  		### !!!
  		### THIS IS NOT THE BEST WAY. WHY SEPARATE ON BEGIN AND END ?
  		###WHY NOT 	hitsBegInt <- GenomicRanges::findOverlaps(readGRanges, 
  		###    refIntGRanges, type= "equal")
  		
  		# hitsBegInt <- GenomicRanges::findOverlaps(readGRanges, 
  		# 	refIntBegGRanges, type= "end", ignore.strand=FALSE)
  		# hitsEndInt <- GenomicRanges::findOverlaps(readGRanges, 
  		# 	refIntEndGRanges, type= "start", ignore.strand=FALSE)
  		hitsInt <- GenomicRanges::findOverlaps(readGRanges, 
        refIntGRanges, type= "equal", ignore.strand=FALSE)
  		
  			# Filter reads mapped to repeats regions if requested
  # 			if(length(repeatsTableToFilter)!=0){
  # 				repeatGRanges= GenomicRanges::GRanges( 
  # 					seqnames=repeatsTableToFilter[,"chr"], 
  # 					IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  # 						end=repeatsTableToFilter[,"end"], 
  # 						width=repeatsTableToFilter[,"end"]-
  # 							repeatsTableToFilter[,"begin"]+1))
  # 				# hitsFilter= GenomicRanges::findOverlaps(readGRanges, 
  # 				# 	repeatGRanges, type= "any", ignore.strand=TRUE)
  # 				# filtBegInd= which(is.na(match(S4Vectors::queryHits(hitsBegInt),
  # 				# 	S4Vectors::queryHits(hitsFilter))))
  # 				# hitsBegInt=hitsBegInt[filtBegInd,]
  # 				# filtEndInd= which(is.na(match(S4Vectors::queryHits(hitsEndInt),
  # 				# 	S4Vectors::queryHits(hitsFilter))))
  # 				# hitsEndInt=hitsEndInt[filtEndInd,]
  # 				hitsFilter= GenomicRanges::findOverlaps(readGRanges, 
  #           repeatGRanges, type= "equal", ignore.strand=TRUE)
  # 				filtInd= which(is.na(match(S4Vectors::queryHits(hitsInt),
  # 				                              S4Vectors::queryHits(hitsFilter))))
  # 				hitsInt=hitsInt[filtInd,]
  # 			}
  			# Filter reads mapped completely to Either introns or exons
  
  			refRes= rep(0,nrow(ref))
  			# if(length(c(S4Vectors::queryHits(hitsBegInt), 
  			# 	S4Vectors::queryHits(hitsEndInt)))>0){
  			# 	hitsApply=tapply(
  			# 		noVec[c(S4Vectors::queryHits(hitsBegInt), 
  			# 			S4Vectors::queryHits(hitsEndInt))], 
  			# 		c(S4Vectors::subjectHits(hitsBegInt), 
  			# 			S4Vectors::subjectHits(hitsEndInt)),
  			# 		function(tmp) return(length(unique(tmp))) )
  			# 	refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			# }
  			if(length(S4Vectors::queryHits(hitsInt))>0){
  			  hitsApply=tapply(
  			    noVec[S4Vectors::queryHits(hitsInt)], 
  			    c(S4Vectors::subjectHits(hitsInt)),
  			    function(tmp) return(length(unique(tmp))) )
  			  refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  			}
  			intSpanRes<- rep(0,nrow(reference))
  			intSpanRes[which(referenceIntronExon=="intron")]<- refRes
  			
  			rm("refRes")
  	}
  
  ####
  ### NEW ExSkip
  	methodNo=which(method=="ExSkip")
  	if(length(methodNo)>0){
  	  
  	  sam1IndSp<- grep("N",sam1$cigar)
  	  sam2IndSp<- c()
  	  
  	  lenRead1= unlist(lapply(sam1$cigar[sam1IndSp], function(tmp) {
  	    frqEvent=as.numeric(unlist(strsplit(tmp,split="[A-Z]")))
  	    names(frqEvent)=unlist(strsplit(tmp,split=""))[grep('[A-Z]',
  	                                                        unlist(strsplit(tmp,split="")))]
  	    return(sum(frqEvent[grep("[N|M|D]",names(frqEvent))]))		
  	  }))
  	  
  	  locRead1= sam1[,"pos"]
  	  chrRead1= sam1[,"rName"]
  	  strRead1=sam1[,"strand"]
  	  chrRead2= c()
  	  strRead2=c()
  	  locRead2=c()
  	  
  	  if(strandSpecific=="stranded"){
  	    if(length(which(readMate==2))>0)
  	      strRead1[which(readMate==2)]<- 
  	        as.character(revStr[which(readMate==2)]) 
  	  } else if (strandSpecific=="reverse"){
  	    strRead1[which(readMate==1)]<- 
  	      as.character(revStr[strRead1[which(readMate==1)]])
  	  }  
  	  
  	  frqEventRead1 =lapply(sam1IndSp, function (tmp) {
  	    frqEventTmp= as.numeric(unlist(strsplit(sam1$cigar[tmp],
  	                                            split="[A-Z]")))
  	    names(frqEventTmp)= unlist(strsplit(sam1$cigar[tmp], 
  	                                        split=""))[grep('[A-Z]', unlist(strsplit(sam1$cigar[tmp]
  	                                                                                 , split="")))]
  	    frqEventTmp= frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          c("N","D","M")))]
  	    
  	    # Finding start and end of the mapped pieces of the reads using cigar 
  	    eventTmp<- c(locRead1[tmp], locRead1[tmp]+
  	                   cumsum(as.numeric(frqEventTmp)))
  	    begEventTmp<-eventTmp[-length(eventTmp)]
  	    endEventTmp<- begEventTmp+as.numeric(frqEventTmp)-1
  	    frqEventTmpM=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    begEventTmpM=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]
  	    endEventTmpM=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "M"))]	    
  	    frqEventTmpN=frqEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    begEventTmpN=begEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    endEventTmpN=endEventTmp[!is.na(match(names(frqEventTmp),
  	                                          "N"))]
  	    return( list(readNo=rep(tmp,length(frqEventTmpN)), 
  	                 chr=rep(chrRead1[tmp],length(frqEventTmpN)), 
  	                 frqEventTmpN, begEventTmpN, endEventTmpN,
  	                 frqEventTmpM, begEventTmpM, endEventTmpM,
  	                 readNoM=rep(tmp,length(frqEventTmpM)),
  	                 strand=rep(strRead1[tmp],length(frqEventTmpN)),
  	                 mate=rep(readMate[tmp],length(frqEventTmpN)),
  	                 chrM=rep(chrRead1[tmp],length(frqEventTmpM))))
  	    
  	  })
  	  
  	  frqEventRead2=NA
  	  
  	  noRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[1]]))))
  	  chrRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[2]]))))
  	  begRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[4]]))))
  	  endRead1= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    unlist(tmp[[5]]))))
  	  strRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    as.character(unlist(tmp[[10]])))))
  	  mateRead1=as.vector(unlist(sapply(frqEventRead1, function(tmp)
  	    as.character(unlist(tmp[[11]])))))
  	  noRead2= c()
  	  chrRead2= c()
  	  begRead2= c()
  	  endRead2= c()
  	  strRead2=c()
  	  strAdj1<- strRead1
  	  
  	  # analyzing reads
  	  noVec=c(noRead1,noRead2)
  	  chrVec=c(as.character(chrRead1),
  	           as.character(chrRead2))
  	  begVec=c(begRead1,begRead2)
  	  endVec=c(endRead1,endRead2)
  	  strVec=c(as.character(strAdj1),
  	           as.character(strAdj2))
  	  
  	  ref=reference[which(referenceIntronExon=="exon"),]
  	  readGRanges=GenomicRanges::GRanges( seqnames=chrVec,
  	    IRanges::IRanges(start=begVec, end=endVec), strand=strVec)
  	  
  	  refGRanges= GenomicRanges::GRanges( seqnames=ref[,"chr"],
        IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"]),
        strand=ref[,"strand"])
  
  	  hitsAllEx <- GenomicRanges::findOverlaps(refGRanges, 
        readGRanges, type= "within", ignore.strand=FALSE)
  
  	  # Filter reads mapped to repeats regions if requested
  # 	  if(length(repeatsTableToFilter)!=0){
  # 	    noRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  # 	      unlist(tmp[[9]]))))
  # 	    chrRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  # 	      unlist(tmp[[12]]))))
  # 	    begRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  # 	      unlist(tmp[[7]]))))
  # 	    endRead1M= as.vector(unlist(sapply(frqEventRead1, function(tmp)
  # 	      unlist(tmp[[8]]))))
  # 	    noRead2M= c()
  # 	    chrRead2M= c()
  # 	    begRead2M= c()
  # 	    endRead2M= c()
  # 	    
  # 	    # analyzing reads
  # 	    noVecM=c(noRead1M,noRead2M)
  # 	    chrVecM=c(as.character(chrRead1M),
  # 	             as.character(chrRead2M))
  # 	    begVecM=c(begRead1M,begRead2M)
  # 	    endVecM=c(endRead1M,endRead2M)
  # 	    
  # 	    readGRangesM=GenomicRanges::GRanges( seqnames=chrVecM, 
  #         IRanges::IRanges(start=begVecM, end=endVecM))
  # 	    repeatGRanges= GenomicRanges::GRanges( 
  # 	      seqnames=repeatsTableToFilter[,"chr"], 
  # 	      IRanges::IRanges(start=repeatsTableToFilter[,"begin"],
  # 	                       end=repeatsTableToFilter[,"end"], 
  # 	                       width=repeatsTableToFilter[,"end"]-
  # 	                         repeatsTableToFilter[,"begin"]+1))
  # 	    hitsFilter= GenomicRanges::findOverlaps(readGRangesM, 
  #         repeatGRanges, type= "any", ignore.strand=TRUE)
  # 	    # filthitsAllExInd= which(is.na(match(S4Vectors::subjectHits(hitsBegInt),
  # 	    #                               S4Vectors::queryHits(hitsFilter))))
  # 	    noVecFil<- unique(noVecM[queryHits(hitsFilter)])
  # 	    filthitsAllExInd<- which(!subjectHits(hitsAllEx) %in% 
  # 	                               subjectHits(hitsAllEx)[
  # 	                                 which(noVec[subjectHits(hitsAllEx)]
  # 	                                       %in% noVecFil)])
  # 	    hitsAllEx=hitsAllEx[filthitsAllExInd,]
  # 
  # 	  }
  	  # Filter reads mapped completely to Either introns or exons
  	  
  	  refRes= rep(0,nrow(ref))
  	  if(length(S4Vectors::subjectHits(hitsAllEx))>0){
  	    hitsApply=tapply(
  	      noVec[S4Vectors::subjectHits(hitsAllEx)], 
  	      S4Vectors::queryHits(hitsAllEx),
  	      function(tmp) return(length(unique(tmp))) )
  	    refRes[as.numeric(names(hitsApply))]= as.vector(hitsApply)
  	  }
  	  exSkipRes<- rep(0,nrow(reference))
  	  exSkipRes[which(referenceIntronExon=="exon")]<- refRes
  	  
  	  rm("refRes")
  	}
  }
########!!!
########
	finalRes<-c()

	
	if(length(exExRes)==0)
	  exExRes<- rep(0,nrow(reference))	
		
	if(length(intRetRes)==0)
	  intRetRes<- rep(0,nrow(reference))

	
	if(length(intSpanRes)==0)
	  intSpanRes<- rep(0,nrow(reference))
	
	if(length(exSkipRes)==0)
	  exSkipRes<- rep(0,nrow(reference))

	
	#	if(length(exExRes)>0){
	if("ExEx" %in% method)
	  finalRes<-c(finalRes, exExRes)
	rm("exExRes")	
		
	#	if(length(intRetRes)>0)
	if("IntRet" %in% method)
	  finalRes<-c(finalRes, intRetRes)
	rm("intRetRes")
	

	########
	########!!!
	#	if(length(intSpanRes)>0)
	if("IntSpan" %in% method)
	  finalRes<-c(finalRes, intSpanRes)
	rm("intSpanRes")
	
	#	if(length(exSkipRes)>0)
	if("ExSkip" %in% method)
	  finalRes<-c(finalRes, exSkipRes)
	rm("exSkipRes")
########!!!
########
	if(logFile!="")
	  cat( "Singleend ", 
	       qNam, " ", length(finalRes), "\n",
	       file=logFile, append=appendLogFile)
	cat( "Singleend ", 
	     qNam, " ", length(finalRes), "\n")
	# if(is.null(finalRes) | (length(finalRes)==0))
	#   finalRes<- rep(0, 
	#     length(which(method%in%c("ExEx", "IntRet", "IntSpan", "ExSkip"))))
	return(finalRes)
	rm("finalRes")
#End of defining function for single mapped reads that runs on parallel cores
} 
	

deseqInterest<- function(x, design,  
	pAdjustMethod = "BH", sizeFactor=c(), 
	contrast, bpparam, ...){
	if(missing(bpparam)){
		parallel<- FALSE
	} else {
		parallel<-TRUE
	}
	dds<- DESeq2::DESeqDataSetFromMatrix(countData = counts(x), 
		colData = colData(x), design = design)
	if(length(sizeFactor)>0)
		DESeq2::sizeFactors(dds)=sizeFactor
	dds<- DESeq2::DESeq(dds, BPPARAM = bpparam)
	cat("\nResult names that can be used for contrasts are:\n")
	cat(DESeq2::resultsNames(dds))
	cat("\n")
	ddsDiff<- DESeq2::results(dds, 
	contrast=contrast, pAdjustMethod=pAdjustMethod, parallel = parallel, 
	BPPARAM = bpparam, ...)
	return(ddsDiff)
}

u12Boxplot<-function(x, sampleAnnoCol=NA, intExCol="int_ex", 
	intTypeCol="int_type", intronExon, col="white", boxplotNames=c(), 
	lasNames=3, outline=FALSE, addGrid=FALSE, ...)
{
	object=x
	if(!is.na(sampleAnnoCol)){
		groups=SummarizedExperiment::colData(object)[,sampleAnnoCol]
	} else {
		groups=x@sampleNames
	}
	uniGroup=unique(as.vector(groups))
	color=c()	
	plotList=c()
	axisAt=c()
	for(cnt in 1:length(uniGroup)){
		axisAt=c(axisAt,TRUE,TRUE,FALSE)
		if(length(col)>1)
			color=c(color, col[(cnt*2)-1],col[(cnt*2)], NA)
		if(length(col)==1)
			color=c(color, col, col, NA)
		if(intronExon=="intron"){
			plotList=c(plotList, 
				list( as.vector(
					unlist(scaledRetention(object)[
						SummarizedExperiment::rowData(object)[,intExCol]==
							"intron" & 
						SummarizedExperiment::rowData(object)[,intTypeCol]==
							"U12", 
						which(groups==uniGroup[cnt])])), 
					as.vector(unlist(scaledRetention(object)[
						SummarizedExperiment::rowData(object)[,intExCol]==
							"intron" & 
						SummarizedExperiment::rowData(object)[,intTypeCol]==
							"U2",
					which(groups==uniGroup[cnt])])), NA))
		} else if (intronExon=="exon") {
			indChooseIntU12=unique(which(SummarizedExperiment::rowData(
				object)[,intExCol]=="intron"
				& SummarizedExperiment::rowData(object)[,intTypeCol]=="U12"))
			indChooseIntU2=unique(which(SummarizedExperiment::rowData(
				object)[,intExCol]=="intron"
				& (SummarizedExperiment::rowData(object)[,
					intTypeCol]!="U12") ))

			indChooseExU12=unique(unlist(lapply(indChooseIntU12, function(tmp)
				return(c(tmp-1, tmp+1)))))
			indChooseExU2=unique(unlist(lapply(indChooseIntU2, function(tmp)
				return(c(tmp-1, tmp+1)))))
			indChooseExU2=indChooseExU2[which(is.na(match(indChooseExU2,
				indChooseExU12)))]
			plotList=c(plotList, 
				list( as.vector(unlist(scaledRetention(object)[indChooseExU12,
					which(groups==uniGroup[cnt])])), 
					as.vector(unlist(scaledRetention(object)[indChooseExU2,
					which(groups==uniGroup[cnt])])), NA))				
		}
		if(length(boxplotNames)==0){
			names(plotList)[(length(plotList)-2):length(plotList)]=
				c(paste("U12",uniGroup[cnt], sep=" "),
					paste("U2",uniGroup[cnt], sep=" "),"")
		} else {
			names(plotList)[(length(plotList)-2):length(plotList)]=
				c(boxplotNames[(cnt*2)-1],boxplotNames[(cnt*2)],"")
		}
	}
	plotList=plotList[-length(plotList)]
	axisAt=axisAt[-length(axisAt)]
	color=color[-length(color)]

	graphics::boxplot(plotList, names=c(), xaxt = "n", outline=outline, 
		col=color, ...)
	if(addGrid){
		graphics::grid(nx=NA, ny=NULL)
		graphics::boxplot(plotList, names=c(), xaxt = "n", outline=outline, 
		col=color, add=TRUE, ...)
	}
	if(length(boxplotNames)==0)
		boxplotNames=names(plotList)
	graphics::axis(1,at=which(axisAt), labels=boxplotNames[boxplotNames!=""],
		las=lasNames, ...)

}

getRepeatTable<-function(
	dbUser="genome",
	dbHost="genome-mysql.cse.ucsc.edu",
	ucscGenome="hg19",
	ucscTable="rmsk",
	minLength=0,
	repFamilyFil="Alu",
	repFamilyCol="repFamily",
	repChrCol="genoName",
	repBegCol="genoStart",
	repEndCol="genoEnd",
	repStrandCol="strand",
	repNameCol="repName",
	repClassCol="repClass")
{
# Calling required functions
dbConnect<- DBI::dbConnect
dbGetQuery<- DBI::dbGetQuery
dbDisconnect<- DBI::dbDisconnect
MariaDB<- RMariaDB::MariaDB

# Connecting to the online shared database and getting the data
con <- dbConnect(MariaDB(), user=dbUser, host=dbHost, db=ucscGenome)
tblRmsk <- dbGetQuery(con, paste("select * from ", ucscTable, ";", sep=""))
tblRmskFilType=tblRmsk[!is.na(match(tblRmsk[,repFamilyCol],repFamilyFil)),]
tblRmskFilTypeFilLen= tblRmskFilType[(tblRmskFilType[,repEndCol]-
	tblRmskFilType[,repBegCol]+1)>minLength,]
dbDisconnect(con)

# OR FOLLOWING CODES ALSO RETREIVES THE RMSK TABLE
#library(rtracklayer)
#session <- rtracklayer::browserSession(browserName, url=browserUrl)
#GenomeInfoDb::genome(session) <- ucscGenome
#tblRmsk <- rtracklayer::getTable(rtracklayer::ucscTableQuery(session, 
#track=ucscTrackName, table=ucscTable))

res= tblRmskFilTypeFilLen[,c(repChrCol, repBegCol, repEndCol, repStrandCol, 
	repNameCol, repClassCol, repFamilyCol)]
colnames(res)[1:3]=c("chr","begin","end")
return(res)

}

unionRefTr<- function( referenceChr, 
    referenceBegin, 
    referenceEnd, 
	referenceTr,
	referenceIntronExon,
	intronExon="exon", 
	silent=FALSE){

	loc<- paste(referenceChr, referenceBegin, referenceEnd, sep='/')
	ind<- which(referenceIntronExon %in% intronExon)
	tr<- as.character(referenceTr)
	if(any((intronExon=="exon"|intronExon=="intron") & 
		length(intronExon)==1)){
		tr<- tr[ind]
		loc<-loc[ind]
		referenceIntronExon<- referenceIntronExon[ind]
	}
	locTrMap<- tapply(tr,loc,unique)
	uniLoc<- names(locTrMap)
	tmpMat<- matrix(unlist(strsplit(uniLoc, split="/")), ncol=3, 
		byrow=TRUE)
	res<-cbind( tmpMat, as.vector(unlist(sapply(locTrMap, function(tmp) 
		paste(tmp, collapse=",")))) )
	colnames(res)<- c("chr", "begin", "end", "transcripts_id")

	genList<- strsplit(res[,"transcripts_id"], split=',')

	genVec<- unlist(genList)
	genUni<-unique(genVec)	
	indVecOrig<- unlist(lapply(1:length(genList), function(tmp){ 
		rep(tmp, length(unlist(genList[tmp]))) 
		} ))
	indVec<-indVecOrig
	lenGenUni<-length(genUni)
	lapplyRes<- lapply(1:lenGenUni, function(i){
		if(i %% 1000 == 1 & (!silent)) 
			print(paste(i, lenGenUni, sep="/"))
		genTmp<-genUni[i]
		if(length(genTmp)>0){
			matchGen<-which(genVec==genTmp)
			indTmp<-indVec[matchGen]
			if(length(indTmp)>0 & length(which(is.na(indTmp)))==0){
				matchInds<-which(indVec%in%indTmp)
				indVec[matchInds]<<-min(indTmp)
			}
		}
	})
	genAnnoTmp<- as.character(
		tapply(genVec, indVec, function(tmp) 
			paste(unique(tmp), collapse=",")))
	if(length(which(intronExon%in%"intron"))>0){
		intExRes<- tapply(referenceIntronExon, loc, head, 1)
	} else if(length(intronExon)==1) {
		intExRes<-as.character(rep(intronExon, nrow(res)))
	}
	names(genAnnoTmp)<- unique(indVec)
	names(intExRes)<- unique(indVec)

	resDf<- data.frame(chr= as.character(res[,"chr"]),
		begin= as.numeric(res[,"begin"]),
		end= as.numeric(res[,"end"]),
		transcripts_id= as.character(
			tapply(indVec, indVecOrig, function(tmp) 
				unique(genAnnoTmp[as.character(tmp)]))),
		int_ex=intExRes)
	resDf<- resDf[order(as.character(resDf[,"transcripts_id"]), 
		decreasing=FALSE),]
	return(resDf)
}

u12Index<-
	function(x, intExCol="int_ex", intTypeCol="int_type", intronExon="intron"){
	return(which(SummarizedExperiment::rowData(x)[,intExCol]==intronExon & 
		SummarizedExperiment::rowData(x)[,intTypeCol]=="U12"))
}

DEXSeqIntEREst <- function(x, design, reducedModel= ~ sample + intex, 
fitExpToVar, intExCol, geneIdCol, bpparam, silent=TRUE, ...){
	if(missing(bpparam)){
		bpparam<- BiocParallel::MulticoreParam(workers=1)
	}

#Check which of the three 'intron' 'exon' or 'intex' variables are used
	parIntExVar<-c("intron", "exon", "intex")
	matchParIntExVar<-match(all.vars(design),parIntExVar)
	matchParIntExVar<-matchParIntExVar[which(!is.na(matchParIntExVar))]
	intEx<- parIntExVar[matchParIntExVar]

	if(length(intEx)==1 & (intEx=="intron"|intEx=="exon")){
		intronExon<-intEx
	} else if(length(intEx)==1 & intEx=="intex"){
		intronExon<-c("intron","exon")
	} else {
		stop(
"One of the variables 'intron', 'exon' or 'intex' must be used in the design.")
	}


# Replace 'intron' in the formula with 'exon' as expected by DEXSeq
	design<- eval(parse(text=paste("substitute(", deparse(design), 
		", list(intron=quote(exon)))", sep="")))
	design<- eval(parse(text=paste("substitute(", deparse(design), 
		", list(intex=quote(exon)))", sep=""))) 	
	reducedModel<- eval(parse(text=paste("substitute(", deparse(reducedModel),
		", list(intron=quote(exon)))", sep="")))
	reducedModel<- eval(parse(text=paste("substitute(", deparse(reducedModel),
		", list(intex=quote(exon)))", sep="")))
	design<-eval(parse(text=design))
	reducedModel<-eval(parse(text=reducedModel))

# Extract the introns or exon (or both) corresponding rows from the object
	x<- x[which(rowData(x)[,intExCol] %in% intronExon),]

	sampleTable<- as.data.frame(colData(x))
	dexObj<- DEXSeq::DEXSeqDataSet( countData=counts(x), 
		sampleData=sampleTable,
		design= design,
		featureID=as.character(1:nrow(counts(x))), 
		groupID=as.character(rowData(x)[,geneIdCol]), ...)

	dexRes<- DEXSeq::DEXSeq(dexObj, BPPARAM=bpparam, 
		fitExpToVar=fitExpToVar, reducedModel=reducedModel, quiet=silent)
	return(dexRes)
}

buildSsTypePwms<-function(
	cexSeqLogo=1,
	pdfWidth=35,
	pdfHeight=10,
	tmpDir="./",
	u12dbSpecies="Homo_sapiens",	
	pwmSource="U12DB",
	u12DonorBegin, u12BranchpointBegin, u12AcceptorBegin, 
	u2DonorBegin, u2AcceptorBegin, u12DonorEnd, 
	u12BranchpointEnd, u12AcceptorEnd, u2DonorEnd, 
	u2AcceptorEnd, pasteSites=FALSE,
	splicerackSsLinks=list(
		U12_AT_AC_donor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.25", 
		U12_AT_AC_branchpoint=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.26", 
		U12_AT_AC_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.29", 
		U12_GT_AG_donor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.22", 
		U12_GT_AG_branchpoint=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.27", 
		U12_GT_AG_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.21", 
		U2_GC_AG_donor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.24", 
		U2_GC_AG_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.30", 
		U2_GT_AG_donor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.23", 
		U2_GT_AG_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.28"),
	u12dbLink="https://genome.crg.cat/pub/software/u12/u12db_v1_0.sql.gz",
	u12dbDbName="u12db", u12dbDropDb=TRUE, pdfFileSeqLogos="",
	removeTempFiles=TRUE, ...)
{

	if (pwmSource=="SpliceRack"){
#from http://katahdin.mssm.edu/splice/splice_matrix.cgi?database=spliceNew
		utils::download.file(unlist(splicerackSsLinks[1]), 
			paste(tmpDir, "AT_AC_U12_Don.txt", sep="/"))
		utils::download.file(unlist(splicerackSsLinks[2]), 
			paste(tmpDir, "AT_AC_U12_BP.txt", sep="/"))
		utils::download.file(unlist(splicerackSsLinks[3]), 
			paste(tmpDir, "AT_AC_U12_Acc.txt", sep="/"))
		
		utils::download.file(unlist(splicerackSsLinks[8]), 
			paste(tmpDir, "GC_AG_U2_Acc.txt", sep="/"))
		utils::download.file(unlist(splicerackSsLinks[7]), 
			paste(tmpDir, "GC_AG_U2_Don.txt", sep="/"))

		utils::download.file(unlist(splicerackSsLinks[4]), 
			paste(tmpDir, "GT_AG_U12_Don.txt", sep="/"))
		utils::download.file(unlist(splicerackSsLinks[5]), 
			paste(tmpDir, "GT_AG_U12_BP.txt", sep="/"))
		utils::download.file(unlist(splicerackSsLinks[6]), 
			paste(tmpDir, "GT_AG_U12_Acc.txt", sep="/"))

		utils::download.file(unlist(splicerackSsLinks[9]), 
			paste(tmpDir, "GT_AG_U2_Don.txt", sep="/"))
		utils::download.file(unlist(splicerackSsLinks[10]), 
			paste(tmpDir, "GT_AG_U2_Acc.txt", sep="/"))


		donAtacU12=read.table(paste(tmpDir, "AT_AC_U12_Don.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')
		bpAtacU12=read.table(paste(tmpDir, "AT_AC_U12_BP.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')
		accAtacU12=read.table(paste(tmpDir, "AT_AC_U12_Acc.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')

		accGcagU2=read.table(paste(tmpDir, "GC_AG_U2_Acc.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')
		donGcagU2=read.table(paste(tmpDir, "GC_AG_U2_Don.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')

		donGtagU12=read.table(paste(tmpDir, "GT_AG_U12_Don.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')
		bpGtagU12=read.table(paste(tmpDir, "GT_AG_U12_BP.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')
		accGtagU12=read.table(paste(tmpDir, "GT_AG_U12_Acc.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')

		donGtagU2=read.table(paste(tmpDir, "GT_AG_U2_Don.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')
		accGtagU2=read.table(paste(tmpDir, "GT_AG_U2_Acc.txt", sep="/"), 
			skip=7, header=TRUE, stringsAsFactors=FALSE, sep='\t')

		u12DonorBeginInd=1
		u12BranchpointBeginInd=1
		u12AcceptorBeginInd=1
		u2DonorBeginInd=1
		u2AcceptorBeginInd=1

		u12DonorEndInd=nrow(donAtacU12)
		u12BranchpointEndInd=nrow(bpAtacU12)
		u12AcceptorEndInd=nrow(accAtacU12)
		u2DonorEndInd=nrow(donGtagU2)
		u2AcceptorEndInd=nrow(accGtagU2)

		if(!missing(u12DonorBegin))
			u12DonorBeginInd= u12DonorBegin
		if(!missing(u12AcceptorBegin))
			u12AcceptorBeginInd= u12AcceptorBegin
		if(!missing(u12BranchpointBegin))
			u12BranchpointBeginInd= u12BranchpointBegin
		if(! missing(u2DonorBegin))
			u2DonorBeginInd=u2DonorBegin
		if(! missing(u2AcceptorBegin))
			u2AcceptorBeginInd=u2AcceptorBegin
		if(!missing(u12DonorEnd))
			u12DonorEndInd= u12DonorEnd			
		if(!missing(u12AcceptorEnd))
			u12AcceptorEndInd= u12AcceptorEnd
		if(!missing(u12BranchpointEnd))
			u12BranchpointEndInd= u12BranchpointEnd
		if(! missing(u2DonorEnd))
			u2DonorEndInd=u2DonorEnd
		if(! missing(u2AcceptorEnd))
			u2AcceptorEndInd=u2AcceptorEndInd

		donAtacU12= donAtacU12[u12DonorBeginInd:u12DonorEndInd, ]
		donGtagU12= donGtagU12[u12DonorBeginInd:u12DonorEndInd, ]
		accAtacU12= accAtacU12[u12AcceptorBeginInd:u12AcceptorEndInd, ]
		accGtagU12= accGtagU12[u12AcceptorBeginInd:u12AcceptorEndInd, ]
		bpAtacU12= bpAtacU12[u12BranchpointBeginInd:u12BranchpointEndInd, ]
		bpGtagU12= bpGtagU12[u12BranchpointBeginInd:u12BranchpointEndInd, ]
		donGtagU2= donGtagU2[u2DonorBeginInd:u2DonorEndInd, ]
		donGcagU2= donGcagU2[u2DonorBeginInd:u2DonorEndInd, ]
		accGtagU2= accGtagU2[u2AcceptorBeginInd:u2AcceptorEndInd, ]
		accGcagU2= accGcagU2[u2AcceptorBeginInd:u2AcceptorEndInd, ]

		rowDifDonU12<- nrow(donGtagU12)-nrow(donAtacU12)
		rowDifAccU12<- nrow(accGtagU12)-nrow(accAtacU12)
		rowDifBpU12<- nrow(bpGtagU12)-nrow(bpAtacU12)

		rowDifDonU2<- nrow(donGtagU2)-nrow(donGcagU2)
		rowDifAccU2<- nrow(accGtagU2)-nrow(accGcagU2)

		if(rowDifDonU12>0){
			donAtacU12<- rbind(donAtacU12, matrix(rep(.25, 4*rowDifDonU12), 
				nrow=rowDifDonU12) )
		} else if(rowDifDonU12<0){
			donGtagU12<- rbind(donGtagU12, matrix(rep(.25, 4*rowDifDonU12), 
				nrow=abs(rowDifDonU12)) )
		}

		if(rowDifAccU12>0){
			accAtacU12<- rbind(accAtacU12, matrix(rep(.25, 4*rowDifAccU12), 
				nrow=rowDifAccU12) )
		} else if(rowDifAccU12<0){
			accGtagU12<- rbind(accGtagU12, matrix(rep(.25, 4*rowDifAccU12), 
				nrow=abs(rowDifAccU12)) )
		}

		if(rowDifBpU12>0){
			bpAtacU12<- rbind(bpAtacU12, matrix(rep(.25, 4*rowDifBpU12), 
				nrow=rowDifBpU12) )
		} else if(rowDifBpU12<0){
			bpGtagU12<- rbind(bpGtagU12, matrix(rep(.25, 4*rowDifBpU12), 
				nrow=abs(rowDifBpU12)) )
		}
		if(rowDifDonU2>0){
			donGcagU2<- rbind(donGcagU2, matrix(rep(.25, 4*rowDifDonU2), 
				nrow=rowDifDonU2) )
		} else if(rowDifDonU2<0){
			donGtagU2<- rbind(donGtagU2, matrix(rep(.25, 4*rowDifDonU2), 
				nrow=abs(rowDifDonU2)) )
		}
		if(rowDifAccU2>0){
			accGcagU2<- rbind(accGcagU2, matrix(rep(.25, 4*rowDifAccU2), 
				nrow=rowDifAccU2) )
		} else if(rowDifAccU2<0){
			accGtagU2<- rbind(accGtagU2, matrix(rep(.25, 4*rowDifAccU2), 
				nrow=abs(rowDifAccU2)) )
		}


		donU12=t((donAtacU12+donGtagU12)/2)
		accU12=t((accAtacU12+accGtagU12)/2)
		bpU12=t((bpAtacU12+bpGtagU12)/2)

		donU2=t((donGtagU2+donGcagU2)/2)
		accU2=t((accGtagU2+accGcagU2)/2)

		
		# Plotting sequence logos

		if(pdfFileSeqLogos!=""){
			grDevices::pdf(pdfFileSeqLogos, width=pdfWidth, height=pdfHeight)
# Codes borrowed from 
#http://grokbase.com/t/r/bioconductor/1096ds3bnk/bioc-drawing-multiple-sequence
#-logos-with-seqlogo#2010090767dkq0ngtwg3fbx8cjx5mxwsn0 
			mySeqLogo = seqLogo::seqLogo

			bad = (sapply( body(mySeqLogo), "==", "grid.newpage()") | 
				sapply( body(mySeqLogo), "==", "par(ask = FALSE)"))
			body(mySeqLogo)[bad] = NULL


			#Defining dimensions
			ncol <- 3
			nrow <- 2

			#Creating plot

			grid::grid.newpage()

			listPwm=list(donU12, bpU12, accU12, donU2, c(), accU2)

			for(i in 1:nrow){
				for(j in 1:ncol){
					vp <- grid::viewport(x = (j-1)/ncol, y = 1-(i-1)/nrow, 
						w = 1/ncol, h = 1/nrow, just = c("left", "top"), 
						gp=grid::gpar(cex=cexSeqLogo))
					grid::pushViewport(vp)

					if(i!=2|j!=2){
						ind=(i-1)*3+j
						mySeqLogo(listPwm[[ind]])
						grid::grid.text(sprintf(c("U12 donor", 
							"U12 branch point", "U12 acceptor", "U2 donor", 
							"", "U2 acceptor" )[ind], row, col), x=0.5, y=0.95,
							just="top")
					}
					grid::upViewport()
				}
			}
			dev.off()
		}

		res=list(pwmDonU12=unitScale(donU12), pwmBpU12=unitScale(bpU12), 
			pwmAccU12=unitScale(accU12), pwmDonU2=unitScale(donU2), 
			pwmAccU2=unitScale(accU2))

		if(removeTempFiles){
			file.remove(c(paste(tmpDir, "AT_AC_U12_Don.txt", sep="/"), 
				paste(tmpDir, "AT_AC_U12_BP.txt", sep="/"), 
				paste(tmpDir, "AT_AC_U12_Acc.txt", sep="/"), 
				paste(tmpDir, "GC_AG_U2_Acc.txt", sep="/"), 
				paste(tmpDir, "GC_AG_U2_Don.txt", sep="/"), 
				paste(tmpDir, "GT_AG_U12_Don.txt", sep="/"), 
				paste(tmpDir, "GT_AG_U12_BP.txt", sep="/"), 
				paste(tmpDir, "GT_AG_U12_Acc.txt", sep="/"),
				paste(tmpDir, "GT_AG_U2_Don.txt", sep="/"), 
				paste(tmpDir, "GT_AG_U2_Acc.txt", sep="/")))
		}

	} else if (pwmSource=="U12DB"){
		# Calling required functions
		dbConnect<- DBI::dbConnect
		dbSendQuery<- DBI::dbSendQuery
		dbGetQuery<- DBI::dbGetQuery
		dbDisconnect<- DBI::dbDisconnect
		MariaDB<- RMariaDB::MariaDB

		# Downloading U12DB
		utils::download.file(u12dbLink, paste(tmpDir,"u12db.sql.gz",sep="/"))
		scriptsTmp=scan(gzfile(paste(tmpDir,"u12db.sql.gz",sep="/")), 
			what="character", sep='\n')

		dbc=dbConnect(MariaDB(), ...)
		dbSendQuery(dbc, paste("CREATE DATABASE IF NOT EXISTS ", u12dbDbName, 
			";", sep=""))
		dbDisconnect(dbc)

		dbc=dbConnect( MariaDB(), dbname = u12dbDbName, ...)

		scriptsTmp=scriptsTmp[-grep("^-",scriptsTmp)]
		scriptsTmp=scriptsTmp[-grep("\\/\\*",scriptsTmp)]

		indBeg= grep("(CREATE|INSERT|LOCK TABLES|UNLOCK TABLES|DROP TABLE)",
			scriptsTmp)
		indEnd=indBeg-1
		indBeg=c(1,indBeg)
		indBeg=indBeg[-length(indBeg)]
		if(length(scriptsTmp)!=indEnd[length(indEnd)]){
			indBeg=c(indBeg,length(scriptsTmp))
			indEnd=c(indEnd,length(scriptsTmp))
		}


		for(cnt in 1:length(indEnd)){
			test= paste(scriptsTmp[unique(indBeg[cnt]:indEnd[cnt])], 
				collapse="\n")
			dbSendQuery(dbc, test)
		}

		selCol= c("intron.gene_id", "intron.type", "splice_site.site_type", 
			"splice_site.seq", "splice_site.position_bp", 
			"splice_site.site_type")

		donor=dbGetQuery(dbc, paste('select ', paste(selCol, collapse=","), 
			' from intron,splice_site where intron.species_id="', u12dbSpecies,
			'" AND intron.donor_ss=splice_site.id', sep=""))
		selCol= c("intron.gene_id", "intron.type", "splice_site.site_type", 
			"splice_site.seq", "splice_site.position_bp", 
			"splice_site.position_ppt", "splice_site.site_type")
		acceptor=dbGetQuery(dbc, paste('select ', paste(selCol, collapse=","),
			' from intron,splice_site where intron.species_id="', u12dbSpecies,
			'" AND intron.acceptor_ss=splice_site.id', sep=""))

		bpStr= unlist(lapply(1:nrow(acceptor), 
			function(i) 
				substr(x=acceptor[i,"seq"], 
					start=nchar(acceptor[i,"seq"])+
						acceptor[i,"position_bp"]-3-9, 
					stop=nchar(acceptor[i,"seq"])+acceptor[i,"position_bp"]-4))
		)

		dbDisconnect(dbc)

		bpStrU12=bpStr[acceptor[,"type"]=="U12"]
		accStrU12=acceptor[acceptor[,"type"]=="U12","seq"]
		donStrU12=donor[donor[,"type"]=="U12","seq"]

		accStrU2=acceptor[acceptor[,"type"]=="U2","seq"]
		donStrU2=donor[donor[,"type"]=="U2","seq"]

		u12DonorBeginInd=1
		u12AcceptorBeginInd=1
		u12BranchpointBeginInd=1
		u2DonorBeginInd=1
		u2AcceptorBeginInd=1

		u12DonorEndInd=nchar(donStrU12[1])
		u12AcceptorEndInd=nchar(accStrU12[1])
		u12BranchpointEndInd=nchar(bpStrU12[1])
		u2DonorEndInd=nchar(donStrU2[1])
		u2AcceptorEndInd=nchar(accStrU2[1])

		if(!missing(u12DonorBegin))
			u12DonorBeginInd= u12DonorBegin
		if(!missing(u12DonorEnd))
			u12DonorEndInd= u12DonorEnd
		if(!missing(u12AcceptorBegin))
			u12AcceptorBeginInd= u12AcceptorBegin
		if(!missing(u12AcceptorEnd))
			u12AcceptorEndInd= u12AcceptorEnd
		if(!missing(u12BranchpointBegin))
			u12BranchpointBeginInd= u12BranchpointBegin
		if(!missing(u12BranchpointEnd))
			u12BranchpointEndInd= u12BranchpointEnd
		if(!missing(u2DonorBegin))
			u2DonorBeginInd= u2DonorBegin
		if(!missing(u2DonorEnd))
			u2DonorEndInd= u2DonorEnd
		if(!missing(u2AcceptorBegin))
			u2AcceptorBeginInd= u2AcceptorBegin
		if(!missing(u2AcceptorEnd))
			u2AcceptorEndInd= u2AcceptorEnd

		if((!missing(u12DonorBegin))|(!missing(u12DonorEnd)))
			donStrU12<- substr(donStrU12, u12DonorBeginInd, u12DonorEndInd)
		if((!missing(u12AcceptorBegin))|(!missing(u12AcceptorEnd)))
			accStrU12<- 
				substr(accStrU12, u12AcceptorBeginInd, u12AcceptorEndInd)
		if((!missing(u12BranchpointBegin))|
			(!missing(u12BranchpointEnd)))
			bpStrU12<- 
				substr(bpStrU12, u12BranchpointBeginInd, u12BranchpointEndInd)
		if((!missing(u2DonorBegin)) | (!missing(u2DonorEnd)))
			donStrU2<- substr(donStrU2, u2DonorBeginInd, u2DonorEndInd)
		if((!missing(u2AcceptorBegin)) | (!missing(u2AcceptorEnd)))
			accStrU2<- substr(accStrU2, u2AcceptorBeginInd, u2AcceptorEndInd)
		if(! pasteSites){
			#Filter Sequences includng characters other than A, C, G and T
			donStrU12<- donStrU12[grep("^[A|C|G|T]+$",donStrU12)]
			bpStrU12<- bpStrU12[grep("^[A|C|G|T]+$",bpStrU12)]
			accStrU12<- accStrU12[grep("^[A|C|G|T]+$",accStrU12)]

			donStrU2<- donStrU2[grep("^[A|C|G|T]+$",donStrU2)]
			accStrU2<- accStrU2[grep("^[A|C|G|T]+$",accStrU2)]


			pwmDonU12=Biostrings::PWM(donStrU12)
			pwmBpU12=Biostrings::PWM(bpStrU12)
			pwmAccU12=Biostrings::PWM(accStrU12)
	
			pwmDonU2=Biostrings::PWM(donStrU2)
			pwmAccU2=Biostrings::PWM(accStrU2)

		colnames(pwmDonU12)=as.character(1:ncol(pwmDonU12))
		colnames(pwmBpU12)=as.character(1:ncol(pwmBpU12))
		colnames(pwmAccU12)=as.character(1:ncol(pwmAccU12))
		colnames(pwmDonU2)=as.character(1:ncol(pwmDonU2))
		colnames(pwmAccU2)=as.character(1:ncol(pwmAccU2))

		res= list( pwmDonU12=pwmDonU12, pwmBpU12=pwmBpU12, 
			pwmAccU12=pwmAccU12, pwmDonU2=pwmDonU2, pwmAccU2=pwmAccU2)


		# End of if (! pasteSites)
		}	else {

			#Filter Sequences includng characters other than A, C, G and T
			indChooseU12<- 
				which(
					grepl("^[A|C|G|T]+$",donStrU12) & 
					grepl("^[A|C|G|T]+$",bpStrU12) &
					grepl("^[A|C|G|T]+$",accStrU12)
				)

			indChooseU2<- 
				which(
					grepl("^[A|C|G|T]+$",donStrU2) &
					grepl("^[A|C|G|T]+$",accStrU2)
				)
			donStrU12<- donStrU12[indChooseU12]
			bpStrU12<- bpStrU12[indChooseU12]
			accStrU12<- accStrU12[indChooseU12]

			donStrU2<- donStrU2[indChooseU2]
			accStrU2<- accStrU2[indChooseU2]

			pwmAllU12=Biostrings::PWM(unlist(lapply(1:length(donStrU12), 
				function(x) 
					paste(donStrU12[x], bpStrU12[x], accStrU12[x], sep=""))))

			pwmAllU2=Biostrings::PWM(unlist(lapply(1:length(donStrU2), 
				function(x) 
					paste(donStrU12[x], accStrU12[x], sep=""))))


			res= list(
				pwmDonU12=as.matrix(pwmAllU12[,1:nchar(donStrU12[1])]), 
				pwmBpU12=as.matrix(pwmAllU12[,(nchar(donStrU12[1])+1): 
					(nchar(donStrU12[1])+nchar(bpStrU12[1]))]), 
				pwmAccU12= as.matrix(pwmAllU12[,(nchar(donStrU12[1])+
					nchar(bpStrU12[1]))+1]), 
				pwmDonU2=as.matrix(pwmAllU2[,1:nchar(donStrU2[1])]), 
				pwmAccU2= as.matrix(pwmAllU2[,nchar(donStrU2[1])+1]))
			if(ncol(res[[1]])>0)
				colnames(res[[1]])<- 1:ncol(res[[1]])
			if(ncol(res[[2]])>0)
				colnames(res[[2]])<- 1:ncol(res[[2]])
			if(ncol(res[[3]])>0)
				colnames(res[[3]])<- 1:ncol(res[[3]])
			if(ncol(res[[4]])>0)
				colnames(res[[4]])<- 1:ncol(res[[4]])
			if(ncol(res[[5]])>0)
				colnames(res[[5]])<- 1:ncol(res[[5]])
		# end of else (if (pasteSites))
		}


		if(pdfFileSeqLogos!=""){
			grDevices::pdf(pdfFileSeqLogos, width=pdfWidth, 
				height=pdfHeight)
# Codes borrowed from http://grokbase.com/t/r/bioconductor/1096ds3bnk/bioc-dra
#wing-multiple-sequence-logos-with-seqlogo#2010090767dkq0ngtwg3fbx8cjx5mxwsn0
			mySeqLogo = seqLogo::seqLogo

			bad = (sapply( body(mySeqLogo), "==", "grid.newpage()") | 
				sapply( body(mySeqLogo), "==", "par(ask = FALSE)"))
			body(mySeqLogo)[bad] = NULL


#Defining dimensions
			ncol <- 3
			nrow <- 2

#Creating plot

			grid::grid.newpage()

			listStr= list(donStrU12, bpStrU12, accStrU12, donStrU2, c(),
				accStrU2)

			for(i in 1:nrow){
				for(j in 1:ncol){
					vp <- grid::viewport(x = (j-1)/ncol, y = 1-(i-1)/nrow,
						w = 1/ncol, h =	1/nrow, just = c("left", "top"), 
						gp=grid::gpar(cex=cexSeqLogo))
					grid::pushViewport(vp)
			
					if(i!=2|j!=2){
						ind=(i-1)*3+j
						strVecTmp=listStr[[ind]]
						prTmp=lapply(strVecTmp, 
							function(tmp)unlist(strsplit(tmp, split="")))
						prTmpStrMat=matrix(unlist(prTmp),byrow=TRUE, 
							ncol=length(prTmp[[1]]))
		
						prTmpMat= matrix(unlist(lapply(1:ncol(prTmpStrMat),
							function(tmp) 
								c(length(which(prTmpStrMat[,tmp]=="A")),
									length(which(prTmpStrMat[,tmp]=="C")),
									length(which(prTmpStrMat[,tmp]=="G")),
									length(which(prTmpStrMat[,tmp]=="T")))/
										nrow(prTmpStrMat))), 
							nrow=4, byrow=FALSE)
						rownames(prTmpMat)=c("A","C","G","T")
						mySeqLogo(prTmpMat)
						grid::grid.text(sprintf(c("U12 donor", 
							"U12 branch point", "U12 acceptor", "U2 donor",
							"",	"U2 acceptor" )[ind], row, col), x=0.5, 
							y=0.95, just="top")
					}
					grid::upViewport()
				}
			}
			dev.off()
		}


		if(u12dbDropDb){
			dbc=dbConnect(MariaDB(), ...)
			dbSendQuery(dbc, paste("DROP DATABASE ", u12dbDbName, ";", sep=""))
			dbDisconnect(dbc)
		}


		if(removeTempFiles){
			file.remove(paste(tmpDir,"u12db.sql.gz",sep="/"))
		}

	}

return (res)

}

applyOverlap<- function(
    query,
    subject,
    type="any",
    replaceValues=FALSE,
    intExCol="int_ex", 
    intronExon="intron",
    sujectGeneNamesCol,
    repeatsTableToFilter=c(),
    scaleFragment=TRUE,
    scaleLength=TRUE,
    unmapValue=0,
    FUN=mean,
    ...
)
{
  if(is(query,"SummarizedExperiment")){
    dfQue<- SummarizedExperiment::rowData(query)
    indQue<- which(dfQue[,intExCol]%in%intronExon)
    dfQue<- dfQue[indQue,]
    queGr<- GenomicRanges::GRanges (as.character(dfQue[,1]), 
                                    IRanges::IRanges(as.numeric(dfQue[,2]), 
                                                     as.numeric(dfQue[,3])))
  }
  
  dfSub<- SummarizedExperiment::rowData(subject)
  indSub<- which(dfSub[,intExCol]%in%intronExon)
  dfSub<- dfSub[indSub,]
  subGr<- GenomicRanges::GRanges (as.character(dfSub[,1]), 
                                  IRanges::IRanges(as.numeric(dfSub[,2]), as.numeric(dfSub[,3])))
  
  mapTmp<- GenomicRanges::findOverlaps(queGr, 
                                       subGr, type= type, select="all", maxgap=0)
  
  time1<- Sys.time()
  
  sumAgg<- stats::aggregate(x=counts(query)[indQue[S4Vectors::queryHits(
    mapTmp)],], 
    by=list(indSub[S4Vectors::subjectHits(mapTmp)]), FUN=FUN, ...)
  time2<- Sys.time()
  runTime1<- difftime(time2,time1, units="secs")
  
  outFreq<- matrix(unmapValue, nrow=nrow(subject), ncol=ncol(subject))
  colnames(outFreq)<- colnames(sumAgg)[-1]
  outFreq[ sumAgg[,1] ,]<- as.matrix(sumAgg[,-1])
  
  
  
  
  sumFrqs<- stats::aggregate(x=outFreq, 
                             by=list(rowData(subject)[,sujectGeneNamesCol]), sum, na.rm=TRUE)
  tmpMat<- sumFrqs[,-1]
  rownames(tmpMat)<- sumFrqs[,1]
  
  # measure FPKM
  FPKM=outFreq
  if(scaleFragment){
    sumMat<- tmpMat[rowData(subject)[,sujectGeneNamesCol],]
    FPKM=((10^6)*FPKM)/(sumMat+1)
    
  }
  if(scaleLength){
    # Get true length
    trueLen<- correctLen(rowData(subject)[indSub,], 
                         rowData(query)[indQue,], repeatsTableToFilter=repeatsTableToFilter)
    lenQue<- rowData(subject)[,"end"]-rowData(subject)[,"begin"]+1
    lenMat<- matrix(rep(lenQue, ncol(subject)), 
                    ncol=ncol(subject), byrow=FALSE)
    lenMat[indSub, ]<- matrix(rep(trueLen,ncol(query)), 
                              ncol=ncol(query), byrow=FALSE)
    FPKM=((10^3)*FPKM)/lenMat
  }
  rownames(FPKM)<-c()
  
  if(replaceValues){
    out<- subject
    # measure sum of read frequency in transcripts
    
    SummarizedExperiment::assays(out)$counts<- outFreq
    
    SummarizedExperiment::assays(out)$scaledRetention<- 
      as.matrix(FPKM)
    
  } else {
    out<- FPKM
  }
  return (out)
}


correctLen<-function(ref, coll, repeatsTableToFilter=c()){
	lenRef<- ref[,"end"]-ref[,"begin"]+1
	lenColl<- coll[,"end"]-coll[,"begin"]+1
	lenOut<- lenRef
	if(length(coll)>0){
		collGRanges<- GenomicRanges::GRanges( seqnames=
			coll[,"chr"],
			IRanges::IRanges(start=coll[,"begin"],
			end=coll[,"end"], 
			width=coll[,"end"]-
				coll[,"begin"]+1))

		refGr<- GenomicRanges::GRanges( seqnames=ref[,"chr"],
			IRanges::IRanges(start=ref[,"begin"], end=ref[,"end"],
				width=ref[,"end"]-ref[,"begin"]+1))
		redcollGr<- GenomicRanges::reduce(collGRanges)
		hits <- findOverlaps(redcollGr, refGr, type="within", maxgap=0, 
			ignore.strand=T)
		lenSum<- tapply(lenColl[S4Vectors::queryHits(hits)], 
			S4Vectors::subjectHits(hits), sum)

		if(length(lenSum)>0) {
			lenOut[as.numeric(names(lenSum))]<- as.numeric(lenSum)
		}
	}

	return(lenOut)
}

annotateU12<-function(
	pwmU12U2=c(), 
	pwmSsIndex=c(), 
	referenceChr, referenceBegin, referenceEnd, referenceIntronExon, 
	intronExon="intron",  matchWindowRelativeUpstreamPos=c() ,
	matchWindowRelativeDownstreamPos=c(), minMatchScore="80%", refGenome="", 	
	setNaAs="U2", annotateU12Subtype=TRUE, includeMatchScores=FALSE, 
	ignoreHybrid=TRUE, filterReference)
{

	if(!missing(filterReference)){
		if(is(filterReference,"SummarizedExperiment")){
			filterReference<- 
				SummarizedExperiment::rowData(filterReference)[,1:3]
			filterReference<- 
				GenomicRanges::GRanges (as.character(filterReference[,1]), 
					IRanges::IRanges(as.numeric(filterReference[,2]), 
						as.numeric(filterReference[,3])))
		} else if (is(filterReference,"GRanges")){
			stop(paste("The filterReference parameter should be either of",
				"'SummarizedExperiment' or 'GRanges' type. For the former,", 
				"i.e. SummarizedExperiment, the first 3 columns of the", 
				"rowData must be: chr name, start and end of the coordinates.",
				sep="\n"))
		}
	}

	if(length(pwmU12U2)==0){
		pwmU12db<-0
		data("pwmU12db")
		pwmU12U2= 
			list(pwmU12db[[1]][,11:17],
			pwmU12db[[2]],pwmU12db[[3]][,38:40],pwmU12db[[4]][,11:17],
			pwmU12db[[5]][,38:40])
	}
	if(length(pwmSsIndex)==0){
		pwmSsIndex=list(indexDonU12=1, indexBpU12=1, indexAccU12=3, 
			indexDonU2=1, indexAccU2=3)
	}
	if(length(matchWindowRelativeUpstreamPos)==0)
		matchWindowRelativeUpstreamPos=c(NA,-29,NA,NA,NA)
	if(length(matchWindowRelativeDownstreamPos)==0)
		matchWindowRelativeDownstreamPos=c(NA,-9,NA,NA,NA)
	if(length(minMatchScore)==1)
		minMatchScore=rep(minMatchScore, 5)
	u12DonMatch=suppressWarnings( matchPwmToReference(pwm=pwmU12U2[[1]], 
		pwmSsIndex=unlist(pwmSsIndex[1]), referenceChr=referenceChr, 
		referencePos=referenceBegin, intronExon="intron", 
		referenceIntronExon=referenceIntronExon, 
		matchWindowRelativePos=c(unlist(matchWindowRelativeUpstreamPos[1]), 
			unlist(matchWindowRelativeDownstreamPos[1])), 
		minMatchScore=minMatchScore[1], 
		refGenome=refGenome) )
	u12DonCompMatch=suppressWarnings(
		matchPwmToReference(pwm=Biostrings::reverseComplement(pwmU12U2[[1]]), 
			pwmSsIndex=ncol(pwmU12U2[[1]])-unlist(pwmSsIndex[1])+1, 
			referenceChr=referenceChr, referencePos=referenceEnd, 
			intronExon="intron", referenceIntronExon=referenceIntronExon,
			matchWindowRelativePos=
				(-1)*c(unlist(matchWindowRelativeDownstreamPos[1]), 
					unlist(matchWindowRelativeUpstreamPos[1])), 
			minMatchScore=minMatchScore[1], 
			refGenome=refGenome))

	u12BpMatch= suppressWarnings(matchPwmToReference(pwm=pwmU12U2[[2]], 
		pwmSsIndex=unlist(pwmSsIndex[2]), referenceChr=referenceChr, 
		referencePos=referenceEnd, intronExon="intron", 
		referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=c(unlist(matchWindowRelativeUpstreamPos[2]), 
			unlist(matchWindowRelativeDownstreamPos[2])), 
		minMatchScore=minMatchScore[2], 
		refGenome=refGenome))
	u12BpCompMatch= suppressWarnings(matchPwmToReference(
		pwm=Biostrings::reverseComplement(pwmU12U2[[2]]), 
		pwmSsIndex=ncol(pwmU12U2[[2]])-unlist(pwmSsIndex[2])+1, 
		referenceChr=referenceChr, referencePos=referenceBegin, 
		intronExon="intron", referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=
			(-1)*c(unlist(matchWindowRelativeDownstreamPos[2]), 
				unlist(matchWindowRelativeUpstreamPos[2])), 
		minMatchScore=minMatchScore[2], 
		refGenome=refGenome))

	u12AccMatch= suppressWarnings(matchPwmToReference(pwm=pwmU12U2[[3]], 
		pwmSsIndex=unlist(pwmSsIndex[3]), 
		referenceChr=referenceChr, 
		referencePos=referenceEnd, 
		intronExon="intron", 
		referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=c(unlist(matchWindowRelativeUpstreamPos[3]), 
			unlist(matchWindowRelativeDownstreamPos[3])), 
		minMatchScore=minMatchScore[3], 
		refGenome=refGenome))
	u12AccCompMatch= suppressWarnings(matchPwmToReference(
		pwm=Biostrings::reverseComplement(pwmU12U2[[3]]), 
		pwmSsIndex=ncol(pwmU12U2[[3]])-unlist(pwmSsIndex[3])+1, 
		referenceChr=referenceChr, referencePos=referenceBegin, 
		intronExon="intron", referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=
			(-1)*c(unlist(matchWindowRelativeDownstreamPos[3]), 
				unlist(matchWindowRelativeUpstreamPos[3])), 
		minMatchScore=minMatchScore[3], 
		refGenome=refGenome))

	u2DonMatch= suppressWarnings(matchPwmToReference(pwm=pwmU12U2[[4]], 
		pwmSsIndex=unlist(pwmSsIndex[4]), referenceChr=referenceChr, 
		referencePos=referenceBegin, intronExon="intron", 
		referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=c(unlist(matchWindowRelativeUpstreamPos[4]), 
			unlist(matchWindowRelativeDownstreamPos[4])), 
		minMatchScore=minMatchScore[4], 
		refGenome=refGenome))
	u2DonCompMatch= suppressWarnings(matchPwmToReference(
		pwm=Biostrings::reverseComplement(pwmU12U2[[4]]), 
		pwmSsIndex=ncol(pwmU12U2[[4]])-unlist(pwmSsIndex[4])+1, 
		referenceChr=referenceChr, referencePos=referenceEnd, 
		intronExon="intron", referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=
			(-1)*c(unlist(matchWindowRelativeDownstreamPos[4]), 
				unlist(matchWindowRelativeUpstreamPos[4])), 
		minMatchScore=minMatchScore[4], 
		refGenome=refGenome))

	u2AccMatch= suppressWarnings(matchPwmToReference(pwm=pwmU12U2[[5]], 
		pwmSsIndex=unlist(pwmSsIndex[5]), referenceChr=referenceChr, 
		referencePos=referenceEnd, intronExon="intron", 
		referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=c(unlist(matchWindowRelativeUpstreamPos[5]), 
			unlist(matchWindowRelativeDownstreamPos[5])), 
		minMatchScore=minMatchScore[5], refGenome=refGenome))
	u2AccCompMatch= suppressWarnings(matchPwmToReference(
		pwm=Biostrings::reverseComplement(pwmU12U2[[5]]), 
		pwmSsIndex=ncol(pwmU12U2[[5]])-unlist(pwmSsIndex[5])+1, 
		referenceChr=referenceChr, referencePos=referenceBegin, 
		intronExon="intron", referenceIntronExon=referenceIntronExon,
		matchWindowRelativePos=
			(-1)*c(unlist(matchWindowRelativeDownstreamPos[5]), 
				unlist(matchWindowRelativeUpstreamPos[5])), 
		minMatchScore=minMatchScore[5], refGenome=refGenome))
	resTmp= rep(NA,nrow(u12DonMatch))
	u12Bool= u12DonMatch[,1]& u12BpMatch[,1]& u12AccMatch[,1]
	u2Bool= u2DonMatch[,1]& u2AccMatch[,1]
	u12CompBool= u12DonCompMatch[,1]& u12BpCompMatch[,1]& u12AccCompMatch[,1]
	u2CompBool= u2DonCompMatch[,1]& u2AccCompMatch[,1]

	resTmp[u12Bool]="U12"
	resTmp[u2Bool]="U2"
	resTmp[u12Bool & u2Bool]="U12/U2"
	resTmp[u12CompBool]="U12"
	resTmp[u2CompBool]="U2"
	resTmp[u12CompBool & u2CompBool]="U12/U2"

	resTmp[is.na(resTmp)]=setNaAs

	strandMatchTmp=rep(NA, nrow(u12DonMatch))
	strandMatchTmp[u12Bool|u2Bool]="+"
	strandMatchTmp[u12CompBool|u2CompBool]="-"

	res=data.frame( int_type=rep(NA,length(referenceIntronExon)), 
		strandMatch=rep(NA,length(referenceIntronExon)))
	res[!is.na(match(referenceIntronExon,intronExon)),1]=resTmp
	res[!is.na(match(referenceIntronExon,intronExon)),2]=strandMatchTmp

	if(annotateU12Subtype & (length(which(res[,1]=="U12"))>0)){
		donPosSeq<- rep(NA, nrow(res))
		accPosSeq<- rep(NA, nrow(res))
		donNegSeq<- rep(NA, nrow(res))
		accNegSeq<- rep(NA, nrow(res))
		donNegSeqTmp<- rep(NA, nrow(res))
		accNegSeqTmp<- rep(NA, nrow(res))
		if (is(refGenome, "BSgenome")){
			if(length(which(res[,2]=="+"))>0){
				donPosSeq= Biostrings::getSeq(refGenome, 
					names=referenceChr[which(!is.na(res[,1])&
						res[,1]=="U12"&res[,2]=="+")],
					start=
						referenceBegin[which(!is.na(res[,1])&res[,1]=="U12"&
							res[,2]=="+")],
					end=
						referenceBegin[which(!is.na(res[,1])&res[,1]=="U12"&
							res[,2]=="+")]+
						1,
					as.character=TRUE)

				accPosSeq= Biostrings::getSeq(refGenome, 
					names=referenceChr[which(!is.na(res[,1])&
						res[,1]=="U12"&res[,2]=="+")],
					start=
						referenceEnd[which(!is.na(res[,1])&
							res[,1]=="U12"&res[,2]=="+")]-1,
					end=
						referenceEnd[which(!is.na(res[,1])&
							res[,1]=="U12"&res[,2]=="+")],
					as.character=TRUE)
			} 
			if(length(which(res[,2]=="-"))>0) {

				donNegSeqTmp=Biostrings::getSeq(refGenome, 
					names=referenceChr[which(!is.na(res[,1])&res[,1]=="U12"&
						res[,2]=="-")],
					start=
						referenceEnd[which(!is.na(res[,1])&res[,1]=="U12"&
							res[,2]=="-")]-1,
					end=
						referenceEnd[which(!is.na(res[,1])&
							res[,1]=="U12"&res[,2]=="-")],
					as.character=TRUE)

				accNegSeqTmp=Biostrings::getSeq(refGenome, 
					names=referenceChr[which(!is.na(res[,1])&res[,1]=="U12"&
						res[,2]=="-")],
					start=
						referenceBegin[which(!is.na(res[,1])&res[,1]=="U12"&
							res[,2]=="-")],
					end=
							referenceBegin[which(!is.na(res[,1])&
							res[,1]=="U12"&	res[,2]=="-")]+ 1,
					as.character=TRUE)
			}
		} else if (is(refGenome, "DNAStringSet")){

			if(length(which(res[,2]=="+"))>0){
				tmpGr<- GenomicRanges::GRanges (
						referenceChr[which(!is.na(res[,1])&res[,1]=="U12"&
							res[,2]=="+")], 
						IRanges(referenceBegin[which(!is.na(res[,1])& 
							res[,1]=="U12"& res[,2]=="+")],
							referenceBegin[which(!is.na(res[,1])&
								res[,1]=="U12"& res[,2]=="+")]+1))

				donPosSeq= as.character(Biostrings::getSeq(refGenome, 
					tmpGr))

				tmpGr<- GenomicRanges::GRanges (referenceChr[which(
					!is.na(res[,1])& res[,1]=="U12"&res[,2]=="+")], 
						IRanges(referenceEnd[which(!is.na(res[,1])&
								res[,1]=="U12"& res[,2]=="+")]-1,
							referenceEnd[which(!is.na(res[,1])&res[,1]=="U12"&
								res[,2]=="+")]))

				accPosSeq= as.character(Biostrings::getSeq(refGenome, 
					tmpGr))
			} 
			if (length(which(res[,2]=="-"))>0){
				tmpGr<- GenomicRanges::GRanges (
						referenceChr[which(!is.na(res[,1])&res[,1]=="U12"&
							res[,2]=="-")], 
						IRanges(referenceEnd[which(!is.na(res[,1])&
								res[,1]=="U12"& res[,2]=="-")]-1,
							referenceEnd[which(!is.na(res[,1])&res[,1]=="U12"&
								res[,2]=="-")]
							))

				donNegSeqTmp=as.character(Biostrings::getSeq(refGenome, 
					tmpGr))

				tmpGr<- GenomicRanges::GRanges (referenceChr[which(
					!is.na(res[,1])& res[,1]=="U12"&res[,2]=="-")], 
						IRanges(referenceBegin[which(!is.na(res[,1])&
								res[,1]=="U12"& res[,2]=="-")],
							referenceBegin[which(!is.na(res[,1])&
								res[,1]=="U12"& res[,2]=="-")]+ 1
							))

				accNegSeqTmp=as.character(Biostrings::getSeq(refGenome, 
					tmpGr))
			}
		} else if (file.exists(refGenome)) {

			fa=seqinr::read.fasta(file = refGenome)
			if(length(which(res[,2]=="+"))>0){
				donPosSeq= unlist(lapply( 
					which(!is.na(res[,1])&res[,1]=="U12"&res[,2]=="+"), 
						function(temp) 
							paste(unlist(seqinr::getSequence(seqinr::getFrag(
								object=fa[as.character(referenceChr)[temp]], 
								begin=referenceBegin[temp], 
								end=referenceBegin[temp]+1, as.string=TRUE))),
								collapse="")))


				accPosSeq= unlist(lapply( 
					which(!is.na(res[,1])&res[,1]=="U12"&res[,2]=="+"), 
						function(temp) 
							paste(unlist(seqinr::getSequence(seqinr::getFrag(
								object=fa[as.character(referenceChr)[temp]], 
								begin=referenceEnd[temp]-1, 
								end=referenceEnd[temp], as.string=TRUE))),
								collapse="")))
			}
			if(length(which(res[,2]=="-"))>0){
				donNegSeqTmp=unlist(lapply( 
					which(!is.na(res[,1])&res[,1]=="U12"&res[,2]=="-"), 
						function(temp) 
							paste(unlist(seqinr::getSequence(seqinr::getFrag(
								object=fa[as.character(referenceChr)[temp]], 
								begin=referenceEnd[temp]-1, 
								end=referenceEnd[temp], as.string=TRUE))),
								collapse="")))

				accNegSeqTmp=unlist(lapply( 
					which(!is.na(res[,1])&res[,1]=="U12"&res[,2]=="-"), 
					function(temp) 
						paste(unlist(seqinr::getSequence(seqinr::getFrag(
							object=fa[as.character(referenceChr)[temp]], 
							begin=referenceBegin[temp], 
							end=referenceBegin[temp]+1, as.string=TRUE))),
							collapse="")))
			}
		}
	if(length(which(!is.na(donNegSeqTmp)))>0)
		donNegSeq= unlist(lapply(donNegSeqTmp, function(tmp) 
			as.character(Biostrings::reverseComplement(DNAString(tmp))) ))
	if(length(which(!is.na(accNegSeqTmp)))>0)
		accNegSeq= unlist(lapply(accNegSeqTmp, function(tmp) 
			as.character(Biostrings::reverseComplement(DNAString(tmp))) ))
		

	res$u12_subtype=rep(NA,nrow(res))
	res$u12_subtype[which((referenceIntronExon %in% intronExon) & 
		!is.na(res[,1])& res[,1]=="U12"& res[,2]=="+")[which(donPosSeq=="GT" & 
			accPosSeq=="AG")]]="GT-AG"
	res$u12_subtype[which((referenceIntronExon %in% intronExon) & 
		!is.na(res[,1])& res[,1]=="U12"& res[,2]=="-")[which(donNegSeq=="GT" & 
			accNegSeq=="AG")]]="GT-AG"
	res$u12_subtype[which((referenceIntronExon %in% intronExon) & 
		!is.na(res[,1])& res[,1]=="U12"& res[,2]=="+")[which(donPosSeq=="AT" & 
			accPosSeq=="AC")]]="AT-AC"
	res$u12_subtype[which((referenceIntronExon %in% intronExon) & 
		!is.na(res[,1])& res[,1]=="U12"& res[,2]=="-")[which(donNegSeq=="AT" & 
			accNegSeq=="AC")]]="AT-AC"
	if(ignoreHybrid)
		res$int_type[which(is.na(res$u12_subtype) & res$int_type=="U12")]<- 
			setNaAs

}

if (includeMatchScores){
	u12_donScoreTmp<- u12DonMatch$pwmMatchScore
	u12_donScoreTmp[u12CompBool]<- u12DonCompMatch$pwmMatchScore[u12CompBool]
	u12_bpScoreTmp<- u12BpMatch$pwmMatchScore
	u12_bpScoreTmp[u12CompBool]<- u12BpCompMatch$pwmMatchScore[u12CompBool]
	u12_accScoreTmp<- u12AccMatch$pwmMatchScore
	u12_accScoreTmp[u12CompBool]<- u12AccCompMatch$pwmMatchScore[u12CompBool]

	u2_donScoreTmp<- u2DonMatch$pwmMatchScore
	u2_donScoreTmp[u2CompBool]<- u2DonCompMatch$pwmMatchScore[u2CompBool]
	u2_accScoreTmp<- u2AccMatch$pwmMatchScore
	u2_accScoreTmp[u2CompBool]<- u2AccCompMatch$pwmMatchScore[u2CompBool]
	
	u12_donScore<- rep(NA, nrow(res))
	u12_donScore[which(!is.na(match(referenceIntronExon,intronExon)))]<- 
		u12_donScoreTmp
	u12_bpScore<- rep(NA, nrow(res))
	u12_bpScore[which(!is.na(match(referenceIntronExon,intronExon)))]<- 
		u12_bpScoreTmp
	u12_accScore<- rep(NA, nrow(res))
	u12_accScore[which(!is.na(match(referenceIntronExon,intronExon)))]<- 
		u12_accScoreTmp

	u2_donScore<- rep(NA, nrow(res))
	u2_donScore[which(!is.na(match(referenceIntronExon,intronExon)))]<- 
		u2_donScoreTmp
	u2_accScore<- rep(NA, nrow(res))
	u2_accScore[which(!is.na(match(referenceIntronExon,intronExon)))]<- 
		u2_accScoreTmp

	res<- 
		cbind(res, u12_donScore, u12_bpScore, u12_accScore, 
			u2_donScore, u2_accScore)


}

if(!missing(filterReference)){
	refGr<- 
		GenomicRanges::GRanges (as.character(referenceChr), 
			IRanges::IRanges(as.numeric(referenceBegin), 
				as.numeric(referenceEnd)))

	tmpMap<- GenomicRanges::findOverlaps(refGr, 
			filterReference, type= "equal")
	res$int_type[-c(unique(S4Vectors::queryHits(tmpMap)))]<-NA
	
}

print(table(res$int_type))

return(res)

}

## ----pipeline, out.width = 500, ppi=100, fig.retina = NULL, fig.align="center", echo=FALSE, eval=TRUE, fig.cap="**Figure 1:** Diagram of IntEREst running pipeline"----
knitr::include_graphics("../inst/fig/IntEREst.png")

## ----collapseExons, out.width = 500, ppi=100, fig.retina = NULL, fig.align="center", echo=FALSE, eval=TRUE, fig.cap="**Figure 2:** Running reference isoforms a, b, c and d leads to gene A with exons that are results of collapsing of exons of all isoforms."----
knitr::include_graphics("../inst/fig/collapseExons.png")

## ----reference_build, out.width = 500, echo=TRUE, eval=TRUE-------------------
# Load library quietly
suppressMessages(library("IntEREst"))
# Selecting rows related to RHBDD3 gene
tmpGen<-u12[u12[,"gene_name"]=="RHBDD3",]
# Extracting exons
tmpEx<-tmpGen[tmpGen[,"int_ex"]=="exon",]

# Building GFF3 file
exonDat<- cbind(tmpEx[,3], ".",
	tmpEx[,c(7,4,5)], ".", tmpEx[,6], ".",paste("ID=exon",
	tmpEx[,11], "; Parent=ENST00000413811", sep="") )
trDat<- c(tmpEx[1,3], ".", "mRNA", as.numeric(min(tmpEx[,4])),
	as.numeric(max(tmpEx[,5])), ".", tmpEx[1,6], ".",
	"ID=ENST00000413811")
outDir<- file.path(tempdir(),"tmpFolder")
dir.create(outDir)
outDir<- normalizePath(outDir)
gff3File<-paste(outDir, "gffFile.gff", sep="/")
cat("##gff-version 3\n",file=gff3File, append=FALSE)
cat(paste(paste(trDat, collapse="\t"),"\n", sep=""),
	file=gff3File, append=TRUE)
write.table(exonDat, gff3File,
	row.names=FALSE, col.names=FALSE,
	sep='\t', quote=FALSE, append=TRUE)

# Extracting U12 introns info from 'u12' data
u12Int<-u12[u12$int_ex=="intron"&u12$int_type=="U12",]

# Building reference
#Since it is based on one gene only (that does not feature alternative splicing
#events) there is no difference if the collapseExons is set as TRUE or FALSE
testRef<- referencePrepare (sourceBuild="file",
	filePath=gff3File, u12IntronsChr=u12Int[,"chr"],
	u12IntronsBeg=u12Int[,"begin"],
	u12IntronsEnd=u12Int[,"end"], collapseExons=TRUE,
	fileFormat="gff3", annotateGeneIds=FALSE)

head (testRef)

## ----annotate_u12, out.width = 500, echo=TRUE, eval=TRUE----------------------
# Improting genome
BSgenome.Hsapiens.UCSC.hg19 <-
BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#Index of the subset of rows
ind<- u12$gene_name %in% c("RHBDD2", "YBX2")

# Annotate U12 introns with strong U12 donor site, branch point
# and acceptor site from the u12 data in the package
annoU12<-
	annotateU12(pwmU12U2=list(pwmU12db[[1]][,11:17],pwmU12db[[2]],
		pwmU12db[[3]][,38:40],pwmU12db[[4]][,11:17],
		pwmU12db[[5]][,38:40]),
	pwmSsIndex=list(indexDonU12=1, indexBpU12=1, indexAccU12=3,
		indexDonU2=1, indexAccU2=3),
	referenceChr=u12[ind,'chr'],
	referenceBegin=u12[ind,'begin'],
	referenceEnd=u12[ind,'end'],
	referenceIntronExon=u12[ind,"int_ex"],
	intronExon="intron",
	matchWindowRelativeUpstreamPos=c(NA,-29,NA,NA,NA),
	matchWindowRelativeDownstreamPos=c(NA,-9,NA,NA,NA),
	minMatchScore=c(rep(paste(80,"%",sep=""),2), "40%",
	paste(80,"%",sep=""), "40%"),
	refGenome=BSgenome.Hsapiens.UCSC.hg19,
	setNaAs="U2",
	annotateU12Subtype=TRUE)
# How many U12 and U2 type introns with strong U12 donor sites,
# acceptor sites (and branch points for U12-type) are there?
	table(annoU12[,1])

## ----testInterest, out.width = 500, echo=TRUE, eval=TRUE----------------------
# Creating temp directory to store the results
outDir<- file.path(tempdir(),"interestFolder")
dir.create(outDir)
outDir<- normalizePath(outDir)
# Loading suitable bam file
bamF <- system.file("extdata", "small_test_SRR1691637_ZRSR2Mut_RHBDD3.bam",
	package="IntEREst", mustWork=TRUE)
# Choosing reference for the gene RHBDD3
ref<-u12[u12[,"gene_name"]=="RHBDD3",]

# Intron retention analysis
# Reads mapping to inner introns are considered, hence 
# junctionReadsOnly is FALSE
testInterest<- interest(
	bamFileYieldSize=10000,
	junctionReadsOnly=FALSE,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=NA,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
		"intRetRes.tsv", sep="/"),
	logFile=paste(outDir,
		"log.txt", sep="/"),
	method="IntRet",
	returnObj=FALSE,
	scaleLength= TRUE,
	scaleFragment= TRUE,
	strandSpecific="unstranded"
)

testIntRetObj<- readInterestResults(
    resultFiles= paste(outDir,
		"intRetRes.tsv", sep="/"), 
    sampleNames="small_test_SRR1691637_ZRSR2Mut_RHBDD3", 
    sampleAnnotation=data.frame( 
        type="ZRSR2mut",
        test_ctrl="test"), 
    commonColumns=1:ncol(ref), freqCol=ncol(ref)+1, 
	scaledRetentionCol=ncol(ref)+2, scaleLength=TRUE, scaleFragment=TRUE, 
	reScale=TRUE, geneIdCol="ens_gene_id")

# Intron Spanning analysis
# Reads mapping to inner introns are considered, hence 
# junctionReadsOnly is FALSE
testInterest<- interest(
	bamFileYieldSize=10000,
	junctionReadsOnly=FALSE,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
		"intSpanRes.tsv", sep="/"),
	logFile=paste(outDir,
		"log.txt", sep="/"),
	method="IntSpan",
	returnObj=FALSE,
	scaleLength= TRUE,
	scaleFragment= TRUE,
	strandSpecific="unstranded"
)

testIntSpanObj<- readInterestResults(
    resultFiles= paste(outDir,
		"intSpanRes.tsv", sep="/"), 
    sampleNames="small_test_SRR1691637_ZRSR2Mut_RHBDD3", 
    sampleAnnotation=data.frame( 
        type="ZRSR2mut",
        test_ctrl="test"), 
    commonColumns=1:ncol(ref), freqCol=ncol(ref)+1, 
	scaledRetentionCol=ncol(ref)+2, scaleLength=TRUE, scaleFragment=TRUE, 
	reScale=TRUE, geneIdCol="ens_gene_id")

# Exon-exon junction analysis
# Reads mapping to inner exons are NOT considered, hence 
# junctionReadsOnly is TRUE
testInterest<- interest(
	bamFileYieldSize=10000,
	junctionReadsOnly=TRUE,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
		"exExRes.tsv", sep="/"),
	logFile=paste(outDir,
		"log.txt", sep="/"),
	method="ExEx",
	returnObj=FALSE,
	scaleLength= TRUE,
	scaleFragment= TRUE,
	strandSpecific="unstranded"
)

testExExObj<- readInterestResults(
    resultFiles= paste(outDir,
		"exExRes.tsv", sep="/"), 
    sampleNames="small_test_SRR1691637_ZRSR2Mut_RHBDD3", 
    sampleAnnotation=data.frame( 
        type="ZRSR2mut",
        test_ctrl="test"), 
    commonColumns=1:ncol(ref), freqCol=ncol(ref)+1, 
	scaledRetentionCol=ncol(ref)+2, scaleLength=TRUE, scaleFragment=TRUE, 
	reScale=TRUE, geneIdCol="ens_gene_id")

# View intron retention result object
testIntRetObj
# View intron spanning  result object
testIntSpanObj
# View exon-exon junction result object
testExExObj

# View first rows of intron retention read counts table
head(counts(testIntRetObj))
# View first rows of intron spanning read counts table
head(counts(testIntSpanObj))
# View first rows of exon-exon junction read counts table
head(counts(testExExObj))


## ----view_object, out.width = 500, echo=TRUE, eval=TRUE-----------------------
# Load library quietly
suppressMessages(library("IntEREst"))
#View object
mdsChr22Obj

mdsChr22ExObj


# See read counts
head(counts(mdsChr22Obj))

# See FPKM Normalized values
head(scaledRetention(mdsChr22Obj))

# See intron/exon annotations
head(rowData(mdsChr22Obj))

# See sample annotations
head(colData(mdsChr22Obj))



## ----plot_intron_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap="**Figure 3:** Plotting the distribution of the retention levels ($log_e$ scaled retention) of introns of genes located on chromosome 22. The values have been averaged across the sample types ZRSR2 mutated, ZRSR2 wild type, and healthy."----

# Retention of all introns
plot(mdsChr22Obj, logScaleBase=exp(1), pch=20, loessLwd=1.2, 
	summary="mean", col="black", sampleAnnoCol="type", 
	lowerPlot=TRUE, upperPlot=TRUE)

## ----plot_u12intron_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap="**Figure 4:** Plotting the distribution of the retention levels ($log_e$ scaled retention) of introns of genes located on chromosome 22. The values have been averaged across the sample types ZRSR2 mutated, ZRSR2 wild type, and healthy."----

#Retention of U12 introns
plot(mdsChr22Obj, logScaleBase=exp(1), pch=20, plotLoess=FALSE, 
	summary="mean", col="black", sampleAnnoCol="type", 
	subsetRows=u12Index(mdsChr22Obj, intTypeCol="intron_type"))

## ----exact_test, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"----
# Check the sample annotation table
getAnnotation(mdsChr22Obj)

# Run exact test
test<- exactTestInterest(mdsChr22Obj, 
	sampleAnnoCol="test_ctrl", sampleAnnotation=c("ctrl","test"), 
	geneIdCol= "collapsed_transcripts_id", silent=TRUE, disp="common")

# Number of stabilized introns (in Chr 22)
sInt<- length(which(test$table[,"PValue"]<0.05 
	& test$table[,"logFC"]>0 & 
	rowData(mdsChr22Obj)[,"int_ex"]=="intron"))
print(sInt)
# Number of stabilized (significantly retained) U12 type introns
numStU12Int<- length(which(test$table[,"PValue"]<0.05 & 
	test$table[,"logFC"]>0 & 
	rowData(mdsChr22Obj)[,"intron_type"]=="U12" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"])))
# Number of U12 introns
numU12Int<- 
	length(which(rowData(mdsChr22Obj)[,"intron_type"]=="U12" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"]))) 
# Fraction(%) of stabilized (significantly retained) U12 introns
perStU12Int<- numStU12Int/numU12Int*100
print(perStU12Int)
# Number of stabilized U2 type introns
numStU2Int<- length(which(test$table[,"PValue"]<0.05 & 
	test$table[,"logFC"]>0 & 
	rowData(mdsChr22Obj)[,"intron_type"]=="U2" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"])))
# Number of U2 introns
numU2Int<- 
	length(which(rowData(mdsChr22Obj)[,"intron_type"]=="U2" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"])))
# Fraction(%) of stabilized U2 introns
perStU2Int<- numStU2Int/numU2Int*100
print(perStU2Int)

## ----glr_test, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"----

# Extract type of samples
group <- getAnnotation(mdsChr22Obj)[,"type"]
group

# Test retention levels' differentiation across 3 types samples
qlfRes<- qlfInterest(x=mdsChr22Obj, 
	design=model.matrix(~group), silent=TRUE, 
	disp="tagwiseInitTrended", coef=2:3, contrast=NULL, 
	poisson.bound=TRUE)

# Extract index of the introns with significant retention changes
ind= which(qlfRes$table$PValue< 0.05)
# Extract introns with significant retention level changes
variedIntrons= rowData(mdsChr22Obj)[ind,]

#Show first 5 rows and columns of the result table
print(variedIntrons[1:5,1:5])


## ----boxplot_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap= "**Figure 5:** Boxplot of the retention levels of U12 introns vs U2 introns, summed over samples with similar annotations *i.e.* ZRSR2 mutation, ZRSR2 wild type, or healthy."----
# boxplot U12 and U2-type introns 
par(mar=c(7,4,2,1))
u12Boxplot(mdsChr22Obj, sampleAnnoCol="type", 
	intExCol="int_ex",	intTypeCol="intron_type", intronExon="intron", 
	col=rep(c("orange", "yellow"),3) ,	lasNames=3, 
	outline=FALSE, ylab="FPKM", cex.axis=0.8)

## ----u12BoxplotNb_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap="**Figure 6:** Boxplot of retention levels of U12 introns vs their up- and down-stream U2 introns across all samples."----
# boxplot U12-type intron and its up/downstream U2-type introns 
par(mar=c(2,4,1,1))
u12BoxplotNb(mdsChr22Obj, sampleAnnoCol="type", lasNames=1,
	intExCol="int_ex", intTypeCol="intron_type", intronExon="intron", 
	boxplotNames=c(), outline=FALSE, plotLegend=TRUE, 
	geneIdCol="collapsed_transcripts_id", xLegend="topleft", 
	col=c("pink", "lightblue", "lightyellow"), ylim=c(0,1e+06), 
	ylab="FPKM", cex.axis=0.8)

## ----density_plot, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.cap= "**Figure 7:** Density plot of the log fold change of U12-type introns, random U2-type introns and U2 introns (up / down / up and down)stream of U12-type introns. "----
u12DensityPlotIntron(mdsChr22Obj, 
	type= c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), 
	fcType= "edgeR", sampleAnnoCol="test_ctrl", 
	sampleAnnotation=c("ctrl","test"), intExCol="int_ex", 
	intTypeCol="intron_type", strandCol= "strand", 
	geneIdCol= "collapsed_transcripts_id", naUnstrand=FALSE, col=c(2,3,4,5,6), 
	lty=c(1,2,3,4,5), lwd=1, plotLegend=TRUE, cexLegend=0.7, 
	xLegend="topright", yLegend=NULL, legend=c(), randomSeed=10,
	ylim=c(0,0.6), xlab=expression("log"[2]*" fold change FPKM"))

# estimate log fold-change of introns 
# by comparing test samples vs ctrl 
# and don't show warnings !
lfcRes<- lfc(mdsChr22Obj, fcType= "edgeR", 
	sampleAnnoCol="test_ctrl",sampleAnnotation=c("ctrl","test"))

# Build the order vector
ord<- rep(1,length(lfcRes))
ord[u12Index(mdsChr22Obj, intTypeCol="intron_type")]=2

# Median of log fold change of U2 introns (ZRSR2 mut. vs ctrl)
median(lfcRes[ord==1])
# Median of log fold change of U2 introns (ZRSR2 mut. vs ctrl)
median(lfcRes[ord==2])

## ----lfc-sig, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"----
# Run Jockheere Terpstra's trend test
library(clinfun)
jtRes<- jonckheere.test(lfcRes, ord, alternative = "increasing", 
	nperm=1000)
jtRes

## ----downstreamExample, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"----
mdsChr22RefIntRetSpObj<- cbind(mdsChr22Obj, mdsChr22IntSpObj)

mdsChr22RefIntRetSpObj<- addAnnotation(x=mdsChr22RefIntRetSpObj, 
	sampleAnnotationType="intronExon", 
	sampleAnnotation=c(rep("intron",16), rep("exon",16))
	)

library(BiocParallel)
mdsChr22RefIntRetSpIntFilObj<- 
	mdsChr22RefIntRetSpObj[rowData(mdsChr22RefIntRetSpObj)$int_ex=="intron",]

# Differential IR analysis run
ddsChr22Diff<- deseqInterest(mdsChr22RefIntRetSpIntFilObj,  
    design=~test_ctrl+test_ctrl:intronExon, 
    sizeFactor=rep(1,nrow(colData(mdsChr22RefIntRetSpIntFilObj))), 
    contrast=list("test_ctrltest.intronExonintron",
        "test_ctrlctrl.intronExonintron"),
    bpparam = SnowParam(workers=20))

# See the number of significantly more retained U12 and U2 introns
pThreshold<- 0.01
mdsChr22UpIntInd<- which(ddsChr22Diff$padj< pThreshold & ddsChr22Diff$padj>0)
table(rowData(mdsChr22RefIntRetSpIntFilObj)$intron_type[mdsChr22UpIntInd])

# See the fraction of significantly more retained U12 and U2 introns
100*table(rowData(mdsChr22RefIntRetSpIntFilObj)$intron_type[mdsChr22UpIntInd])/
	table(rowData(mdsChr22RefIntRetSpIntFilObj)$intron_type)

lfc<-function(x, fcType="edgeR", sampleAnnoCol=c(), sampleAnnotation=c(), 
	silent=TRUE, group=c(), rejection.region="doubletail", pseudoCnt=1, 
	log2=TRUE, ... )
{
	object=x
	if(is(object,"SummarizedExperiment")){
		if(fcType=="edgeR"){
			testRes=exactTestInterest(x=object, sampleAnnoCol=sampleAnnoCol, 
				sampleAnnotation=sampleAnnotation, silent=TRUE, group=group,
				rejection.region="doubletail", ...)
			fcRes=testRes$table[,"logFC"]
			if(!log2)
				fcRes=2^fcRes
		} else if(fcType=="scaledRetention"){
			if(length(sampleAnnoCol)>0){
				colInd=!is.na(match(
					as.character(SummarizedExperiment::colData(x)[,
						sampleAnnoCol]),
					sampleAnnotation))
				group=as.character(SummarizedExperiment::colData(x)[colInd,
					sampleAnnoCol])
			}
			if(length(sampleAnnotation)==0& length(unique(group))==2){
				sampleAnnotation=unique(group)
			} else if(length(sampleAnnotation)!=2 | length(unique(group))!=2) {
				msg<-
'The sampleAnnotation parameter should be a vector of size 2 which cotains 
values from colData(x); e.g. if colData(x)[,sampleAnnoCol] =
c("test", "test", "ctrl","ctrl", ...), and the goal is to compare "test" and 
"ctrl" samples, sampleAnnotation should either be c("test","ctrl") or 
c("ctrl","test").'
				stop(msg)
			}
			if(length(group)==0){
				ind1= (1:ncol(scaledRetention(object)))[getAnnotation(object)[
					,sampleAnnoCol]==sampleAnnotation[1]]
				ind2= (1:ncol(scaledRetention(object)))[getAnnotation(object)[
					,sampleAnnoCol]==sampleAnnotation[2]]
			} else {
				ind1= (1:ncol(scaledRetention(object)))[
					group==sampleAnnotation[1]]
				ind2= (1:ncol(scaledRetention(object)))[
					group==sampleAnnotation[2]]
			}

			fcRes= (apply(scaledRetention(object)[,ind2], 1,mean, na.rm=TRUE)+
				pseudoCnt)/ (apply(scaledRetention(object)[,ind1], 1,mean, 
					na.rm=TRUE)+ pseudoCnt)
			if(log2)
				fcRes=log(fcRes, base=2)
		}
	return(fcRes)	
	}	
}

interest.sequential <-
function(
	bamFileYieldSize=1000000,
	bamFile,
	isPaired,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference,
	referenceGeneNames,
	referenceIntronExon,
	repeatsTableToFilter=c(),
	junctionReadsOnly=FALSE,
	outFile,
	logFile="",
	returnObj=FALSE,
	method=c("ExEx", "IntRet", "IntSpan", "ExSkip"),
	strandSpecific,
	appendLogFile=FALSE,
	sampleName=c(), 
	scaleLength= c(TRUE,FALSE), 
	scaleFragment= c(TRUE,TRUE),
	limitRanges=GRanges(),
	excludeFusionReads=FALSE,
	loadLimitRangesReads=FALSE,
	... ){

  interest(
      bamFileYieldSize=bamFileYieldSize, 
      bamFile=bamFile,
      isPaired=isPaired,
      isPairedDuplicate=isPairedDuplicate,
      isSingleReadDuplicate=isSingleReadDuplicate,
      reference=reference, 
      referenceGeneNames=referenceGeneNames,
      referenceIntronExon=referenceIntronExon, 
      repeatsTableToFilter=repeatsTableToFilter,
      junctionReadsOnly=junctionReadsOnly, 
      outFile=outFile, 
      logFile=logFile,
      returnObj=returnObj, 
      method=method,
      strandSpecific=strandSpecific,
      appendLogFile=appendLogFile, 
      sampleName=sampleName, 
      scaleLength= scaleLength, scaleFragment= scaleFragment, 
      limitRanges=limitRanges, 
      excludeFusionReads=excludeFusionReads,
      loadLimitRangesReads=loadLimitRangesReads,
      ...)
  
  
}

#!/usr/bin/env Rscript
args = commandArgs(trailingOnly=TRUE)

if (length(args)<2) {
  stop(
"the path to the bam files and should be supplied as the 1st argument and 
the path to the ouput data should be supplied as the 2nd argument", 
call.=FALSE)
}
MDS_Chr22_BAMFILES<-dir(path = args[1], pattern = ".bam$", full.names = TRUE)
names(MDS_Chr22_BAMFILES)<-
	gsub("\\.bam", "", gsub("/","",gsub(args[1], "",MDS_Chr22_BAMFILES)))

library("IntEREst")

### INTRON RETENTION MEASUREMENT

# Building reference; Do collapse exons
refseqRef<- referencePrepare (sourceBuild="UCSC", ucscGenome="hg19",
    addCollapsedTranscripts=TRUE, ignore.strand=FALSE)

# Annotate U12 type introns
library("BSgenome.Hsapiens.UCSC.hg19")
refseqAnnoMat<- annotateU12(
    pwmU12U2= list(
        pwmU12db[[1]][,11:17],
        pwmU12db[[2]],
        pwmU12db[[3]][,38:40],
        pwmU12db[[4]][,11:17],
        pwmU12db[[5]][,38:40]),
    pwmSsIndex= list(
        indexDonU12=1, 
        indexBpU12=1, 
        indexAccU12=3, 
        indexDonU2=1, 
        indexAccU2=3), 
    referenceChr= refseqRef[,"chr"], 
    referenceBegin= as.numeric(refseqRef[,"begin"]), 
    referenceEnd= as.numeric(refseqRef[,"end"]), 
    referenceIntronExon= refseqRef[,"int_ex"],
    intronExon= "intron",
    matchWindowRelativeUpstreamPos= c(NA,-29,NA,NA,NA),
    matchWindowRelativeDownstreamPos= c(NA,-9,NA,NA,NA), 
    minMatchScore= c( rep("80%", 2), "40%", "80%",  "40%"), 
    refGenome= BSgenome.Hsapiens.UCSC.hg19, 
    setNaAs= "U2", 
    annotateU12Subtype= TRUE)


# Creating temp directory to store the results
outDir<- file.path(tempdir(),"interest_sequential_results")
dir.create(outDir)
outDir<- normalizePath(outDir)

# Summarize read sequences in bam files. Measure Intron retention levels
for(i in 1:length(MDS_BAMFILES)){
    dir.create(paste(outDir, names(MDS_BAMFILES)[i],
        sep="/"), recursive = TRUE)
   interest(
        bamFileYieldSize=1000000,
        bamFile=MDS_BAMFILES[i],
        isPaired=TRUE,
        isPairedDuplicate=FALSE,
        isSingleReadDuplicate=NA,
        reference=refseqRef,
        referenceGeneNames=refseqRef[,"collapsed_transcripts_id"],
        referenceIntronExon=refseqRef[,"int_ex"],
        repeatsTableToFilter= c(),
        junctionReadsOnly=FALSE,
        outFile=paste(outDir, names(MDS_BAMFILES)[i], 
            "interestRes.tsv", sep="/"),
        logFile=paste(outDir, names(MDS_BAMFILES)[i], 
            "log.txt", sep="/"),
        method="IntRet",
        clusterNo=40,
        returnObj=FALSE, 
        scaleLength= TRUE, 
        scaleFragment= TRUE
    )
}

# Reading the intron retention results
# and build SummarizedExperiment object
mdsRefObj<-readInterestResults(
    resultFiles=paste(outDir, names(MDS_BAMFILES), 
            "interestRes.tsv", sep="/"), 
    sampleNames=names(MDS_BAMFILES), 
    sampleAnnotation=data.frame( 
        type=c(rep("ZRSR2mut",8), rep("ZRSR2wt",4), rep("HEALTHY",4)),
        test_ctrl=c(rep("test",8), rep("ctrl",8))), 
    commonColumns=1:9, freqCol=10, scaledRetentionCol=11,
    scaleLength=TRUE, scaleFragment=TRUE, reScale=TRUE, 
    geneIdCol="collapsed_transcripts_id")

# update the object with the intron type (U12- or U2-type) annotations
mdsRefObj<- updateRowDataCol(mdsRefObj,  "intron_type", refseqAnnoMat[,1])

# Choose U12 gebnes on chromosome 22 only
rowInd<- which(
	rowData(mdsRefObj)$collapsed_transcripts_id %in%
		unique(rowData(mdsRefObj)$collapsed_transcripts_id[
			which(rowData(mdsRefObj)$intron_type=="U12" & 
				rowData(mdsRefObj)$chr=="chr22")]))
mdsChr22Obj<-mdsRefObj[rowInd,]

save(mdsChr22Obj,file=paste(args[2],"mdsChr22Obj.rda",sep="/"))




### EXON-EXON JUNCTION MEASUREMENT
library("IntEREst")
library("BSgenome.Hsapiens.UCSC.hg19")
refseqUncollapsed<- referencePrepare (sourceBuild="UCSC", ucscGenome="hg19",
    addCollapsedTranscripts=FALSE, collapseExons=FALSE, ignore.strand=FALSE)

# Union exons of transcripts with overlapping exons
# Keep one copy from each repeating set of exons, only
refExDf<- unionRefTr(referenceChr= refseqUncollapsed[,"chr"], 
    referenceBegin= as.numeric(refseqUncollapsed[,"begin"]), 
    referenceEnd= as.numeric(refseqUncollapsed[,"end"]), 
    referenceTr=as.character(refseqUncollapsed[,"transcript_id"]),
    referenceIntronExon=refseqUncollapsed[,"int_ex"],
    intronExon="exon",
    silent=FALSE)


# Creating temp directory to store the results
outDir<- file.path(tempdir(),"interest_exex_sequential_results")
dir.create(outDir)
outDir<- normalizePath(outDir)

# Summarize read sequences in bam files. Measure exon-exon junction levels
for(i in 1:length(MDS_BAMFILES)){
    dir.create(paste(outDir, names(MDS_BAMFILES)[i],
        sep="/"), recursive = TRUE)
   interest(
        bamFileYieldSize=1000000,
        bamFile=MDS_BAMFILES[i],
        isPaired=TRUE,
        isPairedDuplicate=FALSE,
        isSingleReadDuplicate=NA,
        reference=refExDf,
        referenceGeneNames=refExDf[,"transcripts_id"],
        referenceIntronExon=refExDf[,"int_ex"],
        repeatsTableToFilter= c(),
        junctionReadsOnly=TRUE,
        outFile=paste(outDir, names(MDS_BAMFILES)[i], 
            "exExRes.tsv", sep="/"),
        logFile=paste(outDir, names(MDS_BAMFILES)[i], 
            "log.txt", sep="/"),
        method=c("ExEx"),
        clusterNo=20,
        returnObj=FALSE, 
        scaleLength= FALSE, 
        scaleFragment= TRUE,
        bpparam= SnowParam(workers=25)
    )
}

# Reading the intron retention results
# and build SummarizedExperiment object
mdsExRefObj<-readInterestResults(
    resultFiles=paste(outDir, names(MDS_BAMFILES), 
            "exExRes.tsv", sep="/"), 
    sampleNames=names(MDS_BAMFILES), 
    sampleAnnotation=data.frame( 
        type=c(rep("ZRSR2mut",8), rep("ZRSR2wt",4), rep("HEALTHY",4)),
        test_ctrl=c(rep("test",8), rep("ctrl",8))), 
    commonColumns=1:5, freqCol=6, scaledRetentionCol=7,
    scaleLength=FALSE, scaleFragment=TRUE, reScale=FALSE, 
    geneIdCol="transcripts_id")

# Choose U12 genes on chromosome 22 only
trChooseGr<- GRanges(
	tapply(rowData(mdsChr22Obj)$chr,rowData(mdsChr22Obj)$
		collapsed_transcripts_id,unique),
    IRanges(tapply(rowData(mdsChr22Obj)$begin,rowData(mdsChr22Obj)$
		collapsed_transcripts_id,min),
        tapply(rowData(mdsChr22Obj)$end,rowData(mdsChr22Obj)$
			collapsed_transcripts_id,max)))

mdsExRefObjGr<- GRanges(rowData(mdsExRefObj)$chr,
    IRanges(rowData(mdsExRefObj)$begin,
        rowData(mdsExRefObj)$end))

exOverlap<- findOverlaps(mdsExRefObjGr, trChooseGr, type="any")


mdsChr22ExObj<- mdsExRefObj[unique(queryHits(exOverlap)),]
save(mdsChr22ExObj,file=paste(args[2],"mdsChr22ExObj.rda",sep="/"))


### INTRON-SPAN MEASUREMENT

library(BiocParallel)
outDir<- "/netapp/ali/interestRun/MDS/intSpan/"
dir.create(outDir)

for(i in 1:length(MDS_BAMFILES)){
	print(paste(i, length(MDS_BAMFILES), sep="/"))
    dir.create(paste(outDir, names(MDS_BAMFILES)[i],
        sep="/"), recursive = TRUE)
   interest(
        bamFileYieldSize=1000000,
        bamFile=MDS_BAMFILES[i],
        isPaired=TRUE,
        isPairedDuplicate=FALSE,
        isSingleReadDuplicate=NA,
        reference=refseqRef,
        referenceGeneNames=refseqRef[,"collapsed_transcripts_id"],
        referenceIntronExon=refseqRef[,"int_ex"],
        repeatsTableToFilter= c(),
        junctionReadsOnly=FALSE,
        outFile=paste(outDir, names(MDS_BAMFILES)[i], 
            "interestRes.tsv", sep="/"),
        logFile=paste(outDir, names(MDS_BAMFILES)[i], 
			"log.txt", sep="/"),
		method="IntSpan",
        bpparam=SnowParam(workers=35),
        returnObj=FALSE, 
        scaleLength= TRUE, 
        scaleFragment= TRUE
    )
}

# Reading the intron retention results
# and build SummarizedExperiment object
mdsRefIntSpObj<-readInterestResults(
    resultFiles=paste(outDir, names(MDS_BAMFILES), 
            "exExRes.tsv", sep="/"), 
    sampleNames=names(MDS_BAMFILES), 
    sampleAnnotation=data.frame( 
        type=c(rep("ZRSR2mut",8), rep("ZRSR2wt",4), rep("HEALTHY",4)),
        test_ctrl=c(rep("test",8), rep("ctrl",8))), 
    commonColumns=1:5, freqCol=6, scaledRetentionCol=7,
    scaleLength=FALSE, scaleFragment=TRUE, reScale=FALSE, 
    geneIdCol="transcripts_id")


# Choose U12 genes on chromosome 22 only
trChooseGr<- GRanges(
	tapply(rowData(mdsChr22Obj)$chr,rowData(mdsChr22Obj)$
		collapsed_transcripts_id,unique),
    IRanges(tapply(rowData(mdsChr22Obj)$begin,rowData(mdsChr22Obj)$
		collapsed_transcripts_id,min),
        tapply(rowData(mdsChr22Obj)$end,rowData(mdsChr22Obj)$
			collapsed_transcripts_id,max)))

mdsRefIntSpObjGr<- GRanges(rowData(mdsRefIntSpObj)$chr,
    IRanges(rowData(mdsRefIntSpObj)$begin,
        rowData(mdsRefIntSpObj)$end))

intSpOverlap<- findOverlaps(mdsRefIntSpObjGr, trChooseGr, type="any")
mdsChr22IntSpObj<- mdsRefIntSpObj[unique(queryHits(intSpOverlap)),]

save(mdsChr22IntSpObj,file=paste(args[2],"mdsChr22IntSpObj.rda",sep="/"))

psi<- function(x, y, intCol, exCol, pseudoCnt=0){
	if(missing(y))
		y<-x

	xCnt<-
		counts(x)[,
			intCol]
	yCnt<-
		counts(y)[,
			exCol]

	psiRes<- (xCnt)/(xCnt+(yCnt*2)+pseudoCnt)
	return (psiRes)

}

interest <-
function(
	bamFileYieldSize=1000000, 
	bamFile,
	isPaired,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference, referenceGeneNames,
	referenceIntronExon, repeatsTableToFilter=c(),
	junctionReadsOnly=FALSE, outFile, logFile="",
	returnObj=FALSE, method=c("ExEx", "IntRet", "IntSpan", "ExSkip"),
	strandSpecific, bpparam, appendLogFile=FALSE, sampleName="", 
	scaleLength= c(TRUE,FALSE), scaleFragment= c(TRUE,TRUE), 
	limitRanges=GRanges(),
	excludeFusionReads=FALSE,
	loadLimitRangesReads=FALSE,
	...)
  
{


	method=unique(method)
	if(length(which( ! method %in% c("ExEx", "IntRet", "IntSpan", "ExSkip")))!=0)
		stop(paste("Unknown method:", 
			method[! method %in% c("ExEx", "IntRet", "IntSpan", "ExSkip")], sep=" "))
	time1=Sys.time()
	if(logFile!=""){
		cat( "Log info: Running interest in Parallel mode.\n", file=logFile, 
			append=appendLogFile)
		cat(
"InERESt: Running bamPreprocess. Detailed log info are written in: ",
			logFile ,"\n")
	}
	cat( "Log info: Running interest in Parallel mode.\n")


	if(is(reference,"GRanges")){
		if(length(names(reference))>0){
			tmpReference=data.frame(
				chr=as.character(GenomicRanges::seqnames(reference)), 
				begin=as.numeric(GenomicRanges::start(reference)), 
				end=as.numeric(GenomicRanges::end(reference)), 
				strand=as.character(GenomicRanges::strand(reference)), 
				names=as.character(names(reference)))
		} else{
			tmpReference=data.frame(
				chr=as.character(GenomicRanges::seqnames(reference)), 
				begin=as.numeric(GenomicRanges::start(reference)), 
				end=as.numeric(GenomicRanges::end(reference)), 
				strand=as.character(GenomicRanges::strand(reference)))
		}
		reference=tmpReference
	}

	if(logFile!="")
		cat( "InERESt: Running interestAnalyse.\n", file=logFile, append=TRUE)
	cat("InERESt: Running interestAnalyse.\n", append=TRUE)
	if(!missing(bpparam)){
		inAnRes<- interestAnalyse(
			reference=reference,
			bamFile=bamFile,
			isPaired=isPaired,
			yieldSize=bamFileYieldSize,
			maxNoMappedReads=1,
			appendLogFile=TRUE,
			logFile=logFile,
			method=method,
			strandSpecific=strandSpecific,
			repeatsTableToFilter=repeatsTableToFilter,
			referenceIntronExon=referenceIntronExon,
			junctionReadsOnly=junctionReadsOnly,
			isPairedDuplicate=isPairedDuplicate, 
			isSingleReadDuplicate=isSingleReadDuplicate,
			bpparam=bpparam, 
			limitRanges=limitRanges, 
			excludeFusionReads=excludeFusionReads,
			loadLimitRangesReads=loadLimitRangesReads,
			...)
	} else {
		inAnRes<- interestAnalyse(
			reference=reference,
			bamFile=bamFile,
			isPaired=isPaired,
			yieldSize=bamFileYieldSize,
			maxNoMappedReads=1,
			appendLogFile=TRUE,
			logFile=logFile,
			method=method,
			strandSpecific=strandSpecific,
			repeatsTableToFilter=repeatsTableToFilter,
			referenceIntronExon=referenceIntronExon,
			junctionReadsOnly=junctionReadsOnly,
			isPairedDuplicate=isPairedDuplicate, 
			isSingleReadDuplicate=isSingleReadDuplicate, 
			limitRanges=limitRanges,
			excludeFusionReads=excludeFusionReads,
			loadLimitRangesReads=loadLimitRangesReads,
			...)

	} 


	if(logFile!="")
		cat( "InERESt: Running interestSummarise.\n", file=logFile, 
			append=TRUE)
	cat("InERESt: Running interestSummarise.\n", append=TRUE)

	interestSummarise(
		reference=reference,
		referenceIntronExon=referenceIntronExon,
		inAnRes=inAnRes,
		method=method,
		referenceGeneNames=referenceGeneNames,
		repeatsTableToFilter=repeatsTableToFilter,
		outFile=outFile,
		scaleLength= scaleLength, 
		scaleFragment= scaleFragment
	)

	if(returnObj & length(method)==1){
		tmpDat<- read.table(outFile, header=TRUE, stringsAsFactors=FALSE)

	readFrq<-matrix(tmpDat[,(ncol(tmpDat)-1)], ncol=1)
	scaledRet<-matrix(tmpDat[,ncol(tmpDat)], ncol=1)
	colnames(readFrq)<-c()
	colnames(scaledRet)<-c()
	resObj=InterestResult(
		resultFiles=outFile,
		counts=readFrq,
		scaledRetention=scaledRet,
		rowData=tmpDat[, 1:(ncol(tmpDat)-2)],
		scaleLength=scaleLength, 
		scaleFragment=scaleFragment)



	} else if (returnObj & length(method)>1 & 
		length(which( ! method %in% c("ExEx", "IntRet", "IntSpan", "ExSkip")))==0){
		resObj<- list()
		if("IntRet" %in% method){
		  indFrq<- 3
		  if(!("ExEx"%in%method))
		    indFrq<- 1
		  
			tmpDat<- read.table(outFile, header=TRUE, stringsAsFactors=FALSE)
			
			resObj<- c(resObj, list(
				IntRet=InterestResult(resultFiles=outFile, 
					counts=matrix(tmpDat[,(ncol(reference)+indFrq)], ncol=1), 
					scaledRetention=matrix(tmpDat[,(ncol(reference)+indFrq+1)], ncol=1), 
					scaleLength=scaleLength[method=="IntRet"], 
					scaleFragment=scaleFragment[method=="IntRet"], 
					rowData=tmpDat[, 1:ncol(reference)]) 
			))
		}
		if("ExEx" %in% method){
			indFrq<- 1
			tmpDat<- read.table(outFile, header=TRUE, stringsAsFactors=FALSE)
			resObj<- c(resObj, list(
				ExEx=InterestResult(resultFiles=outFile, 
					counts=matrix(tmpDat[,(ncol(reference)+indFrq)], ncol=1), 
					scaledRetention=
						matrix(tmpDat[,(ncol(reference)+indFrq+1)], ncol=1), 
					scaleLength=scaleLength[method=="ExEx"], 
					scaleFragment=scaleFragment[method=="ExEx"], 
					rowData=tmpDat[, 1:ncol(reference)]) 
			))
		}		
		if("IntSpan" %in% method){
		  cntMet<-length(which(c("ExEx", "IntRet")%in%method))
			indFrq<- 2*cntMet+1
			tmpDat<- read.table(outFile, header=TRUE, stringsAsFactors=FALSE)
			resObj<- c(resObj, list(
				IntSpan=InterestResult(resultFiles=outFile, 
					counts=matrix(tmpDat[,(ncol(reference)+indFrq)], ncol=1), 
					scaledRetention=
						matrix(tmpDat[,(ncol(reference)+indFrq+1)], ncol=1), 
					scaleLength=scaleLength[method=="IntSpan"], 
					scaleFragment=scaleFragment[method=="IntSpan"], 
					rowData=tmpDat[, 1:ncol(reference)]) 
			))
		}
		if("ExSkip" %in% method){
		  cntMet<-length(which(c("ExEx", "IntRet", "IntSpan")%in%method))
		  indFrq<- 2*cntMet+1
		  tmpDat<- read.table(outFile, header=TRUE, stringsAsFactors=FALSE)
		  resObj<- c(resObj, list(
		    ExSkip=InterestResult(resultFiles=outFile, 
		                           counts=matrix(tmpDat[,(ncol(reference)+indFrq)], ncol=1), 
		                           scaledRetention=
		                             matrix(tmpDat[,(ncol(reference)+indFrq+1)], ncol=1), 
		                           scaleLength=scaleLength[method=="Exskip"], 
		                           scaleFragment=scaleFragment[method=="Exskip"], 
		                           rowData=tmpDat[, 1:ncol(reference)]) 
		  ))
		}
	}
	time2=Sys.time()
	runTime=difftime(time2,time1, units="secs")
	if(logFile!="")
		cat( "InERESt: run ends. Full running time: ",runTime," secs\n", 
			file=logFile, append=TRUE)
	cat( "InERESt: run ends. Full running time: ",runTime," secs\n", 
		append=TRUE)
	if(returnObj)
		return(resObj)
}

u12DensityPlotIntron<- function(
	x, type=c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), fcType="edgeR", 
	sampleAnnotation=c(),  sampleAnnoCol=c(), group=c(), intExCol="int_ex", 
	intTypeCol="int_type", strandCol="strand",
	geneIdCol="collapsed_transcripts", naUnstrand=FALSE, col=1, lty=1, lwd=1, 
	plotLegend=TRUE, cexLegend=1, xLegend="topright", yLegend=NULL, legend=c(),
	randomSeed=NULL, xlab="", ...){
	u12DensityPlot (x=x, type=type, fcType=fcType, 
	sampleAnnotation=sampleAnnotation,  sampleAnnoCol=sampleAnnoCol, 
	group=group, intExCol=intExCol, intTypeCol=intTypeCol, 
	intronExon="intron", strandCol=strandCol, geneIdCol=geneIdCol, 
	naUnstrand=naUnstrand, col=col, lty=lty, lwd=lwd, 
	plotLegend=plotLegend, cexLegend=cexLegend, xLegend=xLegend, 
	yLegend=yLegend, legend=legend, randomSeed=randomSeed, 
	xlab=xlab, ...)

}

exactTestInterest<- function(x, sampleAnnoCol=c(), sampleAnnotation=c(),
	geneIdCol, silent=TRUE, group=c(), rejection.region="doubletail", 
	big.count=900, prior.count=0.125, disp="common", ...)
{

	if(length(group)==0 & length(sampleAnnoCol)>0 & length(sampleAnnotation)>0){
		colInd=!is.na(match(as.character(SummarizedExperiment::colData(x)[,
			sampleAnnoCol]), sampleAnnotation))
		group=as.character(SummarizedExperiment::colData(x)[colInd,
			sampleAnnoCol])
	} else if (length(group)>0){
		#Check if sampleAnnotation param is set correctly
		if(length(sampleAnnotation)>0)
			if(length(which(is.na(match(sampleAnnotation,group))))>0 & 
				length(sampleAnnotation)>0)
				stop(
'The sampleAnnotation parameter should be a vector of size 2 which cotains
values from group; e.g. if group=c("test", "test", "ctrl","ctrl", ...), and the
goal is to compare "test" and "ctrl" samples, sampleAnnotation should either be
c("test","ctrl") or c("ctrl","test").')

		if(length(sampleAnnotation)==0)
			sampleAnnotation=unique(group)
		colInd=!is.na(match(group,sampleAnnotation))
	} else {
		stop(
'Either group or the sampleAnnotation and sampleAnnoCol parameters need to be
set.')
	}
	y <- edgeR::DGEList(counts=counts(x)[,colInd], group=group )
	if(is.character(disp)){
		if((is.na(match(disp, c("tagwise", "trended", "common", "genewise", 
			"auto")))) & length(disp)==1){
				stop(
'The disp parameter should be set "tagwise", "trended", "common", or 
"genewise"'
				)
		}
		if(disp!="genewise")
			dispTmp=edgeR::estimateDisp(y, ...)
	}
	if(disp=="tagwise" & length(disp)==1){
		dispersionType="tagwise"
		dispersion=dispTmp$tagwise.dispersion
	} else if(disp=="trended"& length(disp)==1){
		dispersionType="trended"
		dispersion=dispTmp$trended.dispersion
	} else if(disp=="common"& length(disp)==1){
		dispersionType="common"
		dispersion=dispTmp$common.dispersion
	} else if(disp=="genewise"& length(disp)==1){
		dispersionType="genewise"
		dispTmp=edgeR::estimateExonGenewiseDisp(counts(x)[,colInd], 
			geneID=SummarizedExperiment::rowData(x)[,geneIdCol], 
			group=group)
		dispersion=as.numeric(dispTmp[as.character(
			SummarizedExperiment::rowData(x)[,geneIdCol])])
	} else if(is.numeric(disp)){
		dispersionType="manualSet"
	}
	res <- edgeR::exactTest(y, dispersion=dispersion, pair=sampleAnnotation, 
		rejection.region=rejection.region, big.count=big.count, 
		prior.count=prior.count)
	if(!silent)
		print(edgeR::topTags(res))
	res$dispersionType=dispersionType
	res$dispersion=dispersion
	return(res)
}

matchPwmToReference<-function(pwm, pwmSsIndex=11, referenceChr, referencePos, 
	referenceIntronExon, intronExon="intron", matchWindowRelativePos=c(NA,NA), 
	minMatchScore="80%", refGenome=""){

	# Check if reference genome sequence is of BSgenome type
	if (is(refGenome, "BSgenome")){

		# Check if only intron sequences should be checked for U12 annotation 
		if(length(intronExon)==1){
			# Check whether an upstream or downstream window is NOT defined for 
			#the PWM matching
			if((!is.na(matchWindowRelativePos[1])) & 
				(!is.na(matchWindowRelativePos[2]))){
				seqIntEx=Biostrings::getSeq(refGenome, 
					names=referenceChr[referenceIntronExon==intronExon], 
					start=(referencePos+(matchWindowRelativePos[1]))[
						referenceIntronExon==intronExon], 
					end=(referencePos+matchWindowRelativePos[2])[
						referenceIntronExon==intronExon],
					as.character=TRUE)
			# Check whether an upstream or downstream window is defined for the 
			#PWM matching
			} else {
				seqIntEx=Biostrings::getSeq(refGenome, 
					names=referenceChr[referenceIntronExon==intronExon], 
					start=(referencePos-(pwmSsIndex-1))[
						referenceIntronExon==intronExon], 
					end=(referencePos+(ncol(pwm)-pwmSsIndex))[
						referenceIntronExon==intronExon],
					as.character=TRUE)
			}
		# Check if all (intron and exon) sequences should be checked for 
		#U12 annotation  
		} else if ( length(which(intronExon=="intron"))==1 & 
			length(which(intronExon=="exon"))==1 ) {
			
			if((!is.na(matchWindowRelativePos[1])) & 
				(!is.na(matchWindowRelativePos[2]))){
				# run if upstream or downstream windows are NOT defined for the 
				#PWM matching
				seqIntEx=Biostrings::getSeq(refGenome, 
					names=referenceChr[referenceIntronExon==intronExon[1] | 
						referenceIntronExon==intronExon[2]], 
					start=(referencePos+(matchWindowRelativePos[1]))[
						referenceIntronExon==intronExon[1] |
							referenceIntronExon==intronExon[2]], 
					end=(referencePos+matchWindowRelativePos[2])[
						referenceIntronExon==intronExon[1] | 
							referenceIntronExon==intronExon[2]],
					as.character=TRUE)
			} else {
				# run if upstream or downstream windows are defined for the 
				#PWM matching
				seqIntEx=Biostrings::getSeq(refGenome, 
					names=referenceChr[referenceIntronExon==intronExon[1] | 
						referenceIntronExon==intronExon[2]], 
					start=(referencePos-(pwmSsIndex-1))[
						referenceIntronExon==intronExon[1] | 
							referenceIntronExon==intronExon[2]], 
					end=(referencePos+(ncol(pwm)-pwmSsIndex))[
						referenceIntronExon==intronExon[1] | 
							referenceIntronExon==intronExon[2]],
					as.character=TRUE)
			}


		} else {
			msg<- 
"Invalid intronExon parameter. Check ?matchPwmToReference for more 
information."
			stop(msg)
		}

		matchInd= lapply(seqIntEx, function(tmp) { 
			test=Biostrings::matchPWM(pwm, tmp, min.score=minMatchScore,
				with.score=TRUE)
			return( list(len=length(GenomicRanges::ranges(test)), 
				score=max(S4Vectors::mcols(test)$score)) )
			})

		lenMatchInd<- 
			as.vector(unlist(sapply(matchInd, function(tmp) return(tmp$len))))
		matchScore<- rep(0,length(lenMatchInd))
		matchScoreTmp<-as.vector(unlist(sapply(matchInd, function(tmp) 
			return(tmp$score))))
		validInd<- which(!is.na(matchScoreTmp)& !is.infinite(matchScoreTmp) & 
					!is.null(matchScoreTmp))
		if(length(which(lenMatchInd>0))>0)
			matchScore[which(lenMatchInd>0)]<- matchScoreTmp[validInd]


	} else if (is(refGenome, "DNAStringSet")){

		# Check if only intron sequences should be checked for U12 annotation 
		if(length(intronExon)==1){
			# Check whether an upstream or downstream window is NOT defined for 
			#the PWM matching
			if((!is.na(matchWindowRelativePos[1])) & 
				(!is.na(matchWindowRelativePos[2]))){
				tmpGr<- GenomicRanges::GRanges (
					referenceChr[referenceIntronExon==intronExon], 
					IRanges((referencePos+(matchWindowRelativePos[1]))[
						referenceIntronExon==intronExon],
						(referencePos+matchWindowRelativePos[2])[
						referenceIntronExon==intronExon]))

				seqIntEx=as.character(Biostrings::getSeq(refGenome, 
					tmpGr))
			# Check whether an upstream or downstream window is defined for the 
			#PWM matching
			} else {
				tmpGr<- GenomicRanges::GRanges (
					referenceChr[referenceIntronExon==intronExon], 
					IRanges(
						(referencePos-(pwmSsIndex-1))[
							referenceIntronExon==intronExon],
						(referencePos+(ncol(pwm)-pwmSsIndex))[
							referenceIntronExon==intronExon]))

				seqIntEx=as.character(Biostrings::getSeq(refGenome, 
					tmpGr))
			}
		# Check if all (intron and exon) sequences should be checked for 
		#U12 annotation  
		} else if ( length(which(intronExon=="intron"))==1 & 
			length(which(intronExon=="exon"))==1 ) {
			
			if((!is.na(matchWindowRelativePos[1])) & 
				(!is.na(matchWindowRelativePos[2]))){
				# run if upstream or downstream windows are NOT defined for the 
				#PWM matching
				tmpGr<-  GenomicRanges::GRanges (
					referenceChr[referenceIntronExon==intronExon[1] | 
						referenceIntronExon==intronExon[2]], 
					IRanges(
						(referencePos+(matchWindowRelativePos[1]))[
						referenceIntronExon==intronExon[1] |
							referenceIntronExon==intronExon[2]],
						(referencePos+matchWindowRelativePos[2])[
						referenceIntronExon==intronExon[1] | 
							referenceIntronExon==intronExon[2]]))

				seqIntEx=as.character(Biostrings::getSeq(refGenome, 
					tmpGr))
			} else {
				# run if upstream or downstream windows are defined for the 
				#PWM matching
				tmpGr<-  GenomicRanges::GRanges (
					referenceChr[referenceIntronExon==intronExon[1] | 
						referenceIntronExon==intronExon[2]], 
					IRanges(
						(referencePos-(pwmSsIndex-1))[
						referenceIntronExon==intronExon[1] | 
							referenceIntronExon==intronExon[2]],
						(referencePos+(ncol(pwm)-pwmSsIndex))[
						referenceIntronExon==intronExon[1] | 
							referenceIntronExon==intronExon[2]]))


				seqIntEx=as.character(Biostrings::getSeq(refGenome, 
					tmpGr))
			}


		} else {
			msg<- 
"Invalid intronExon parameter. Check ?matchPwmToReference for more 
information."
			stop(msg)
		}

		matchInd= lapply(seqIntEx, function(tmp) { 
			test=Biostrings::matchPWM(pwm, tmp, min.score=minMatchScore,
				with.score=TRUE)
			return( list(len=length(GenomicRanges::ranges(test)), 
				score=S4Vectors::mcols(test)$score) )
			}) 

		lenMatchInd<- 
			as.vector(unlist(sapply(matchInd, function(tmp) return(tmp$len))))
		matchScore<- rep(0,length(lenMatchInd))
		matchScoreTmp<-as.vector(unlist(sapply(matchInd, function(tmp) 
			return(tmp$score))))
		validInd<- which(!is.na(matchScoreTmp)& !is.infinite(matchScoreTmp) & 
					!is.null(matchScoreTmp))
		if(length(which(lenMatchInd>0))>0)
			matchScore[which(lenMatchInd>0)]<- matchScoreTmp[validInd]


	} else if (file.exists(refGenome)) {
		#Run if reference genome sequence is a fasta file
		fa=seqinr::read.fasta(file = refGenome)
		# Check if only intron sequences should be checked for U12 annotation
		if(length(intronExon)==1){
			# Check whether an upstream or downstream window is NOT defined for
			#the PWM matching
			if((!is.na(matchWindowRelativePos[1])) & 
				(!is.na(matchWindowRelativePos[2]))){

				seqIntEx=unlist(lapply( which(referenceIntronExon==intronExon),
					function(temp) seqinr::getSequence(seqinr::getFrag(
						object=fa[as.character(referenceChr)[temp]],
						begin=(referencePos+(matchWindowRelativePos[1]))[temp],
						end=(referencePos+matchWindowRelativePos[2])[temp]), 
							as.string=TRUE)))
			
			# Check whether an upstream or downstream window is defined for the
			#PWM matching
			} else {

				seqIntEx=unlist(lapply( which(referenceIntronExon==intronExon), 
					function(temp) seqinr::getSequence(seqinr::getFrag(
						object=fa[as.character(referenceChr)[temp]], 
						begin=(referencePos-(pwmSsIndex-1))[temp], 
						end=(referencePos+(ncol(pwm)-pwmSsIndex))[temp]), 
							as.string=TRUE)))

			}
		# Check if all (intron and exon) sequences should be checked for U12
		#annotation
		} else if ( length(which(intronExon=="intron"))==1 & 
			length(which(intronExon=="exon"))==1 ) {
			# Check Whether an upstream or downstream window is NOT defined for
			#the PWM matching
			if((!is.na(matchWindowRelativePos[1])) & 
				(!is.na(matchWindowRelativePos[2]))){

				seqIntEx=unlist(lapply( which(
					referenceIntronExon==intronExon[1]| 
						referenceIntronExon==intronExon[2]), 
					function(temp) seqinr::getSequence(seqinr::getFrag(
						object=fa[as.character(referenceChr)[temp]], 
						begin=(referencePos+(matchWindowRelativePos[1]))[temp],
						end=(referencePos+matchWindowRelativePos[2])[temp]),
							as.string=TRUE)))

			# Check whether an upstream or downstream window is defined for the
			#PWM matching
			} else {

				seqIntEx=unlist(lapply( which(
					referenceIntronExon==intronExon[1]| 
						referenceIntronExon==intronExon[2]), 
					function(temp) seqinr::getSequence(seqinr::getFrag(
						object=fa[as.character(referenceChr)[temp]], 
						begin=(referencePos-(pwmSsIndex-1))[temp], 
						end=(referencePos+(ncol(pwm)-pwmSsIndex))[temp]), 
							as.string=TRUE)))

			}
		} else {
			msg<-
"Invalid intronExon parameter. Check ?matchPwmToReference for more 
information."
			stop(msg)
		}

		matchInd= lapply(seqIntEx, function(tmp) { 
			test=Biostrings::matchPWM(pwm, tmp, min.score=minMatchScore, 
				with.score=TRUE)
			return( list(len=length(GenomicRanges::ranges(test)), 
				score=S4Vectors::mcols(test)$score) )
			}) 

		lenMatchInd<- 
			as.vector(unlist(sapply(matchInd, function(tmp) return(tmp$len))))
		matchScore<- rep(0,length(lenMatchInd))
		matchScoreTmp<-as.vector(unlist(sapply(matchInd, function(tmp) 
			return(tmp$score))))
		validInd<- which(!is.na(matchScoreTmp)& !is.infinite(matchScoreTmp) & 
					!is.null(matchScoreTmp))
		if(length(which(lenMatchInd>0))>0)
			matchScore[which(lenMatchInd>0)]<- matchScoreTmp[validInd]



	}


	pwmMatchBool=lenMatchInd>0

	res=data.frame(pwmMatchBool=pwmMatchBool, pwmMatchScore=matchScore)
	return(res)

}

#Calling the constructor
InterestResult <- function(resultFiles=c(), counts, scaledRetention, 
	scaleLength, scaleFragment, sampleAnnotation, rowData){
	if(!missing(sampleAnnotation)){
		if(length(resultFiles)>0)
			sampleAnnotation<- data.frame(resultFiles=resultFiles, 
				sampleAnnotation, row.names= rownames(sampleAnnotation))
		res<- SummarizedExperiment::SummarizedExperiment(
			assays=list(counts=counts, 
			scaledRetention=scaledRetention), 
			rowData=rowData,
			colData=sampleAnnotation, 
			metadata=list( scaleFragment= scaleFragment,
			scaleLength= scaleLength)		
		)
	} else {
		if(length(resultFiles)>0)
			sampleAnnotation<- data.frame(resultFiles=resultFiles,
				row.names=colnames(counts))
		res<- SummarizedExperiment::SummarizedExperiment(
			assays=list(counts=counts, 
			scaledRetention=scaledRetention), 
			rowData=rowData, 
			metadata=list( scaleFragment= scaleFragment,
			scaleLength= scaleLength)
		)
	}
	return(res)
}

# plot method
plot.InterestResult<-function(x, summary="none", subsetRows=NULL, 
	what="scaled", intronExon="intron", logScaleBase=NULL, logPseudoCnt=1, 
	plotLoess=TRUE, loessCol="red",	loessLwd=1, loessLty=1, cexText=1, 
	marPlot=c(2,2,2,2), mgpPlot=c(1, 1, 0), cexAxis=1, writeCor=TRUE, corCex=1,
	corMethod="pearson", corCol="grey63", upperCorXY=c("topleft", NULL),
	lowerCorXY= c("topleft", NULL), na.rm=TRUE, cex=1, sampleAnnoCol=c(),
	lowerPlot=FALSE, upperPlot=TRUE, ...){
	object=x
	if(summary=="mean")
		summaryFun=mean
	if(summary=="median")
		summaryFun=stats::median
	if(is.null(subsetRows))
		subsetRows=1:nrow(SummarizedExperiment::rowData(object))
	subDat=SummarizedExperiment::rowData(object)[subsetRows, ]

	indRow=!is.na(match(subDat$int_ex, intronExon))

	if(ncol(SummarizedExperiment::colData(object))==2){
		sampleGroups=SummarizedExperiment::colData(object)[,2]
	} else if( ncol(SummarizedExperiment::colData(object))>2 & 
		length(sampleAnnoCol)>0 & summary!="none"){
		sampleGroups=SummarizedExperiment::colData(object)[,sampleAnnoCol]
	} else if (ncol(SummarizedExperiment::colData(object))>2 & 
		length(sampleAnnoCol)==0 & summary!="none"){
		stop('Please define the sampleAnnoCol.')
	}

	if(summary=="none"& what=="scaled"){
		plotDat=scaledRetention(object)[subsetRows,]
	}
	if(summary=="none"& what=="counts"){
		plotDat=counts(object)[subsetRows,]
	}
	if(summary!="none"&what=="scaled"){
		plotList= tapply(1:ncol(scaledRetention(object)), sampleGroups, 
			function(x) apply(scaledRetention(object)[subsetRows,x], 1, 
				summaryFun) )
		plotList= plotList[match(unique(sampleGroups),names(plotList))]
		plotDat= matrix(unlist(plotList), ncol=length(unique(sampleGroups)), 
			byrow=FALSE)
		colnames(plotDat)= names(plotList)
		plotDat= as.data.frame(plotDat)
	}
	if(summary!="none"&what=="counts"){
		plotList=tapply(1:ncol(counts(object)), sampleGroups, function(x) 
			apply(counts(object)[subsetRows,x], 1, summaryFun) )
		plotList=plotList[match(unique(sampleGroups),names(plotList))]
		plotDat=matrix(unlist(plotList), ncol=length(unique(sampleGroups)), 
			byrow=FALSE)
		colnames(plotDat)=names(plotList)
		plotDat=as.data.frame(plotDat)
	}
	if(!is.null(logScaleBase))
		plotDat=log(plotDat+logPseudoCnt, base=logScaleBase)
	if(na.rm)
		indRow=indRow& (!is.na(rowSums(plotDat)))

	
	if(dim(plotDat)[2]==2){	
		loessInd=indRow& (!is.infinite(rowSums(plotDat)))
		loessDat=plotDat[loessInd, ]
		mainText=""
		if(writeCor)
			mainText=paste("cor (",corMethod,") = ", 
				format(stats::cor(loessDat[, 1], loessDat[,2], method=corMethod)
				, digits=2), sep="")
		graphics::par(mfrow=c(1,1))	
		graphics::par(cex.main=corCex*(3/ncol(plotDat)))
		graphics::par(mar=marPlot*(3/ncol(plotDat)))
		graphics::plot(plotDat[indRow, ], cex=cex*(3/ncol(plotDat)), 
			main=mainText, ...)
		if(dim(plotDat)[2]==2)
			if(plotLoess)
				graphics::points(stats::loess.smooth(plotDat[indRow, 1], 
					plotDat[indRow, 2]), col=loessCol, type="l", 
					lwd= loessLwd,lty=loessLty)
	}else{
		graphics::par(mfrow=c(ncol(plotDat),ncol(plotDat)))
		graphics::par(cex.main=corCex*(3/ncol(plotDat)))
		for(j in 1: ncol(plotDat)){
			for(i in 1:ncol(plotDat)){
				graphics::par(mar=marPlot*(3/ncol(plotDat)))
				if(i==j){
					graphics::plot(c(0, 1), c(0, 1), ann = FALSE, type = 'n', 
						xaxt = 'n', yaxt = 'n')
					graphics::text(x = 0.5, y = 0.5, colnames(plotDat)[i], 
						cex=cexText*(3/ncol(plotDat)))
				# If upperPlot is requested
				} else if(j<i & upperPlot) {
					xAxt='n'
					yAxt='n'
					mainText=""
					if(i==ncol(plotDat))
						yAxt='s'
					if(j==1)
						xAxt='s'

					loessInd=indRow& (!is.infinite(rowSums(plotDat)))
					loessDat=plotDat[loessInd, ]
					if(writeCor)
						mainText=paste("cor = ", format(stats::cor(loessDat[, i]
							, loessDat[,j], method=corMethod), digits=2), 
							sep="")

					graphics::plot(plotDat[indRow, i], plotDat[indRow, j], 
						ylab="", xlab="", xaxt='n', yaxt='n', 
						cex.axis=cexAxis*(3/ncol(plotDat)), 
						main="", cex=cex*(3/ncol(plotDat)), 
						xlim=c(min(plotDat[indRow,], na.rm=TRUE), 
							max(plotDat[indRow,], na.rm=TRUE)), 
						ylim=c(min(plotDat[indRow,], na.rm=TRUE), 
							max(plotDat[indRow,], na.rm=TRUE)), ...)
					if(xAxt=='s')
						graphics::axis(3, cex.axis=cexAxis*(3/ncol(plotDat)), 
							mgp=mgpPlot*(3/ncol(plotDat)))
					if(yAxt=='s')
						graphics::axis(4, cex.axis=cexAxis*(3/ncol(plotDat)), 
							mgp=mgpPlot*(3/ncol(plotDat)))

					graphics::legend(upperCorXY[1], upperCorXY[2], mainText, 
						bty="n", text.col=corCol, text.font=1, 
						cex=corCex*(3/ncol(plotDat)))
					if(plotLoess)
						graphics::points(stats::loess.smooth(loessDat[,i], 
							loessDat[,j]), col=loessCol, type="l", 
							lwd= loessLwd,lty=loessLty)
				} else if(j>i & lowerPlot) {
					xAxt='n'
					yAxt='n'
					mainText=""
					if(j==ncol(plotDat))
						xAxt='s'

					if(i==1)
						yAxt='s'						

					loessInd=indRow& (!is.infinite(rowSums(plotDat)))
					loessDat=plotDat[loessInd, ]
					if(writeCor)
						mainText=paste("cor = ", format(stats::cor(loessDat[, i]
							, loessDat[,j], method=corMethod) , digits=2), 
							sep="")

					graphics::plot(plotDat[indRow, i], plotDat[indRow, j], 
						ylab="", xlab="", xaxt='n', yaxt='n', 
						cex.axis=cexAxis*(3/ncol(plotDat)), 
						main="", cex=cex*(3/ncol(plotDat)), 
						xlim=c(min(plotDat[indRow,], na.rm=TRUE), 
							max(plotDat[indRow,], na.rm=TRUE)),
						ylim=c(min(plotDat[indRow,], na.rm=TRUE), 
							max(plotDat[indRow,], na.rm=TRUE)), ...)
					if(xAxt=='s')
						graphics::axis(1, cex.axis=cexAxis*(3/ncol(plotDat)), 
							mgp=mgpPlot*(3/ncol(plotDat)))
					if(yAxt=='s')
						graphics::axis(2, cex.axis=cexAxis*(3/ncol(plotDat)), 
							mgp=mgpPlot*(3/ncol(plotDat)))

					graphics::legend(lowerCorXY[1], lowerCorXY[2], mainText, 
						bty="n", text.col=corCol, text.font=1, 
						cex=corCex*(3/ncol(plotDat)))
					if(plotLoess)
						graphics::points(stats::loess.smooth(loessDat[,i], 
							loessDat[,j]), col=loessCol, type="l", 
							lwd= loessLwd,lty=loessLty)
				} else {
					graphics::par(mar=c(0,0,0,0))
					graphics::plot(c(0, 1), c(0, 1), ann = FALSE, bty = 'n', 
						type = 'n', xaxt = 'n', yaxt = 'n')
					graphics::rect(par("usr")[1],par("usr")[3],par("usr")[2],
						par("usr")[4],col = "grey",border="grey")	
				}
			}
		}
	}
	
}

methods::setMethod("plot", "SummarizedExperiment", plot.InterestResult)

# Functions getting methods  
getAnnotation<-function(x){
	return(SummarizedExperiment::colData(x))
}

getRowData<-function(x){
	return(SummarizedExperiment::rowData(x))
}

addAnnotation<-function(x, sampleAnnotationType, sampleAnnotation){
	tmp=cbind(as.data.frame(SummarizedExperiment::colData(x)), 
		sampleAnnotation)
	colnames(tmp)[ncol(tmp)]= sampleAnnotationType
	SummarizedExperiment::colData(x)<-
		S4Vectors::DataFrame(tmp)
	return(x)
}


scaledRetention<-function(x){
	return(SummarizedExperiment::assays(x)$scaledRetention)
}

counts.InterestResults<-function(object){
	return(SummarizedExperiment::assays(object)$counts)
}
methods::setMethod("counts", "SummarizedExperiment", counts.InterestResults)


# box plot method
intexBoxplot<- function(x, sampleAnnoCol=NA, intexTypeCol="int_type", 
	intexType=c(), col="white", boxplotNames=c(), lasNames=3, outline=FALSE, 
	addGrid=FALSE, ...){

	object=x
	if(!is.na(sampleAnnoCol)){
		groups=SummarizedExperiment::colData(object)[,sampleAnnoCol]
	} else {
		groups=x@sampleNames
	}
	uniGroup=unique(as.vector(groups))
	if(length(unique(intexType))==0){
		uniIntexType= unique(rowData(object)[,intexTypeCol])
	} else {
		uniIntexType= unique(intexType)
	}
	color=c()	
	plotList=c()
	axisAt=c()
	for(cnt in 1:length(uniGroup)){

		for(tcnt in 1:length(uniIntexType)){
			plotList=c(plotList, 
				list( as.vector(
					unlist(scaledRetention(object)[
						which(!is.na(match(
							SummarizedExperiment::rowData(object)[,
								intexTypeCol],
							uniIntexType[tcnt]
						))), 
						which(!is.na(match(
						as.vector(groups), uniGroup[cnt])))]
					)
				))
			)
			if(length(boxplotNames)==0){
				names(plotList)[length(plotList)]=
					paste(uniIntexType[tcnt],uniGroup[cnt], sep=" ")
						
			}
			axisAt=c(axisAt,TRUE)

		}
		axisAt=c(axisAt,FALSE)
		if(length(col)>1)
			color=c(color, col[((cnt-1)*length(uniIntexType)+1):
				(cnt*length(uniIntexType))], NA)
		if(length(col)==1)
			color=c(color, rep(col,uniIntexType))
		plotList<-c(plotList, list(NA))
		if(length(boxplotNames)>0){
			names(plotList)[(length(plotList)-length(uniIntexType)):
				length(plotList)]=
				c(boxplotNames[((cnt-1)*length(uniIntexType)+1):
					(cnt*length(uniIntexType))], "")
		}
	}
	plotList=plotList[-length(plotList)]
	axisAt=axisAt[-length(axisAt)]
	color=color[-length(color)]

	graphics::boxplot(plotList, names=c(), xaxt = "n", outline=outline, 
		col=color, ...)
	if(addGrid){
		graphics::grid(nx=NA, ny=NULL)
		graphics::boxplot(plotList, names=c(), xaxt = "n", outline=outline, 
		col=color, add=TRUE, ...)
	}
	if(length(boxplotNames)==0)
		boxplotNames=names(plotList)
	graphics::axis(1,at=which(axisAt), labels=boxplotNames[boxplotNames!=""],
		las=lasNames, ...)
}
methods::setMethod("boxplot", "SummarizedExperiment", intexBoxplot)

#!/bin/bash
#
# Copy the u12Regions.bed file to $MAPPINGPATH and run the following scripts
# The folder used here was ~/analysis/zrsr2/mapping 
# samtools 0.1.18 was used

# Copying the u12Regions.bed file to MAPPINGPATH
cp $SCRIPTSPATH/u12Regions.bed $MAPPINGPATH/

cd $MAPPINGPATH
# Choosing Chr22 
samtools view -b -o SRR1691633_ZRSR2Mut.bam SRR1691633/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691634_ZRSR2Mut.bam SRR1691634/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691635_ZRSR2Mut.bam SRR1691635/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691636_ZRSR2Mut.bam SRR1691636/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691637_ZRSR2Mut.bam SRR1691637/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691638_ZRSR2Mut.bam SRR1691638/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691639_ZRSR2Mut.bam SRR1691639/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691640_ZRSR2Mut.bam SRR1691640/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691641_WT.bam SRR1691641/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691642_WT.bam SRR1691642/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691643_WT.bam SRR1691643/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691644_WT.bam SRR1691644/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691645_Normal.bam SRR1691645/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691646_Normal.bam SRR1691646/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691647_Normal.bam SRR1691647/accepted_hits.sorted.bam chr22
samtools view -b -o SRR1691648_Normal.bam SRR1691648/accepted_hits.sorted.bam chr22
# Sorting the bam files
samtools sort SRR1691633_ZRSR2Mut.bam SRR1691633_ZRSR2Mut
samtools sort SRR1691634_ZRSR2Mut.bam SRR1691634_ZRSR2Mut
samtools sort SRR1691635_ZRSR2Mut.bam SRR1691635_ZRSR2Mut
samtools sort SRR1691636_ZRSR2Mut.bam SRR1691636_ZRSR2Mut
samtools sort SRR1691637_ZRSR2Mut.bam SRR1691637_ZRSR2Mut
samtools sort SRR1691638_ZRSR2Mut.bam SRR1691638_ZRSR2Mut
samtools sort SRR1691639_ZRSR2Mut.bam SRR1691639_ZRSR2Mut
samtools sort SRR1691640_ZRSR2Mut.bam SRR1691640_ZRSR2Mut
samtools sort SRR1691641_WT.bam SRR1691641_WT
samtools sort SRR1691642_WT.bam SRR1691642_WT
samtools sort SRR1691643_WT.bam  SRR1691643_WT
samtools sort SRR1691644_WT.bam  SRR1691644_WT
samtools sort SRR1691645_Normal.bam SRR1691645_Normal
samtools sort SRR1691646_Normal.bam SRR1691646_Normal
samtools sort SRR1691647_Normal.bam SRR1691647_Normal
samtools sort SRR1691648_Normal.bam SRR1691648_Normal

#Indexing bam files
samtools index SRR1691633_ZRSR2Mut.bam
samtools index SRR1691634_ZRSR2Mut.bam
samtools index SRR1691635_ZRSR2Mut.bam
samtools index SRR1691636_ZRSR2Mut.bam
samtools index SRR1691637_ZRSR2Mut.bam
samtools index SRR1691638_ZRSR2Mut.bam
samtools index SRR1691639_ZRSR2Mut.bam
samtools index SRR1691640_ZRSR2Mut.bam
samtools index SRR1691641_WT.bam
samtools index SRR1691642_WT.bam
samtools index SRR1691643_WT.bam
samtools index SRR1691644_WT.bam
samtools index SRR1691645_Normal.bam
samtools index SRR1691646_Normal.bam
samtools index SRR1691647_Normal.bam
samtools index SRR1691648_Normal.bam

#Converting bam to sam files
samtools view -h -o SRR1691633_ZRSR2Mut.sam SRR1691633_ZRSR2Mut.bam
samtools view -h -o SRR1691634_ZRSR2Mut.sam SRR1691634_ZRSR2Mut.bam
samtools view -h -o SRR1691635_ZRSR2Mut.sam SRR1691635_ZRSR2Mut.bam
samtools view -h -o SRR1691636_ZRSR2Mut.sam SRR1691636_ZRSR2Mut.bam
samtools view -h -o SRR1691637_ZRSR2Mut.sam SRR1691637_ZRSR2Mut.bam
samtools view -h -o SRR1691638_ZRSR2Mut.sam SRR1691638_ZRSR2Mut.bam
samtools view -h -o SRR1691639_ZRSR2Mut.sam SRR1691639_ZRSR2Mut.bam
samtools view -h -o SRR1691640_ZRSR2Mut.sam SRR1691640_ZRSR2Mut.bam
samtools view -h -o SRR1691641_WT.sam SRR1691641_WT.bam
samtools view -h -o SRR1691642_WT.sam SRR1691642_WT.bam
samtools view -h -o SRR1691643_WT.sam SRR1691643_WT.bam
samtools view -h -o SRR1691644_WT.sam SRR1691644_WT.bam
samtools view -h -o SRR1691645_Normal.sam SRR1691645_Normal.bam
samtools view -h -o SRR1691646_Normal.sam SRR1691646_Normal.bam
samtools view -h -o SRR1691647_Normal.sam SRR1691647_Normal.bam
samtools view -h -o SRR1691648_Normal.sam SRR1691648_Normal.bam

# Correct the read names to identify the paired reads correctly
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691633_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691634_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691635_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691636_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691637_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691638_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691639_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691640_ZRSR2Mut.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691641_WT.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691642_WT.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691643_WT.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691644_WT.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691645_Normal.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691646_Normal.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691647_Normal.sam
sed -ri -- 's/\.2\t|\.1\t/\t/' SRR1691648_Normal.sam

# Convert corrected sam to bam
samtools view -bS -o SRR1691633_ZRSR2Mut.bam SRR1691633_ZRSR2Mut.sam
samtools view -bS -o SRR1691634_ZRSR2Mut.bam SRR1691634_ZRSR2Mut.sam
samtools view -bS -o SRR1691635_ZRSR2Mut.bam SRR1691635_ZRSR2Mut.sam
samtools view -bS -o SRR1691636_ZRSR2Mut.bam SRR1691636_ZRSR2Mut.sam
samtools view -bS -o SRR1691637_ZRSR2Mut.bam SRR1691637_ZRSR2Mut.sam
samtools view -bS -o SRR1691638_ZRSR2Mut.bam SRR1691638_ZRSR2Mut.sam
samtools view -bS -o SRR1691639_ZRSR2Mut.bam SRR1691639_ZRSR2Mut.sam
samtools view -bS -o SRR1691640_ZRSR2Mut.bam SRR1691640_ZRSR2Mut.sam
samtools view -bS -o SRR1691641_WT.bam SRR1691641_WT.sam
samtools view -bS -o SRR1691642_WT.bam SRR1691642_WT.sam
samtools view -bS -o SRR1691643_WT.bam SRR1691643_WT.sam
samtools view -bS -o SRR1691644_WT.bam SRR1691644_WT.sam
samtools view -bS -o SRR1691645_Normal.bam SRR1691645_Normal.sam
samtools view -bS -o SRR1691646_Normal.bam SRR1691646_Normal.sam
samtools view -bS -o SRR1691647_Normal.bam SRR1691647_Normal.sam
samtools view -bS -o SRR1691648_Normal.bam SRR1691648_Normal.sam

# Convert Sort the corrected bam
samtools sort SRR1691633_ZRSR2Mut.bam SRR1691633_ZRSR2Mut
samtools sort SRR1691634_ZRSR2Mut.bam SRR1691634_ZRSR2Mut
samtools sort SRR1691635_ZRSR2Mut.bam SRR1691635_ZRSR2Mut
samtools sort SRR1691636_ZRSR2Mut.bam SRR1691636_ZRSR2Mut
samtools sort SRR1691637_ZRSR2Mut.bam SRR1691637_ZRSR2Mut
samtools sort SRR1691638_ZRSR2Mut.bam SRR1691638_ZRSR2Mut
samtools sort SRR1691639_ZRSR2Mut.bam SRR1691639_ZRSR2Mut
samtools sort SRR1691640_ZRSR2Mut.bam SRR1691640_ZRSR2Mut
samtools sort SRR1691641_WT.bam SRR1691641_WT
samtools sort SRR1691642_WT.bam SRR1691642_WT
samtools sort SRR1691643_WT.bam  SRR1691643_WT
samtools sort SRR1691644_WT.bam  SRR1691644_WT
samtools sort SRR1691645_Normal.bam SRR1691645_Normal
samtools sort SRR1691646_Normal.bam SRR1691646_Normal
samtools sort SRR1691647_Normal.bam SRR1691647_Normal
samtools sort SRR1691648_Normal.bam SRR1691648_Normal
# Index the corrected bam
samtools index SRR1691633_ZRSR2Mut.bam
samtools index SRR1691634_ZRSR2Mut.bam
samtools index SRR1691635_ZRSR2Mut.bam
samtools index SRR1691636_ZRSR2Mut.bam
samtools index SRR1691637_ZRSR2Mut.bam
samtools index SRR1691638_ZRSR2Mut.bam
samtools index SRR1691639_ZRSR2Mut.bam
samtools index SRR1691640_ZRSR2Mut.bam
samtools index SRR1691641_WT.bam
samtools index SRR1691642_WT.bam
samtools index SRR1691643_WT.bam
samtools index SRR1691644_WT.bam
samtools index SRR1691645_Normal.bam
samtools index SRR1691646_Normal.bam
samtools index SRR1691647_Normal.bam
samtools index SRR1691648_Normal.bam

#Remove the sam files
rm *.sam

#make a tmp directory (folder)
mkdir tmp
# Limit the data even further to the U12 genes regions
samtools view -b -L u12Regions.bed -o tmp/SRR1691633_ZRSR2Mut.bam SRR1691633_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691634_ZRSR2Mut.bam SRR1691634_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691635_ZRSR2Mut.bam SRR1691635_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691636_ZRSR2Mut.bam SRR1691636_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691637_ZRSR2Mut.bam SRR1691637_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691638_ZRSR2Mut.bam SRR1691638_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691639_ZRSR2Mut.bam SRR1691639_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691640_ZRSR2Mut.bam SRR1691640_ZRSR2Mut.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691641_WT.bam SRR1691641_WT.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691642_WT.bam SRR1691642_WT.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691643_WT.bam SRR1691643_WT.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691644_WT.bam SRR1691644_WT.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691645_Normal.bam SRR1691645_Normal.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691646_Normal.bam SRR1691646_Normal.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691647_Normal.bam SRR1691647_Normal.bam
samtools view -b -L u12Regions.bed -o tmp/SRR1691648_Normal.bam SRR1691648_Normal.bam

samtools index tmp/SRR1691633_ZRSR2Mut.bam
samtools index tmp/SRR1691634_ZRSR2Mut.bam
samtools index tmp/SRR1691635_ZRSR2Mut.bam
samtools index tmp/SRR1691636_ZRSR2Mut.bam
samtools index tmp/SRR1691637_ZRSR2Mut.bam
samtools index tmp/SRR1691638_ZRSR2Mut.bam
samtools index tmp/SRR1691639_ZRSR2Mut.bam
samtools index tmp/SRR1691640_ZRSR2Mut.bam
samtools index tmp/SRR1691641_WT.bam
samtools index tmp/SRR1691642_WT.bam
samtools index tmp/SRR1691643_WT.bam
samtools index tmp/SRR1691644_WT.bam
samtools index tmp/SRR1691645_Normal.bam
samtools index tmp/SRR1691646_Normal.bam
samtools index tmp/SRR1691647_Normal.bam
samtools index tmp/SRR1691648_Normal.bam

# Remove all previously generatyed files
rm *.bam*
# move everything from tmp directory to current path
mv tmp/*.* ./
#Remove tmp directory
rm -r tmp/

#!/bin/bash
#
# Run this in your mapping folder. Read scripts/readme.txt in IntEREst package.
#indexPATH=~/software/sequencing/bowtie2/indexes/hg19NoColor/hg19
#MAPPINGPATH=~/analysis/zrsr2/mapping
#RAWDATAPATH=~/projects/data/zrsr2
cd $MAPPINGPATH
mkdir $MAPPINGPATH/SRR1691633/
tophat2 -o $MAPPINGPATH/SRR1691633/ -p 6 $indexPATH $RAWDATAPATH/SRR1691633_1.fastq $RAWDATAPATH/SRR1691633_2.fastq
samtools sort $MAPPINGPATH/SRR1691633/accepted_hits.bam $MAPPINGPATH/SRR1691633/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691633/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691634/
tophat2 -o $MAPPINGPATH/SRR1691634/ -p 6 $indexPATH $RAWDATAPATH/SRR1691634_1.fastq $RAWDATAPATH/SRR1691634_2.fastq
samtools sort $MAPPINGPATH/SRR1691634/accepted_hits.bam $MAPPINGPATH/SRR1691634/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691634/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691635/
tophat2 -o $MAPPINGPATH/SRR1691635/ -p 6 $indexPATH $RAWDATAPATH/SRR1691635_1.fastq $RAWDATAPATH/SRR1691635_2.fastq
samtools sort $MAPPINGPATH/SRR1691635/accepted_hits.bam $MAPPINGPATH/SRR1691635/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691635/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691636/
tophat2 -o $MAPPINGPATH/SRR1691636/ -p 6 $indexPATH $RAWDATAPATH/SRR1691636_1.fastq $RAWDATAPATH/SRR1691636_2.fastq
samtools sort $MAPPINGPATH/SRR1691636/accepted_hits.bam $MAPPINGPATH/SRR1691636/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691636/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691637/
tophat2 -o $MAPPINGPATH/SRR1691637/ -p 6 $indexPATH $RAWDATAPATH/SRR1691637_1.fastq $RAWDATAPATH/SRR1691637_2.fastq
samtools sort $MAPPINGPATH/SRR1691637/accepted_hits.bam $MAPPINGPATH/SRR1691637/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691637/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691638/
tophat2 -o $MAPPINGPATH/SRR1691638/ -p 6 $indexPATH $RAWDATAPATH/SRR1691638_1.fastq $RAWDATAPATH/SRR1691638_2.fastq
samtools sort $MAPPINGPATH/SRR1691638/accepted_hits.bam $MAPPINGPATH/SRR1691638/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691638/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691639/
tophat2 -o $MAPPINGPATH/SRR1691639/ -p 6 $indexPATH $RAWDATAPATH/SRR1691639_1.fastq $RAWDATAPATH/SRR1691639_2.fastq
samtools sort $MAPPINGPATH/SRR1691639/accepted_hits.bam $MAPPINGPATH/SRR1691639/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691639/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691640/
tophat2 -o $MAPPINGPATH/SRR1691640/ -p 6 $indexPATH $RAWDATAPATH/SRR1691640_1.fastq $RAWDATAPATH/SRR1691640_2.fastq
samtools sort $MAPPINGPATH/SRR1691640/accepted_hits.bam $MAPPINGPATH/SRR1691640/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691640/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691641/
tophat2 -o $MAPPINGPATH/SRR1691641/ -p 6 $indexPATH $RAWDATAPATH/SRR1691641_1.fastq $RAWDATAPATH/SRR1691641_2.fastq
samtools sort $MAPPINGPATH/SRR1691641/accepted_hits.bam $MAPPINGPATH/SRR1691641/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691641/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691642/
tophat2 -o $MAPPINGPATH/SRR1691642/ -p 6 $indexPATH $RAWDATAPATH/SRR1691642_1.fastq $RAWDATAPATH/SRR1691642_2.fastq
samtools sort $MAPPINGPATH/SRR1691642/accepted_hits.bam $MAPPINGPATH/SRR1691642/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691642/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691643/
tophat2 -o $MAPPINGPATH/SRR1691643/ -p 6 $indexPATH $RAWDATAPATH/SRR1691643_1.fastq $RAWDATAPATH/SRR1691643_2.fastq
samtools sort $MAPPINGPATH/SRR1691643/accepted_hits.bam $MAPPINGPATH/SRR1691643/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691643/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691644/
tophat2 -o $MAPPINGPATH/SRR1691644/ -p 6 $indexPATH $RAWDATAPATH/SRR1691644_1.fastq $RAWDATAPATH/SRR1691644_2.fastq
samtools sort $MAPPINGPATH/SRR1691644/accepted_hits.bam $MAPPINGPATH/SRR1691644/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691644/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691645/
tophat2 -o $MAPPINGPATH/SRR1691645/ -p 6 $indexPATH $RAWDATAPATH/SRR1691645_1.fastq $RAWDATAPATH/SRR1691645_2.fastq
samtools sort $MAPPINGPATH/SRR1691645/accepted_hits.bam $MAPPINGPATH/SRR1691645/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691645/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691646/
tophat2 -o $MAPPINGPATH/SRR1691646/ -p 6 $indexPATH $RAWDATAPATH/SRR1691646_1.fastq $RAWDATAPATH/SRR1691646_2.fastq
samtools sort $MAPPINGPATH/SRR1691646/accepted_hits.bam $MAPPINGPATH/SRR1691646/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691646/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691647/
tophat2 -o $MAPPINGPATH/SRR1691647/ -p 6 $indexPATH $RAWDATAPATH/SRR1691647_1.fastq $RAWDATAPATH/SRR1691647_2.fastq
samtools sort $MAPPINGPATH/SRR1691647/accepted_hits.bam $MAPPINGPATH/SRR1691647/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691647/accepted_hits.sorted.bam

mkdir $MAPPINGPATH/SRR1691648/
tophat2 -o $MAPPINGPATH/SRR1691648/ -p 6 $indexPATH $RAWDATAPATH/SRR1691648_1.fastq $RAWDATAPATH/SRR1691648_2.fastq
samtools sort $MAPPINGPATH/SRR1691648/accepted_hits.bam $MAPPINGPATH/SRR1691648/accepted_hits.sorted
samtools index $MAPPINGPATH/SRR1691648/accepted_hits.sorted.bam

nohup fastq-dump -I --split-files SRR1691633.sra &
nohup fastq-dump -I --split-files SRR1691634.sra &
nohup fastq-dump -I --split-files SRR1691635.sra &
nohup fastq-dump -I --split-files SRR1691636.sra &
nohup fastq-dump -I --split-files SRR1691637.sra &
nohup fastq-dump -I --split-files SRR1691638.sra &
nohup fastq-dump -I --split-files SRR1691639.sra &
nohup fastq-dump -I --split-files SRR1691640.sra &
nohup fastq-dump -I --split-files SRR1691641.sra &
nohup fastq-dump -I --split-files SRR1691642.sra &
nohup fastq-dump -I --split-files SRR1691643.sra &
nohup fastq-dump -I --split-files SRR1691644.sra &
nohup fastq-dump -I --split-files SRR1691645.sra &
nohup fastq-dump -I --split-files SRR1691646.sra &
nohup fastq-dump -I --split-files SRR1691647.sra &
nohup fastq-dump -I --split-files SRR1691648.sra &
nohup fastq-dump -I --split-files SRR1691649.sra &
nohup fastq-dump -I --split-files SRR1691650.sra &
nohup fastq-dump -I --split-files SRR1691651.sra &
nohup fastq-dump -I --split-files SRR1691652.sra &
nohup fastq-dump -I --split-files SRR1691653.sra &
nohup fastq-dump -I --split-files SRR1691654.sra &

#!/bin/bash
# Run where your raw files need to be, i.e. RAWDATAPATH
# The SCRIPTSPATH is the path of the scripts folder. 
# For more info see readme.txt. 
cd $RAWDATAPATH
wget -i $SCRIPTSPATH/sraFilesURL.txt

---
title: "IntEREst"
date: "`r Sys.Date()`"
author: "Ali Oghabian"
contact: "ali.oghabian@helsinki.fi"
output: rmarkdown::html_vignette
bibliography: ref.bib
vignette: >
  %\VignetteIndexEntry{IntEREst, Intron Exon Retention Estimator}
  %\VignetteEngine{knitr::rmarkdown}
  \usepackage[utf8]{inputenc}
---
In this documents the following subjects have been covered:

* [Introduction to IntEREst](#Intro)
* [Creating reference](#refCr)
* [Annotating U12 type introns](#annoU12)
* [Intron retention, Inton spanning and exon-exon junction level estimation](#readSum)
* [Using the test data mdsChr22Obj](#dataUse)
* [Comparing intron retention levels across various samples](#irCompare)
* [Our recommended pipeline for differential intron retention analysis](#difanalysis)


## Introduction to IntEREst {#Intro}
The IntEREst, *i.e.* Intron Exon Retention Estimator (Oghabian 
*et al.* [-@pmid29642843]), facilitates estimation and comparison of splicing 
efficiency of transcripts across several samples. In particular, It can 
estimate the intron-retention levels or the exon-exon junction levels across 
the transcripts. Similar to the Intron retention analysis used by Niemelä
*et al.* [-@pmid24848017], our method estimates the Intron-mapping read levels
by counting the number of RNAseq reads that have been mapped to the Intron-exon
junctions of the genes, additionally it can estimate the exon-exon junction 
levels by counting the reads that have been mapped to the exons or by counting 
reads that span the introns. 
It is also possible to limit the analysis to reads that are mapped to
the intron-exon or exon-exon junctions only and filter the ones that fully map
to the introns/exons (See the `junctionReadsOnly` parameter in the `interest()`
and `interest.sequential()` functions). However, by default this limitation is 
not taken into account, *i.e.* the reads that are fully mapped to the introns 
or exons are also considered.
The package accepts standard BAM files as input and produces tab separated text
files together with `SummarizedExperiment` objects as results. To improve the 
performance and running time, the processing of each single BAM file can be 
divided to smaller processes and distributed and run on several computing 
cores. Using IntEREst functions the results can also be plotted and 
statistically analyzed to screen the distribution of the intron retention 
levels, and compare the retention levels of U12 type introns to the U2 type 
across the studied samples. Note that although we mainly use this package to 
compare the retention of U12-type introns to the U2 type, comparisons for other
sub-classes of introns (defined by the user) can also be performed, however the
functions `u12NbIndex()`, `u12Index()`, `u12Boxplot()`, `u12BoxplotNb()`, 
`u12DensityPlot()`and `u12DensityPlotIntron()` in IntEREst are specifically 
used for U12-type introns. A diagram of the running pipeline is shown in 
*figure 1*. 

<br>
```{r pipeline, out.width = 500, ppi=100, fig.retina = NULL, fig.align="center", echo=FALSE, eval=TRUE, fig.cap="**Figure 1:** Diagram of IntEREst running pipeline" }
knitr::include_graphics("../inst/fig/IntEREst.png")
```
<br>

## Creating reference {#refChr}
The first step is to build a reference which will be used for the summarization
of the sequence reads, and also downstream analysis (e.g. significant 
differential IR analysis). This can be carried out by `referencePrepare()` 
function. The resulted reference data frame includes coordinates of introns and
exons of the genes; They can be extracted from various sources i.e. UCSC, 
biomaRt or a user defined file (e.g. GFF3/GTF). The exons with overlapping 
genomic coordinates can be collapsed (if `collapseExons` parameter is set as 
`TRUE`) to avoid assigning reads mapping to any alternatively skipped exons to 
their overlapping introns. An example of the process is shown in *figure 2*.
<br>
```{r collapseExons, out.width = 500, ppi=100, fig.retina = NULL, fig.align="center", echo=FALSE, eval=TRUE, fig.cap="**Figure 2:** Running reference isoforms a, b, c and d leads to gene A with exons that are results of collapsing of exons of all isoforms." }
knitr::include_graphics("../inst/fig/collapseExons.png")
```
<br>
Here we build a reference data frame from a manually built GFF3 file that 
includes exonic coordinates of the gene RHBDD3. 
<br>
```{r reference_build, out.width = 500, echo=TRUE, eval=TRUE }
# Load library quietly
suppressMessages(library("IntEREst"))
# Selecting rows related to RHBDD3 gene
tmpGen<-u12[u12[,"gene_name"]=="RHBDD3",]
# Extracting exons
tmpEx<-tmpGen[tmpGen[,"int_ex"]=="exon",]

# Building GFF3 file
exonDat<- cbind(tmpEx[,3], ".",
	tmpEx[,c(7,4,5)], ".", tmpEx[,6], ".",paste("ID=exon",
	tmpEx[,11], "; Parent=ENST00000413811", sep="") )
trDat<- c(tmpEx[1,3], ".", "mRNA", as.numeric(min(tmpEx[,4])),
	as.numeric(max(tmpEx[,5])), ".", tmpEx[1,6], ".",
	"ID=ENST00000413811")
outDir<- file.path(tempdir(),"tmpFolder")
dir.create(outDir)
outDir<- normalizePath(outDir)
gff3File<-paste(outDir, "gffFile.gff", sep="/")
cat("##gff-version 3\n",file=gff3File, append=FALSE)
cat(paste(paste(trDat, collapse="\t"),"\n", sep=""),
	file=gff3File, append=TRUE)
write.table(exonDat, gff3File,
	row.names=FALSE, col.names=FALSE,
	sep='\t', quote=FALSE, append=TRUE)

# Extracting U12 introns info from 'u12' data
u12Int<-u12[u12$int_ex=="intron"&u12$int_type=="U12",]

# Building reference
#Since it is based on one gene only (that does not feature alternative splicing
#events) there is no difference if the collapseExons is set as TRUE or FALSE
testRef<- referencePrepare (sourceBuild="file",
	filePath=gff3File, u12IntronsChr=u12Int[,"chr"],
	u12IntronsBeg=u12Int[,"begin"],
	u12IntronsEnd=u12Int[,"end"], collapseExons=TRUE,
	fileFormat="gff3", annotateGeneIds=FALSE)

head (testRef)
```
<br>

## Annotating U12 type introns {#annoU12}
It is possible to annotate the U12 type introns in a reference using the 
`annotateU12` function. U12-type introns (also known as minor type introns) are
detected and spliced by the U12 splicing machinery as opposed to the majority 
of the introns (known as major type or U2 type) which are spliced by the U2 
spliceosome. U12-type introns also feature evolutionary conserved splice sites 
which are distinguished from the splice sites of U2 type introns hence they can
be detected by mapping a position weigh matrix (PWM) to their splice sites and 
measuring their match score based on the PWM. The following scripts
re-annotates introns of the genes RHBDD2 and YBX2.
<br>
```{r annotate_u12, out.width = 500, echo=TRUE, eval=TRUE }
# Improting genome
BSgenome.Hsapiens.UCSC.hg19 <-
BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#Index of the subset of rows
ind<- u12$gene_name %in% c("RHBDD2", "YBX2")

# Annotate U12 introns with strong U12 donor site, branch point
# and acceptor site from the u12 data in the package
annoU12<-
	annotateU12(pwmU12U2=list(pwmU12db[[1]][,11:17],pwmU12db[[2]],
		pwmU12db[[3]][,38:40],pwmU12db[[4]][,11:17],
		pwmU12db[[5]][,38:40]),
	pwmSsIndex=list(indexDonU12=1, indexBpU12=1, indexAccU12=3,
		indexDonU2=1, indexAccU2=3),
	referenceChr=u12[ind,'chr'],
	referenceBegin=u12[ind,'begin'],
	referenceEnd=u12[ind,'end'],
	referenceIntronExon=u12[ind,"int_ex"],
	intronExon="intron",
	matchWindowRelativeUpstreamPos=c(NA,-29,NA,NA,NA),
	matchWindowRelativeDownstreamPos=c(NA,-9,NA,NA,NA),
	minMatchScore=c(rep(paste(80,"%",sep=""),2), "40%",
	paste(80,"%",sep=""), "40%"),
	refGenome=BSgenome.Hsapiens.UCSC.hg19,
	setNaAs="U2",
	annotateU12Subtype=TRUE)
# How many U12 and U2 type introns with strong U12 donor sites,
# acceptor sites (and branch points for U12-type) are there?
	table(annoU12[,1])
```
<br>

## Intron retention, Inton spanning and exon-exon junction level estimation {#readSum}
The raw counts and normalized intron retention, intron spanning and exon-exon 
junction levels can be estimated using any of the two RNAseq read 
summarization functions, `interest()` and `interest.sequential()`. 
The `interest()` function is more robust since it distributes the reads in the 
.bam file over several computing cores and analyze the distributed data 
simultaneously. Note that regions in the genome with repetitive sequence 
elements may bias the mapping of the read sequences and the retention analysis.
If you wish to exclude these regions from the analysis you can use the 
`getRepeatTable()` function, however We did not find repetitive DNA elements in
particular biasing our results therefore we do not routinely use this function. 
As for instance, if you wish to exclude the coordinates in the genome housing 
Alu elements, you can run the reads summarization functions with the 
`repeatsTableToFilter= getRepeatTable(repFamilyFil= "Alu")` parameter setting. 
Also, to only consider the reads that map to intron-exon or exon-exon
junctions set `junctionReadsOnly= TRUE`, however we recommend setting 
`junctionReadsOnly= FLASE` when measuring the intron retention levels (i.e. 
`method=IntRet`) and setting `junctionReadsOnly= TRUE` when measuring the 
exon-exon junction levels. The `junctionReadsOnly' parameter does NOT apply to
the intron-spanning levels estimation mode (i.e. `method=IntSpan`).

The `interest()` and `interest.sequential()` read summarization functions write
output text files, additionally they can return a `summarizedExperiment` object
for every sample they analyze. As shown in the following test script we, 
however usually prevent the individual runs to return any objects (by setting 
the `returnObj=FALSE`); instead, after running the analysis for all samples we
generate a single `summarizedExperiment` object that includes results of all
analyzed samples. To build such object from the output text files the 
`readInterestResults()` function can be used. In the following scripts a bam 
file from a single MDS sample with mutated ZRSR2 is used which includes all the
reads mapped to the gene RHBDD3 only. We run 3 analysis that results to the 
number of reads mapping to the introns of the gene RHBDD3, number of reads 
spanning the introns of the gene RHBDD3 and the number of junction reads 
mapping to the exons of gene RHBDD3. eventually a `SummarizedExperiment` object 
is built for each of the 3 analysis that includes the read counts together with
the coordinates and annotations of the introns and exons. The same analysis can
be run on multiple .bam files to obtain `SummarizedExperiment` objects that 
include results for all analyzed .bam files.

```{r testInterest, out.width = 500, echo=TRUE, eval=TRUE }
# Creating temp directory to store the results
outDir<- file.path(tempdir(),"interestFolder")
dir.create(outDir)
outDir<- normalizePath(outDir)
# Loading suitable bam file
bamF <- system.file("extdata", "small_test_SRR1691637_ZRSR2Mut_RHBDD3.bam",
	package="IntEREst", mustWork=TRUE)
# Choosing reference for the gene RHBDD3
ref<-u12[u12[,"gene_name"]=="RHBDD3",]

# Intron retention analysis
# Reads mapping to inner introns are considered, hence 
# junctionReadsOnly is FALSE
testInterest<- interest(
	bamFileYieldSize=10000,
	junctionReadsOnly=FALSE,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=NA,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
		"intRetRes.tsv", sep="/"),
	logFile=paste(outDir,
		"log.txt", sep="/"),
	method="IntRet",
	returnObj=FALSE,
	scaleLength= TRUE,
	scaleFragment= TRUE,
	strandSpecific="unstranded"
)

testIntRetObj<- readInterestResults(
    resultFiles= paste(outDir,
		"intRetRes.tsv", sep="/"), 
    sampleNames="small_test_SRR1691637_ZRSR2Mut_RHBDD3", 
    sampleAnnotation=data.frame( 
        type="ZRSR2mut",
        test_ctrl="test"), 
    commonColumns=1:ncol(ref), freqCol=ncol(ref)+1, 
	scaledRetentionCol=ncol(ref)+2, scaleLength=TRUE, scaleFragment=TRUE, 
	reScale=TRUE, geneIdCol="ens_gene_id")

# Intron Spanning analysis
# Reads mapping to inner introns are considered, hence 
# junctionReadsOnly is FALSE
testInterest<- interest(
	bamFileYieldSize=10000,
	junctionReadsOnly=FALSE,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
		"intSpanRes.tsv", sep="/"),
	logFile=paste(outDir,
		"log.txt", sep="/"),
	method="IntSpan",
	returnObj=FALSE,
	scaleLength= TRUE,
	scaleFragment= TRUE,
	strandSpecific="unstranded"
)

testIntSpanObj<- readInterestResults(
    resultFiles= paste(outDir,
		"intSpanRes.tsv", sep="/"), 
    sampleNames="small_test_SRR1691637_ZRSR2Mut_RHBDD3", 
    sampleAnnotation=data.frame( 
        type="ZRSR2mut",
        test_ctrl="test"), 
    commonColumns=1:ncol(ref), freqCol=ncol(ref)+1, 
	scaledRetentionCol=ncol(ref)+2, scaleLength=TRUE, scaleFragment=TRUE, 
	reScale=TRUE, geneIdCol="ens_gene_id")

# Exon-exon junction analysis
# Reads mapping to inner exons are NOT considered, hence 
# junctionReadsOnly is TRUE
testInterest<- interest(
	bamFileYieldSize=10000,
	junctionReadsOnly=TRUE,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
		"exExRes.tsv", sep="/"),
	logFile=paste(outDir,
		"log.txt", sep="/"),
	method="ExEx",
	returnObj=FALSE,
	scaleLength= TRUE,
	scaleFragment= TRUE,
	strandSpecific="unstranded"
)

testExExObj<- readInterestResults(
    resultFiles= paste(outDir,
		"exExRes.tsv", sep="/"), 
    sampleNames="small_test_SRR1691637_ZRSR2Mut_RHBDD3", 
    sampleAnnotation=data.frame( 
        type="ZRSR2mut",
        test_ctrl="test"), 
    commonColumns=1:ncol(ref), freqCol=ncol(ref)+1, 
	scaledRetentionCol=ncol(ref)+2, scaleLength=TRUE, scaleFragment=TRUE, 
	reScale=TRUE, geneIdCol="ens_gene_id")

# View intron retention result object
testIntRetObj
# View intron spanning  result object
testIntSpanObj
# View exon-exon junction result object
testExExObj

# View first rows of intron retention read counts table
head(counts(testIntRetObj))
# View first rows of intron spanning read counts table
head(counts(testIntSpanObj))
# View first rows of exon-exon junction read counts table
head(counts(testExExObj))

```
<br>

## Using the test data mdsChr22Obj {#dataUse}
As a demo we ran the IntEREst pipeline on 16 .bam files that each includes 
reads mapped to U12 genes (i.e. genes with at least one U12-type intron) 
located in chromosome 22. These bam files were results of mapping RNAseq data 
from bone-marrow samples published by Madan et al. [-@pmid25586593] to the 
Human genome (hg19). The studied samples were extracted from 16 individuals; 
out of which 8 were diagnosed with Myelodysplastic syndrome (MDS) and featured 
ZRSR2 mutation, 4 were diagnosed with MDS but lacked the mutation (referred to 
as ZRSR2 wild-type MDS samples) and 4 were healthy individuals. 

The data is accessible through GEO with the accession number GSE63816 and the 
scripts that we ran to map the RNAseq data, modify the bam files, extract the 
reads mapped to U12 genes in chr22 and build `mdsChr22Obj`, `mdsChr22ExObj`
and `mdsChr22RefIntRetSpObj` objects are available in the `scripts` folder of 
the `IntEREst` package (See the `readme.txt` file in the folder for more 
information). You can get its full path using this script in R: 
`system.file("scripts","readme.txt", package="IntEREst")`. 

The `mdsChr22Obj` object is a `summarizedExperiment` object that includes 
information regarding levels of intron-mapping reads in the U12 genes located 
on the Chromosome 22, across all the 16 MDS samples. The `mdsChr22ExObj` object
contain the levels of exon-exon junction mapping reads and the 
`mdsChr22RefIntRetSpObj` include the levels of intron-spanning reads. Each 
object include two assays: counts and scaledRetention. Both can be accessed 
using functions with the same names: `counts()` and `scaledRetention()`. The 
former (counts) returns a data frame which includes the read counts of each 
intron/exon in each sample, and the latter (scaledRetention) returns a data 
frame with similar dimensions that includes the FPKM normalized read counts. 
The result objects also include intron/exon and sample annotations that can be 
retrieved using `rowData()` and `colData()` functions.

<br>
```{r view_object, out.width = 500, echo=TRUE, eval=TRUE }
# Load library quietly
suppressMessages(library("IntEREst"))
#View object
mdsChr22Obj

mdsChr22ExObj


# See read counts
head(counts(mdsChr22Obj))

# See FPKM Normalized values
head(scaledRetention(mdsChr22Obj))

# See intron/exon annotations
head(rowData(mdsChr22Obj))

# See sample annotations
head(colData(mdsChr22Obj))


```
<br>
It is possible to `plot()` the object to check the distribution of the intron 
retention levels. The following scripts plot the average retention of all 
introns across the 3 sample types: ZRSR2 mutated MDS, ZRSR2 wild type MDS and 
healthy. The `lowerPlot=TRUE` and `upperPlot=TRUE` parameter settings ensures 
that both, the upper and lower triangle of the grid are plotted. 

<br>

```{r plot_intron_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap="**Figure 3:** Plotting the distribution of the retention levels ($log_e$ scaled retention) of introns of genes located on chromosome 22. The values have been averaged across the sample types ZRSR2 mutated, ZRSR2 wild type, and healthy."}

# Retention of all introns
plot(mdsChr22Obj, logScaleBase=exp(1), pch=20, loessLwd=1.2, 
	summary="mean", col="black", sampleAnnoCol="type", 
	lowerPlot=TRUE, upperPlot=TRUE)
```
<br>

The following script plots the average retention of the U12 introns across the 
3 sample types: ZRSR2 mutated MDS, ZRSR2 MDS wild type and healthy. By default 
the upper triangle of the grid is plotted only (`lowerPlot=FALSE`). 
<br>
```{r plot_u12intron_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap="**Figure 4:** Plotting the distribution of the retention levels ($log_e$ scaled retention) of introns of genes located on chromosome 22. The values have been averaged across the sample types ZRSR2 mutated, ZRSR2 wild type, and healthy."}

#Retention of U12 introns
plot(mdsChr22Obj, logScaleBase=exp(1), pch=20, plotLoess=FALSE, 
	summary="mean", col="black", sampleAnnoCol="type", 
	subsetRows=u12Index(mdsChr22Obj, intTypeCol="intron_type"))
```
<br>

## Comparing intron retention levels across various samples {#irCompare}
IntEREst also provides various tools to compare the retention levels of the 
introns or exon junction levels across various samples. Initially, we extract 
the significantly higher and lower retained introns by using 
`exactTestInterest()` function which employs the `exactTest()` function from 
the *edgeR* package, i.e. an exact test for differences between two groups of 
negative-binomial counts. Note that `exactTestInterest()` makes comparison 
between a pair of sample types only (e.g. test vs ctrl).  

<br>
```{r exact_test, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"}
# Check the sample annotation table
getAnnotation(mdsChr22Obj)

# Run exact test
test<- exactTestInterest(mdsChr22Obj, 
	sampleAnnoCol="test_ctrl", sampleAnnotation=c("ctrl","test"), 
	geneIdCol= "collapsed_transcripts_id", silent=TRUE, disp="common")

# Number of stabilized introns (in Chr 22)
sInt<- length(which(test$table[,"PValue"]<0.05 
	& test$table[,"logFC"]>0 & 
	rowData(mdsChr22Obj)[,"int_ex"]=="intron"))
print(sInt)
# Number of stabilized (significantly retained) U12 type introns
numStU12Int<- length(which(test$table[,"PValue"]<0.05 & 
	test$table[,"logFC"]>0 & 
	rowData(mdsChr22Obj)[,"intron_type"]=="U12" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"])))
# Number of U12 introns
numU12Int<- 
	length(which(rowData(mdsChr22Obj)[,"intron_type"]=="U12" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"]))) 
# Fraction(%) of stabilized (significantly retained) U12 introns
perStU12Int<- numStU12Int/numU12Int*100
print(perStU12Int)
# Number of stabilized U2 type introns
numStU2Int<- length(which(test$table[,"PValue"]<0.05 & 
	test$table[,"logFC"]>0 & 
	rowData(mdsChr22Obj)[,"intron_type"]=="U2" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"])))
# Number of U2 introns
numU2Int<- 
	length(which(rowData(mdsChr22Obj)[,"intron_type"]=="U2" & 
	!is.na(rowData(mdsChr22Obj)[,"intron_type"])))
# Fraction(%) of stabilized U2 introns
perStU2Int<- numStU2Int/numU2Int*100
print(perStU2Int)
```

<br>
As shown in the previous analysis ~`r trunc(perStU12Int)`% of U12-type introns 
(of genes on Chr22) are significantly more retained (i.e. stabilized) in the 
ZRSR2 mutated samples comparing to the other samples, whereas same comparison 
shows that only ~`r trunc(perStU2Int)`% of the U2-type introns are 
significantly more retained. For more complex experiments such as comparing 
samples based on a user defined design matrix other differential expression 
analysis functions from `edgeR` package, e.g. Linear Model (GLM) functions, 
have also been implemented in IntEREst; `glmInterest()` performs GLM likelihood
ratio test, `qlfInterest()` runs quasi likelihood F-test, and `treatInterest()`
runs fold-change threshold test on the retention levels of the introns/exons. 
DESeq2 and DEXSeq based functions (`deseqInterest()` and `DEXSeqIntEREst()`) 
are also available in the package. Using the QLF `edgeR` based method the 
following commands can be used to extract the data for introns/exons that their
retention levels vary significantly across all sample types: ZRSR2 mutation, 
ZRSR2 wild type, and healthy.

```{r glr_test, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"}

# Extract type of samples
group <- getAnnotation(mdsChr22Obj)[,"type"]
group

# Test retention levels' differentiation across 3 types samples
qlfRes<- qlfInterest(x=mdsChr22Obj, 
	design=model.matrix(~group), silent=TRUE, 
	disp="tagwiseInitTrended", coef=2:3, contrast=NULL, 
	poisson.bound=TRUE)

# Extract index of the introns with significant retention changes
ind= which(qlfRes$table$PValue< 0.05)
# Extract introns with significant retention level changes
variedIntrons= rowData(mdsChr22Obj)[ind,]

#Show first 5 rows and columns of the result table
print(variedIntrons[1:5,1:5])

```
Next, to better illustrate the differences in the retention levels of different
types of introns across the studied samples, we first use the `bopxplot()` 
method to illustrate the retention levels of all U12-type and U2-type introns 
in various sample types, and then we use the `u12BoxplotNb()` function to 
compare the retention of the U12 introns to their up- and down-stream U2-type 
introns.

<br>

```{r boxplot_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap= "**Figure 5:** Boxplot of the retention levels of U12 introns vs U2 introns, summed over samples with similar annotations *i.e.* ZRSR2 mutation, ZRSR2 wild type, or healthy."}
# boxplot U12 and U2-type introns 
par(mar=c(7,4,2,1))
u12Boxplot(mdsChr22Obj, sampleAnnoCol="type", 
	intExCol="int_ex",	intTypeCol="intron_type", intronExon="intron", 
	col=rep(c("orange", "yellow"),3) ,	lasNames=3, 
	outline=FALSE, ylab="FPKM", cex.axis=0.8)
```
<br>

```{r u12BoxplotNb_object, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center", fig.cap="**Figure 6:** Boxplot of retention levels of U12 introns vs their up- and down-stream U2 introns across all samples."}
# boxplot U12-type intron and its up/downstream U2-type introns 
par(mar=c(2,4,1,1))
u12BoxplotNb(mdsChr22Obj, sampleAnnoCol="type", lasNames=1,
	intExCol="int_ex", intTypeCol="intron_type", intronExon="intron", 
	boxplotNames=c(), outline=FALSE, plotLegend=TRUE, 
	geneIdCol="collapsed_transcripts_id", xLegend="topleft", 
	col=c("pink", "lightblue", "lightyellow"), ylim=c(0,1e+06), 
	ylab="FPKM", cex.axis=0.8)
```
<br>

The boxplot clearly shows the increase retention of U12-type introns comparing 
to all the U2 introns (*figure 5*) and in particular comparing to the U2-type 
introns located on the up- or down-stream of the U12-type introns (*figure 6*).
It is also clear that the elevated level of intron retention with U12-type 
introns is exacerbated in the ZRSR2 mutated samples comparing to the other 
studied samples. In order to better illustrate the stabilization of the 
transcripts with U12-type introns comparing to the ones that lack U12-type 
introns, we plot the density of the log fold-change of the retention (ZRSR2 
mutated v.s. other samples) of U12-type introns and compare it to the log 
fold-change values for randomly selected U2-type introns, and U2-type introns 
up- or down-stream the U12-type introns.

<br>

```{r density_plot, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.cap= "**Figure 7:** Density plot of the log fold change of U12-type introns, random U2-type introns and U2 introns (up / down / up and down)stream of U12-type introns. "}
u12DensityPlotIntron(mdsChr22Obj, 
	type= c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), 
	fcType= "edgeR", sampleAnnoCol="test_ctrl", 
	sampleAnnotation=c("ctrl","test"), intExCol="int_ex", 
	intTypeCol="intron_type", strandCol= "strand", 
	geneIdCol= "collapsed_transcripts_id", naUnstrand=FALSE, col=c(2,3,4,5,6), 
	lty=c(1,2,3,4,5), lwd=1, plotLegend=TRUE, cexLegend=0.7, 
	xLegend="topright", yLegend=NULL, legend=c(), randomSeed=10,
	ylim=c(0,0.6), xlab=expression("log"[2]*" fold change FPKM"))

# estimate log fold-change of introns 
# by comparing test samples vs ctrl 
# and don't show warnings !
lfcRes<- lfc(mdsChr22Obj, fcType= "edgeR", 
	sampleAnnoCol="test_ctrl",sampleAnnotation=c("ctrl","test"))

# Build the order vector
ord<- rep(1,length(lfcRes))
ord[u12Index(mdsChr22Obj, intTypeCol="intron_type")]=2

# Median of log fold change of U2 introns (ZRSR2 mut. vs ctrl)
median(lfcRes[ord==1])
# Median of log fold change of U2 introns (ZRSR2 mut. vs ctrl)
median(lfcRes[ord==2])
```

<br>
As shown in *figure 7* (and computed after the plot), when comparing the 
ZRSR2 mutated samples vs the other samples, for all U2-type introns the most 
frequent log fold-change (median) is 
~`r round(median(lfcRes[ord==1]), digits=2)` whereas this value for the 
U12-type introns is noticeably higher 
(~`r round(median(lfcRes[ord==2]), digits=2)`). It is also possible to run a 
statistical test to see if the log fold-changes of U12-type introns (ZRSR2 
mutated samples vs other samples) are significantly higher than the log 
fold-changes of U2-type introns. For this purpose we use the 
`jonckheere.test()` function, i.e. Jonckheere-Terpstra ordered alternative 
hypothesis test, from the  *Clinfun* package.

<br>
```{r lfc-sig, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"}
# Run Jockheere Terpstra's trend test
library(clinfun)
jtRes<- jonckheere.test(lfcRes, ord, alternative = "increasing", 
	nperm=1000)
jtRes
```

<br>

The result of the Jonckheere-Terpstra test with 1000 permutation runs shows
that when comparing the samples that lack the ZRSR2 mutation to the the ZRSR2
mutated samples, the null hypothesis that the log fold-changes of the
retentions of U12-type and U2-type introns are equally distributed was rejected
with p-value `r jtRes$p.value`, while the alternative being that the values in
the U12-type introns are higher compared to the U2-type.

## Our recommended pipeline for differential intron retention analysis {#difanalysis}
After building the reference as described in the test scripts 
[above](#readSum), we recommend running `interest()` (or 
`interest.sequential()`) twice: once on the reference with uncollapsed exons 
and with `method="IntSpan"` setting (whcih results to the intron-spanning 
object). and subsequently on the reference with collapsed exons and 
with `method="IntRet"` parameter setting. Next, use 
`applyOverlap(query, subject, type="within", replaceValues=TRUE, FUN=sum)` to 
map the reference with collpased exon to the reference with uncollapsed exon 
and sum the read-count levels accordingly (whcih results to the intron-mapping 
object). cbind the 2 objects and continue as the exmple shown below to detect 
the significantly differential retained introns.

```{r downstreamExample, echo = TRUE, eval=TRUE, message = FALSE, fig.width=6, fig.height=4, fig.align="center"}
mdsChr22RefIntRetSpObj<- cbind(mdsChr22Obj, mdsChr22IntSpObj)

mdsChr22RefIntRetSpObj<- addAnnotation(x=mdsChr22RefIntRetSpObj, 
	sampleAnnotationType="intronExon", 
	sampleAnnotation=c(rep("intron",16), rep("exon",16))
	)

library(BiocParallel)
mdsChr22RefIntRetSpIntFilObj<- 
	mdsChr22RefIntRetSpObj[rowData(mdsChr22RefIntRetSpObj)$int_ex=="intron",]

# Differential IR analysis run
ddsChr22Diff<- deseqInterest(mdsChr22RefIntRetSpIntFilObj,  
    design=~test_ctrl+test_ctrl:intronExon, 
    sizeFactor=rep(1,nrow(colData(mdsChr22RefIntRetSpIntFilObj))), 
    contrast=list("test_ctrltest.intronExonintron",
        "test_ctrlctrl.intronExonintron"),
    bpparam = SnowParam(workers=20))

# See the number of significantly more retained U12 and U2 introns
pThreshold<- 0.01
mdsChr22UpIntInd<- which(ddsChr22Diff$padj< pThreshold & ddsChr22Diff$padj>0)
table(rowData(mdsChr22RefIntRetSpIntFilObj)$intron_type[mdsChr22UpIntInd])

# See the fraction of significantly more retained U12 and U2 introns
100*table(rowData(mdsChr22RefIntRetSpIntFilObj)$intron_type[mdsChr22UpIntInd])/
	table(rowData(mdsChr22RefIntRetSpIntFilObj)$intron_type)
```

Note that the two `SummarizedExperiment` objects mentioned above (i.e. 
`mdsChr22Obj` and `mdsChr22ExObj`) were the results of running interest() in 
"IntRet" and "IntSpan" modes on the exon-collapsed reference. As the names 
suggest these two objects are limited to the U12 intron containing genes on 
chr22. The described pipeline, analyzes the variation of the intron mapping 
reads relative to the variation of the intron spanning reads  across the 
studied conditions whilst excluding the reads that map to exons that overlap 
the studying intronic regions. 

## References

\name{updateRowDataCol}
\alias{updateRowDataCol}

\title{
 Updating contents of \code{rowData} of \code{SummarizedExperiment} objects
}
\description{
Updates the values in a single column of the \code{rowData} of 
\code{SummarizedExperiment} objects.
}
\usage{
updateRowDataCol(x,  updateCol, value)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{updateCol}{ 
Name or the number of the column in the \code{rowData} of \code{x} to be 
updated with the new values. if the \code{updateCol} does not match to any 
column names it will be added as a new column.
}
\item{value}{ 
	The new Replacing values.
}
}
\value{
	Returns an object of type \code{SummarizedExperiment}.
}
\seealso{
	\code{\link{annotateU12}}
}

\author{Ali Oghabian}

\examples{

test<- mdsChr22Obj
# See the the frequency of each intron type annotation
table(rowData(test)$intron_type)

#Change U2 to u2
newIntType<- as.character(rowData(test)$intron_type)
newIntType[newIntType=="U2" & 
	!is.na(newIntType=="U2")]<- "u2"
#Updating values
test<- updateRowDataCol(test, updateCol="intron_type", 
	value=newIntType)
#See the frequency of the updated intron type annotations
table(rowData(test)$intron_type)

#Adding a new column
test<- updateRowDataCol(test, updateCol="new_column", 
	value=rep(NA, nrow(rowData(test))) )
head(rowData(test))

}

\docType{methods}
\name{plot-method}
\alias{plot.InterestResult}
\alias{plot,SummarizedExperiment,ANY-method}
\alias{plot-method}

\title{
	plot - method
}
\description{
	plot method for \code{SummarizedExperiment} objects.
}
\usage{
\S4method{plot}{SummarizedExperiment,ANY}(x, summary="none", 
	subsetRows=NULL, what="scaled", intronExon="intron", 
	logScaleBase=NULL, logPseudoCnt=1, plotLoess=TRUE, 
	loessCol="red", loessLwd=1, loessLty=1, cexText=1, 
	marPlot=c(2,2,2,2), mgpPlot=c(1, 1, 0), cexAxis=1, 
	writeCor=TRUE, corCex=1, corMethod="pearson", corCol="grey63", 
	upperCorXY=c("topleft", NULL), lowerCorXY=c("topleft", NULL), 
	na.rm=TRUE,	cex=1, sampleAnnoCol=c(), lowerPlot=FALSE, 
	upperPlot=TRUE, ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment} generated by either  
	\code{interest()},  \code{interest.sequential()} or  
	\code{readInterestResults()}.
}
\item{summary}{ 
Whether to plot the mean or median of the values over the sample with the same 
annotations, or plot the values for each individual sample separately. The 
available options are "mean", "median", or "none".
}
\item{subsetRows}{
Vector either constructed of TRUE/FALSE values or constructed of numeric values
that could be used to choose rows of \code{x} i.e. the 
\code{SummarizedExperiment} object.
}
\item{what}{
Whether plot "scaled" (default) or read counts ("counts").
}
\item{intronExon}{
Whether plot intron retention, i.e. "intron" (default) or exon-junction "exon".
}
\item{logScaleBase}{
Base of the log transform of the values, if defined. By default the value is 
\code{NULL} meaning that the values would not be log transformed.
}
\item{logPseudoCnt}{
Pseudocount for the log transformation (default=1).
}
\item{plotLoess}{
Whether fit and plot LOESS curve line (default="red").
}
\item{loessCol}{
loess line colour (default="red").
}
\item{loessLwd}{
loess line width (default=1).
}
\item{loessLty}{
loess line type (default=1).
}
\item{cexText}{
Size of the text for sample names or annotations (default=1). 
}
\item{marPlot}{
Plot margins (default=c(2,2,2,2)). See \code{?par} for more information.
}
\item{mgpPlot}{
Plotting \code{mgp} parameter (default=c(1, 1, 0)). See \code{?par} for more 
information.
}
\item{cexAxis}{
Size of the text for the axis (default=1). 
}
\item{writeCor}{
Write correlation values (default=TRUE). 
}
\item{corCex}{
Text size of correlation values (default=1). 
}
\item{corMethod}{
Method used for correlation calculation. For more information see 
\code{\link{cor}} from \code{stats} package of R. 
}
\item{corCol}{
	Color of the text of correlation (default="grey").
}
\item{upperCorXY}{
The coordinates of the correlation text in the upper panel plots 
( default= c("topleft", NULL) ).
}
\item{lowerCorXY}{
The coordinates of the correlation text in the lower panel plots 
( default= c("topleft", NULL) ).
}
\item{na.rm}{
whether remove the rows with missing values (default=TRUE). 
}
\item{cex}{
size of the plot text and symbols (default=1). 
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} of object \code{SummarizedExperiment} to 
consider for plotting.
}
\item{lowerPlot}{
Whether plot the lower panel (default=FALSE).
}
\item{upperPlot}{
Whether plot the upper panel (default=TRUE).
}
\item{...}{
Other arguments to pass to the \code{plot()} function.
}

}
\value{
	Returns NULL.
}
\seealso{
Class:
	\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}
Method:
	\code{\link{counts-method}}
	\code{\link{boxplot-method}}
}
\author{Ali Oghabian}

\examples{


geneId<- paste("gene", c(rep(1,5), rep(2,5), rep(3,5), rep(4,5)), 
	sep="_")
readCnt1<- sample(1:100, 20)
readCnt2<- sample(1:100, 20)
readCnt3<- sample(1:100, 20)
readCnt4<- sample(1:100, 20)
fpkm1<- readCnt1/(tapply(readCnt1, geneId, sum))[geneId]
fpkm2<- readCnt2/(tapply(readCnt2, geneId, sum))[geneId]
fpkm3<- readCnt3/(tapply(readCnt3, geneId, sum))[geneId]
fpkm4<- readCnt4/(tapply(readCnt4, geneId, sum))[geneId]

# Creating object using test data
interestDat<- data.frame( 
		int_ex=rep(c(rep(c("exon","intron"),2),"exon"),4),
		int_ex_num= rep(c(1,1,2,2,3),4),         
		gene_id= geneId,
		sam1_readCnt=readCnt1,
		sam2_readCnt=readCnt2,
		sam3_readCnt=readCnt3,
		sam4_readCnt=readCnt4,
		sam1_fpkm=fpkm1,
		sam2_fpkm=fpkm2,
		sam3_fpkm=fpkm3,
		sam4_fpkm=fpkm4
)
readFreqColIndex<- grep("_readCnt$",colnames(interestDat))
scaledRetentionColIndex<- grep("_fpkm$",colnames(interestDat))

scalRetTmp<- as.matrix(interestDat[ ,scaledRetentionColIndex])
colnames(scalRetTmp)<-gsub("_fpkm$","", colnames(scalRetTmp))

frqTmp<- as.matrix(interestDat[ ,readFreqColIndex])
colnames(frqTmp)<-gsub("_readCnt$","", colnames(frqTmp))


InterestResultObj<- InterestResult(
	resultFiles=paste("file",1:4, sep="_"),
	rowData= interestDat[ , -c(readFreqColIndex, 
		scaledRetentionColIndex)],
	counts= frqTmp,
	scaledRetention= scalRetTmp,
	scaleLength=TRUE, 
	scaleFragment=FALSE,
	sampleAnnotation=data.frame(
		sampleName=paste("sam",1:4, sep=""),
		gender=c("M","M","F","F"), row.names=paste("sam", 1:4, sep="")
	)
)

InterestResultObj2<- addAnnotation(x=InterestResultObj,
	sampleAnnotationType="health",
	sampleAnnotation=c("healthy","unhealthy","healthy","unhealthy")
)

#Plotting
plot(InterestResultObj)
plot(InterestResultObj, sampleAnnoCol="gender", summary="mean")
plot(InterestResultObj2, sampleAnnoCol=3, summary="mean")
plot(InterestResultObj2, summary="none")
}

\name{subInterestResult}
\alias{subInterestResult}
\title{
Extract subset of object 
}
\description{
Build a new object using subset of data in an \code{SummarizedExperiment} 
object. 
}
\usage{
subInterestResult(x, selectRow, selectCol, 
	sampleAnnoCol, sampleAnnotation=c())
}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{selectRow}{
Numeric or TRUE/FALSE Vector indicating what rows to extract.
}
\item{selectCol}{
A vector with Numeric values, character strings (sample names) or TRUE/FALSE 
Vector indicating what columns to extract.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} of object \code{x} to consider for subset data 
extraction.
}
\item{sampleAnnotation}{
Vector including the annotations to consider for subset data extraction. They 
should be present in the \code{sampleAnnoCol} column of the \code{colData} of 
\code{x}.
}
}
\value{
An object of calss \code{SummarizedExperiment}.
}

\seealso{
	\code{\link{interest}},
	\code{\link{InterestResult}}.
}

\author{Ali Oghabian}

\examples{

geneId<- paste("gene", c(rep(1,7), rep(2,7), rep(3,7), rep(4,7)), 
	sep="_")
readCnt1<- sample(1:100, 28)
readCnt2<- sample(1:100, 28)
readCnt3<- sample(1:100, 28)
readCnt4<- sample(1:100, 28)
fpkm1<- readCnt1/(tapply(readCnt1, geneId, sum))[geneId]
fpkm2<- readCnt2/(tapply(readCnt2, geneId, sum))[geneId]
fpkm3<- readCnt3/(tapply(readCnt3, geneId, sum))[geneId]
fpkm4<- readCnt4/(tapply(readCnt4, geneId, sum))[geneId]

# Creating object using test data
interestDat<-data.frame( 
		int_ex=rep(c(rep(c("exon","intron"),3),"exon"),4),
		int_ex_num= rep(c(1,1,2,2,3,3,4),4),         
		int_type=rep(c(NA,"U2",NA,"U12",NA,"U2",NA),4),
		strand=rep("*",28),
		gene_id= geneId,
		sam1_readCnt=readCnt1,
		sam2_readCnt=readCnt2,
		sam3_readCnt=readCnt3,
		sam4_readCnt=readCnt4,
		sam1_fpkm=fpkm1,
		sam2_fpkm=fpkm2,
		sam3_fpkm=fpkm3,
		sam4_fpkm=fpkm4
)
readFreqColIndex<- grep("_readCnt$",colnames(interestDat))
scaledRetentionColIndex<- grep("_fpkm$",colnames(interestDat))
samNames<-paste("sam", 1:4, sep="")
frqTmp<-as.matrix(interestDat[, readFreqColIndex])
sclTmp<-as.matrix(interestDat[, scaledRetentionColIndex])
colnames(frqTmp)<- samNames
colnames(sclTmp)<- samNames
interestResObj<- InterestResult(
	resultFiles=paste("file",1:4, sep="_"),
	rowData= interestDat[, -c(readFreqColIndex, 
		scaledRetentionColIndex)],
	counts= frqTmp,
	scaledRetention= sclTmp ,
	scaleLength=TRUE, 
	scaleFragment=FALSE,
	sampleAnnotation=data.frame(
		sampleName=paste("sam",1:4, sep=""),
		gender=c("M","M","F","F"),
		health=c("healthy","unhealthy","healthy","unhealthy"),
		row.names=samNames
	)
)

#Build new object
newObj<- subInterestResult(interestResObj, selectRow=1:20)

#View newObj
print(newObj)

}

\name{lfc}
\alias{lfc}
\title{
	Log fold change
}
\description{
Log fold change estimation and normalized log fold change using \code{edgeR}
 package. 
}
\usage{
lfc(x, fcType="edgeR", sampleAnnoCol=c(), sampleAnnotation=c(), 
	silent=TRUE, group=c(), rejection.region="doubletail", 
	pseudoCnt=1, log2=TRUE, ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{fcType}{
Available as "scaledRetention" or "edgeR" (as default) corresponding to either
log fold change of scaled retention values or degeR normalized log fold change
values.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} of \code{x} to consider for the analysis.
}
\item{sampleAnnotation}{
A vector of size 2 which cotains values from \code{colData} of 
\code{SummarizedExperiment} object; e.g. if \code{getAnnotation(x)[,
sampleAnnoCol]= c("test", "test", "ctrl","ctrl", ...)} , and the goal is to 
compare "test" and "ctrl" samples, \code{sampleAnnotation} should either be 
\code{c("test", "ctrl")} or \code{c("ctrl", "test")}.
}
\item{silent}{
Whether run \code{\link{exactTestInterest}} silently, without warnings.
}
\item{group}{
Vector to manually define the sample groups (or annotations). It is ignored if
 \code{sampleAnnoCol} is defined.
}
\item{rejection.region}{
The rejection.region parameter in \code{\link[edgeR]{exactTest}}, considered
 only if \code{fcType} is "edgeR".
}
\item{pseudoCnt}{
	Pseudo count for log transformation (default=1).
}
\item{log2}{
Logical value either TRUE (default) or FALSE indicating whether the foldchanges
should be log 2 transformed.
}
\item{...}{
Other parameter settings from the \code{\link{exactTestInterest}} function.
}

}
\value{
Vector including fold change values.
}

\seealso{
	\code{\link{exactTestInterest}}, \code{\link{u12DensityPlotIntron}}
}

\author{Ali Oghabian}

\examples{


lfcFpkm<- lfc(mdsChr22Obj, fcType="scaledRetention",
	sampleAnnoCol="test_ctrl", 
	sampleAnnotation=c("ctrl", "test"), 
	silent=TRUE, group=c(), pseudoFpkm=1, log2=TRUE)


lfcEdgeRFpkm<- lfc(mdsChr22Obj, fcType="edgeR",
	sampleAnnoCol="test_ctrl", 
	sampleAnnotation=c("ctrl", "test"), 
	silent=TRUE, group=c(), pseudoFpkm=1, log2=TRUE)

}

\name{u12DensityPlot}
\alias{u12DensityPlotIntron}
\alias{u12DensityPlot}
\title{
Density plot of fld changes of intron retention and exon-exon junction levels
}
\description{
Density plot of fold change of the retention levels of U12- vs U2- type intron,
or exon-exon junction levels of the flanking exons. For the density plot of the
foldchange of intron retention levels the \code{u12DensityPlotIntron()} 
function or \code{u12DensityPlot()} function with \code{intronExon= "intron"} 
can be used. For density plot of the foldchange of exon-exon junction levels 
use \code{u12DensityPlot()} function with \code{intronExon= "exon"}.
}
\usage{

u12DensityPlot(x, 
	type=c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), 
	fcType="edgeR", sampleAnnotation=c(),  sampleAnnoCol=c(), 
	group=c(), intExCol="int_ex", intTypeCol="int_type", intronExon, 
	strandCol="strand", geneIdCol="collapsed_transcripts", 
	naUnstrand=FALSE, col=1, lty=1, lwd=1, plotLegend=TRUE, 
	cexLegend=1, xLegend="topright", yLegend=NULL, legend=c(), 
	randomSeed=NULL, xlab="", ...)

u12DensityPlotIntron(x, 
	type= c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), 
	fcType= "edgeR", sampleAnnotation=c(),  sampleAnnoCol=c(), 
	group=c(), intExCol="int_ex", intTypeCol="int_type", 
	strandCol= "strand", geneIdCol= "collapsed_transcripts", 
	naUnstrand=FALSE, col=1, lty=1, lwd=1, plotLegend=TRUE, 
	cexLegend=1, xLegend="topright", yLegend=NULL, legend=c(), 
	randomSeed=NULL, xlab="", ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{type}{
A vector that includes the type of introns to plot. Available options are U12 
introns "U12", U2 introns at downstream of U12 introns "U2Dn", U2 introns at 
upstream of U12 introns "U2Up",  U2 introns at upstream or downstream of U12 
introns suitable for when the coorduinates in object x are unstranded (their 
strand is "*") "U2UpDn",  random U2 introns from object x "U2Rand". Settings 
"U2Up", "U2Dn" and "U2UpDn" are useful only if the refernce is linearly 
ordered. References with exons only resulted by \code{referencePrepare} and 
\code{unionRefTr} are NOT necessarily linearly ordered.
}
\item{fcType}{
Available as "fpkm" or "edgeR" (as default) corresponding to either log fold 
change of fpkm values or degeR normalized log fold change values.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} of \code{x} to consider for plotting.
}
\item{sampleAnnotation}{
A vector of size 2 which cotains values from \code{colData} of 
\code{SummarizedExperiment} object; e.g. if \code{getAnnotation(x)[,
sampleAnnoCol]= c("test", "test", "ctrl","ctrl", ...)} , and the goal is to 
compare "test" and "ctrl" samples, \code{sampleAnnotation} should either be 
\code{c("test", "ctrl")} or \code{c("ctrl", "test")}.
}
\item{group}{
Vector to manually define the sample groups (or annotations). It is ignored if 
\code{sampleAnnoCol} is defined.
}
\item{intExCol}{
Column name (or number) that represents whether each row of \code{x} assays is 
"intron" or "exon".
}
\item{intTypeCol}{
Column name (or number) that represents what type of intron each row of 
\code{x} assays represents.
}
\item{intronExon}{
Whether plot intron retention (set \code{intronExon="intron"}) or exon-exon 
junction (set \code{intronExon="exon"}) levels. 
}
\item{strandCol}{
Column name (or number) that represents the strand of each row of assays in
\code{x}. The values in the column are either "+", "-" or "*".
}
\item{geneIdCol}{
Column name (or number) that represents the gene ID of each row of assays in
\code{x}.
}
\item{naUnstrand}{
Replace unstranded results, i.e. introns or exon with "*" strand, with NA (to 
be excluded).
}
\item{col}{
A vector with the size of 1 or the same size as the \code{type} parameter which 
includes the colour/colours of the plotted density lines (default=1).
}
\item{lty}{
A vector with the size of 1 or the same size as the \code{type} parameter which
includes the type of the plotted density lines (default=1).
}
\item{lwd}{
A vector with the size of 1 or the same size as the \code{type} parameter which
includes the width of the plotted density lines (default=1).
}
\item{plotLegend}{
Whether show legend (TRUE by default).
}
\item{cexLegend}{
Size of the text in legend .
}
\item{xLegend, yLegend}{
Position of legend in the plot. For more info see \code{x} and \code{y} 
parameters in \code{\link{legend}}.
}
\item{legend}{ 
The replacement texts to be used in legend.
}
\item{randomSeed}{
	Seed value for random number generator.
}
\item{xlab}{
The lable of the X axis of the plot; by default it is "".
}
\item{...}{
Other parameter settings from the \code{\link[graphics]{plot}} function.
}

}
\value{
Returns NULL.
}

\seealso{
\code{\link{exactTestInterest}}, \code{\link{lfc}}
}

\author{Ali Oghabian}

\examples{

u12DensityPlotIntron(mdsChr22Obj, 
    type= c("U12", "U2Up", "U2Dn", "U2UpDn", "U2Rand"), 
    fcType= "edgeR", sampleAnnoCol="test_ctrl", 
    sampleAnnotation=c("ctrl","test"), intExCol="int_ex", 
    intTypeCol="intron_type", strandCol= "strand", 
    geneIdCol= "collapsed_transcripts_id", naUnstrand=FALSE, col=c(2,3,4,5,6), 
    lty=c(1,2,3,4,5), lwd=1, plotLegend=TRUE, cexLegend=0.7, 
    xLegend="topright", yLegend=NULL, legend=c(), randomSeed=10,
    ylim=c(0,0.6), xlab=expression("log"[2]*" fold change FPKM"))

}

\name{u12BoxplotNb}
\alias{u12BoxplotNb}
\title{
boxplot U12 introns retention levels (or flanking exons junction levels) and 
(up/down)stream U2 introns (or exons junction levels)
}
\description{
boxplot U12 introns and (Up/Down)stream U2 introns in 
\code{SummarizedExperiment} objects.
}
\usage{
u12BoxplotNb(x, sampleAnnoCol=2, intExCol="int_ex",
	intTypeCol="int_type", intronExon, strandCol="strand", geneIdCol, 
	col=c(), names=c(), lasNames=1, outline=FALSE, plotLegend=TRUE, 
	cexLegend=1, xLegend="topright", yLegend=NULL, bgLegend="transparent", 
	legend=c(), addGrid=FALSE, ...)
}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} of \code{x} to consider for plotting.
}
\item{intExCol}{
Column name (or number) that represents whether each row of \code{x} assays is 
"intron" or "exon".
}
\item{intTypeCol}{
Column name (or number) that represents what type of intron each row of 
\code{x} assays represents.
}
\item{intronExon}{
Whether plot intron retention (set \code{intronExon="intron"}) or exon-exon 
junction (set \code{intronExon="exon"}) levels. 
}
\item{strandCol}{
Column name (or number) that represents the strand of each row of assays in
\code{x}. The values in the column are either "+", "-" or "*".
}
\item{geneIdCol}{
Column name (or number) that represents the gene ID of each row of assays in
\code{x}.
}
\item{col}{
Vector containing box colours. It is either of size 1 or the same size as the 
number of boxes resulted based on the grouping of the samples defined by 
\code{sampleAnnoCol}.
}
\item{names}{
Names to write under group of boxes.
}
\item{lasNames}{
Orientation of the box names.
}
\item{outline}{
If outline is TRUE the outlier points are drawn otherwise if FALSE (default) 
they are not.
}
\item{plotLegend}{
Whether show legend (TRUE by default).
}
\item{cexLegend}{
Size of the text in legend .
}
\item{xLegend, yLegend}{
Position of legend in the plot. For more info see \code{x} and \code{y} 
parameters in \code{\link{legend}}.
}
\item{bgLegend}{ 
Bakcground colour of the legend box. It is "transparent" by default.
}
\item{legend}{ 
The replacement texts to be used in legend.
}
\item{addGrid}{ 
Whether add a grid under the boxplots (FALSE by default). 
}
\item{...}{
	Other arguments to pass to the \code{boxplot()} function.
}
}
\value{
Returns NULL
}

\seealso{
	\code{\link{u12Boxplot}}
}

\author{Ali Oghabian}

\examples{

u12BoxplotNb(mdsChr22Obj, sampleAnnoCol="type", lasNames=1,
    intExCol="int_ex", intTypeCol="intron_type", intronExon="intron", 
    boxplotNames=c(), outline=FALSE, plotLegend=TRUE, 
    geneIdCol="collapsed_transcripts_id", xLegend="topleft", 
    col=c("pink", "lightblue", "lightyellow"), ylim=c(0,600000), 
    ylab="FPKM", cex.axis=0.8)

}

\name{unionRefTr}
\alias{unionRefTr}
\title{Union introns/exons of transcripts}
\description{ 
Performs union on the overlapping introns/exons so that the final merged 
transcripts would feature from each exon or intron, one copy.}
\usage{
unionRefTr( referenceChr, referenceBegin, referenceEnd, referenceTr, 
	referenceIntronExon, intronExon="exon", silent=FALSE)
}
\arguments{
\item{referenceChr}{
Chromosome names of the references (e.g. introns).}
\item{referenceBegin}{
A vector that corresponds to the begin coordinates of the reference.}
\item{referenceEnd}{
A vector that corresponds to the end coordinates of the reference.}
\item{referenceTr}{
A character vector that includes transcription IDs.}
\item{referenceIntronExon}{
A vector with the same size as the \code{referenceChr}, \code{referenceBegin} 
and \code{referenceEnd} which contains \code{'intron'} and \code{'exon'}
describing what (either intron or exon) each element of the 3 vectors 
represents.}
\item{intronExon}{
Should be assigned either \code{'intron'} or \code{'exon'} or 
\code{c('intron','exon')} based on whether match the PWM to the intronic, 
exonic, or intronic and exonic regions of the reference. By default it seeks 
matches in intronic regions (intronExon='intron').}
\item{silent}{
Whether run silently.
}
}
\value{
Data frame containing merged transcripts structure. The merged transcripts 
feature from each intron or exon, one copy ONLY.
}
\seealso{
  \code{\link{annotateU12}}.
}

\author{Ali Oghabian}

\examples{

unU12Ex<-unionRefTr( referenceChr=u12[1:94,"chr"], 
	referenceBegin=u12[1:94,"begin"], referenceEnd=u12[1:94,"end"], 
	referenceTr=u12[1:94,"trans_name"], 
	referenceIntronExon=u12[1:94,"int_ex"], intronExon="exon", silent=TRUE)

unU12Int<-unionRefTr( referenceChr=u12[1:94,"chr"], 
	referenceBegin=u12[1:94,"begin"], referenceEnd=u12[1:94,"end"], 
	referenceTr=u12[1:94,"trans_name"], 
	referenceIntronExon=u12[1:94,"int_ex"], intronExon="intron", silent=TRUE)

unU12IntEx<-unionRefTr( referenceChr=u12[1:94,"chr"], 
	referenceBegin=u12[1:94,"begin"], referenceEnd=u12[1:94,"end"], 
	referenceTr=u12[1:94,"trans_name"], 
	referenceIntronExon=u12[1:94,"int_ex"], intronExon=c("intron","exon"), 
	silent=TRUE)

}

\name{annotateU12}
\alias{annotateU12}
\title{Annotate the U12 (and U2) type introns}
\description{ 
Receives coordinates, a reference genome and PWMs of splice site of U12 and U2 
type introns, and returns a data.frame with 2 columns. The first column shows 
wheather the corresponding sequences matches U12, U2 or both (U12/U2) consensus
sequences (based on their score when fitting the PWMs). The second column shows
whether the match is on positive strand or negative when fitting the PWMs to
the sequences.  }
\usage{
annotateU12(pwmU12U2=c(), pwmSsIndex=c(), referenceChr, referenceBegin, 
	referenceEnd, referenceIntronExon, intronExon='intron', 
	matchWindowRelativeUpstreamPos=c() , matchWindowRelativeDownstreamPos=c(), 
	minMatchScore='80\%', refGenome='', setNaAs='U2', annotateU12Subtype=TRUE, 
	includeMatchScores=FALSE, ignoreHybrid=TRUE, filterReference)
}
\arguments{
\item{pwmU12U2}{
A list containing position weight matrices of (in order): Donor site, branch 
point, and acceptor site of U12-type introns, and donor site and acceptor site 
of U2-type introns. If not provided, the information related to \code{pwmU12db}
data is used.}

\item{pwmSsIndex}{
A list (or vector) that contains the column number in each element of 
\code{pwmU12U2} that represents the 5' or 3' Splice Site; The order should be 
equivalent to the \code{pwmU12U2}. If not provided the information from 
\code{pwmU12db} data is used, i.e. \code{pwmSsIndex=list(indexDonU12=1, 
indexBpU12=1, indexAccU12=3, indexDonU2=1, indexAccU2=3)} }

\item{referenceChr}{
Chromosome names of the references (e.g. introns).}

\item{referenceBegin}{
A vector that corresponds to the begin coordinates of the reference 
(e.g. introns).}

\item{referenceEnd}{
A vector that corresponds to the end coordinates of the reference (e.g. 
introns). \code{referenceEnd} should be greater than or equal to 
\code{referenceBegin}.}

\item{referenceIntronExon}{
A vector with the same size as the \code{referenceChr}, \code{referenceBegin} 
and \code{referenceEnd} which contains \code{'intron'} and \code{'exon'}
describing what (either intron or exon) each element of the 3 vectors 
represents.}

\item{intronExon}{
Should be assigned either \code{'intron'} or \code{'exon'} or 
\code{c('intron','exon')} based on whether match the PWM to the intronic, 
exonic, or intronic and exonic regions of the reference. By default it seeks 
matches in intronic regions (intronExon='intron').}

\item{matchWindowRelativeUpstreamPos}{
A vector the same size as the \code{pwmU12U2} (and the same order of 
donor/acceptor sites' information in \code{pwmU12U2}) which consists of the 
upstream distance from the donor/acceptor site from which each PWM should be 
tested (to see if they match). If not provided, the information from 
\code{pwmU12db} data is used i.e. 
\code{matchWindowRelativeUpstreamPos= c(NA, -29, NA, NA, NA)}.}

\item{matchWindowRelativeDownstreamPos}{
A vector the same size as the \code{pwmU12U2} (and the same order of 
donor/acceptor sites' information in \code{pwmU12U2}) which consists of the 
downstream distance from the donor/acceptor site to which each PWM should be 
tested (to see if they match). If not provided, the information from 
\code{pwmU12db} data is used i.e. 
\code{matchWindowRelativeDownstreamPos= c(NA,-9, NA, NA, NA)}.}

\item{minMatchScore}{
Min percentage match score, when scoring matching of a sequence to \code{pwm}. 
Different score thresholds could also be defined for the various sites (U12/U2 
donors, the U12 branch point and U12/U2 acceptors); A vector with 5 elements
can be assigned which each shows the match score to use for each PWM in 
\code{pwmU12U2}.}

\item{refGenome}{
The reference genome; Object of class BSgenome. Use \code{available.genome()} 
from the \code{BSgenome} package to see the available genomes. 
\code{DNAStringSet} objects (from \code{Biostrings} package) and fasta files 
are also accepted as input.}

\item{setNaAs}{
Defines that if reference (e.g. intron) did not match any of U12 or U2 type 
introns based on the scores obtained from PWM what should the function return. 
If an intron was not proven to be U12 or U2 based on PWM scores it can be 
considered as U2-type since the U12 type introns constitute for about 1\% of 
introns in human genome and they are muxh more conserved than the U2 type 
introns, hence the default is 'U2'; otherwise it is also possible to set it as 
NA or nan or 'U12/U2'.}

\item{annotateU12Subtype}{Whether annotate the subtypes of the U12 type 
Introns. The value is \code{TRUE} by default.}

\item{includeMatchScores}{If set as TRUE the final data frame result includes
the PWM match scores (FALSE by default).}

\item{ignoreHybrid}{Whether ignore the U12 hybrid subtypes, i.e. GT-AC and 
AT-AG (TRUE by default).}

\item{filterReference}{Optional parameter that can be defined either as a 
GRanges or SummarizedExperiment object. If defined as the latter, the first 3 
columns of the rowData must be: chr name, start and end of the coordinates.
If the parameter is defined the introns/exon coordinates will be mapped against
it and the intron type of all those that do not match will be set as NA. }

}
\value{
 Data frame containing 3 columns representing (in order): intron type (U12, U2 
or none), strand match indicating whether the PWM matches to the sequence 
(+ strand) or the reverese complement of the sequence (- strand) or none (NA), 
and the U12 subtype (GT-AG or AT-AC). If includeMatchScores is set as TRUE 
further columns that include the PWM match scores will also be included.
}
\seealso{
  \code{\link{buildSsTypePwms}}.
}

\author{Ali Oghabian}

\examples{



# Improting genome
BSgenome.Hsapiens.UCSC.hg19 <- 
	BSgenome.Hsapiens.UCSC.hg19::BSgenome.Hsapiens.UCSC.hg19
#Choosing subset of rows
ind<- 69:94
# Annotate U12 introns with strong U12 donor site, branch point 
# and acceptor site from the u12 data in the package
annoU12<- 
	annotateU12(pwmU12U2=list(pwmU12db[[1]][,11:17],pwmU12db[[2]]
		,pwmU12db[[3]][,38:40],pwmU12db[[4]][,11:17],
		pwmU12db[[5]][,38:40]), 
	pwmSsIndex=list(indexDonU12=1, indexBpU12=1, indexAccU12=3, 
		indexDonU2=1, indexAccU2=3), 
	referenceChr=u12[ind,'chr'], 
	referenceBegin=u12[ind,'begin'], 
	referenceEnd=u12[ind,'end'], 
	referenceIntronExon=u12[ind,"int_ex"], 
	intronExon="intron",  
	matchWindowRelativeUpstreamPos=c(NA,-29,NA,NA,NA),
	matchWindowRelativeDownstreamPos=c(NA,-9,NA,NA,NA), 
	minMatchScore=c(rep(paste(80,"\%",sep=""),2), "60\%", 
		paste(80,"\%",sep=""), "60\%"), 
	refGenome=BSgenome.Hsapiens.UCSC.hg19, 
	setNaAs="U2", 
	annotateU12Subtype=TRUE)

# How many U12 and U2 type introns with strong U12 donor sites, 
# acceptor sites (and branch points for U12-type) are there?
table(annoU12[,1])

}

\name{u12}
\alias{u12}
\docType{data}
\title{
U12 data
}
\description{
Intron/exon annotations of genes featuring U12 introns. It is based on 
HG19/GRCh37 (converted from hg17/NCBI35). Moreover the u12 genes are based on 
the U12DB database.
}
\usage{data("u12")}
\format{
  A data frame with 22713 observations on the following 17 variables.
  \describe{
    \item{\code{id}}{a numeric vector}
    \item{\code{int_ex_id}}{a character vector}
    \item{\code{chr}}{a character vector}
    \item{\code{begin}}{a numeric vector}
    \item{\code{end}}{a numeric vector}
    \item{\code{strand}}{a numeric vector}
    \item{\code{int_ex}}{a character vector}
    \item{\code{trans_type}}{a character vector}
    \item{\code{ens_gene_id}}{a character vector}
    \item{\code{ens_trans_id}}{a character vector}
    \item{\code{int_ex_num}}{a numeric vector}
    \item{\code{gene_name}}{a character vector}
    \item{\code{trans_name}}{a character vector}
    \item{\code{overlap_no}}{a numeric vector}
    \item{\code{int_type}}{a character vector}
    \item{\code{int_subtype}}{a character vector}
  }
}
\value{
Data frame that includes the coordinates and annotations of the introns and 
exons of the transcripts, i.e. the reference.
}
\source{
Alioto, T.S. U12DB: a database of orthologous U12-type spliceosomal introns. 
Nucleic Acids Research 2006, doi: 10.1093/nar/gkl796
}
\keyword{datasets}

\name{DEXSeqIntEREst}
\alias{DEXSeqIntEREst}
\title{
	DEXSeq test for IntEREst object
}
\description{
	Genewise differential exon usage or intron retention test adapted from the 
\code{DEXSeq} package. 
}
\usage{
DEXSeqIntEREst (x, design, reducedModel = ~ sample + intex, fitExpToVar, 
intExCol, geneIdCol, bpparam, silent=TRUE,...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{design}{
Formula specifying the design of the experiment. It must specify an interaction
term between a variable from columns of \code{sampleData(x)} with one of the 
'exon', 'intron' or 'intex' (i.e. intron and exon) variables; based on which of
these variables are used (exon, intron , or 'intex') the x will be filtered
reletively to include exons, introns , or introns and exons. See
\code{\link[DEXSeq]{DEXSeqDataSet}} for more information.}
\item{reducedModel}{
The null model formula. By default it is '~ sample + intex'.}
\item{fitExpToVar}{
A variable name contained in the column data (i.e. column names of
\code{colData(x)}). See \code{\link[DEXSeq]{DEXSeq}} for more information.}
\item{intExCol}{
Column name (or number) that represents whether each row is "intron" or "exon"
 in \code{rowData} of \code{x}.
}
\item{geneIdCol}{
Column name (or number of column) in \code{rowData} of \code{x}, i.e. 
\code{SummarizedExperiment} object, that represents the gene ID of the 
introns and exons in \code{x}.
}
\item{bpparam}{An optional \code{BiocParallelParam} instance defining the 
parallel back-end to be used.}
\item{silent}{
Whether run the DEXSeq function silently (if TRUE) or allow it to print 
messages at each step (if FALSE).
}
\item{...}{
Other parameter settings for the \code{\link[DEXSeq]{DEXSeqDataSet}} function 
in the \code{DEXSeq} package.
}
}
\details{
The \code{design} and \code{reduceModel} accept formula that specify the design
of the experiment. The formula must describe an interaction between variables
from columns of \code{sampleData(x)} with one of the 'exon', 'intron' or 
'intex' (i.e. intron and exon) variables; Based on which of these variables are
used (exon, intron , or 'intex') the input object (\code{x}) will be filtered
reletively to include exons, introns , or introns and exons. Hence the number 
of the rows of the returned value is equal to the number of the rows of the 
filtered object, i.e. the number of the exons, introns or both based on the
\code{design} formula.
}

\value{
 A \code{DEXSeqResults} object.
}
\seealso{
\code{\link{exactTestInterest}}
}

\author{Ali Oghabian}

\examples{

dexseqExRes<-DEXSeqIntEREst (x=mdsChr22ExObj, 
	design= ~ sample + exon + test_ctrl:exon, 
	reducedModel = ~ sample + exon, fitExpToVar="test_ctrl", 
	intExCol="int_ex", geneIdCol="transcripts_id", silent=TRUE)
head(dexseqExRes)

}

\name{exactTestInterest}
\alias{exactTestInterest}
\title{
	Exact test
}
\description{
Compute genewise exact test between two groups of read counts, using the 
\code{edgeR} package. 
}
\usage{
exactTestInterest(x, sampleAnnoCol=c(), sampleAnnotation=c(), 
	geneIdCol, silent=TRUE, group=c(), rejection.region="doubletail", 
	big.count=900, prior.count=0.125, disp="common", ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} of \code{x} to consider for the analysis.
}
\item{sampleAnnotation}{
A vector of size 2 which cotains values from \code{colData} of 
\code{SummarizedExperiment} object; e.g. if \code{getAnnotation(x)[,
sampleAnnoCol]= c("test", "test", "ctrl","ctrl", ...)} , and the goal is to 
compare "test" and "ctrl" samples, \code{sampleAnnotation} should either be 
\code{c("test", "ctrl")} or \code{c("ctrl", "test")}.
}
\item{geneIdCol}{
Column name (or number of column) in \code{rowData} of \code{x}, i.e. 
\code{SummarizedExperiment} object, that represents the gene ID of the 
introns and exons in \code{x}.
}
\item{silent}{
Whether run the function silently, i.e. without printing the top differential 
expression tags.
}
\item{group}{
Vector to manually define the sample groups (or annotations). It is ignored if 
\code{sampleAnnopCol} is defined.
}
\item{rejection.region}{
The \code{rejection.region} parameter in \code{\link[edgeR]{exactTest}} from 
\code{edgeR} package.
}
\item{big.count}{
The \code{big.count} parameter in \code{\link[edgeR]{exactTest}} from 
\code{edgeR} package.
}
\item{prior.count}{
The \code{prior.count} parameter in \code{\link[edgeR]{exactTest}} from 
\code{edgeR} package.
}
\item{disp}{
The type of estimating the dispersion in the data. Available options are: 
"tagwise", "trended", "common" and "genewise". It is also possible to assign a 
number for manually setting the \code{disp}.
}
\item{...}{
Other parameter settings for the \code{\link[edgeR]{estimateDisp}} function 
(e.g. the \code{design} parameter) in the \code{edgeR} package.
}

}
\value{
\item{table}{ 
Data frame containing columns for the log2 fold-change (logFC), the average of 
log2 counts-per-million (logCPM), and the two-sided p-value (PValue).  
}
\item{comparison}{The name of the two compared groups.}
\item{dispersionType}{The name of the type of dispersion used.}
\item{dispersion}{The estimated dispersion values.}
}
\seealso{
\code{\link{lfc}}, \code{\link{glmInterest}}, \code{\link{qlfInterest}}, 
\code{\link{treatInterest}}, \code{\link{DEXSeqIntEREst}}
}

\author{Ali Oghabian}

\examples{


geneId<- paste("gene", c(rep(1,5), rep(2,5), rep(3,5), rep(4,5)), 
	sep="_")
readCnt1<- sample(1:100, 20)
readCnt2<- sample(1:100, 20)
readCnt3<- sample(1:100, 20)
readCnt4<- sample(1:100, 20)
fpkm1<- readCnt1/(tapply(readCnt1, geneId, sum))[geneId]
fpkm2<- readCnt2/(tapply(readCnt2, geneId, sum))[geneId]
fpkm3<- readCnt3/(tapply(readCnt3, geneId, sum))[geneId]
fpkm4<- readCnt4/(tapply(readCnt4, geneId, sum))[geneId]

# Creating object using test data
interestDat<- data.frame( 
		int_ex=rep(c(rep(c("exon","intron"),2),"exon"),4),
		int_ex_num= rep(c(1,1,2,2,3),4),         
		gene_id= geneId,
		sam1_readCnt=readCnt1,
		sam2_readCnt=readCnt2,
		sam3_readCnt=readCnt3,
		sam4_readCnt=readCnt4,
		sam1_fpkm=fpkm1,
		sam2_fpkm=fpkm2,
		sam3_fpkm=fpkm3,
		sam4_fpkm=fpkm4
)
readFreqColIndex<- grep("_readCnt$",colnames(interestDat))
scaledRetentionColIndex<- grep("_fpkm$",colnames(interestDat))

scalRetTmp<- as.matrix(interestDat[ ,scaledRetentionColIndex])
colnames(scalRetTmp)<-gsub("_fpkm$","", colnames(scalRetTmp))

frqTmp<- as.matrix(interestDat[ ,readFreqColIndex])
colnames(frqTmp)<-gsub("_readCnt$","", colnames(frqTmp))


InterestResultObj<- InterestResult(
	resultFiles=paste("file",1:4, sep="_"),
	rowData= interestDat[ , -c(readFreqColIndex, 
		scaledRetentionColIndex)],
	counts= frqTmp,
	scaledRetention= scalRetTmp,
	scaleLength=TRUE, 
	scaleFragment=FALSE,
	sampleAnnotation=data.frame(
		sampleName=paste("sam",1:4, sep=""),
		gender=c("M","M","F","F"), row.names=paste("sam", 1:4, sep="")
	)
)

res<- exactTestInterest(InterestResultObj, sampleAnnoCol="gender", 
	sampleAnnotation=c("F","M"), geneIdCol= "gene_id", 
	silent=TRUE, disp="common")

}

\name{getRepeatTable}
\alias{getRepeatTable}
\title{Get table of regions with repetetive DNA sequences}
\description{
This function returns a data.frame that includes regions with repetetive DNA 
sequences. These sequences can bias the mapping of the reads to the genome 
excluding them will remove the bias.}
\usage{
getRepeatTable( dbUser="genome", 
	dbHost="genome-mysql.cse.ucsc.edu",	ucscGenome="hg19",
	ucscTable="rmsk", minLength=0, repFamilyFil="Alu", 
	repFamilyCol="repFamily", repChrCol="genoName", 
	repBegCol="genoStart", repEndCol="genoEnd", 
	repStrandCol="strand", repNameCol="repName", 
	repClassCol="repClass")
}
\arguments{
\item{dbUser}{Database user name; set as "genome" by default.}
\item{dbHost}{
Database host address; set as "genome-mysql.cse.ucsc.edu" by default.}
\item{ucscGenome}{The UCSC genome.}
\item{ucscTable}{
The UCSC table name. The table with repetetive sequences by default it is set 
as \code{"rmsk"}.}
\item{minLength}{
the minimum length criteria to consider the repetetive sequences. the default 
setting is \code{0}.}
\item{repFamilyFil}{
A vector including the repeats family to consider. By default the \code{"Alu"} 
elements are considered.}
\item{repFamilyCol}{
The name of the column of the input table (\code{ucscTable}) that represents
the repeats family.}
\item{repChrCol}{
The column (either name or the number of the column) of the input table that 
represents the Chromosome names.}
\item{repBegCol}{
The column of the table that represents the start coordinates.}
\item{repEndCol}{The column of the table that represents the end coordinates.}
\item{repStrandCol}{The column of the table that represents the strand.}
\item{repNameCol}{The column of the table representing the repeats' names.}
\item{repClassCol}{The column of the table representing the repeats' classes.}
}
\value{
Data frame with columns representing coordinates and annotations of repetitive
DNA elements.  
}

\author{Ali Oghabian}

\examples{
\dontrun{
# Download table for Alu elemnts in the human genome
suppressWarnings(repTable<- getRepeatTable(repFamilyFil="Alu",
	ucscGenome="hg19"))
}
}

\name{InterestResult}
\alias{InterestResult}
\title{
	Building SummarizedExperiment object from results in IntEREst.
}
\description{
Calls the constructors and creates a \code{SummarizedExperiment} object. 
For more information on the resulted object and the class see 
\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}.
}
\usage{

InterestResult(resultFiles=c(), counts, scaledRetention, 
	scaleLength, scaleFragment, sampleAnnotation, rowData)

}
\arguments{
\item{resultFiles}{
Vector of link to the result files of \code{interest}.
}
\item{counts}{
Numeric Matrix that includes the read counts.
}
\item{scaledRetention}{
Matrix that includes the scaled retention values.
}
\item{scaleLength}{
Logical value, indicating whether the intron/exon retention levels are scaled 
to the length of the introns/exons. 
}
\item{scaleFragment}{
Logical value, indicating whether the intron/exon retention levels are scaled 
to the fragments mapped to the genes. 
}
\item{sampleAnnotation}{
Data frame with the row-size equal to the size of \code{resultFiles} and 
\code{sampleAnnotation}. Each column of the matrix represents annotations for 
the samples. Column name represents annotation name.
}
\item{rowData}{ 
Data frame with Intron/Exon annotations and read count  and scaled retention 
values for each sample.
}
}
\value{
Returns an object of class \code{SummarizedExperiment}. 
}
\seealso{
	\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}
	\code{\link{attributes}}
	\code{\link{addAnnotation}}
	\code{\link{counts-method}}
	\code{\link{plot-method}}
}

\author{Ali Oghabian}

\examples{


geneId<- paste("gene", c(rep(1,5), rep(2,5), rep(3,5), rep(4,5)), 
	sep="_")
readCnt1<- sample(1:100, 20)
readCnt2<- sample(1:100, 20)
readCnt3<- sample(1:100, 20)
readCnt4<- sample(1:100, 20)
fpkm1<- readCnt1/(tapply(readCnt1, geneId, sum))[geneId]
fpkm2<- readCnt2/(tapply(readCnt2, geneId, sum))[geneId]
fpkm3<- readCnt3/(tapply(readCnt3, geneId, sum))[geneId]
fpkm4<- readCnt4/(tapply(readCnt4, geneId, sum))[geneId]

# Creating object using test data
interestDat<- data.frame( 
		int_ex=rep(c(rep(c("exon","intron"),2),"exon"),4),
		int_ex_num= rep(c(1,1,2,2,3),4),         
		gene_id= geneId,
		sam1_readCnt=readCnt1,
		sam2_readCnt=readCnt2,
		sam3_readCnt=readCnt3,
		sam4_readCnt=readCnt4,
		sam1_fpkm=fpkm1,
		sam2_fpkm=fpkm2,
		sam3_fpkm=fpkm3,
		sam4_fpkm=fpkm4
)
readFreqColIndex<- grep("_readCnt$",colnames(interestDat))
scaledRetentionColIndex<- grep("_fpkm$",colnames(interestDat))

scalRetTmp<- as.matrix(interestDat[ ,scaledRetentionColIndex])
colnames(scalRetTmp)<-gsub("_fpkm$","", colnames(scalRetTmp))

frqTmp<- as.matrix(interestDat[ ,readFreqColIndex])
colnames(frqTmp)<-gsub("_readCnt$","", colnames(frqTmp))


InterestResultObj<- InterestResult(
	resultFiles=paste("file",1:4, sep="_"),
	rowData= interestDat[ , -c(readFreqColIndex, 
		scaledRetentionColIndex)],
	counts= frqTmp,
	scaledRetention= scalRetTmp,
	scaleLength=TRUE, 
	scaleFragment=FALSE,
	sampleAnnotation=data.frame(
		sampleName=paste("sam",1:4, sep=""),
		gender=c("M","M","F","F"), row.names=paste("sam", 1:4, sep="")
	)
)

# View object
InterestResultObj

}

\docType{methods}
\name{boxplot-method}
\alias{intexBoxplot}
\alias{boxplot,SummarizedExperiment-method}
\alias{boxplot-method}

\title{
	boxplot - method
}
\description{
	boxplot method for \code{SummarizedExperiment} objects.
}
\usage{
\S4method{boxplot}{SummarizedExperiment}(x, sampleAnnoCol=NA, 
	intexTypeCol="int_type", intexType=c(), col="white", boxplotNames=c(), 
	lasNames=3, outline=FALSE, addGrid=FALSE, ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment} generated by either  
	\code{interest()},  \code{interest.sequential()} or  
	\code{readInterestResults()}.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} in \code{x} to consider for plotting.
}
\item{intexTypeCol}{
Column name (or number) that represents what type of intron/exon each row of 
\code{x} assays represents.
}
\item{intexType}{
A vector of characters describing types of introns/exons to be plotted. They 
must be elements in the \code{intexTypeCol} column of the rowData of \code{x}. 
rowData of \code{x} is a dataframe that includes various annotations of the
introns/exons.
}
\item{col}{
Vector showing box colours. It is either of size 1 or the same size as the 
number of groups to be plotted.
}
\item{boxplotNames}{
Names to write under boxes. If not defined, as names, it pastes the row 
(intron/exon) annotation names to the sample group annotations separated by a
space " ".
}
\item{lasNames}{
Orientation of the box names.
}
\item{outline}{
If outline is TRUE the outlier points are drawn otherwise if FALSE (default) 
they are not.
}
\item{addGrid}{ 
Whether add a grid under the boxplots (FALSE by default). 
}
\item{...}{
Other arguments to pass to the \code{boxplot()} and \code{axis} function.
}

}
\value{
	Returns NULL.
}
\seealso{
Class:
	\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}
Method:
	 \code{\link{counts-method}}
	\code{\link{plot-method}}
}
\author{Ali Oghabian}

\examples{

#Plotting U12- vs U2-type introns
par(mar=c(8,4,2,1))
boxplot(x=mdsChr22Obj, sampleAnnoCol="type", intexTypeCol="intron_type", 
	intexType=c("U2", "U12"), 
	col=rep(c("yellow", "orange"),3), 
	boxplotNames=c(), lasNames=3, outline=FALSE, 
	addGrid=TRUE)

}

\name{u12Index}
\alias{u12Index}
\title{
	Extract index of U12 introns rows
}
\description{
Extract row numbers of U12 introns in an object of class 
\code{SummarizedExperiment}.
}
\usage{
u12Index(x, intExCol="int_ex", intTypeCol="int_type", intronExon="intron")
}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{intExCol}{
Column name (or number) that represents whether each row of \code{x} assays is 
"intron" or "exon".
}
\item{intTypeCol}{
Column name (or number) that represents what type of intron each row of 
\code{x} assays represents.
}
\item{intronExon}{
Whether extract U12 type introns (set \code{intronExon="intron"}) or exon-exon 
junction (set \code{intronExon="exon"}) flanking U12 introns. 
}

}
\value{
A numeric vector which includes the index of U12 introns.
}

\seealso{
	\code{\link{u12NbIndex}}
}

\author{Ali Oghabian}

\examples{

head(u12Index(mdsChr22Obj, intTypeCol="intron_type"))

}

\name{referencePrepare}
\alias{referencePrepare}
\title{Creates reference file}
\description{
Creates reference file for IntEREst functions, e.g. \code{interest()}. The 
function uses functions of \code{biomaRt} library.}
\usage{
referencePrepare( outFileTranscriptsAnnotation="",
	annotateGeneIds=TRUE, 
	u12IntronsChr=c(), u12IntronsBeg=c(), u12IntronsEnd=c(),
	u12IntronsRef,	collapseExons=TRUE, sourceBuild="UCSC", 
	ucscGenome="hg19", ucscTableName="knownGene",
	ucscUrl="http://genome-euro.ucsc.edu/cgi-bin/",
	biomart="ENSEMBL_MART_ENSEMBL",
	biomartDataset="hsapiens_gene_ensembl",
	biomartTranscriptIds=NULL, biomartExtraFilters=NULL, 
	biomartIdPrefix="ensembl_",	biomartHost="www.ensembl.org",
	biomartPort=80,	circSeqs="", taxonomyId=NA,
	filePath="", fileFormat=c("auto", "gff3", "gtf"), fileDatSrc=NA,
	fileOrganism=NA, fileChrInf=NULL, 
	fileDbXrefTag=c(), addCollapsedTranscripts=TRUE, 
	ignore.strand=FALSE )
}
\arguments{
\item{
outFileTranscriptsAnnotation}{If defined outputs transcripts annotations.}
\item{annotateGeneIds}{
Wether annotate and add the gene ids information.}
\item{collapseExons}{
Whether collapse (i.e. reduce) the exonic regions. TRUE by default.}
\item{sourceBuild}{
The source to use to build the reference data, \code{"UCSC"}, \code{"biomaRt"},
and \code{"file"} (for GFF3 or GTF files) are supported.}
\item{ucscGenome}{
The genome to use. \code{"hg19"} is the default. See \code{genome} parameter of
\code{\link[txdbmaker]{makeTxDbFromUCSC}} function of 
\code{txdbmaker} library for more information.}
\item{ucscTableName}{
The UCSC table name to use. See \code{tablename} parameter of 
\code{\link[txdbmaker]{makeTxDbFromUCSC}} function of 
\code{txdbmaker} library for more information.}
\item{ucscUrl}{
The UCSC URL address.  See \code{url} parameter of 
\code{\link[txdbmaker]{makeTxDbFromUCSC}} function of 
\code{txdbmaker} library for more information.}
\item{u12IntronsChr}{
A vector of character strings that includes chromsomal locations of the U12 
type introns. If defined together with \code{u12IntronsBeg} and 
\code{u12IntronsBeg}, they would be used to annotate the U12-type introns.}
\item{u12IntronsBeg}{
A vector of numbers that defines the begin (or start) coordinates of the 
u12-type introns.}
\item{u12IntronsEnd}{
A vector of numbers that defines the end coordinates of the u12-type introns.}
\item{u12IntronsRef}{
A GRanges object that includes the coordinates of the U12 type introns. If 
defined, it would be used to annotate the U12-type introns.}
\item{biomart}{
BioMart database name. See \code{biomart} parameter of 
\code{\link[txdbmaker]{makeTxDbFromBiomart}} function of 
\code{txdbmaker} library for more information.}
\item{biomartDataset}{
BioMart dataset name; default is "hsapiens_gene_ensembl". See \code{dataset} 
parameter of \code{\link[txdbmaker]{makeTxDbFromBiomart}} function of 
\code{txdbmaker} library for more information.}
\item{biomartTranscriptIds}{
optional parameter to only retrieve transcript annotation results for a defined
set of transcript ids. See \code{transcript_ids} parameter of 
\code{\link[txdbmaker]{makeTxDbFromBiomart}} function of 
\code{txdbmaker} library for more information.}
\item{biomartExtraFilters}{
A list of names; i.e. additional filters to use in the BioMart query. See 
\code{filters} parameter of \code{\link[txdbmaker]{makeTxDbFromBiomart}} 
function of \code{txdbmaker} library for more information.}
\item{biomartIdPrefix}{
A list of names; i.e. additional filters to use in the BioMart query. See 
\code{id_prefix} parameter of 
\code{\link[txdbmaker]{makeTxDbFromBiomart}} function of 
\code{txdbmaker} library for more information.}
\item{biomartHost}{ 
Host to connect to; the default is "www.ensembl.org". For older versions of the
GRCH you can provide the archive websites, e.g. for GRCH37 you can use 
"grch37.ensembl.org".}
\item{biomartPort}{
The port to use in the HTTP communication with the host. Default is 80.}
\item{circSeqs}{
A character vector that includes chromosomes that should be marked as circular.
See \code{circ_seqs} parameter of 
\code{\link[txdbmaker]{makeTxDbFromBiomart}} and 
\code{\link[txdbmaker]{makeTxDbFromUCSC}} functions of 
\code{txdbmaker} library for more information.}
\item{taxonomyId}{
This parameter can be used to provide taxonomy Ids. It is set to NA by default.
You can check the taxonomy Ids with the \code{available.species()} function in 
\code{GenomeInfoDb} package. For more information see \code{taxonomyId} 
parameter of \code{\link[txdbmaker]{makeTxDbFromBiomart}} and 
\code{\link[txdbmaker]{makeTxDbFromUCSC}} functions of 
\code{txdbmaker} library.}
\item{filePath}{
Character string i.e. the path to file. Used if \code{sourceBuild} is 
\code{"file"}. }
\item{fileFormat}{
The format of the input file. \code{"auto"}, \code{"gff3"} and \code{"gtf"} is
supported. }
\item{fileDatSrc}{
Character string describing the source of the data file. Used if 
\code{sourceBuild} is \code{"file"}.}
\item{fileOrganism}{
The genus and species name of the organism. Used if \code{sourceBuild} is 
\code{"file"}.}
\item{fileChrInf}{
Dataframe that includes information about the chromosome. The first column 
represents the chromosome name and the second column is the length of the 
chromosome. Used if \code{sourceBuild} is \code{"file"}.}
\item{fileDbXrefTag}{
A vector of chracater strings which if defined it would be used as feature 
names. Used if \code{sourceBuild} is \code{"file"}.}
\item{addCollapsedTranscripts}{
Whether add a column that includes the collapsed transcripts information. Used 
if \code{collapseExons} is \code{TRUE}.}
\item{ignore.strand}{
Whether consider the strands in the reference. If set \code{TURE} the strands 
would be ingnored.}
}
\value{
Data frame that includes the coordinates and annotations of the introns and 
exons of the transcripts, i.e. the reference.
}

\author{Ali Oghabian}
\examples{

	# Build test gff3 data
	tmpGen<- u12[u12[,"ens_trans_id"]=="ENST00000413811",]
	tmpEx<-tmpGen[tmpGen[,"int_ex"]=="exon",]
	exonDat<- cbind(tmpEx[,3], ".", 
		tmpEx[,c(7,4,5)], ".", tmpEx[,6], ".",paste("ID=exon", 
		tmpEx[,11], "; Parent=ENST00000413811", sep="") )
	trDat<- c(tmpEx[1,3], ".", "mRNA", as.numeric(min(tmpEx[,4])), 
		as.numeric(max(tmpEx[,5])), ".", tmpEx[1,6], ".", 
		"ID=ENST00000413811")

	outDir<- file.path(tempdir(),"tmpFolder")
	dir.create(outDir)
	outDir<- normalizePath(outDir)

	gff3File=paste(outDir, "gffFile.gff", sep="/")

	cat("##gff-version 3\n",file=gff3File, append=FALSE)
	cat(paste(paste(trDat, collapse="\t"),"\n", sep=""),
		file=gff3File, append=TRUE)

	write.table(exonDat, gff3File,
		row.names=FALSE, col.names=FALSE,
		sep='\t', quote=FALSE, append=TRUE)	

	# Selecting U12 introns info from 'u12' data
	u12Int<-u12[u12$int_ex=="intron"&u12$int_type=="U12",]

	# Test the function
	refseqRef<- referencePrepare (sourceBuild="file", 
		filePath=gff3File, u12IntronsChr=u12Int[,"chr"], 
		u12IntronsBeg=u12Int[,"begin"], 
		u12IntronsEnd=u12Int[,"end"], collapseExons=TRUE, 
		fileFormat="gff3", annotateGeneIds=FALSE)
}

\name{applyOverlap}
\alias{applyOverlap}
\title{Apply function over counts}
\description{ 
Runs a function on columns of the counts (assay) of a 'SummarizedExperiment'
object (resulted by \code{interest()}, \code{interest.sequential()} or 
\code{readInterestResults()} ) based on the overalp of its exon/intron
coordinates with those of another 'SummarizedExperiment' object. The number of
the rows and the dimensions of the counts of the result are equal to those of
the \code{subject}. The function is applied on the query based on it's overlap
to the subject.}
\usage{
applyOverlap(
	query,
	subject,
	type="any",
	replaceValues=FALSE,
	intExCol="int_ex", 
	intronExon="intron",
	sujectGeneNamesCol,
	repeatsTableToFilter=c(),
	scaleFragment=TRUE,
	scaleLength=TRUE,
	unmapValue=0,
	FUN=mean,
	...
)
}
\arguments{
\item{query, subject}{
SummarizedExperiment objects resulted by \code{interest()}, 
\code{interest.sequential()} or \code{readInterestResults()} functions. }

\item{type}{
The type of overlap. By default it considers any overlap. See
\link[IRanges]{findOverlaps-methods} for more info.}

\item{replaceValues}{
Whether return a 'SummarizedExperiment' object with new counts (resulted by 
running function) replaced.}

\item{intExCol}{
Column name (or number) in the rowData of the objects that represents whether 
each row of the assay is "intron" or "exon".}

\item{intronExon}{
Should be assigned either \code{'intron'} or \code{'exon'} or 
\code{c('intron','exon')} based on whether match the PWM to the intronic, 
exonic, or intronic and exonic regions of the reference. By default it seeks 
matches in intronic regions (intronExon='intron').}

\item{sujectGeneNamesCol}{
The column in the row data of the subject that includes the gene names.}

\item{repeatsTableToFilter}{A data.frame  table  that includes chr,begin and
end columns. If defined, all reads mapped to the described regions will be 
ingnored.
}

\item{scaleFragment}{ 
Logical value, indicating whether the retention levels must be scaled by 
(genewide) fragment levels.}

\item{scaleLength}{
Logical value, indicating whether the retention levels must be scaled by 
length of the introns/exons.}

\item{unmapValue}{
The value to assign to unmapped rows (i.e. introns/exons).}

\item{FUN}{
The function to apply.}

\item{...}{
Other parameter settings from \code{aggregate()} function.}

}
\value{
The returned value is a data frame if \code{replaceValues} is FALSE and it is 
SummarizedExperiment if \code{replaceValues} is TRUE.
}
\seealso{
	\code{\link{readInterestResults}}
	\code{\link{interest}}
	\code{\link{interest.sequential}}
}

\author{Ali Oghabian}

\examples{

mdsChr22Obj

tmp<- applyOverlap(
	query=mdsChr22Obj,
	subject=mdsChr22Obj,
	type="equal",
	replaceValues=FALSE,
	intExCol="int_ex", 
	intronExon="intron",
	sujectGeneNamesCol="collapsed_transcripts",
	scaleFragment=TRUE,
	scaleLength=TRUE,
	unmapValue=0,
	FUN=head,
	n=1
)

}

\name{readInterestResults}
\alias{readInterestResults}
\title{
	Read interest/interest.sequential results text files
}
\description{
Reads one or multiple text file results generated by the \code{\link{interest}}
or \code{\link{interest.sequential}} functions and builds an object of 
\code{\link[SummarizedExperiment]{SummarizedExperiment-class}} class. 
}
\usage{
readInterestResults(resultFiles, sampleNames, 
	sampleAnnotation, commonColumns, freqCol, scaledRetentionCol,
	scaleLength, scaleFragment, reScale=FALSE, geneIdCol, 
	repeatsTableToFilter=c())
}
\arguments{
\item{resultFiles}{ 
Vector of character strings which includes the path to the tab-separated files 
resulted by the \code{\link{interest}} function.
}
\item{sampleNames}{
Vector of character strings which includes the  name of the samples. It should 
be the same size as the \code{resultFiles} parameter. 
}
\item{sampleAnnotation}{
Data frame with the same row number as the size of \code{resultFiles} and  
\code{sampleNames} parameter. The column names represent the annotation names 
and values in each column represent the annotations of the samples.
}
\item{commonColumns}{
Columns in the result file which include intron/exon annotations and are common
across all files defined in \code{resultFiles}.
}
\item{freqCol}{
Column in the result file which include the read counts for introns/exons.
}
\item{scaledRetentionCol}{
Column in the result file which include the scaled retention values for 
introns/exons.
}
\item{scaleLength}{
Logical value, indicating whether the intron/exon retention levels are scaled
to the length of the introns/exons. If \code{reScale} is \code{TRUE} the scaled
retention levels would be rescalculated when reading the data. 
}
\item{scaleFragment}{
Logical value, indicating whether the intron/exon retention levels are scaled
to the fragments mapped to the genes. If \code{reScale} is \code{TRUE} the 
scaled retention levels would be rescalculated when reading the data.
}
\item{reScale}{
Logical value, indicating whether the scaled retention levels would be 
rescalculated when reading the data. By default it does not calculate and 
trusts the user to set the \code{scaleLength} and \code{scaleFragment} 
parameters correctly, i.e. as it was set in the \code{interest()} or 
\code{interest.sequential()} analysis.
}
\item{geneIdCol}{
The number or name of the column in \code{resultFiles} which represents the 
gene/transcript names. It would be used for summing up the number of mapped 
fragments to the genes when scaling the retention levels. It is only used if 
\code{reScale} and \code{scaleFragment} arguments are set \code{TRUE}.}
\item{
repeatsTableToFilter}{A data.frame table with similar stucture to the 
\code{reference}. It includes \code{chr}, \code{begin}, and \code{end} columns.
If defined, all reads mapped to the described regions would be ingnored and the
Intron/exon lengths would be corrected to exclude the to exclude the regions 
with repetitive DNA sequences. See \code{\link{getRepeatTable}}. It is only 
used if \code{reScale} and \code{scaleLength} arguments are set \code{TRUE}.}
}
\value{
An object of calss 
\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}.
}

\seealso{
	\code{\link{interest}},
	\code{\link{InterestResult}}.
}

\author{Ali Oghabian}

\examples{


geneId<- paste("gene", c(rep(1,7), rep(2,7), rep(3,7), rep(4,7)), 
	sep="_")
readCnt1<- sample(1:100, 28)
readCnt2<- sample(1:100, 28)
readCnt3<- sample(1:100, 28)
readCnt4<- sample(1:100, 28)
fpkm1<- readCnt1/(tapply(readCnt1, geneId, sum))[geneId]
fpkm2<- readCnt2/(tapply(readCnt2, geneId, sum))[geneId]
fpkm3<- readCnt3/(tapply(readCnt3, geneId, sum))[geneId]
fpkm4<- readCnt4/(tapply(readCnt4, geneId, sum))[geneId]

#Create tmp director
tmpDir=file.path(tempdir(),"InterestResult")
dir.create(tmpDir)

# Build text files similar to files resulted by interest
dfTmp=data.frame( 
		int_ex=rep(c(rep(c("exon","intron"),3),"exon"),4),
		int_ex_num= rep(c(1,1,2,2,3,3,4),4),         
		int_type=rep(c(NA,"U2",NA,"U12",NA,"U2",NA),4),
		strand=rep("*",28),
		gene_id= geneId,
		sam1_readCnt=readCnt1,
		sam2_readCnt=readCnt2,
		sam3_readCnt=readCnt3,
		sam4_readCnt=readCnt4,
		sam1_fpkm=fpkm1,
		sam2_fpkm=fpkm2,
		sam3_fpkm=fpkm3,
		sam4_fpkm=fpkm4
)

writeDf<-function(df, file){
	write.table(df, file, col.names=TRUE, 
		row.names=FALSE, quote=FALSE, sep='\t')
}

writeDf(dfTmp[, c(1:5,6,10)], paste(tmpDir, "df1.tsv", sep="/"))
writeDf(dfTmp[, c(1:5,7,11)], paste(tmpDir, "df2.tsv", sep="/"))
writeDf(dfTmp[, c(1:5,8,12)], paste(tmpDir, "df3.tsv", sep="/"))
writeDf(dfTmp[, c(1:5,9,13)], paste(tmpDir, "df4.tsv", sep="/"))

# Build object from generated text file results
testObj<-readInterestResults(
	resultFiles=paste(tmpDir, 
		c("df1.tsv", "df2.tsv", "df3.tsv", "df4.tsv"), sep="/"), 
	sampleNames=c("sam1","sam2","sam3","sam4"), 
	sampleAnnotation= data.frame( gender=c("M","M","F","F"),
		health=c("healthy","unhealthy","healthy","unhealthy")), 
	commonColumns=1:5, freqCol=6, scaledRetentionCol=7, 
	scaleLength=FALSE, scaleFragment=TRUE, reScale=FALSE)

#View object
testObj


}

\name{u12Boxplot}
\alias{u12Boxplot}
\title{
	U12 boxplot
}
\description{
A boxplot method for U12 and U2-type introns of \code{SummarizedExperiment} 
objects.
}
\usage{
u12Boxplot(x, sampleAnnoCol=NA, intExCol="int_ex",
	intTypeCol="int_type", intronExon, col="white",
	boxplotNames=c(), lasNames=3, outline=FALSE, addGrid=FALSE, ...)
}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{sampleAnnoCol}{
Which colummn of \code{colData} in \code{x} to consider for plotting.
}
\item{intExCol}{
Column name (or number) that represents whether each row of \code{x} assays is 
"intron" or "exon".
}
\item{intTypeCol}{
Column name (or number) that represents what type of intron each row of 
\code{x} assays represents.
}
\item{intronExon}{
Whether plot intron retention (set \code{intronExon="intron"}) or exon-exon 
junction (set \code{intronExon="exon"}) levels. 
}
\item{col}{
Vector showing box colours. It is either of size 1 or the same size as the 
number of groups to be plotted.
}
\item{boxplotNames}{
Names to write under boxes. If not defined, as names, it pastes U12/U2 (intron 
annotation) to the sample group annotations separated by a space " ".
}
\item{lasNames}{
Orientation of the box names.
}
\item{outline}{
If outline is TRUE the outlier points are drawn otherwise if FALSE (default) 
they are not.
}
\item{addGrid}{ 
Whether add a grid under the boxplots (FALSE by default). 
}
\item{...}{
Other arguments to pass to the \code{boxplot()} function.
}
}
\value{
A \code{SummarizedExperiment} object.
}

\seealso{
	\code{\link{u12BoxplotNb}}
}

\author{Ali Oghabian}

\examples{


u12Boxplot(mdsChr22Obj, sampleAnnoCol="type", 
    intExCol="int_ex",  intTypeCol="intron_type", intronExon="intron", 
    col=rep(c("orange", "yellow"),3) ,  lasNames=3, 
    outline=FALSE, ylab="FPKM", cex.axis=0.8)

}

\name{mdsChr22Obj}
\alias{mdsChr22Obj}
\docType{data}
\title{
	Object of SummarizedExperiment type for intron retention MDS data
}
\description{
The Results of \code{interest()} analysis in Intron-retention mode, for the 
genes that feature U12-type introns and are located on Chr22 in MDS data.
}
\usage{data(mdsChr22Obj)}
\format{
An Object of class \code{SummarizedExperiment} that contains intron retention 
results generated by \code{interest()} function on MDS data consisting of 
bone-marrows samples of 8 MDS patients with ZRSR2 mutations, 4 patients without
the mutation and 4 healthy individuals.
  \describe{
    \item{\code{@colData}}{A "DataFrame" (from "S4Vectors" package) that its 
	rownames can be set as the sample identification names and the other 
	columns are various annotations for the samples. Its column names are 
	characters that describe the annotations.}
   \item{\code{@assays}}{List of size 2 that includes two numeric matrices: 
	\code{counts} that includes raw read counts of the sequencing reads 
	mapped to introns and exons, and (2) \code{scaledRetention}, i.e. the 
	normalized read counts.}
   \item{\code{@NAMES}}{A NULL value.}
	\item{\code{@elementMetadata}}{A "DataFrame" (from "S4Vectors" package) 
	that include intron and exon annotations.}
	\item{\code{@metadata}}{A list of size 2 that includes parameter settings 
	for the \code{interest()} and \code{interest.sequential()} runs.}
  }
}
\value{
Object of class \code{SummarizedExperiment}. 
}
\source{
Madan, V., et.al.,  Aberrant splicing of U12-type introns is the hallmark of 
ZRSR2 mutant myelodysplastic syndrome. Nat Communication 2015 Jan 14;6:6042. 
doi: 10.1038/ncomms7042.
}
\keyword{datasets}

\name{intexIndex}
\alias{intexIndex}
\title{
	Extract index of intron or exon rows
}
\description{
Extract row numbers where introns (or exons dependant on user's request) 
are located in an object of type \code{SummarizedExperiment}.
}
\usage{
intexIndex(x, intExCol="int_ex", what="intron")
}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{intExCol}{
Column name (or number) that represents whether each row is "intron" or "exon"
 in \code{rowData} of \code{x}.
}
\item{what}{
A character string that defines whether the index for the introns or exons 
should be returned. Accepts either \code{"exon"} or \code{"intron"} (default)
as values.
}

}
\value{
A numeric vector which includes the index of the introns/exons.
}

\seealso{
	\code{\link{u12NbIndex}}
}

\author{Ali Oghabian}

\examples{

# Show the few first index of rows that represent the introns
head(intexIndex(mdsChr22Obj, what="intron"))

}

\name{interestResultIntEx}
\alias{interestResultIntEx}
\title{
Building results object that contains Intron-retention and exon-exon junction
information
}
\description{
Building \code{\link[SummarizedExperiment]{SummarizedExperiment-class}} object
from an intron retention and an exon-exon junction results in IntEREst. The 
average of the junction levels are added to the SummerizedExperiment object of
the intron retentions.

}
\usage{

interestResultIntEx (intObj, exObj, intExCol=c(), 
	mean.na.rm=TRUE, postExName="ex_junc" )

}
\arguments{
\item{intObj}{
A \code{SummarizedExperiment} including intron retention information.
}
\item{exObj}{
A \code{SummarizedExperiment} including exon-exon junction information.
}
\item{intExCol}{
Column name (or number) in the \code{rowData} of the intron object that 
represents whether each row of \code{x} assays is "intron" or "exon".
}
\item{mean.na.rm}{
Whether exclude missing values when measuring the mean.
}
\item{postExName}{
The postfix to use for the column names of the exons junction values in the
}
}
\value{
Returns an object of class \code{SummarizedExperiment}. 
}
\seealso{
	\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}
	\code{\link{attributes}}
	\code{\link{addAnnotation}}
	\code{\link{counts-method}}
	\code{\link{plot-method}}
}

\author{Ali Oghabian}

\examples{

testIntObj<- InterestResult(
		resultFiles= paste(paste("testFile",1:3, sep="_"),"bam", sep="."), 
		counts= matrix(1:15, ncol=3, nrow=5, byrow=TRUE, 
			dimnames= list(c(), paste("s", 1:3, sep="_"))), 
		scaledRetention= matrix(1:15, ncol=3, nrow=5, byrow=TRUE, 
			dimnames= list(c(), paste("s", 1:3, sep="_"))), 
		scaleLength= FALSE, 
		scaleFragment= FALSE, 
		sampleAnnotation= data.frame(
			files=paste(paste("testFile",1:3, sep="_"),"bam", sep="."),
			names=paste("s", 1:3, sep="_"),
			row.names=paste("s", 1:3, sep="_")), 
		rowData=data.frame(id= paste("i", 1:5, sep="_"),
			chr= rep("chr1", 5),
			begin=seq(100, by=100, length.out=5 ),
			end=seq(110, by=100, length.out=5 ),
			strand=rep("+",5))
	)

testExObj<- InterestResult(
		resultFiles= paste(paste("testFile",1:3, sep="_"),"bam", sep="."), 
		counts= matrix(1:30, ncol=3, nrow=10, byrow=TRUE, 
			dimnames= list(c(), paste("s", 1:3, sep="_"))), 
		scaledRetention= matrix(1:30, ncol=3, nrow=10, byrow=TRUE, 
			dimnames= list(c(), paste("s", 1:3, sep="_"))), 
		scaleLength= FALSE, 
		scaleFragment= FALSE, 
		sampleAnnotation= data.frame(
			files=paste(paste("testFile",1:3, sep="_"),"bam", sep="."),
			names=paste("s", 1:3, sep="_"),
			row.names=paste("s", 1:3, sep="_")), 
		rowData=data.frame(id= paste("e", 1:10, sep="_"),
			chr= rep("chr1", 10),
			begin= c(seq(90, by=100, length.out=5),
				seq(111, by=100, length.out=5)),
			end= c(seq(99, by=100, length.out=5),
				seq(120, by=100, length.out=5 )),
			strand=rep("+",10))
	)


(testIntExObj<- interestResultIntEx(intObj=testIntObj, exObj=testExObj, 
	mean.na.rm=TRUE, postExName="ex_junc" ) )

}

\name{u12NbIndex}
\alias{u12NbIndex}
\title{
	Extract index of U2 introns (up/down)stream of U12 introns rows
}
\description{
Extract row numbers of U2-type introns (up/down)stream of U12-type introns (in 
the \code{@interestDf} attribute of an object of class 
\code{SummarizedExperiment}).
}
\usage{
u12NbIndex(x, intExCol="int_ex", intTypeCol="int_type", 
	strandCol="strand", geneIdCol="collapsed_transcripts", 
	naUnstrand=FALSE)
}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{intExCol}{
Column name (or number) that represents whether each row of \code{x} assays is 
"intron" or "exon".
}
\item{intTypeCol}{
Column name (or number) that represents what type of intron each row of 
\code{x} assays represents.
}
\item{strandCol}{
Column name (or number) that represents the strand of each row of assays in
\code{x}. The values in the column are either "+", "-" or "*".
}
\item{geneIdCol}{
Column name (or number) that represents the gene ID of each row of assays in
\code{x}.
}
\item{naUnstrand}{
Replace unstranded results, i.e. introns or exon with "*" strand, with NA. If 
set as FALSE (default) "*" strand would be same as "+" strand.
}

}
\value{
\item{upIntron}{
A numeric vector which includes the index of U2-type intron upstream the 
U12-type introns.
}
\item{downIntron}{
A numeric vector which includes the index of U2-type intron downstream the 
U12-type introns.
}
\item{upExon}{
A numeric vector which includes the index of exon upstream the U12-type 
introns.
}
\item{downExon}{
A numeric vector which includes the index of exon downstream the U12-type 
introns.
}
}

\seealso{
	\code{\link{u12Index}}
}

\author{Ali Oghabian}

\examples{


head(u12NbIndex(mdsChr22Obj, intExCol="int_ex", 
	intTypeCol="intron_type", strandCol="strand", 
	geneIdCol="collapsed_transcripts_id", naUnstrand=FALSE))
# Return NA if no strand information available
head(u12NbIndex(mdsChr22Obj, intExCol="int_ex", 
	intTypeCol="intron_type", strandCol="strand", 
	geneIdCol="collapsed_transcripts_id", naUnstrand=TRUE))

}

\name{psi}
\alias{psi}
\title{
	Psi values estimation
}
\description{
Calculating the relative inclusion level of intron or Psi values base on two 
count matrices from a single or two separate objects. The values for each 
intron is in the range of [0,1], where 0 means complete splicing or no 
retention of the intron and 1 represnet complete 100% retention of the intron.
}
\usage{
psi (x, y, intCol, exCol, pseudoCnt=0)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{y}{ 
	Optional; i.e. an object of type \code{SummarizedExperiment}.
}

\item{intCol}{
Column numbers or column names in counts matrix of \code{x} which include the 
number of reads mapped to the introns.}
\item{exCol}{
Column numbers or column names in counts matrix of \code{x} (or if defined 
\code{y}) which include the number of reads spanning the introns (or mapping
exons flanking the introns).
}
\item{pseudoCnt}{Pseudo counts to sum to the denominator of the devision to 
avoid devision to zero.
}

}
\value{
data.frame with column size equal to the size of \code{intCol} parameter, and
row size equal to the number of rows in \code{x}. It contains the psi values 
(i,e.values between 0 and 1 showing the fraction of spliced in transcripts).
}

\seealso{
	\code{\link{interestResultIntEx}}
}

\author{Ali Oghabian}

\examples{

mdsChr22IntObj<- mdsChr22Obj[which(rowData(mdsChr22Obj)$int_ex=="intron"), ]

#Build object including intron-retention and exon-junction results
mdsChr22RefIntExObj<- interestResultIntEx(intObj=mdsChr22Obj, 
	exObj=mdsChr22ExObj, mean.na.rm=TRUE, postExName="ex_junc", 
	intExCol="int_ex" )
# Calculate Psi
psiRes<- psi(mdsChr22RefIntExObj,
	intCol=which(colData(mdsChr22RefIntExObj)$intronExon=="intron"),
	exCol=which(colData(mdsChr22RefIntExObj)$intronExon=="exon"))
# show Psi results
head(psiRes)
}

\name{IntEREst-package}
\alias{IntEREst-package}
\alias{IntEREst}
\docType{package}
\title{
IntEREst
}
\description{
Intron/Exon retention estimator quantifies and normalizes Intron retention and 
Exon junction read levels by analyzing mapped reads (.bam) files.
}
\details{
\tabular{ll}{
Package: \tab IntEREst\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2015-11-18\cr
License: GPL-2
}
To run the pipeline use functions \code{interest()} or 
\code{interest.sequential()}, i.e. wrapper functions that run all the necessary
functions.
}
\author{
Ali Oghabian <Ali.Oghabian@Helsinki.Fi>, 
Dario Greco <dario.greco@helsinki.fi>, 
Mikko Frilander <Mikko.Frilander@helsinki.fi>

Maintainer: Ali Oghabian <Ali.Oghabian@Helsinki.Fi>,
Mikko Frilander <Mikko.Frilander@helsinki.fi>
}

\keyword{package} 
\keyword{expression} 
\keyword{sequencing}
\keyword{splicing}
\keyword{rna-seq} 
\keyword{intron} 
\keyword{retention}

\name{addAnnotation}
\alias{addAnnotation}
\title{
	Adding sample annotations to a \code{SummarizedExperiment} object
}
\description{
Adds a new sample annotation to the \code{SummarizedExperiment} object. In 
other words it adds and column with sample annotations to the colData of the 
\code{SummarizedExperiment} object. 
}
\usage{
addAnnotation(x, sampleAnnotationType, sampleAnnotation)

}
\arguments{
\item{x}{ 
Object of type \code{SummarizedExperiment}.
}
\item{sampleAnnotationType}{
The name of the new column to be added to the \code{colData} table of 
\code{SummarizedExperiment} object.
}
\item{sampleAnnotation}{
Vector with the same length as the row-size of the \code{colData} attribute of 
the \code{SummarizedExperiment} object, which includes the sample annotations.
}

}
\value{
An InterestResult object.
}

\seealso{
	\code{\link{getAnnotation}}
}

\author{Ali Oghabian}

\examples{
# Check the annotation table of mdsChr22Obj data
getAnnotation(mdsChr22Obj)

# Add a new sample annotation
newMdsChr22Obj <- addAnnotation(x=mdsChr22Obj,
	sampleAnnotationType="sample_number",
	sampleAnnotation=1:16
)

# Retrieve annotations of the new object
getAnnotation(newMdsChr22Obj)

}

\name{pwmU12db}
\alias{pwmU12db}
\docType{data}
\title{
	PWM of U12 and U2-type introns splice sites
}
\description{
PWM of U12 and U2-type introns splice sites and it is based on the U12DB 
database. 
}
\usage{data("pwmU12db")}
\format{
A list that contains Position Weight Matrices (PWM) of donor site, branch 
point and acceptor site of U12-type introns and the PWMs of donor site and 
acceptor site of U2-type introns. It is based on the U12DB database.
  \describe{
    \item{\code{pwmDonU12}}{
		A position weigh matrix for the donor site of the U12-type introns, 
		with 4 rows and 46 columns. The rows of the matrix represent "A", "C", 
		"G", and "T" nucleotides and the columns represent the postions in the 
		genome. Each position in the matrix include a weight (i.e. number 
		between 0 and 1) which indicates how common the corresponding base 
		(represented by the row of the matrix) is observed in the corerespoding
		position (represented by the colum of the matrix).}
    \item{\code{pwmBpU12}}{
		A position weigh matrix for the branch point of the U12-type introns, 
		with 4 rows and 9 columns.}
    \item{\code{pwmAccU12}}{
		A position weigh matrix for the acceptor site of the U12-type introns, 
		with 4 rows and 46 columns.}
    \item{\code{pwmDonU2}}{
		A position weigh matrix for the donor site of the U2-type introns, with
		4 rows and 25 columns.}
    \item{\code{pwmAccU2}}{
		A position weigh matrix for the acceptor site of the U12-type introns, 
		with 4 rows and 46 columns.}
  }
}
\value{
List of 5 numeric matrices representing the PWMs of donor site of U12-type 
introns, branch point site of U12-type introns, acceptor site of U12-type 
introns, donor site of U2-type introns, and acceptor site of U2-type introns.
}
\source{
Alioto, T.S. U12DB: a database of orthologous U12-type spliceosomal introns. 
Nucleic Acids Research 2006, doi: 10.1093/nar/gkl796
}
\keyword{datasets}

\name{deseqInterest}
\alias{deseqInterest}
\title{
	DESeq2 analysis for IntEREst object
}
\description{
	Differential intron retention test adapted from the \code{DESeq2} package. 
}
\usage{
deseqInterest (x, design, pAdjustMethod = "BH", 
	sizeFactor=c(), contrast, bpparam, ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{design}{
Formula specifying the design of the experiment. It must specify an interaction
term between variables from column names of \code{sampleData(x)}.}
\item{pAdjustMethod}{
What adjustment method to be sed on the p-values. See \link[stats]{p.adjust} 
for more information.}
\item{sizeFactor}{
Numeric vector with the same size as the clolumn size of the count matrix in 
\code{x}, if defined it will be used for scaling of the count matrix.}
\item{contrast}{
Argument speciftying the comparison to extract from \code{x}. See 
\code{\link[DESeq2]{results}} function in the \code{DESeq2} package for more
information.
}
\item{bpparam}{An optional \code{BiocParallelParam} instance defining the 
parallel back-end to be used. If not defined the function will run 
sequentially (on a single computing core).}
\item{...}{
Other parameter settings for the \link[DESeq2]{results} function 
in the \code{DESeq2} package.
}
}

\value{
 a \code{DESeqResults} object.
}
\seealso{
\code{\link{exactTestInterest}}
\code{\link{qlfInterest}}, 
\code{\link{treatInterest}}
\code{\link{DEXSeqIntEREst}}
}

\author{Ali Oghabian}

\examples{
mdsChr22IntObj<- mdsChr22Obj[rowData(mdsChr22Obj)$int_ex=="intron",]
deseqRes<- deseqInterest(x=mdsChr22IntObj, 
	design=~test_ctrl, contrast=list("test_ctrl_test_vs_ctrl"))

# Number of U12/U2 type significantly differential retained introns in chr22
table(rowData(mdsChr22Obj)[which(deseqRes$padj<.01), "intron_type"])
}

\name{interest}
\alias{interest}
\title{Wrapper function: Parallel run}
\description{
A read summarization function that countsns all the reads mapping to the 
introns/exons based on the users detailed parameter settings. The process can 
be run in parallel on multiple computing cores to improve it performance.}
\usage{
interest( bamFileYieldSize=1000000, bamFile, isPaired, 
	isPairedDuplicate=FALSE, isSingleReadDuplicate= NA, reference, 
	referenceGeneNames, referenceIntronExon, repeatsTableToFilter=c(),
	junctionReadsOnly=FALSE, outFile, logFile="", 
	returnObj= FALSE, method=c("ExEx", "IntRet", "IntSpan", "ExSkip"), 
	strandSpecific,
	bpparam, appendLogFile=FALSE, sampleName="",
	scaleLength= c(TRUE,FALSE), scaleFragment= c(TRUE,TRUE), 
	limitRanges=GRanges(),
	excludeFusionReads=FALSE,
	loadLimitRangesReads=FALSE, ...)
}
\arguments{
\item{bamFileYieldSize}{
Maximum number of pair reads in the temprorary files created as the result of 
dividing the input .bam file. }
\item{bamFile}{Path of the input bam file. }
\item{isPaired}{Whether the bam file is the result of a paired end sequencing
read mapping (TRUE) or not (FALSE).}
\item{isPairedDuplicate}{
Whether extract only (if set TRUE), filter (FALSE) or include (if set NA) PCR 
dupplicates for paired mapped reads. It uses the FLAG field in the bam file to 
filter the duplicate read. If the mapping software does not support detection 
and flaging the duplicate reads \code{dedup} tool of \code{BamUtil} or 
\code{MarkDuplicates} of \code{Picard} tools could be used.}
\item{isSingleReadDuplicate}{
Whether extract only (if set TRUE), filter (FALSE) or include (if set NA) PCR 
dupplicates for single mapped reads. }
\item{reference}{
Dataframe to be used as reference; It should at least contain three same-size 
vectors with the tag names \code{chr}, \code{begin}, and \code{end} which 
describe the exons and introns genome coordinates. It also accepts a 
\code{GRanges} object. To build a new reference check the 
\code{\link{referencePrepare}} function. }
\item{referenceGeneNames}{
A vector with the same size as the row-size of the reference which includes the
 gene names of the reference.}
\item{referenceIntronExon}{
A vector with the same size as the row-size of the reference with values 
"intron" and "exon" describing which (intron or exon) each row of the reference
represents.}
\item{repeatsTableToFilter}{
A data.frame table with similar stucture to the \code{reference}. It includes 
\code{chr}, \code{begin}, and \code{end} columns. If defined, all reads mapped 
to the described regions would be ingnored and the Intron/exon lengths would be
corrected to exclude the to exclude the regions with repetitive DNA sequences. 
See \code{\link{getRepeatTable}}.}
\item{junctionReadsOnly}{
The parameter is considered if the \code{method} is set as \code{IntRet} or 
\code{ExEx} (NOT \code{IntSpan}). It declares whether only consider the 
Intron-Exon or Exon-Exon junction reads and ignore the reads that fully map to 
exons or introns. By default this argument is set as FALSE.}
\item{outFile}{The name or path of the result file. }
\item{logFile}{
The log file path; if defined log information are written to the log file. }
\item{returnObj}{
If set \code{TRUE} in addition to making result text files, the results would 
also be returned as an object of class \code{SummarizedExperiment}.}
\item{method}{
A vector describing the summarization methods to use; i.e. whether count reads 
mapping to the introns (\code{IntRet}), reads mapping to the exons 
(\code{ExEx}), reads spanning the introns (\code{IntSpan}), or reads that skip
the exons (\code{ExSkip}). In \code{IntSpan} mode the introns in the reference
are taken into account only; whilst in \code{IntRet} the introns and their 
spanning exons, and in \code{ExEx} and \code{ExSkip} mode only the exons in the
reference are taken into account.}
\item{strandSpecific}{The description for strand specificity of the RNAseq data.
The values are either "unstranded", "stranded", or "reverse".If the reads are 
not strand specific or directional use "unstranded". If the first read in 
paired-read sequencing or the reads single-read sequencing is in the same 
direction as the the transcript strand use "stranded". If the first read in 
paired-read sequencing or the reads in single-read sequencing is in the oposite
direction to the transcript strand use "reverse".}
\item{bpparam}{An optional \code{BiocParallelParam} instance defining the 
parallel back-end to be used.}
\item{appendLogFile}{
Whether log information should be appended to the \code{logFile}. It is set 
\code{FALSE} by default.}
\item{sampleName}{
The name of the sample being analyzed. It will be included in the returned 
object if \code{returnObj} is \code{TRUE}.}
\item{scaleLength}{
A vector constructed of TRUE/FALSE values, same size as the 
\code{method} argument. It indcates whether the retention levels of the 
intron/exons should be scaled to their lengths.}
\item{scaleFragment}{
A vector constructed of TRUE/FALSE values, same size as the 
\code{method} argument. It indcates whether the retention levels of the 
intron/exons should be scaled to the sum of retention levels (i.e. mapped 
fragments) over the genes.}
\item{limitRanges}{ A GRanges object. If defined it loads sequencing reads that
fall in the defined coordinates. It is similar to \code{which} 
parameter in \code{\link[Rsamtools]{ScanBamParam}}.}
\item{excludeFusionReads}{Only valid if limitRanges is defined. It filters the
defined by \code{limitRanges}. It also filters the read pairs if each read pair
maps reads pairs where one of the reads either do not fall into one of the 
regions to a different region defined in \code{limitRanges}. It is useful to ignore 
analyzing the chimeric reads and fusion reads, i.e. reads that map to fusion 
genes. To filter properly, \code{limitRanges} must include coordinates of all
genes. }
\item{loadLimitRangesReads}{ Boolean (TRUE/FALSE) variable. If set as 
\code{TRUE} only the reads in the limitRanges are loaded from bam file (and 
\code{bamFileYieldSize} parameter will be ignored).}
\item{...}{
Other parameter settings specific to \code{\link[Rsamtools]{BamFile-class}} 
function in the \code{Rsamtools} package. Parameters \code{qnamePrefixEnd} and 
\code{qnameSuffixStart} are in particular useful to modify qnames in the BAM 
files.}
}
\value{
If \code{returnObj} is set \code{TRUE} in addition to making result text files,
dependant on whether a single or two \code{method} is defined, the results
would be returned as a single object of class \code{SummarizedExperiment} or as 
a list of size 2 which includes 2 objects of class \code{SummarizedExperiment} 
one for IntRet and the other for ExEx. 
}
\seealso{
  \code{\link{interest.sequential}}.
}

\author{Ali Oghabian}

\examples{

# Creating temp directory to store the results
outDir<- file.path(tempdir(),"interestFolder")
dir.create(outDir)
outDir<- normalizePath(outDir)

# Loading suitable bam file
bamF <- system.file("extdata", "small_test_SRR1691637_ZRSR2Mut_RHBDD3.bam", 
	package="IntEREst", mustWork=TRUE)

# Choosing reference for the gene RHBDD3
ref= u12[u12[,"gene_name"]=="RHBDD3",]

test= interest(
	bamFileYieldSize=10000,
	bamFile=bamF,
	isPaired=TRUE,
	isPairedDuplicate=FALSE,
	isSingleReadDuplicate=NA,
	reference=ref,
	referenceGeneNames=ref[,"ens_gene_id"],
	referenceIntronExon=ref[,"int_ex"],
	repeatsTableToFilter=c(),
	outFile=paste(outDir,
	    "interestRes.tsv", sep="/"),
	logFile=paste(outDir, 
	    "log.txt", sep="/"),
	method=c("IntRet", "IntSpan"),
	strandSpecific="unstranded",
	junctionReadsOnly=FALSE,
	returnObj=TRUE, 
	scaleLength= c(TRUE,FALSE), 
	scaleFragment= c(TRUE,TRUE)
)

test

}

\docType{methods}
\name{counts-method}
\alias{counts.InterestResults}
\alias{counts,SummarizedExperiment-method}
\alias{counts-method}

\title{
	Counts - method
}
\description{
	Returns the (row) number of reads that are mapped to introns/exons in 
	various samples.
}
\usage{
\S4method{counts}{SummarizedExperiment}(object)
}
\arguments{
\item{object}{ 
	Object of type \code{SummarizedExperiment}.
}
}
\value{
	Returns a numeric matrix.
}
\seealso{
Class:
	\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}


Method:
	 \code{\link{plot-method}}.
}
\author{Ali Oghabian}

\examples{
#Show contents of a InterestResults object included in IntEREst 
head(counts(mdsChr22Obj))

#Make a test InterestResults object
geneId<- paste("gene", c(rep(1,5), rep(2,5), rep(3,5), rep(4,5)), 
	sep="_")
readCnt1<- sample(1:100, 20)
readCnt2<- sample(1:100, 20)
readCnt3<- sample(1:100, 20)
readCnt4<- sample(1:100, 20)
fpkm1<- readCnt1/(tapply(readCnt1, geneId, sum))[geneId]
fpkm2<- readCnt2/(tapply(readCnt2, geneId, sum))[geneId]
fpkm3<- readCnt3/(tapply(readCnt3, geneId, sum))[geneId]
fpkm4<- readCnt4/(tapply(readCnt4, geneId, sum))[geneId]

# Creating object using test data
interestDat<- data.frame( 
		int_ex=rep(c(rep(c("exon","intron"),2),"exon"),4),
		int_ex_num= rep(c(1,1,2,2,3),4),         
		gene_id= geneId,
		sam1_readCnt=readCnt1,
		sam2_readCnt=readCnt2,
		sam3_readCnt=readCnt3,
		sam4_readCnt=readCnt4,
		sam1_fpkm=fpkm1,
		sam2_fpkm=fpkm2,
		sam3_fpkm=fpkm3,
		sam4_fpkm=fpkm4
)
readFreqColIndex<- grep("_readCnt$",colnames(interestDat))
scaledRetentionColIndex<- grep("_fpkm$",colnames(interestDat))

scalRetTmp<- as.matrix(interestDat[ ,scaledRetentionColIndex])
colnames(scalRetTmp)<-gsub("_fpkm$","", colnames(scalRetTmp))

frqTmp<- as.matrix(interestDat[ ,readFreqColIndex])
colnames(frqTmp)<-gsub("_readCnt$","", colnames(frqTmp))


InterestResultObj<- InterestResult(
	resultFiles=paste("file",1:4, sep="_"),
	rowData= interestDat[ , -c(readFreqColIndex, 
		scaledRetentionColIndex)],
	counts= frqTmp,
	scaledRetention= scalRetTmp,
	scaleLength=TRUE, 
	scaleFragment=FALSE,
	sampleAnnotation=data.frame(
		sampleName=paste("sam",1:4, sep=""),
		gender=c("M","M","F","F"),
		health=c("healthy","unhealthy","healthy","unhealthy")
		, row.names=paste("sam", 1:4, sep="")
	)
)

#Show 
head(counts(InterestResultObj))
}

\name{qlfInterest}
\alias{qlfInterest}
\title{
	quasi-likelihood F-test
}
\description{
Compute quasi-likelihood F-test using \code{edgeR} package. For more 
information see \code{glmQLFit} and \code{\link[edgeR]{glmQLFTest}} functions 
in \code{edgeR} package.
}
\usage{
	qlfInterest(x, design=c(), silent=TRUE, disp="common", 
		coef=c(), contrast=NULL, 
		poisson.bound=TRUE, ...)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
\item{design}{
	Design matrix.
}
\item{silent}{
Whether run silently, i.e. without printing the top differential expression
 tags. The default is TRUE.
}
\item{disp}{
The method of estimating the dispersion in the data. Available options are: 
"common", "trended", "tagwiseInitCommon" and "tagwiseInitTrended". It is also 
possible to assign a number.
}
\item{coef}{
Integer or character vector indicating which coefficients of the linear model 
are to be tested equal to zero. See \code{\link[edgeR]{glmQLFTest}} for more 
information.
}
\item{contrast}{
Numeric vector or matrix specifying contrasts of the linear model coefficients 
to be tested equal to zero. See \code{\link[edgeR]{glmQLFTest}} for more 
information.
}
\item{poisson.bound}{
Logical value, if TRUE (i.e. default) the pvalue would be higher than when 
obtained fom likelihood ratio test while Negative Binomial dispersion is zero.
}
\item{...}{
Other parameter settings for the \code{\link[edgeR]{glmQLFTest}} function in 
the \code{edgeR} package.
}

}
\value{
All values produced by \code{\link[edgeR]{glmQLFTest}} plus the following :
\item{dispersionType}{The name of the type of dispersion used.}
\item{dispersion}{The estimated dispersion values.}
}
\seealso{
\code{\link{exactTestInterest}}, \code{\link{glmInterest}}, 
\code{\link{treatInterest}}
}

\author{Ali Oghabian}

\examples{

#Test retention differentiation across the 3 types of sampels
group <- getAnnotation(mdsChr22Obj)[,"type"]
qlfRes<- qlfInterest(x=mdsChr22Obj, 
	design=model.matrix(~group), silent=TRUE, 
	disp="tagwiseInitTrended", coef=2:3, contrast=NULL)

qlfRes
}

\name{treatInterest}
\alias{treatInterest}
\title{
	Differential retention test relative to a threshold
}
\description{
Compute a genewise statistical test relative to a fold-change threshold using 
\code{edgeR} package. For more information see \code{\link[edgeR]{glmTreat}} 
function in \code{edgeR} package.
}
\usage{
	treatInterest(x, design=c(), silent=TRUE, disp="common", 
		coef=c(), contrast=NULL, lfc=0, ...)
}
\arguments{
\item{x}{ 
	Object of class \code{SummarizedExperiment}.
}
\item{design}{
	Design matrix.
}
\item{silent}{
Whether run silently, i.e. without printing the top differential expression 
tags. Default is TRUE.
}
\item{disp}{
The method of estimating the dispersion in the data. Available options are: 
"common", "trended", "tagwiseInitCommon" and "tagwiseInitTrended". It is also 
possible to assign a number.
}
\item{coef}{
Integer or character vector indicating which coefficients of the linear model 
are to be tested equal to zero. See \code{\link[edgeR]{glmTreat}} for more 
information.
}
\item{contrast}{
Numeric vector or matrix specifying contrasts of the linear model coefficients 
to be tested equal to zero. See \code{\link[edgeR]{glmTreat}} for more 
information.
}
\item{lfc}{
	Numeric scalar i.e. the log fold change threshold. 
}
\item{...}{
Other parameter settings for the \code{glmFit} function in the \code{edgeR} 
package.
}

}
\value{
All values produced by \code{\link[edgeR]{glmTreat}} plus the following :
\item{dispersionType}{The name of the type of dispersion used.}
\item{dispersion}{The estimated dispersion values.}
}
\seealso{
\code{\link{exactTestInterest}}, \code{\link{qlfInterest}}, 
\code{\link{glmInterest}}
}

\author{Ali Oghabian}

\examples{

group <- getAnnotation(mdsChr22Obj)[,"type"]

#Test retention differentiation across the 3 types of sampels 
# The log fold change threshold is 0
treatRes<- treatInterest(x=mdsChr22Obj, 
	design=model.matrix(~group), silent=TRUE, 
	disp="tagwiseInitTrended", coef=2:3, contrast=NULL, lfc=0)
treatRes
}

\name{attributes}
\alias{attributes}
\alias{getAnnotation}
\alias{scaledRetention}

\title{
 Extracting values of useful attributes of SummarizedExperiment objects
}
\description{
Several functions are provided that can extract various attribnutes from an 
object of class \code{SummarizedExperiment} generated by IntEREst functions, 
e.g. \code{interest()}, \code{interest}, and \code{readInterestResults}. It is 
possible to extract sample annotations using \code{getAnnotation} function. 
One can also extract the scaled retention levels of the introns/exons using 
\code{scaledRetention()} function. Notes that \code{colData} and \code{rowData} 
methods of \code{SummarizedExperiment} class can also be used to extract row 
and column data.
}
\usage{
getAnnotation(x)
scaledRetention(x)
}
\arguments{
\item{x}{ 
	Object of type \code{SummarizedExperiment}.
}
}
\value{
Various data types (data.frame/vector) dependent on the function used. See the 
"Description" for more information.
}
\seealso{
	\code{\link[SummarizedExperiment]{SummarizedExperiment-class}}
	\code{\link{addAnnotation}}
	\code{\link{counts-method}}
	\code{\link{plot-method}}
}

\author{Ali Oghabian}

\examples{

# Retrieve the sample annotations from mdsChr22Obj
getAnnotation(mdsChr22Obj)
# Retrieving the scaled retention levels from mdsChr22Obj
head(scaledRetention(mdsChr22Obj))

#for row and column data SummarizedExperiment methods can be used
head(rowData(mdsChr22Obj))
colData(mdsChr22Obj)

}

\name{buildSsTypePwms}
\alias{buildSsTypePwms}
\title{
Building Position Weight Matrices for Splice Sites of U12 and U2 type introns.
}
\description{ 
Builds position Weigh Matrices for the donor and acceptor sites of the U12 and 
U2 type introns, and the branchpoint of the U12 type introns. if 
\code{pdfFileSeqLogos} is defined a pdf is also produced that contains the 
sequence logos of the results. The result is a list that contains PWMs of the 
splice sites of U12 and U2 dependent introns.}
\usage{
buildSsTypePwms( cexSeqLogo=1, pdfWidth=35, pdfHeight=10, tmpDir="./",
	u12dbSpecies="Homo_sapiens", 
	pwmSource="U12DB", 
	u12DonorBegin, u12BranchpointBegin, u12AcceptorBegin, 
	u2DonorBegin, u2AcceptorBegin, u12DonorEnd, 
	u12BranchpointEnd, u12AcceptorEnd, u2DonorEnd, 
	u2AcceptorEnd, pasteSites=FALSE,
	splicerackSsLinks=list(
		U12_AT_AC_donor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.25", 
		U12_AT_AC_branchpoint=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.26",
		U12_AT_AC_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.29",
		U12_GT_AG_donor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.22", 
		U12_GT_AG_branchpoint=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.27",
		U12_GT_AG_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.21",
		U2_GC_AG_donor="http://katahdin.mssm.edu/splice/out/9606_logo_file.24",
		U2_GC_AG_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.30", 
		U2_GT_AG_donor="http://katahdin.mssm.edu/splice/out/9606_logo_file.23",
		U2_GT_AG_acceptor=
			"http://katahdin.mssm.edu/splice/out/9606_logo_file.28"),
	u12dbLink="https://genome.crg.cat/pub/software/u12/u12db_v1_0.sql.gz",
	u12dbDbName="u12db", u12dbDropDb=TRUE,  pdfFileSeqLogos="", 
	removeTempFiles=TRUE, ...)
}
\arguments{
\item{cexSeqLogo}{
Font size of sequence logo plots; used only if  \code{pdfFileSeqLogos} is 
defined.}
\item{pdfWidth, pdfHeight}{
The width and height of the graphics region of the pdf in inches. The default 
values are 35 and 10. }
\item{tmpDir}{Path to directory used for storing temporary files.}
\item{u12dbSpecies}{ 
What species data to use when  getting the data from the U12DB database 
(\code{pwmSource="U12DB"}).}
\item{pwmSource}{ 
The source used to buildSplice Sites of U12 and U2 type introns the PWM for U12
and U2 dependent introns. Default is \code{U12DB}; but also accepts 
\code{SpliceRack}. }
\item{u12DonorBegin, u12DonorEnd}{Integer values. They correspond to the begin 
and end point of the donor sequences of U12-type introns to consider 
(optional).}
\item{u12BranchpointBegin, u12BranchpointEnd}{Integer values. Begin and end 
points of the branch point sequences of U12-type introns (optional).} 
\item{u12AcceptorBegin, u12AcceptorEnd}{Integer values. Begin and end points of
the acceptor sequences of U12-type introns (optional).}
\item{u2DonorBegin, u2DonorEnd}{Integer values. Begin and end points of the 
donor sequences of U2-type introns (optional).} 
\item{u2AcceptorBegin, u2AcceptorEnd}{Integer values. Begin and end points of 
the acceptor sequences of U2-type introns (optional).} 
\item{pasteSites}{Logical. If TRUE the donor, branch point and acceptor seqs 
are pasted before a PWM is built; then the PWMs of each (donor, acceptor and 
bp) are assigned. If FALSE (default) the PWMs for each is built separately.}
\item{splicerackSsLinks}{
A list (or vector) that contains the SpliceRack URL links to the text files 
that contain Position Weigh Matrices of the splice sites of U12 and U2 introns.
This parameter is used only when pwmSource="SpliceRack". You can get the links
to PWM files from this URL (choose logo files with "File" links): 
\url{http://katahdin.mssm.edu/splice/splice_matrix.cgi?database=spliceNew}.
The links should  be defined in the following order: \code{U12_AT_AC_donor}, 
\code{U12_AT_AC_branchpoint}, \code{U12_AT_AC_acceptor},
\code{U12_GT_AG_donor}, \code{U12_GT_AG_branchpoint}, 
\code{U12_GT_AG_acceptor}, \code{U2_GC_AG_donor}, \code{U2_GC_AG_acceptor}, 
\code{U2_GT_AG_donor}, and \code{U2_GT_AG_acceptor}. }
\item{u12dbLink}{
A character string containing the URL for downloading the zipped MySQL dump
file of the U12DB. Used when \code{pwmSource="U12DB"}. }
\item{u12dbDbName}{
Name of the database copy of the U12DB that is build locally. Used when 
\code{pwmSource="U12DB"}.}
\item{u12dbDropDb}{
Drop (or remove) the local copy of the U12DB database at the end of the run.
Used when \code{pwmSource="U12DB"}.}
\item{pdfFileSeqLogos}{
Path to PDF file containing the sequence logos of the results. By default it 
does not produce a file.}
\item{removeTempFiles}{ 
Whether remove temporary files at the end of the run; accepts  \code{TRUE} or  
\code{FALSE} values (default is  \code{TRUE}).}
\item{...}{ 
Authorization arguments needed by the DBMS instance. See the manual for 
\code{dbConnect} of the \code{DBI} package for more info.}
}
\value{
\item{pwmDonorU12}{ 
Matrix (with 4 rows represnting A, C, G, T and \code{n} columns representing
the genomic coordinates) representing the Position Weight Matrix of donor site
of U12-type introns. }
\item{pwmBpU12}{Position Weight Matrix of branchpoint of U12-type introns. }
\item{pwmAccU12}{Position Weight Matrix of acceptor site of U12-type introns. }
\item{pwmDonU2}{Position Weight Matrix of donor site of U2-type introns.}
\item{pwmAccU2}{ Position Weight Matrix of acceptor site of U2-type introns. }
}
\seealso{
  \code{\link{annotateU12}}.
}

\author{Ali Oghabian}

\examples{
# Time demanding function
\dontrun{
#Build temp directory  
tmpDir<- tempdir()


# Creating subdirectory for storing u12db temp files
dir.create(paste(tmpDir, "u12dbTmp", sep="/"))

# Extracting PWMs of Splice Sites of U12 and U2 type introns -
# based on u12db
u12dbPwm<-buildSsTypePwms(
	tmpDir=paste(tmpDir, "u12dbTmp", sep="/"),
	u12dbSpecies="Homo_sapiens",
	resource="U12DB",
	u12dbDbName="u12db",
	u12dbDropDb=TRUE,
	removeTempFiles=TRUE)


# Creating subdirectory for storing SpliceRack temp files
dir.create(paste(tmpDir, "splicerackTmp", sep="/"))

# Extracting PWMs of Splice Sites of U12 and U2 type introns - 
# based on SpliceRack
spliceRackPwm<- buildSsTypePwms(
	tmpDir= paste(tmpDir, "splicerackTmp", sep="/"),
	resource="SpliceRack",
	removeTempFiles=TRUE)
}
}
